JQuery API – jQuery API

jQuery: Write Less, Do More.

jQuery API

  • jQuery .ajaxComplete( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

    New in 1.0 !

    Register a handler to be called when Ajax requests complete. This is an .

  • jQuery .ajaxSuccess( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

    New in 1.0 !

  • jQuery .ajaxStop( [Function] handler() )

    New in 1.0 !

    Register a handler to be called when all Ajax requests have completed. This is an .

  • jQuery .ajaxStart( [Function] handler() )

    New in 1.0 !

    Register a handler to be called when the first Ajax request begins. This is an .

  • jQuery .ajaxSend( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

    New in 1.0 !

  • jQuery .ajaxError( [Function] handler(event, XMLHttpRequest, ajaxOptions, thrownError) )

    New in 1.0 !

    Register a handler to be called when Ajax requests complete with an error. This is an .

  • Array .serializeArray( )

    New in 1.2 !

    Encode a set of form elements as an array of names and values.

  • String .serialize( )

    New in 1.0 !

    Encode a set of form elements as a string for submission.

  • String jQuery.param( [Array|Object] obj, [Boolean] traditional )

    New in 1.4 !

    Create a serialized representation of an array or object, suitable for use in a URL query string or Ajax request.

  • jQuery.ajaxSetup( [Options] options )

    New in 1.1 !

    Set default values for future Ajax requests.

  • XMLHttpRequest jQuery.ajax( [Map] settings )

    New in 1.0 !

    Perform an asynchronous HTTP (Ajax) request.

  • XMLHttpRequest jQuery.post( [String] url, [Map|String] data, [Function] success(data, textStatus, XMLHttpRequest), [String] dataType )

    New in 1.0 !

    Load data from the server using a HTTP POST request.

  • XMLHttpRequest jQuery.getScript( [String] url, [Function] success(data, textStatus) )

    New in 1.0 !

    Load a JavaScript file from the server using a GET HTTP request, then execute it.

  • XMLHttpRequest jQuery.getJSON( [String] url, [Map] data, [Function] callback(data, textStatus) )

    New in 1.0 !

    Load JSON-encoded data from the server using a GET HTTP request.

  • XMLHttpRequest jQuery.get( [String] url, [Map|String] data, [Function] callback(data, textStatus, XMLHttpRequest), [String] dataType )

    New in 1.0 !

    Load data from the server using a HTTP GET request.

  • jQuery .load( [String] url, [Map|String] data, [Function] complete(responseText, textStatus, XMLHttpRequest) )

    New in 1.0 !

    Load data from the server and place the returned HTML into the matched element.

  • jQuery .val( [Function] function(index, value) )

    New in 1.4 !

    Set the value of each element in the set of matched elements.

  • jQuery .html( [Function] function(index, oldhtml) )

    New in 1.4 !

    Set the HTML contents of each element in the set of matched elements.

  • jQuery .toggleClass( [Function] function(index, class), [Boolean] switch )

    New in 1.4 !

    Add or remove one or more classes from each element in the set of matched elements, depending on either the class's presence or the value of the switch argument.

  • jQuery .removeClass( [Function] function(index, class) )

    New in 1.4 !

    Remove a single class, multiple classes, or all classes from each element in the set of matched elements.

  • Boolean .hasClass( [String] className )

    New in 1.2 !

    Determine whether any of the matched elements are assigned the given class.

  • jQuery .removeAttr( [String] attributeName )

    New in 1.0 !

    Remove an attribute from each element in the set of matched elements.

  • jQuery .attr( [String] attributeName, [Function] function(index, attr) )

    New in 1.1 !

    Set one or more attributes for the set of matched elements.

  • jQuery .addClass( [Function] function(index, class) )

    New in 1.4 !

    Adds the specified class(es) to each of the set of matched elements.

  • Object jQuery.noConflict( [Boolean] removeAll )

    New in 1.0 !

    Relinquish jQuery's control of the variable.

  • jQuery jQuery( [Function] callback )

    New in 1.0 !

    Binds a function to be executed when the DOM has finished loading.

  • Integer .outerWidth( [Boolean] includeMargin )

    New in 1.2.6 !

    Get the current computed width for the first element in the set of matched elements, including padding and border.

  • Integer .outerHeight( [Boolean] includeMargin )

    New in 1.2.6 !

    Get the current computed height for the first element in the set of matched elements, including padding, border, and optionally margin.

  • Integer .innerWidth( )

    New in 1.2.6 !

    Get the current computed width for the first element in the set of matched elements, including padding but not border.

  • Integer .innerHeight( )

    New in 1.2.6 !

    Get the current computed height for the first element in the set of matched elements, including padding but not border.

  • jQuery .width( [Function] function(index, width) )

    New in 1.4.1 !

    Set the CSS width of each element in the set of matched elements.

  • jQuery .height( [Function] function(index, height) )

    New in 1.4.1 !

    Set the CSS height of every matched element.

  • jQuery .scrollLeft( [Number] value )

    New in 1.2.6 !

    Set the current horizontal position of the scroll bar for each of the set of matched elements.

  • jQuery .scrollTop( [Number] value )

    New in 1.2.6 !

    Set the current vertical position of the scroll bar for each of the set of matched elements.

  • Object .position( )

    New in 1.2 !

    Get the current coordinates of the first element in the set of matched elements, relative to the offset parent.

  • jQuery .offset( [Function] function(index, coords) )

    New in 1.4 !

    Set the current coordinates of every element in the set of matched elements, relative to the document.

  • jQuery .css( [Map] map )

    New in 1.0 !

    Set one or more CSS properties for the set of matched elements.

  • jQuery .toggleClass( [Function] function(index, class), [Boolean] switch )

    New in 1.4 !

    Add or remove one or more classes from each element in the set of matched elements, depending on either the class's presence or the value of the switch argument.

  • jQuery .removeClass( [Function] function(index, class) )

    New in 1.4 !

    Remove a single class, multiple classes, or all classes from each element in the set of matched elements.

  • Boolean .hasClass( [String] className )

    New in 1.2 !

    Determine whether any of the matched elements are assigned the given class.

  • jQuery .addClass( [Function] function(index, class) )

    New in 1.4 !

    Adds the specified class(es) to each of the set of matched elements.

  • jQuery jQuery.removeData( [Element] element, [String] name )

    New in 1.2.3 !

    Remove a previously-stored piece of data.

  • Object jQuery.data( [Element] element )

    New in 1.4 !

    Returns value at named data store for the element, as set by , or the full data store for the element.

  • jQuery jQuery.dequeue( [Element] element, [String] queueName )

    New in 1.3 !

    Execute the next function on the queue for the matched element.

  • jQuery jQuery.queue( [Element] element, [String] queueName, [Function] callback() )

    New in 1.3 !

    Manipulate the queue of functions to be executed on the matched element.

  • jQuery .clearQueue( [String] queueName )

    New in 1.4 !

    Remove from the queue all items that have not yet been run.

  • jQuery .removeData( [String] name )

    New in 1.2.3 !

    Remove a previously-stored piece of data.

  • Object .data( )

    New in 1.4 !

    Returns value at named data store for the element, as set by data(name, value).

  • jQuery .dequeue( [String] queueName )

    New in 1.2 !

    Execute the next function on the queue for the matched elements.

  • jQuery .queue( [String] queueName, [Function] callback( next ) )

    New in 1.2 !

    Manipulate the queue of functions to be executed on the matched elements.

  • Integer .outerWidth( [Boolean] includeMargin )

    New in 1.2.6 !

    Get the current computed width for the first element in the set of matched elements, including padding and border.

  • Integer .outerHeight( [Boolean] includeMargin )

    New in 1.2.6 !

    Get the current computed height for the first element in the set of matched elements, including padding, border, and optionally margin.

  • Integer .innerWidth( )

    New in 1.2.6 !

    Get the current computed width for the first element in the set of matched elements, including padding but not border.

  • Integer .innerHeight( )

    New in 1.2.6 !

    Get the current computed height for the first element in the set of matched elements, including padding but not border.

  • jQuery .width( [Function] function(index, width) )

    New in 1.4.1 !

    Set the CSS width of each element in the set of matched elements.

  • jQuery .height( [Function] function(index, height) )

    New in 1.4.1 !

    Set the CSS height of every matched element.

  • jQuery .toggle( [Boolean] showOrHide )

    New in 1.3 !

    Display or hide the matched elements.

  • jQuery .hide( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Hide the matched elements.

  • jQuery .show( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display the matched elements.

  • jQuery .delay( [Integer] duration, [String] queueName )

    New in 1.4 !

    Set a timer to delay execution of subsequent items in the queue.

  • Boolean jQuery.fx.off

    New in 1.3 !

    Globally disable all animations.

  • jQuery .clearQueue( [String] queueName )

    New in 1.4 !

    Remove from the queue all items that have not yet been run.

  • jQuery .dequeue( [String] queueName )

    New in 1.2 !

    Execute the next function on the queue for the matched elements.

  • jQuery .queue( [String] queueName, [Function] callback( next ) )

    New in 1.2 !

    Manipulate the queue of functions to be executed on the matched elements.

  • jQuery .stop( [Boolean] clearQueue, [Boolean] jumpToEnd )

    New in 1.2 !

    Stop the currently-running animation on the matched elements.

  • jQuery .animate( [Options] properties, [Options] options )

    New in 1.0 !

    Perform a custom animation of a set of CSS properties.

  • jQuery .fadeTo( [String,Number] duration, [Number] opacity, [Callback] callback )

    New in 1.0 !

    Adjust the opacity of the matched elements.

  • jQuery .fadeOut( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Hide the matched elements by fading them to transparent.

  • jQuery .fadeIn( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display the matched elements by fading them to opaque.

  • jQuery .slideToggle( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display or hide the matched elements with a sliding motion.

  • jQuery .slideUp( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Hide the matched elements with a sliding motion.

  • jQuery .slideDown( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display the matched elements with a sliding motion.

  • jQuery .scroll( )

    New in 1.0 !

    Bind an event handler to the "scroll" JavaScript event, or trigger that event on an element.

  • jQuery .resize( )

    New in 1.0 !

    Bind an event handler to the "resize" JavaScript event, or trigger that event on an element.

  • jQuery .error( [Function] handler(eventObject) )

    New in 1.0 !

    Bind an event handler to the "error" JavaScript event.

  • jQuery .unload( [Function] handler(eventObject) )

    New in 1.0 !

    Bind an event handler to the "unload" JavaScript event.

  • jQuery .load( [Function] handler(eventObject) )

    New in 1.0 !

    Bind an event handler to the "load" JavaScript event.

  • jQuery .ready( [Function] handler )

    New in 1.0 !

    Specify a function to execute when the DOM is fully loaded.

  • jQuery .undelegate( [String] selector, [String] eventType, [Function] handler )

    New in 1.4.2 !

    Remove a handler from the event for all elements which match the current selector, now or in the future, based upon a specific set of root elements.

  • jQuery .delegate( [String] selector, [String] eventType, [Object] eventData, [Function] handler )

    New in 1.4.2 !

    Attach a handler to one or more events for all elements that match the selector, now or in the future, based on a specific set of root elements.

  • Function jQuery.proxy( [Object] context, [String] name )

    New in 1.4 !

    Takes a function and returns a new one that will always have a particular context.

  • jQuery .die( [String] eventType, [String] handler )

    New in 1.3 !

    Remove an event handler previously attached using from the elements.

  • jQuery .live( [String] eventType, [Object] eventData, [Function] handler )

    New in 1.4 !

    Attach a handler to the event for all elements which match the current selector, now or in the future.

  • Object .triggerHandler( [String] eventType, [Array] extraParameters )

    New in 1.2 !

    Execute all handlers attached to an element for an event.

  • jQuery .trigger( [String] eventType, [Array] extraParameters )

    New in 1.0 !

    Execute all handlers and behaviors attached to the matched elements for the given event type.

  • jQuery .one( [String] eventType, [Object] eventData, [Function] handler(eventObject) )

    New in 1.1 !

    Attach a handler to an event for the elements. The handler is executed at most once per element.

  • jQuery .unbind( [Object] event )

    New in 1.0 !

    Remove a previously-attached event handler from the elements.

  • jQuery .bind( [Object] events )

    New in 1.4 !

    Attach a handler to an event for the elements.

  • Boolean event.isImmediatePropagationStopped( )

    New in 1.3 !

    Returns whether event.stopImmediatePropagation() was ever called on this event object.

  • event.stopImmediatePropagation( )

    New in 1.3 !

    Keeps the rest of the handlers from being executed and prevents the event from bubbling up the DOM tree

  • Boolean event.isPropagationStopped( )

    New in 1.3 !

    Returns whether was ever called on this event object.

  • event.stopPropagation( )

    New in 1.0 !

    Prevents the event from bubbling up the DOM tree, preventing any parent handlers from being notified of the event.

  • Boolean event.isDefaultPrevented( )

    New in 1.3 !

    Returns whether was ever called on this event object.

  • undefined event.preventDefault( )

    New in 1.0 !

    If this method is called, the default action of the event will not be triggered.

  • Number event.timeStamp

    New in 1.2.6 !

    This attribute returns the number of milliseconds since January 1, 1970, when the event is triggered.

  • Object event.result

    New in 1.3 !

    This attribute contains the last value returned by an event handler that was triggered by this event, unless the value was .

  • String event.which

    New in 1.1.3 !

    For key or button events, this attribute indicates the specific button or key that was pressed.

  • Number event.pageY

    New in 1.0.4 !

    The mouse position relative to the top edge of the document.

  • Number event.pageX

    New in 1.0.4 !

    The mouse position relative to the left edge of the document.

  • Element event.currentTarget

    New in 1.3 !

    The current DOM element within the event bubbling phase.

  • Element event.relatedTarget

    New in 1.1.4 !

    The other DOM element involved in the event, if any.

  • Anything event.data

    New in 1.1 !

    Contains the optional data passed to jQuery.fn.bind when the current executing handler was bound.

  • Element event.target

    New in 1.0 !

    The DOM element that initiated the event.

  • String event.type

    New in 1.0 !

    Describes the nature of the event.

  • jQuery .submit( )

    New in 1.0 !

    Bind an event handler to the "submit" JavaScript event, or trigger that event on an element.

  • jQuery .select( )

    New in 1.0 !

    Bind an event handler to the "select" JavaScript event, or trigger that event on an element.

  • jQuery .change( )

    New in 1.0 !

    Bind an event handler to the "change" JavaScript event, or trigger that event on an element.

  • jQuery .blur( )

    New in 1.0 !

    Bind an event handler to the "blur" JavaScript event, or trigger that event on an element.

  • jQuery .focus( )

    New in 1.0 !

    Bind an event handler to the "focus" JavaScript event, or trigger that event on an element.

  • jQuery .focusout( [Function] handler(eventObject) )

    New in 1.4 !

    Bind an event handler to the "focusout" JavaScript event.

  • jQuery .focusin( [Function] handler(eventObject) )

    New in 1.4 !

    Bind an event handler to the "focusin" JavaScript event.

  • jQuery .keydown( )

    New in 1.0 !

    Bind an event handler to the "keydown" JavaScript event, or trigger that event on an element.

  • jQuery .keyup( )

    New in 1.0 !

    Bind an event handler to the "keyup" JavaScript event, or trigger that event on an element.

  • jQuery .keypress( )

    New in 1.0 !

    Bind an event handler to the "keypress" JavaScript event, or trigger that event on an element.

  • jQuery .focusout( [Function] handler(eventObject) )

    New in 1.4 !

    Bind an event handler to the "focusout" JavaScript event.

  • jQuery .focusin( [Function] handler(eventObject) )

    New in 1.4 !

    Bind an event handler to the "focusin" JavaScript event.

  • jQuery .mousemove( )

    New in 1.0 !

    Bind an event handler to the "mousemove" JavaScript event, or trigger that event on an element.

  • jQuery .hover( [Function] handlerInOut(eventObject) )

    New in 1.4 !

    Bind a single handler to the matched elements, to be executed when the mouse pointer enters or leaves the elements.

  • jQuery .mouseleave( )

    New in 1.0 !

    Bind an event handler to be fired when the mouse leaves an element, or trigger that handler on an element.

  • jQuery .mouseenter( )

    New in 1.0 !

    Bind an event handler to be fired when the mouse enters an element, or trigger that handler on an element.

  • jQuery .mouseout( )

    New in 1.0 !

    Bind an event handler to the "mouseout" JavaScript event, or trigger that event on an element.

  • jQuery .mouseover( )

    New in 1.0 !

    Bind an event handler to the "mouseover" JavaScript event, or trigger that event on an element.

  • jQuery .dblclick( )

    New in 1.0 !

    Bind an event handler to the "dblclick" JavaScript event, or trigger that event on an element.

  • jQuery .click( )

    New in 1.0 !

    Bind an event handler to the "click" JavaScript event, or trigger that event on an element.

  • jQuery .mouseup( )

    New in 1.0 !

    Bind an event handler to the "mouseup" JavaScript event, or trigger that event on an element.

  • jQuery .mousedown( )

    New in 1.0 !

    Bind an event handler to the "mousedown" JavaScript event, or trigger that event on an element.

  • jQuery .toggle( [Boolean] showOrHide )

    New in 1.3 !

    Display or hide the matched elements.

  • jQuery .submit( )

    New in 1.0 !

    Bind an event handler to the "submit" JavaScript event, or trigger that event on an element.

  • jQuery .select( )

    New in 1.0 !

    Bind an event handler to the "select" JavaScript event, or trigger that event on an element.

  • jQuery .change( )

    New in 1.0 !

    Bind an event handler to the "change" JavaScript event, or trigger that event on an element.

  • jQuery .blur( )

    New in 1.0 !

    Bind an event handler to the "blur" JavaScript event, or trigger that event on an element.

  • jQuery .focus( )

    New in 1.0 !

    Bind an event handler to the "focus" JavaScript event, or trigger that event on an element.

  • Array .serializeArray( )

    New in 1.2 !

    Encode a set of form elements as an array of names and values.

  • String .serialize( )

    New in 1.0 !

    Encode a set of form elements as a string for submission.

  • String jQuery.param( [Array|Object] obj, [Boolean] traditional )

    New in 1.4 !

    Create a serialized representation of an array or object, suitable for use in a URL query string or Ajax request.

  • jQuery .val( [Function] function(index, value) )

    New in 1.4 !

    Set the value of each element in the set of matched elements.

  • jQuery .toggleClass( [Function] function(index, class), [Boolean] switch )

    New in 1.4 !

    Add or remove one or more classes from each element in the set of matched elements, depending on either the class's presence or the value of the switch argument.

  • jQuery .removeClass( [Function] function(index, class) )

    New in 1.4 !

    Remove a single class, multiple classes, or all classes from each element in the set of matched elements.

  • Boolean .hasClass( [String] className )

    New in 1.2 !

    Determine whether any of the matched elements are assigned the given class.

  • jQuery .addClass( [Function] function(index, class) )

    New in 1.4 !

    Adds the specified class(es) to each of the set of matched elements.

  • jQuery .clone( [Boolean] withDataAndEvents )

    New in 1.0 !

    Create a copy of the set of matched elements.

  • jQuery .unwrap( )

    New in 1.4 !

    Remove the parents of the set of matched elements from the DOM, leaving the matched elements in their place.

  • jQuery .wrapInner( [Function] wrappingFunction )

    New in 1.4 !

    Wrap an HTML structure around the content of each element in the set of matched elements.

  • jQuery .wrapAll( [String|Selector|Element|jQuery] wrappingElement )

    New in 1.2 !

    Wrap an HTML structure around all elements in the set of matched elements.

  • jQuery .wrap( [Function] wrappingFunction )

    New in 1.4 !

    Wrap an HTML structure around each element in the set of matched elements.

  • jQuery .prependTo( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements to the beginning of the target.

  • jQuery .prepend( [Function] function(index, html) )

    New in 1.4 !

    Insert content, specified by the parameter, to the beginning of each element in the set of matched elements.

  • jQuery .appendTo( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements to the end of the target.

  • jQuery .append( [Function] function(index, html) )

    New in 1.4 !

    Insert content, specified by the parameter, to the end of each element in the set of matched elements.

  • jQuery .text( [Function] function(index, text) )

    New in 1.4 !

    Set the content of each element in the set of matched elements to the specified text.

  • jQuery .html( [Function] function(index, oldhtml) )

    New in 1.4 !

    Set the HTML contents of each element in the set of matched elements.

  • jQuery .insertBefore( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements before the target.

  • jQuery .before( [Function] function )

    New in 1.4 !

    Insert content, specified by the parameter, before each element in the set of matched elements.

  • jQuery .insertAfter( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements after the target.

  • jQuery .after( [Function] function(index) )

    New in 1.4 !

    Insert content, specified by the parameter, after each element in the set of matched elements.

  • jQuery .unwrap( )

    New in 1.4 !

    Remove the parents of the set of matched elements from the DOM, leaving the matched elements in their place.

  • jQuery .detach( [Selector] selector )

    New in 1.4 !

    Remove the set of matched elements from the DOM.

  • jQuery .remove( [String] selector )

    New in 1.0 !

    Remove the set of matched elements from the DOM.

  • jQuery .empty( )

    New in 1.0 !

    Remove all child nodes of the set of matched elements from the DOM.

  • jQuery .replaceAll( )

    New in 1.2 !

    Replace each target element with the set of matched elements.

  • jQuery .replaceWith( [Function] function )

    New in 1.4 !

    Replace each element in the set of matched elements with the provided new content.

  • jQuery .val( [Function] function(index, value) )

    New in 1.4 !

    Set the value of each element in the set of matched elements.

  • jQuery .removeAttr( [String] attributeName )

    New in 1.0 !

    Remove an attribute from each element in the set of matched elements.

  • jQuery .attr( [String] attributeName, [Function] function(index, attr) )

    New in 1.1 !

    Set one or more attributes for the set of matched elements.

  • Integer .outerWidth( [Boolean] includeMargin )

    New in 1.2.6 !

    Get the current computed width for the first element in the set of matched elements, including padding and border.

  • Integer .outerHeight( [Boolean] includeMargin )

    New in 1.2.6 !

    Get the current computed height for the first element in the set of matched elements, including padding, border, and optionally margin.

  • Integer .innerWidth( )

    New in 1.2.6 !

    Get the current computed width for the first element in the set of matched elements, including padding but not border.

  • Integer .innerHeight( )

    New in 1.2.6 !

    Get the current computed height for the first element in the set of matched elements, including padding but not border.

  • jQuery .width( [Function] function(index, width) )

    New in 1.4.1 !

    Set the CSS width of each element in the set of matched elements.

  • jQuery .height( [Function] function(index, height) )

    New in 1.4.1 !

    Set the CSS height of every matched element.

  • jQuery .scrollLeft( [Number] value )

    New in 1.2.6 !

    Set the current horizontal position of the scroll bar for each of the set of matched elements.

  • jQuery .scrollTop( [Number] value )

    New in 1.2.6 !

    Set the current vertical position of the scroll bar for each of the set of matched elements.

  • Object .position( )

    New in 1.2 !

    Get the current coordinates of the first element in the set of matched elements, relative to the offset parent.

  • jQuery .offset( [Function] function(index, coords) )

    New in 1.4 !

    Set the current coordinates of every element in the set of matched elements, relative to the document.

  • jQuery .css( [Map] map )

    New in 1.0 !

    Set one or more CSS properties for the set of matched elements.

  • jQuery .each( [Function] function(index, Element) )

    New in 1.0 !

    Iterate over a jQuery object, executing a function for each matched element.

  • String jQuery.param( [Array|Object] obj, [Boolean] traditional )

    New in 1.4 !

    Create a serialized representation of an array or object, suitable for use in a URL query string or Ajax request.

  • jQuery .removeData( [String] name )

    New in 1.2.3 !

    Remove a previously-stored piece of data.

  • Object .data( )

    New in 1.4 !

    Returns value at named data store for the element, as set by data(name, value).

  • Array .toArray( )

    New in 1.4 !

    Retrieve all the DOM elements contained in the jQuery set, as an array.

  • Number .index( [Element|jQuery] element )

    New in 1.0 !

    Search for a given element from among the matched elements.

  • Element, Array .get( [Number] index )

    New in 1.0 !

    Retrieve the DOM elements matched by the jQuery object.

  • Number .size( )

    New in 1.0 !

    Return the number of DOM elements matched by the jQuery object.

  • Object jQuery.noConflict( [Boolean] removeAll )

    New in 1.0 !

    Relinquish jQuery's control of the variable.

  • jQuery .offsetParent( )

    New in 1.26 !

    Get the closest ancestor element that is positioned.

  • jQuery .scrollLeft( [Number] value )

    New in 1.2.6 !

    Set the current horizontal position of the scroll bar for each of the set of matched elements.

  • jQuery .scrollTop( [Number] value )

    New in 1.2.6 !

    Set the current vertical position of the scroll bar for each of the set of matched elements.

  • Object .position( )

    New in 1.2 !

    Get the current coordinates of the first element in the set of matched elements, relative to the offset parent.

  • jQuery .offset( [Function] function(index, coords) )

    New in 1.4 !

    Set the current coordinates of every element in the set of matched elements, relative to the document.

  • jQuery.error( [String] message )

    New in 1.4.1 !

    Takes a string and throws an exception containing it.

  • jQuery jQuery.pushStack( [Array] elements, [String] name, [Array] arguments )

    New in 1.3 !

    Add a collection of DOM elements onto the jQuery stack.

  • String selector

    New in 1.3 !

    A selector representing selector originally passed to jQuery().

  • Element context

    New in 1.3 !

    The DOM node context originally passed to jQuery(); if none was passed then context will likely be the document.

  • Number length

    New in 1.0 !

    The number of elements in the jQuery object.

  • String selector

    New in 1.3 !

    A selector representing selector originally passed to jQuery().

  • Element context

    New in 1.3 !

    The DOM node context originally passed to jQuery(); if none was passed then context will likely be the document.

  • Boolean jQuery.fx.off

    New in 1.3 !

    Globally disable all animations.

  • Map jQuery.browser

    New in 1.0 !

    Contains flags for the useragent, read from navigator.userAgent. While jQuery.browser will not be removed from future versions of jQuery, every effort to use jQuery.support and proper feature detection should be made.

  • String jQuery.browser.version

    New in 1.1.3 !

    The version number of the rendering engine for the user's browser.

  • Object jQuery.support

    New in 1.3 !

    A collection of properties that represent the presence of different browser features or bugs.

  • JQuery("[attribute|=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value either equal to a given string or starting with that string followed by a hyphen (-).

  • JQuery("[attribute~=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value containing a given word, delimited by spaces.

  • JQuery("[attributeFilter1][attributeFilter2][attributeFilterN]")

    New in 1.0 !

    Matches elements that match all of the specified attribute filters.

  • JQuery("[attribute*=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value containing the a given substring.

  • JQuery("[attribute$=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value ending exactly with a given string.

  • JQuery("[attribute^=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value beginning exactly with a given string.

  • JQuery("[attribute!=value]")

    New in 1.0 !

    Select elements that either don't have the specified attribute, or do have the specified attribute but not with a certain value.

  • JQuery("[attribute=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value exactly equal to a certain value.

  • JQuery("[attribute]")

    New in 1.0 !

    Selects elements that have the specified attribute, with any value.

  • JQuery("selector1, selector2, selectorN")

    New in 1.0 !

    Selects the combined results of all the specified selectors.

  • JQuery("*")

    New in 1.0 !

    Selects all elements.

  • JQuery(".class")

    New in 1.0 !

    Selects all elements with the given class.

  • JQuery("element")

    New in 1.0 !

    Selects all elements with the given tag name.

  • JQuery("#id")

    New in 1.0 !

    Selects a single element with the given id attribute.

  • JQuery(":animated")

    New in 1.2 !

    Select all elements that are in the progress of an animation at the time the selector is run.

  • JQuery(":header")

    New in 1.2 !

    Selects all elements that are headers, like h1, h2, h3 and so on.

  • JQuery(":lt(index)")

    New in 1.0 !

    Select all elements at an index less than within the matched set.

  • JQuery(":gt(index)")

    New in 1.0 !

    Select all elements at an index greater than within the matched set.

  • JQuery(":eq(index)")

    New in 1.0 !

    Select the element at index within the matched set.

  • JQuery(":odd")

    New in 1.0 !

    Selects odd elements, zero-indexed. See also .

  • JQuery(":even")

    New in 1.0 !

    Selects even elements, zero-indexed. See also .

  • JQuery(":not(selector)")

    New in 1.0 !

    Selects all elements that do not match the given selector.

  • JQuery(":last")

    New in 1.0 !

    Selects the last matched element.

  • JQuery(":first")

    New in 1.0 !

    Selects the first matched element.

  • JQuery(":only-child")

    New in 1.1.4 !

    Selects all elements that are the only child of their parent.

  • JQuery(":last-child")

    New in 1.1.4 !

    Selects all elements that are the last child of their parent.

  • JQuery(":first-child")

    New in 1.1.4 !

    Selects all elements that are the first child of their parent.

  • JQuery(":nth-child(index/even/odd/equation)")

    New in 1.1.4 !

    Selects all elements that are the nth-child of their parent.

  • JQuery(":parent")

    New in 1.0 !

    Select all elements that are the parent of another element, including text nodes.

  • JQuery(":has(selector)")

    New in 1.1.4 !

    Selects elements which contain at least one element that matches the specified selector.

  • JQuery(":empty")

    New in 1.0 !

    Select all elements that have no children (including text nodes).

  • JQuery(":contains(text)")

    New in 1.1.4 !

    Select all elements that contain the specified text.

  • JQuery(":selected")

    New in 1.0 !

    Selects all elements that are selected.

  • JQuery(":checked")

    New in 1.0 !

    Matches all elements that are checked.

  • JQuery(":disabled")

    New in 1.0 !

    Selects all elements that are disabled.

  • JQuery(":enabled")

    New in 1.0 !

    Selects all elements that are enabled.

  • JQuery(":file")

    New in 1.0 !

    Selects all elements of type file.

  • JQuery(":button")

    New in 1.0 !

    Selects all button elements and elements of type button.

  • JQuery(":reset")

    New in 1.0 !

    Selects all elements of type reset.

  • JQuery(":image")

    New in 1.0 !

    Selects all elements of type image.

  • JQuery(":submit")

    New in 1.0 !

    Selects all elements of type submit.

  • JQuery(":checkbox")

    New in 1.0 !

    Selects all elements of type checkbox.

  • JQuery(":radio")

    New in 1.0 !

    Selects all elements of type radio.

  • JQuery(":password")

    New in 1.0 !

    Selects all elements of type password.

  • JQuery(":text")

    New in 1.0 !

    Selects all elements of type text.

  • JQuery(":input")

    New in 1.0 !

    Selects all input, textarea, select and button elements.

  • JQuery("prev ~ siblings")

    New in 1.0 !

    Selects all sibling elements that follow after the "prev" element, have the same parent, and match the filtering "siblings" selector.

  • JQuery("prev + next")

    New in 1.0 !

    Selects all next elements matching "next" that are immediately preceded by a sibling "prev".

  • child")" rel="bookmark">JQuery("parent > child")

    New in 1.0 !

    Selects all direct child elements specified by "child" of elements specified by "parent".

  • JQuery("ancestor descendant")

    New in 1.0 !

    Selects all elements that are descendants of a given ancestor.

  • JQuery(":visible")

    New in 1.0 !

    Selects all elements that are visible.

  • JQuery(":hidden")

    New in 1.0 !

    Selects all elements that are hidden.

  • jQuery .has( [Element] contained )

    New in 1.4 !

    Reduce the set of matched elements to those that have a descendant that matches the selector or DOM element.

  • jQuery .first( )

    New in 1.4 !

    Reduce the set of matched elements to the first in the set.

  • jQuery .last( )

    New in 1.4 !

    Reduce the set of matched elements to the final one in the set.

  • jQuery .slice( [Integer] start, [Integer] end )

    New in 1.1.4 !

    Reduce the set of matched elements to a subset specified by a range of indices.

  • jQuery .not( [Function] function(index) )

    New in 1.4 !

    Remove elements from the set of matched elements.

  • jQuery .map( [Function] callback(index, domElement) )

    New in 1.2 !

    Pass each element in the current matched set through a function, producing a new jQuery object containing the return values.

  • Boolean .is( [Selector] selector )

    New in 1.0 !

    Check the current matched set of elements against a selector and return true if at least one of these elements matches the selector.

  • jQuery .eq( [Integer] -index )

    New in 1.4 !

    Reduce the set of matched elements to the one at the specified index.

  • jQuery .filter( [Function] function(index) )

    New in 1.0 !

    Reduce the set of matched elements to those that match the selector or pass the function's test.

  • jQuery .end( )

    New in 1.0 !

    End the most recent filtering operation in the current chain and return the set of matched elements to its previous state.

  • jQuery .andSelf( )

    New in 1.2 !

    Add the previous set of elements on the stack to the current set.

  • jQuery .contents( )

    New in 1.2 !

    Get the children of each element in the set of matched elements, including text nodes.

  • jQuery .add( [Selector] selector, [Element] context )

    New in 1.4 !

    Add elements to the set of matched elements.

  • jQuery .parentsUntil( [Selector] selector )

    New in 1.4 !

    Get the ancestors of each element in the current set of matched elements, up to but not including the element matched by the selector.

  • jQuery .prevUntil( [Selector] selector )

    New in 1.4 !

    Get all preceding siblings of each element up to but not including the element matched by the selector.

  • jQuery .nextUntil( [Selector] selector )

    New in 1.4 !

    Get all following siblings of each element up to but not including the element matched by the selector.

  • jQuery .siblings( [Selector] selector )

    New in 1.0 !

    Get the siblings of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .prevAll( [Selector] selector )

    New in 1.2 !

    Get all preceding siblings of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .prev( [Selector] selector )

    New in 1.0 !

    Get the immediately preceding sibling of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .parents( [Selector] selector )

    New in 1.0 !

    Get the ancestors of each element in the current set of matched elements, optionally filtered by a selector.

  • jQuery .parent( [Selector] selector )

    New in 1.0 !

    Get the parent of each element in the current set of matched elements, optionally filtered by a selector.

  • jQuery .offsetParent( )

    New in 1.26 !

    Get the closest ancestor element that is positioned.

  • jQuery .nextAll( [String] selector )

    New in 1.2 !

    Get all following siblings of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .next( [Selector] selector )

    New in 1.0 !

    Get the immediately following sibling of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .find( [Selector] selector )

    New in 1.0 !

    Get the descendants of each element in the current set of matched elements, filtered by a selector.

  • Array .closest( [Array] selectors, [Element] context )

    New in 1.4 !

    Gets an array of all the elements and selectors matched against the current element up through the DOM tree.

  • jQuery .children( [Selector] selector )

    New in 1.0 !

    Get the children of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .each( [Function] function(index, Element) )

    New in 1.0 !

    Iterate over a jQuery object, executing a function for each matched element.

  • Object jQuery.parseJSON( [String] json )

    New in 1.4.1 !

    Takes a well-formed JSON string and returns the resulting JavaScript object.

  • Function jQuery.proxy( [Object] context, [String] name )

    New in 1.4 !

    Takes a function and returns a new one that will always have a particular context.

  • Boolean jQuery.contains( [Element] container, [Element] contained )

    New in 1.4 !

    Check to see if a DOM node is within another DOM node.

  • Function jQuery.noop( )

    New in 1.4 !

    An empty function.

  • jQuery.globalEval( [String] code )

    New in 1.0.4 !

    Execute some JavaScript code globally.

  • Boolean jQuery.isXMLDoc( [Element] node )

    New in 1.1.4 !

    Check to see if a DOM node is within an XML document (or is an XML document).

  • jQuery jQuery.removeData( [Element] element, [String] name )

    New in 1.2.3 !

    Remove a previously-stored piece of data.

  • Object jQuery.data( [Element] element )

    New in 1.4 !

    Returns value at named data store for the element, as set by , or the full data store for the element.

  • jQuery jQuery.dequeue( [Element] element, [String] queueName )

    New in 1.3 !

    Execute the next function on the queue for the matched element.

  • jQuery jQuery.queue( [Element] element, [String] queueName, [Function] callback() )

    New in 1.3 !

    Manipulate the queue of functions to be executed on the matched element.

  • jQuery .clearQueue( [String] queueName )

    New in 1.4 !

    Remove from the queue all items that have not yet been run.

  • Boolean jQuery.isEmptyObject( [Object] object )

    New in 1.4 !

    Check to see if an object is empty (contains no properties).

  • Boolean jQuery.isPlainObject( [Object] object )

    New in 1.4 !

    Check to see if an object is a plain object (created using "{}" or "new Object").

  • jQuery .dequeue( [String] queueName )

    New in 1.2 !

    Execute the next function on the queue for the matched elements.

  • jQuery .queue( [String] queueName, [Function] callback( next ) )

    New in 1.2 !

    Manipulate the queue of functions to be executed on the matched elements.

  • Map jQuery.browser

    New in 1.0 !

    Contains flags for the useragent, read from navigator.userAgent. While jQuery.browser will not be removed from future versions of jQuery, every effort to use jQuery.support and proper feature detection should be made.

  • String jQuery.browser.version

    New in 1.1.3 !

    The version number of the rendering engine for the user's browser.

  • String jQuery.trim( [String] str )

    New in 1.0 !

    Remove the whitespace from the beginning and end of a string.

  • boolean jQuery.isFunction( [Object] obj )

    New in 1.2 !

    Determine if the argument passed is a Javascript function object.

  • boolean jQuery.isArray( [Object] obj )

    New in 1.3 !

    Determine whether the argument is an array.

  • Array jQuery.unique( [Array] array )

    New in 1.1.3 !

    Sorts an array of DOM elements, in place, with the duplicates removed. Note that this only works on arrays of DOM elements, not strings or numbers.

  • Array jQuery.merge( [Array] first, [Array] second )

    New in 1.0 !

    Merge the contents of two arrays together into the first array.

  • Number jQuery.inArray( [Any] value, [Array] array )

    New in 1.2 !

    Search for a specified value within an array and return its index (or -1 if not found).

  • Array jQuery.map( [Array] array, [Function] callback(elementOfArray, indexInArray) )

    New in 1.0 !

    Translate all items in an array or array-like object to another array of items.

  • Array jQuery.makeArray( [Object] obj )

    New in 1.2 !

    Convert an array-like object into a true JavaScript array.

  • Array jQuery.grep( [Array] array, [Function] function(elementOfArray, indexInArray), [Boolean] invert )

    New in 1.0 !

    Finds the elements of an array which satisfy a filter function. The original array is not affected.

  • Object jQuery.extend( [Boolean] deep, [Object] target, [Object] object1, [Object] objectN )

    New in 1.1.4 !

    Merge the contents of two or more objects together into the first object.

  • Object jQuery.each( [Object] collection, [Function] callback(indexInArray, valueOfElement) )

    New in 1.0 !

    A generic iterator function, which can be used to seamlessly iterate over both objects and arrays. Arrays and array-like objects with a length property (such as a function's arguments object) are iterated by numeric index, from 0 to length-1. Other objects are iterated via their named properties.

  • Boolean jQuery.boxModel

    New in 1.0 !

    . States if the current page, in the user's browser, is being rendered using the .

  • Object jQuery.support

    New in 1.3 !

    A collection of properties that represent the presence of different browser features or bugs.

  • event.stopPropagation( )

    New in 1.0 !

    Prevents the event from bubbling up the DOM tree, preventing any parent handlers from being notified of the event.

  • undefined event.preventDefault( )

    New in 1.0 !

    If this method is called, the default action of the event will not be triggered.

  • Element event.target

    New in 1.0 !

    The DOM element that initiated the event.

  • String event.type

    New in 1.0 !

    Describes the nature of the event.

  • jQuery .each( [Function] function(index, Element) )

    New in 1.0 !

    Iterate over a jQuery object, executing a function for each matched element.

  • jQuery jQuery.pushStack( [Array] elements, [String] name, [Array] arguments )

    New in 1.3 !

    Add a collection of DOM elements onto the jQuery stack.

  • jQuery .keydown( )

    New in 1.0 !

    Bind an event handler to the "keydown" JavaScript event, or trigger that event on an element.

  • Number .index( [Element|jQuery] element )

    New in 1.0 !

    Search for a given element from among the matched elements.

  • Element, Array .get( [Number] index )

    New in 1.0 !

    Retrieve the DOM elements matched by the jQuery object.

  • Number .size( )

    New in 1.0 !

    Return the number of DOM elements matched by the jQuery object.

  • Object jQuery.noConflict( [Boolean] removeAll )

    New in 1.0 !

    Relinquish jQuery's control of the variable.

  • JQuery(":selected")

    New in 1.0 !

    Selects all elements that are selected.

  • JQuery(":checked")

    New in 1.0 !

    Matches all elements that are checked.

  • JQuery(":disabled")

    New in 1.0 !

    Selects all elements that are disabled.

  • JQuery(":enabled")

    New in 1.0 !

    Selects all elements that are enabled.

  • JQuery(":file")

    New in 1.0 !

    Selects all elements of type file.

  • JQuery(":button")

    New in 1.0 !

    Selects all button elements and elements of type button.

  • JQuery(":reset")

    New in 1.0 !

    Selects all elements of type reset.

  • JQuery(":image")

    New in 1.0 !

    Selects all elements of type image.

  • jQuery .submit( )

    New in 1.0 !

    Bind an event handler to the "submit" JavaScript event, or trigger that event on an element.

  • JQuery(":checkbox")

    New in 1.0 !

    Selects all elements of type checkbox.

  • JQuery(":radio")

    New in 1.0 !

    Selects all elements of type radio.

  • JQuery(":password")

    New in 1.0 !

    Selects all elements of type password.

  • jQuery .text( [Function] function(index, text) )

    New in 1.4 !

    Set the content of each element in the set of matched elements to the specified text.

  • JQuery(":input")

    New in 1.0 !

    Selects all input, textarea, select and button elements.

  • JQuery("[attribute|=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value either equal to a given string or starting with that string followed by a hyphen (-).

  • JQuery("[attribute~=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value containing a given word, delimited by spaces.

  • JQuery("[attributeFilter1][attributeFilter2][attributeFilterN]")

    New in 1.0 !

    Matches elements that match all of the specified attribute filters.

  • JQuery("[attribute*=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value containing the a given substring.

  • JQuery("[attribute$=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value ending exactly with a given string.

  • JQuery("[attribute^=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value beginning exactly with a given string.

  • JQuery("[attribute!=value]")

    New in 1.0 !

    Select elements that either don't have the specified attribute, or do have the specified attribute but not with a certain value.

  • JQuery("[attribute=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value exactly equal to a certain value.

  • JQuery("[attribute]")

    New in 1.0 !

    Selects elements that have the specified attribute, with any value.

  • JQuery(":visible")

    New in 1.0 !

    Selects all elements that are visible.

  • JQuery(":hidden")

    New in 1.0 !

    Selects all elements that are hidden.

  • jQuery .parent( [Selector] selector )

    New in 1.0 !

    Get the parent of each element in the current set of matched elements, optionally filtered by a selector.

  • jQuery .empty( )

    New in 1.0 !

    Remove all child nodes of the set of matched elements from the DOM.

  • JQuery(":lt(index)")

    New in 1.0 !

    Select all elements at an index less than within the matched set.

  • JQuery(":gt(index)")

    New in 1.0 !

    Select all elements at an index greater than within the matched set.

  • JQuery(":eq(index)")

    New in 1.0 !

    Select the element at index within the matched set.

  • JQuery(":odd")

    New in 1.0 !

    Selects odd elements, zero-indexed. See also .

  • JQuery(":even")

    New in 1.0 !

    Selects even elements, zero-indexed. See also .

  • jQuery .not( [Function] function(index) )

    New in 1.4 !

    Remove elements from the set of matched elements.

  • JQuery(":last")

    New in 1.0 !

    Selects the last matched element.

  • JQuery(":first")

    New in 1.0 !

    Selects the first matched element.

  • JQuery("prev ~ siblings")

    New in 1.0 !

    Selects all sibling elements that follow after the "prev" element, have the same parent, and match the filtering "siblings" selector.

  • JQuery("prev + next")

    New in 1.0 !

    Selects all next elements matching "next" that are immediately preceded by a sibling "prev".

  • child")" rel="bookmark">JQuery("parent > child")

    New in 1.0 !

    Selects all direct child elements specified by "child" of elements specified by "parent".

  • JQuery("ancestor descendant")

    New in 1.0 !

    Selects all elements that are descendants of a given ancestor.

  • JQuery("selector1, selector2, selectorN")

    New in 1.0 !

    Selects the combined results of all the specified selectors.

  • JQuery("*")

    New in 1.0 !

    Selects all elements.

  • JQuery(".class")

    New in 1.0 !

    Selects all elements with the given class.

  • JQuery("element")

    New in 1.0 !

    Selects all elements with the given tag name.

  • JQuery("#id")

    New in 1.0 !

    Selects a single element with the given id attribute.

  • jQuery .scroll( )

    New in 1.0 !

    Bind an event handler to the "scroll" JavaScript event, or trigger that event on an element.

  • jQuery .resize( )

    New in 1.0 !

    Bind an event handler to the "resize" JavaScript event, or trigger that event on an element.

  • jQuery .keyup( )

    New in 1.0 !

    Bind an event handler to the "keyup" JavaScript event, or trigger that event on an element.

  • jQuery .keypress( )

    New in 1.0 !

    Bind an event handler to the "keypress" JavaScript event, or trigger that event on an element.

  • jQuery .select( )

    New in 1.0 !

    Bind an event handler to the "select" JavaScript event, or trigger that event on an element.

  • jQuery .change( )

    New in 1.0 !

    Bind an event handler to the "change" JavaScript event, or trigger that event on an element.

  • jQuery .blur( )

    New in 1.0 !

    Bind an event handler to the "blur" JavaScript event, or trigger that event on an element.

  • jQuery .focus( )

    New in 1.0 !

    Bind an event handler to the "focus" JavaScript event, or trigger that event on an element.

  • jQuery .mousemove( )

    New in 1.0 !

    Bind an event handler to the "mousemove" JavaScript event, or trigger that event on an element.

  • jQuery .hover( [Function] handlerInOut(eventObject) )

    New in 1.4 !

    Bind a single handler to the matched elements, to be executed when the mouse pointer enters or leaves the elements.

  • jQuery .mouseleave( )

    New in 1.0 !

    Bind an event handler to be fired when the mouse leaves an element, or trigger that handler on an element.

  • jQuery .mouseenter( )

    New in 1.0 !

    Bind an event handler to be fired when the mouse enters an element, or trigger that handler on an element.

  • jQuery .mouseout( )

    New in 1.0 !

    Bind an event handler to the "mouseout" JavaScript event, or trigger that event on an element.

  • jQuery .mouseover( )

    New in 1.0 !

    Bind an event handler to the "mouseover" JavaScript event, or trigger that event on an element.

  • jQuery .dblclick( )

    New in 1.0 !

    Bind an event handler to the "dblclick" JavaScript event, or trigger that event on an element.

  • jQuery .click( )

    New in 1.0 !

    Bind an event handler to the "click" JavaScript event, or trigger that event on an element.

  • jQuery .mouseup( )

    New in 1.0 !

    Bind an event handler to the "mouseup" JavaScript event, or trigger that event on an element.

  • jQuery .mousedown( )

    New in 1.0 !

    Bind an event handler to the "mousedown" JavaScript event, or trigger that event on an element.

  • jQuery .error( [Function] handler(eventObject) )

    New in 1.0 !

    Bind an event handler to the "error" JavaScript event.

  • jQuery .unload( [Function] handler(eventObject) )

    New in 1.0 !

    Bind an event handler to the "unload" JavaScript event.

  • jQuery .load( [String] url, [Map|String] data, [Function] complete(responseText, textStatus, XMLHttpRequest) )

    New in 1.0 !

    Load data from the server and place the returned HTML into the matched element.

  • jQuery .ready( [Function] handler )

    New in 1.0 !

    Specify a function to execute when the DOM is fully loaded.

  • Map jQuery.browser

    New in 1.0 !

    Contains flags for the useragent, read from navigator.userAgent. While jQuery.browser will not be removed from future versions of jQuery, every effort to use jQuery.support and proper feature detection should be made.

  • String jQuery.browser.version

    New in 1.1.3 !

    The version number of the rendering engine for the user's browser.

  • jQuery .trigger( [String] eventType, [Array] extraParameters )

    New in 1.0 !

    Execute all handlers and behaviors attached to the matched elements for the given event type.

  • jQuery .ajaxComplete( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

    New in 1.0 !

    Register a handler to be called when Ajax requests complete. This is an .

  • String .serialize( )

    New in 1.0 !

    Encode a set of form elements as a string for submission.

  • jQuery .ajaxSuccess( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

    New in 1.0 !

  • jQuery .ajaxStop( [Function] handler() )

    New in 1.0 !

    Register a handler to be called when all Ajax requests have completed. This is an .

  • jQuery .ajaxStart( [Function] handler() )

    New in 1.0 !

    Register a handler to be called when the first Ajax request begins. This is an .

  • jQuery .ajaxSend( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

    New in 1.0 !

  • jQuery .ajaxError( [Function] handler(event, XMLHttpRequest, ajaxOptions, thrownError) )

    New in 1.0 !

    Register a handler to be called when Ajax requests complete with an error. This is an .

  • jQuery .unbind( [Object] event )

    New in 1.0 !

    Remove a previously-attached event handler from the elements.

  • jQuery .bind( [Object] events )

    New in 1.4 !

    Attach a handler to an event for the elements.

  • jQuery jQuery( [Function] callback )

    New in 1.0 !

    Binds a function to be executed when the DOM has finished loading.

  • jQuery .end( )

    New in 1.0 !

    End the most recent filtering operation in the current chain and return the set of matched elements to its previous state.

  • jQuery .siblings( [Selector] selector )

    New in 1.0 !

    Get the siblings of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .animate( [Options] properties, [Options] options )

    New in 1.0 !

    Perform a custom animation of a set of CSS properties.

  • jQuery .prev( [Selector] selector )

    New in 1.0 !

    Get the immediately preceding sibling of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .fadeTo( [String,Number] duration, [Number] opacity, [Callback] callback )

    New in 1.0 !

    Adjust the opacity of the matched elements.

  • jQuery .fadeOut( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Hide the matched elements by fading them to transparent.

  • jQuery .parents( [Selector] selector )

    New in 1.0 !

    Get the ancestors of each element in the current set of matched elements, optionally filtered by a selector.

  • jQuery .fadeIn( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display the matched elements by fading them to opaque.

  • jQuery .slideToggle( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display or hide the matched elements with a sliding motion.

  • XMLHttpRequest jQuery.post( [String] url, [Map|String] data, [Function] success(data, textStatus, XMLHttpRequest), [String] dataType )

    New in 1.0 !

    Load data from the server using a HTTP POST request.

  • jQuery .slideUp( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Hide the matched elements with a sliding motion.

  • jQuery .next( [Selector] selector )

    New in 1.0 !

    Get the immediately following sibling of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .slideDown( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display the matched elements with a sliding motion.

  • jQuery .find( [Selector] selector )

    New in 1.0 !

    Get the descendants of each element in the current set of matched elements, filtered by a selector.

  • XMLHttpRequest jQuery.getScript( [String] url, [Function] success(data, textStatus) )

    New in 1.0 !

    Load a JavaScript file from the server using a GET HTTP request, then execute it.

  • XMLHttpRequest jQuery.getJSON( [String] url, [Map] data, [Function] callback(data, textStatus) )

    New in 1.0 !

    Load JSON-encoded data from the server using a GET HTTP request.

  • XMLHttpRequest jQuery.get( [String] url, [Map|String] data, [Function] callback(data, textStatus, XMLHttpRequest), [String] dataType )

    New in 1.0 !

    Load data from the server using a HTTP GET request.

  • XMLHttpRequest jQuery.ajax( [Map] settings )

    New in 1.0 !

    Perform an asynchronous HTTP (Ajax) request.

  • Number length

    New in 1.0 !

    The number of elements in the jQuery object.

  • jQuery .children( [Selector] selector )

    New in 1.0 !

    Get the children of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .add( [Selector] selector, [Element] context )

    New in 1.4 !

    Add elements to the set of matched elements.

  • jQuery .toggle( [Boolean] showOrHide )

    New in 1.3 !

    Display or hide the matched elements.

  • jQuery .hide( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Hide the matched elements.

  • jQuery .width( [Function] function(index, width) )

    New in 1.4.1 !

    Set the CSS width of each element in the set of matched elements.

  • jQuery .height( [Function] function(index, height) )

    New in 1.4.1 !

    Set the CSS height of every matched element.

  • jQuery .show( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display the matched elements.

  • String jQuery.trim( [String] str )

    New in 1.0 !

    Remove the whitespace from the beginning and end of a string.

  • Array jQuery.merge( [Array] first, [Array] second )

    New in 1.0 !

    Merge the contents of two arrays together into the first array.

  • Array jQuery.map( [Array] array, [Function] callback(elementOfArray, indexInArray) )

    New in 1.0 !

    Translate all items in an array or array-like object to another array of items.

  • Array jQuery.grep( [Array] array, [Function] function(elementOfArray, indexInArray), [Boolean] invert )

    New in 1.0 !

    Finds the elements of an array which satisfy a filter function. The original array is not affected.

  • Object jQuery.extend( [Boolean] deep, [Object] target, [Object] object1, [Object] objectN )

    New in 1.1.4 !

    Merge the contents of two or more objects together into the first object.

  • Object jQuery.each( [Object] collection, [Function] callback(indexInArray, valueOfElement) )

    New in 1.0 !

    A generic iterator function, which can be used to seamlessly iterate over both objects and arrays. Arrays and array-like objects with a length property (such as a function's arguments object) are iterated by numeric index, from 0 to length-1. Other objects are iterated via their named properties.

  • Boolean jQuery.boxModel

    New in 1.0 !

    . States if the current page, in the user's browser, is being rendered using the .

  • jQuery .css( [Map] map )

    New in 1.0 !

    Set one or more CSS properties for the set of matched elements.

  • jQuery .clone( [Boolean] withDataAndEvents )

    New in 1.0 !

    Create a copy of the set of matched elements.

  • jQuery .remove( [String] selector )

    New in 1.0 !

    Remove the set of matched elements from the DOM.

  • jQuery .wrap( [Function] wrappingFunction )

    New in 1.4 !

    Wrap an HTML structure around each element in the set of matched elements.

  • jQuery .insertBefore( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements before the target.

  • jQuery .before( [Function] function )

    New in 1.4 !

    Insert content, specified by the parameter, before each element in the set of matched elements.

  • jQuery .insertAfter( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements after the target.

  • jQuery .after( [Function] function(index) )

    New in 1.4 !

    Insert content, specified by the parameter, after each element in the set of matched elements.

  • jQuery .prependTo( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements to the beginning of the target.

  • jQuery .prepend( [Function] function(index, html) )

    New in 1.4 !

    Insert content, specified by the parameter, to the beginning of each element in the set of matched elements.

  • jQuery .appendTo( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements to the end of the target.

  • jQuery .append( [Function] function(index, html) )

    New in 1.4 !

    Insert content, specified by the parameter, to the end of each element in the set of matched elements.

  • jQuery .val( [Function] function(index, value) )

    New in 1.4 !

    Set the value of each element in the set of matched elements.

  • jQuery .html( [Function] function(index, oldhtml) )

    New in 1.4 !

    Set the HTML contents of each element in the set of matched elements.

  • Boolean .is( [Selector] selector )

    New in 1.0 !

    Check the current matched set of elements against a selector and return true if at least one of these elements matches the selector.

  • jQuery .filter( [Function] function(index) )

    New in 1.0 !

    Reduce the set of matched elements to those that match the selector or pass the function's test.

  • jQuery .toggleClass( [Function] function(index, class), [Boolean] switch )

    New in 1.4 !

    Add or remove one or more classes from each element in the set of matched elements, depending on either the class's presence or the value of the switch argument.

  • jQuery .removeClass( [Function] function(index, class) )

    New in 1.4 !

    Remove a single class, multiple classes, or all classes from each element in the set of matched elements.

  • jQuery .removeAttr( [String] attributeName )

    New in 1.0 !

    Remove an attribute from each element in the set of matched elements.

  • jQuery .attr( [String] attributeName, [Function] function(index, attr) )

    New in 1.1 !

    Set one or more attributes for the set of matched elements.

  • jQuery .addClass( [Function] function(index, class) )

    New in 1.4 !

    Adds the specified class(es) to each of the set of matched elements.

  • Number event.pageY

    New in 1.0.4 !

    The mouse position relative to the top edge of the document.

  • Number event.pageX

    New in 1.0.4 !

    The mouse position relative to the left edge of the document.

  • jQuery.globalEval( [String] code )

    New in 1.0.4 !

    Execute some JavaScript code globally.

  • Anything event.data

    New in 1.1 !

    Contains the optional data passed to jQuery.fn.bind when the current executing handler was bound.

  • jQuery .one( [String] eventType, [Object] eventData, [Function] handler(eventObject) )

    New in 1.1 !

    Attach a handler to an event for the elements. The handler is executed at most once per element.

  • jQuery.ajaxSetup( [Options] options )

    New in 1.1 !

    Set default values for future Ajax requests.

  • jQuery .attr( [String] attributeName, [Function] function(index, attr) )

    New in 1.1 !

    Set one or more attributes for the set of matched elements.

  • jQuery .eq( [Integer] -index )

    New in 1.4 !

    Reduce the set of matched elements to the one at the specified index.

  • String event.which

    New in 1.1.3 !

    For key or button events, this attribute indicates the specific button or key that was pressed.

  • Map jQuery.browser

    New in 1.0 !

    Contains flags for the useragent, read from navigator.userAgent. While jQuery.browser will not be removed from future versions of jQuery, every effort to use jQuery.support and proper feature detection should be made.

  • String jQuery.browser.version

    New in 1.1.3 !

    The version number of the rendering engine for the user's browser.

  • Array jQuery.unique( [Array] array )

    New in 1.1.3 !

    Sorts an array of DOM elements, in place, with the duplicates removed. Note that this only works on arrays of DOM elements, not strings or numbers.

  • Element event.relatedTarget

    New in 1.1.4 !

    The other DOM element involved in the event, if any.

  • Boolean jQuery.isXMLDoc( [Element] node )

    New in 1.1.4 !

    Check to see if a DOM node is within an XML document (or is an XML document).

  • JQuery(":only-child")

    New in 1.1.4 !

    Selects all elements that are the only child of their parent.

  • JQuery(":last-child")

    New in 1.1.4 !

    Selects all elements that are the last child of their parent.

  • JQuery(":first-child")

    New in 1.1.4 !

    Selects all elements that are the first child of their parent.

  • JQuery(":nth-child(index/even/odd/equation)")

    New in 1.1.4 !

    Selects all elements that are the nth-child of their parent.

  • JQuery(":has(selector)")

    New in 1.1.4 !

    Selects elements which contain at least one element that matches the specified selector.

  • JQuery(":contains(text)")

    New in 1.1.4 !

    Select all elements that contain the specified text.

  • jQuery .slice( [Integer] start, [Integer] end )

    New in 1.1.4 !

    Reduce the set of matched elements to a subset specified by a range of indices.

  • JQuery(":animated")

    New in 1.2 !

    Select all elements that are in the progress of an animation at the time the selector is run.

  • JQuery(":header")

    New in 1.2 !

    Selects all elements that are headers, like h1, h2, h3 and so on.

  • jQuery .dequeue( [String] queueName )

    New in 1.2 !

    Execute the next function on the queue for the matched elements.

  • jQuery .queue( [String] queueName, [Function] callback( next ) )

    New in 1.2 !

    Manipulate the queue of functions to be executed on the matched elements.

  • Object .triggerHandler( [String] eventType, [Array] extraParameters )

    New in 1.2 !

    Execute all handlers attached to an element for an event.

  • Array .serializeArray( )

    New in 1.2 !

    Encode a set of form elements as an array of names and values.

  • jQuery .stop( [Boolean] clearQueue, [Boolean] jumpToEnd )

    New in 1.2 !

    Stop the currently-running animation on the matched elements.

  • jQuery .andSelf( )

    New in 1.2 !

    Add the previous set of elements on the stack to the current set.

  • jQuery .prevAll( [Selector] selector )

    New in 1.2 !

    Get all preceding siblings of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .nextAll( [String] selector )

    New in 1.2 !

    Get all following siblings of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .contents( )

    New in 1.2 !

    Get the children of each element in the set of matched elements, including text nodes.

  • String jQuery.param( [Array|Object] obj, [Boolean] traditional )

    New in 1.4 !

    Create a serialized representation of an array or object, suitable for use in a URL query string or Ajax request.

  • boolean jQuery.isFunction( [Object] obj )

    New in 1.2 !

    Determine if the argument passed is a Javascript function object.

  • Number jQuery.inArray( [Any] value, [Array] array )

    New in 1.2 !

    Search for a specified value within an array and return its index (or -1 if not found).

  • Array jQuery.makeArray( [Object] obj )

    New in 1.2 !

    Convert an array-like object into a true JavaScript array.

  • Object .position( )

    New in 1.2 !

    Get the current coordinates of the first element in the set of matched elements, relative to the offset parent.

  • jQuery .offset( [Function] function(index, coords) )

    New in 1.4 !

    Set the current coordinates of every element in the set of matched elements, relative to the document.

  • jQuery .replaceAll( )

    New in 1.2 !

    Replace each target element with the set of matched elements.

  • jQuery .replaceWith( [Function] function )

    New in 1.4 !

    Replace each element in the set of matched elements with the provided new content.

  • jQuery .wrapInner( [Function] wrappingFunction )

    New in 1.4 !

    Wrap an HTML structure around the content of each element in the set of matched elements.

  • jQuery .wrapAll( [String|Selector|Element|jQuery] wrappingElement )

    New in 1.2 !

    Wrap an HTML structure around all elements in the set of matched elements.

  • jQuery .map( [Function] callback(index, domElement) )

    New in 1.2 !

    Pass each element in the current matched set through a function, producing a new jQuery object containing the return values.

  • Boolean .hasClass( [String] className )

    New in 1.2 !

    Determine whether any of the matched elements are assigned the given class.

  • jQuery jQuery.removeData( [Element] element, [String] name )

    New in 1.2.3 !

    Remove a previously-stored piece of data.

  • Object jQuery.data( [Element] element )

    New in 1.4 !

    Returns value at named data store for the element, as set by , or the full data store for the element.

  • jQuery .removeData( [String] name )

    New in 1.2.3 !

    Remove a previously-stored piece of data.

  • Object .data( )

    New in 1.4 !

    Returns value at named data store for the element, as set by data(name, value).

  • Number event.timeStamp

    New in 1.2.6 !

    This attribute returns the number of milliseconds since January 1, 1970, when the event is triggered.

  • Integer .outerWidth( [Boolean] includeMargin )

    New in 1.2.6 !

    Get the current computed width for the first element in the set of matched elements, including padding and border.

  • Integer .outerHeight( [Boolean] includeMargin )

    New in 1.2.6 !

    Get the current computed height for the first element in the set of matched elements, including padding, border, and optionally margin.

  • Integer .innerWidth( )

    New in 1.2.6 !

    Get the current computed width for the first element in the set of matched elements, including padding but not border.

  • Integer .innerHeight( )

    New in 1.2.6 !

    Get the current computed height for the first element in the set of matched elements, including padding but not border.

  • jQuery .scrollLeft( [Number] value )

    New in 1.2.6 !

    Set the current horizontal position of the scroll bar for each of the set of matched elements.

  • jQuery .scrollTop( [Number] value )

    New in 1.2.6 !

    Set the current vertical position of the scroll bar for each of the set of matched elements.

  • Boolean event.isImmediatePropagationStopped( )

    New in 1.3 !

    Returns whether event.stopImmediatePropagation() was ever called on this event object.

  • event.stopImmediatePropagation( )

    New in 1.3 !

    Keeps the rest of the handlers from being executed and prevents the event from bubbling up the DOM tree

  • Boolean event.isPropagationStopped( )

    New in 1.3 !

    Returns whether was ever called on this event object.

  • Boolean event.isDefaultPrevented( )

    New in 1.3 !

    Returns whether was ever called on this event object.

  • Object event.result

    New in 1.3 !

    This attribute contains the last value returned by an event handler that was triggered by this event, unless the value was .

  • Element event.currentTarget

    New in 1.3 !

    The current DOM element within the event bubbling phase.

  • Boolean jQuery.fx.off

    New in 1.3 !

    Globally disable all animations.

  • jQuery jQuery.pushStack( [Array] elements, [String] name, [Array] arguments )

    New in 1.3 !

    Add a collection of DOM elements onto the jQuery stack.

  • jQuery jQuery.dequeue( [Element] element, [String] queueName )

    New in 1.3 !

    Execute the next function on the queue for the matched element.

  • jQuery jQuery.queue( [Element] element, [String] queueName, [Function] callback() )

    New in 1.3 !

    Manipulate the queue of functions to be executed on the matched element.

  • jQuery .die( [String] eventType, [String] handler )

    New in 1.3 !

    Remove an event handler previously attached using from the elements.

  • jQuery .live( [String] eventType, [Object] eventData, [Function] handler )

    New in 1.4 !

    Attach a handler to the event for all elements which match the current selector, now or in the future.

  • Array .closest( [Array] selectors, [Element] context )

    New in 1.4 !

    Gets an array of all the elements and selectors matched against the current element up through the DOM tree.

  • String selector

    New in 1.3 !

    A selector representing selector originally passed to jQuery().

  • Element context

    New in 1.3 !

    The DOM node context originally passed to jQuery(); if none was passed then context will likely be the document.

  • jQuery .toggle( [Boolean] showOrHide )

    New in 1.3 !

    Display or hide the matched elements.

  • boolean jQuery.isArray( [Object] obj )

    New in 1.3 !

    Determine whether the argument is an array.

  • Object jQuery.support

    New in 1.3 !

    A collection of properties that represent the presence of different browser features or bugs.

  • jQuery .toggleClass( [Function] function(index, class), [Boolean] switch )

    New in 1.4 !

    Add or remove one or more classes from each element in the set of matched elements, depending on either the class's presence or the value of the switch argument.

  • Function jQuery.proxy( [Object] context, [String] name )

    New in 1.4 !

    Takes a function and returns a new one that will always have a particular context.

  • jQuery .focusout( [Function] handler(eventObject) )

    New in 1.4 !

    Bind an event handler to the "focusout" JavaScript event.

  • jQuery .focusin( [Function] handler(eventObject) )

    New in 1.4 !

    Bind an event handler to the "focusin" JavaScript event.

  • jQuery .has( [Element] contained )

    New in 1.4 !

    Reduce the set of matched elements to those that have a descendant that matches the selector or DOM element.

  • Boolean jQuery.contains( [Element] container, [Element] contained )

    New in 1.4 !

    Check to see if a DOM node is within another DOM node.

  • Function jQuery.noop( )

    New in 1.4 !

    An empty function.

  • jQuery .delay( [Integer] duration, [String] queueName )

    New in 1.4 !

    Set a timer to delay execution of subsequent items in the queue.

  • jQuery .parentsUntil( [Selector] selector )

    New in 1.4 !

    Get the ancestors of each element in the current set of matched elements, up to but not including the element matched by the selector.

  • jQuery .prevUntil( [Selector] selector )

    New in 1.4 !

    Get all preceding siblings of each element up to but not including the element matched by the selector.

  • jQuery .nextUntil( [Selector] selector )

    New in 1.4 !

    Get all following siblings of each element up to but not including the element matched by the selector.

  • Object jQuery.data( [Element] element )

    New in 1.4 !

    Returns value at named data store for the element, as set by , or the full data store for the element.

  • jQuery .clearQueue( [String] queueName )

    New in 1.4 !

    Remove from the queue all items that have not yet been run.

  • Array .toArray( )

    New in 1.4 !

    Retrieve all the DOM elements contained in the jQuery set, as an array.

  • Boolean jQuery.isEmptyObject( [Object] object )

    New in 1.4 !

    Check to see if an object is empty (contains no properties).

  • Boolean jQuery.isPlainObject( [Object] object )

    New in 1.4 !

    Check to see if an object is a plain object (created using "{}" or "new Object").

  • Number .index( [Element|jQuery] element )

    New in 1.0 !

    Search for a given element from among the matched elements.

  • Object .data( )

    New in 1.4 !

    Returns value at named data store for the element, as set by data(name, value).

  • jQuery .bind( [Object] events )

    New in 1.4 !

    Attach a handler to an event for the elements.

  • jQuery .first( )

    New in 1.4 !

    Reduce the set of matched elements to the first in the set.

  • jQuery .last( )

    New in 1.4 !

    Reduce the set of matched elements to the final one in the set.

  • jQuery jQuery( [Function] callback )

    New in 1.0 !

    Binds a function to be executed when the DOM has finished loading.

  • Array .closest( [Array] selectors, [Element] context )

    New in 1.4 !

    Gets an array of all the elements and selectors matched against the current element up through the DOM tree.

  • jQuery .add( [Selector] selector, [Element] context )

    New in 1.4 !

    Add elements to the set of matched elements.

  • jQuery .not( [Function] function(index) )

    New in 1.4 !

    Remove elements from the set of matched elements.

  • String jQuery.param( [Array|Object] obj, [Boolean] traditional )

    New in 1.4 !

    Create a serialized representation of an array or object, suitable for use in a URL query string or Ajax request.

  • jQuery .offset( [Function] function(index, coords) )

    New in 1.4 !

    Set the current coordinates of every element in the set of matched elements, relative to the document.

  • jQuery .css( [Map] map )

    New in 1.0 !

    Set one or more CSS properties for the set of matched elements.

  • jQuery .unwrap( )

    New in 1.4 !

    Remove the parents of the set of matched elements from the DOM, leaving the matched elements in their place.

  • jQuery .detach( [Selector] selector )

    New in 1.4 !

    Remove the set of matched elements from the DOM.

  • jQuery .replaceWith( [Function] function )

    New in 1.4 !

    Replace each element in the set of matched elements with the provided new content.

  • jQuery .wrapInner( [Function] wrappingFunction )

    New in 1.4 !

    Wrap an HTML structure around the content of each element in the set of matched elements.

  • jQuery .wrapAll( [String|Selector|Element|jQuery] wrappingElement )

    New in 1.2 !

    Wrap an HTML structure around all elements in the set of matched elements.

  • jQuery .wrap( [Function] wrappingFunction )

    New in 1.4 !

    Wrap an HTML structure around each element in the set of matched elements.

  • jQuery .before( [Function] function )

    New in 1.4 !

    Insert content, specified by the parameter, before each element in the set of matched elements.

  • jQuery .after( [Function] function(index) )

    New in 1.4 !

    Insert content, specified by the parameter, after each element in the set of matched elements.

  • jQuery .prepend( [Function] function(index, html) )

    New in 1.4 !

    Insert content, specified by the parameter, to the beginning of each element in the set of matched elements.

  • jQuery .append( [Function] function(index, html) )

    New in 1.4 !

    Insert content, specified by the parameter, to the end of each element in the set of matched elements.

  • jQuery .val( [Function] function(index, value) )

    New in 1.4 !

    Set the value of each element in the set of matched elements.

  • jQuery .text( [Function] function(index, text) )

    New in 1.4 !

    Set the content of each element in the set of matched elements to the specified text.

  • jQuery .html( [Function] function(index, oldhtml) )

    New in 1.4 !

    Set the HTML contents of each element in the set of matched elements.

  • jQuery .toggleClass( [Function] function(index, class), [Boolean] switch )

    New in 1.4 !

    Add or remove one or more classes from each element in the set of matched elements, depending on either the class's presence or the value of the switch argument.

  • jQuery .removeClass( [Function] function(index, class) )

    New in 1.4 !

    Remove a single class, multiple classes, or all classes from each element in the set of matched elements.

  • jQuery .removeAttr( [String] attributeName )

    New in 1.0 !

    Remove an attribute from each element in the set of matched elements.

  • jQuery .addClass( [Function] function(index, class) )

    New in 1.4 !

    Adds the specified class(es) to each of the set of matched elements.

  • jQuery.error( [String] message )

    New in 1.4.1 !

    Takes a string and throws an exception containing it.

  • Object jQuery.parseJSON( [String] json )

    New in 1.4.1 !

    Takes a well-formed JSON string and returns the resulting JavaScript object.

  • jQuery .die( [String] eventType, [String] handler )

    New in 1.3 !

    Remove an event handler previously attached using from the elements.

  • jQuery .width( [Function] function(index, width) )

    New in 1.4.1 !

    Set the CSS width of each element in the set of matched elements.

  • jQuery .height( [Function] function(index, height) )

    New in 1.4.1 !

    Set the CSS height of every matched element.

  • jQuery .undelegate( [String] selector, [String] eventType, [Function] handler )

    New in 1.4.2 !

    Remove a handler from the event for all elements which match the current selector, now or in the future, based upon a specific set of root elements.

  • jQuery .delegate( [String] selector, [String] eventType, [Object] eventData, [Function] handler )

    New in 1.4.2 !

    Attach a handler to one or more events for all elements that match the selector, now or in the future, based on a specific set of root elements.

© 2010 The jQuery Project

  • Download
  • Documentation
  • Tutorials
  • Bug Tracker
  • Discussion


Ajax – jQuery API

Ajax

  • jQuery .ajaxComplete( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

    New in 1.0 !

    Register a handler to be called when Ajax requests complete. This is an .

  • jQuery .ajaxSuccess( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

    New in 1.0 !

  • jQuery .ajaxStop( [Function] handler() )

    New in 1.0 !

    Register a handler to be called when all Ajax requests have completed. This is an .

  • jQuery .ajaxStart( [Function] handler() )

    New in 1.0 !

    Register a handler to be called when the first Ajax request begins. This is an .

  • jQuery .ajaxSend( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

    New in 1.0 !

  • jQuery .ajaxError( [Function] handler(event, XMLHttpRequest, ajaxOptions, thrownError) )

    New in 1.0 !

    Register a handler to be called when Ajax requests complete with an error. This is an .

  • Array .serializeArray( )

    New in 1.2 !

    Encode a set of form elements as an array of names and values.

  • String .serialize( )

    New in 1.0 !

    Encode a set of form elements as a string for submission.

  • String jQuery.param( [Array|Object] obj, [Boolean] traditional )

    New in 1.4 !

    Create a serialized representation of an array or object, suitable for use in a URL query string or Ajax request.

  • jQuery.ajaxSetup( [Options] options )

    New in 1.1 !

    Set default values for future Ajax requests.

  • XMLHttpRequest jQuery.ajax( [Map] settings )

    New in 1.0 !

    Perform an asynchronous HTTP (Ajax) request.

  • XMLHttpRequest jQuery.post( [String] url, [Map|String] data, [Function] success(data, textStatus, XMLHttpRequest), [String] dataType )

    New in 1.0 !

    Load data from the server using a HTTP POST request.

  • XMLHttpRequest jQuery.getScript( [String] url, [Function] success(data, textStatus) )

    New in 1.0 !

    Load a JavaScript file from the server using a GET HTTP request, then execute it.

  • XMLHttpRequest jQuery.getJSON( [String] url, [Map] data, [Function] callback(data, textStatus) )

    New in 1.0 !

    Load JSON-encoded data from the server using a GET HTTP request.

  • XMLHttpRequest jQuery.get( [String] url, [Map|String] data, [Function] callback(data, textStatus, XMLHttpRequest), [String] dataType )

    New in 1.0 !

    Load data from the server using a HTTP GET request.

  • jQuery .load( [String] url, [Map|String] data, [Function] complete(responseText, textStatus, XMLHttpRequest) )

    New in 1.0 !

    Load data from the server and place the returned HTML into the matched element.

© 2010 The jQuery Project


Global Ajax Event Handlers – jQuery API

Global Ajax Event Handlers

  • jQuery .ajaxComplete( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

    New in 1.0 !

    Register a handler to be called when Ajax requests complete. This is an .

  • jQuery .ajaxSuccess( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

    New in 1.0 !

  • jQuery .ajaxStop( [Function] handler() )

    New in 1.0 !

    Register a handler to be called when all Ajax requests have completed. This is an .

  • jQuery .ajaxStart( [Function] handler() )

    New in 1.0 !

    Register a handler to be called when the first Ajax request begins. This is an .

  • jQuery .ajaxSend( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

    New in 1.0 !

  • jQuery .ajaxError( [Function] handler(event, XMLHttpRequest, ajaxOptions, thrownError) )

    New in 1.0 !

    Register a handler to be called when Ajax requests complete with an error. This is an .


ajaxComplete – jQuery API

Returns: jQueryjQuery .ajaxComplete( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

Categories: Global Ajax Event Handlers, Version 1.0
Description: Register a handler to be called when Ajax requests complete. This is an .
  • version added: 1.0

  • .ajaxComplete( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

  • handler(event, XMLHttpRequest, ajaxOptions) The function to be invoked.

Whenever an Ajax request completes, jQuery triggers the event. Any and all handlers that have been registered with the method are executed at this time.

To observe this method in action, we can set up a basic Ajax load request:

<div class="trigger">Trigger</div>
<div class="result"></div>
<div class="log"></div>

We can attach our event handler to any element:

$('.log').ajaxComplete(function() {
  $(this).text('Triggered ajaxComplete handler.');
});

Now, we can make an Ajax request using any jQuery method:

$('.trigger').click(function() {
  $('.result').load('ajax/test.html');
});

When the user clicks the button and the Ajax request completes, the log message is displayed.

Because is implemented as a method of jQuery object instances, we can use the keyword as we do here to refer to the selected elements within the callback function.

All handlers are invoked, regardless of what Ajax request was completed. If we must differentiate between the requests, we can use the parameters passed to the handler. Each time an handler is executed, it is passed the event object, the object, and the settings object that was used in the creation of the request. For example, we can restrict our callback to only handling events dealing with a particular URL:

$('.log').ajaxComplete(function(e, xhr, settings) {
  if (settings.url == 'ajax/test.html') {
    $(this).text('Triggered ajaxComplete handler.');
  }
});

Examples:

Example:

Show a message when an Ajax request completes.
<script>$("#msg").ajaxComplete(function(event,request, settings){
   $(this).append("<li>Request Complete.</li>");
 });</script>

Comments

© 2010 The jQuery Project


ajaxSuccess – jQuery API

Returns: jQueryjQuery .ajaxSuccess( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

Categories: Global Ajax Event Handlers, Version 1.0
Description:
  • version added: 1.0

  • .ajaxSuccess( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

  • handler(event, XMLHttpRequest, ajaxOptions) The function to be invoked.

Whenever an Ajax request completes successfully, jQuery triggers the event. Any and all handlers that have been registered with the method are executed at this time.

To observe this method in action, we can set up a basic Ajax load request:

<div class="trigger">Trigger</div>
<div class="result"></div>
<div class="log"></div>

We can attach our event handler to any element:

$('.log').ajaxSuccess(function() {
  $(this).text('Triggered ajaxSuccess handler.');
});

Now, we can make an Ajax request using any jQuery method:

$('.trigger').click(function() {
  $('.result').load('ajax/test.html');
});

When the user clicks the button and the Ajax request completes successfully, the log message is displayed.

Because is implemented as a method of jQuery object instances, we can use the keyword as we do here to refer to the selected elements within the callback function.

All handlers are invoked, regardless of what Ajax request was completed. If we must differentiate between the requests, we can use the parameters passed to the handler. Each time an handler is executed, it is passed the event object, the object, and the settings object that was used in the creation of the request. For example, we can restrict our callback to only handling events dealing with a particular URL:

$('.log').ajaxSuccess(function(e, xhr, settings) {
  if (settings.url == 'ajax/test.html') {
    $(this).text('Triggered ajaxSuccess handler.');
  }
});

Examples:

Example:

Show a message when an Ajax request completes successfully.
<script>$("#msg").ajaxSuccess(function(evt, request, settings){
      $(this).append("<li>Successful Request!</li>");
      });</script>

Comments

© 2010 The jQuery Project


ajaxStop – jQuery API

Returns: jQueryjQuery .ajaxStop( [Function] handler() )

Categories: Global Ajax Event Handlers, Version 1.0
Description: Register a handler to be called when all Ajax requests have completed. This is an .
  • version added: 1.0

  • .ajaxStop( [Function] handler() )

  • handler() The function to be invoked.

Whenever an Ajax request completes, jQuery checks whether there are any other outstanding Ajax requests. If none remain, jQuery triggers the event. Any and all handlers that have been registered with the method are executed at this time.

To observe this method in action, we can set up a basic Ajax load request:

<div class="trigger">Trigger</div>
<div class="result"></div>
<div class="log"></div>

We can attach our event handler to any element:

$('.log').ajaxStop(function() {
  $(this).text('Triggered ajaxStop handler.');
});

Now, we can make an Ajax request using any jQuery method:

$('.trigger').click(function() {
  $('.result').load('ajax/test.html');
});

When the user clicks the button and the Ajax request completes, the log message is displayed.

Because is implemented as a method of jQuery object instances, we can use the keyword as we do here to refer to the selected elements within the callback function.

Examples:

Example:

Hide a loading message after all the Ajax requests have stopped.
<script>$("#loading").ajaxStop(function(){
      $(this).hide();
      });</script>

Comments

© 2010 The jQuery Project


ajaxStart – jQuery API

Returns: jQueryjQuery .ajaxStart( [Function] handler() )

Categories: Global Ajax Event Handlers, Version 1.0
Description: Register a handler to be called when the first Ajax request begins. This is an .
  • version added: 1.0

  • .ajaxStart( [Function] handler() )

  • handler() The function to be invoked.

Whenever an Ajax request is about to be sent, jQuery checks whether there are any other outstanding Ajax requests. If none are in progress, jQuery triggers the event. Any and all handlers that have been registered with the method are executed at this time.

To observe this method in action, we can set up a basic Ajax load request:

<div class="trigger">Trigger</div>
<div class="result"></div>
<div class="log"></div>

We can attach our event handler to any element:

$('.log').ajaxStart(function() {
  $(this).text('Triggered ajaxStart handler.');
});

Now, we can make an Ajax request using any jQuery method:

$('.trigger').click(function() {
  $('.result').load('ajax/test.html');
});

When the user clicks the button and the Ajax request is sent, the log message is displayed.

Because is implemented as a method of jQuery object instances, we can use the keyword as we do here to refer to the selected elements within the callback function.

Examples:

Example:

Show a loading message whenever an Ajax request starts (and none is already active).
<script>$("#loading").ajaxStart(function(){
   $(this).show();
 });</script>

Comments

© 2010 The jQuery Project


ajaxSend – jQuery API

Returns: jQueryjQuery .ajaxSend( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

Categories: Global Ajax Event Handlers, Version 1.0
Description:
  • version added: 1.0

  • .ajaxSend( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

  • handler(event, XMLHttpRequest, ajaxOptions) The function to be invoked.

Whenever an Ajax request is about to be sent, jQuery triggers the event. Any and all handlers that have been registered with the method are executed at this time.

To observe this method in action, we can set up a basic Ajax load request:

<div class="trigger">Trigger</div>
<div class="result"></div>
<div class="log"></div>

We can attach our event handler to any element:

$('.log').ajaxSend(function() {
  $(this).text('Triggered ajaxSend handler.');
});

Now, we can make an Ajax request using any jQuery method:

$('.trigger').click(function() {
  $('.result').load('ajax/test.html');
});

When the user clicks the button and the Ajax request is about to begin, the log message is displayed.

Because is implemented as a method of jQuery instances, we can use the keyword as we do here to refer to the selected elements within the callback function.

All handlers are invoked, regardless of what Ajax request is to be sent. If we must differentiate between the requests, we can use the parameters passed to the handler. Each time an handler is executed, it is passed the event object, the object, and the that was used in the creation of the Ajax request. For example, we can restrict our callback to only handling events dealing with a particular URL:

$('.log').ajaxSend(function(e, xhr, settings) {
  if (settings.url == 'ajax/test.html') {
    $(this).text('Triggered ajaxSend handler.');
  }
});

Examples:

Example:

Show a message before an Ajax request is sent.
<script>$("#msg").ajaxSend(function(evt, request, settings){
        $(this).append("<li>Starting request at " + settings.url + "</li>");
      });</script>

Comments

© 2010 The jQuery Project


ajaxError – jQuery API

Returns: jQueryjQuery .ajaxError( [Function] handler(event, XMLHttpRequest, ajaxOptions, thrownError) )

Categories: Global Ajax Event Handlers, Version 1.0
Description: Register a handler to be called when Ajax requests complete with an error. This is an .
  • version added: 1.0

  • .ajaxError( [Function] handler(event, XMLHttpRequest, ajaxOptions, thrownError) )

  • handler(event, XMLHttpRequest, ajaxOptions, thrownError) The function to be invoked.

Whenever an Ajax request completes with an error, jQuery triggers the event. Any and all handlers that have been registered with the method are executed at this time.

To observe this method in action, we can set up a basic Ajax load request:

<div class="trigger">Trigger</div>
<div class="result"></div>
<div class="log"></div>

We can attach our event handler to any element:

$('.log').ajaxError(function() {
  $(this).text('Triggered ajaxError handler.');
});

Now, we can make an Ajax request using any jQuery method:

$('.trigger').click(function() {
  $('.result').load('ajax/missing.html');
});

When the user clicks the button and the Ajax request fails, because the requested file is missing, the log message is displayed.

Because is implemented as a method of jQuery object instances, we can use the keyword as we do here to refer to the selected elements within the callback function.

All handlers are invoked, regardless of what Ajax request was completed. If we must differentiate between the requests, we can use the parameters passed to the handler. Each time an handler is executed, it is passed the event object, the object, and the settings object that was used in the creation of the request. If the request failed because JavaScript raised an exception, the exception object is passed to the handler as a fourth parameter. For example, we can restrict our callback to only handling events dealing with a particular URL:

$('.log').ajaxError(function(e, xhr, settings, exception) {
  if (settings.url == 'ajax/missing.html') {
    $(this).text('Triggered ajaxError handler.');
  }
});

Examples:

Example:

Show a message when an Ajax request fails.
<script>$("#msg").ajaxError(function(event, request, settings){
   $(this).append("<li>Error requesting page " + settings.url + "</li>");
 });</script>

Comments

© 2010 The jQuery Project


Helper Functions – jQuery API

Helper Functions

  • Array .serializeArray( )

    New in 1.2 !

    Encode a set of form elements as an array of names and values.

  • String .serialize( )

    New in 1.0 !

    Encode a set of form elements as a string for submission.

  • String jQuery.param( [Array|Object] obj, [Boolean] traditional )

    New in 1.4 !

    Create a serialized representation of an array or object, suitable for use in a URL query string or Ajax request.


serializeArray – jQuery API

Returns: ArrayArray .serializeArray( )

Categories: Forms, Helper Functions, Version 1.2
Description: Encode a set of form elements as an array of names and values.
  • version added: 1.2

  • .serializeArray( )

The method creates a JavaScript array of objects, ready to be encoded as a JSON string. It operates on a jQuery object representing a set of form elements. The form elements can be of several types:

<form>
  <div><input type="text" name="a" value="1" id="a" /></div>
  <div><input type="text" name="b" value="2" id="b" /></div>
  <div><input type="hidden" name="c" value="3" id="c" /></div>
  <div>
    <textarea name="d" rows="8" cols="40">4</textarea>
  </div>
  <div><select name="e">
    <option value="5" selected="selected">5</option>
    <option value="6">6</option>
    <option value="7">7</option>
  </select></div>
  <div>
    <input type="checkbox" name="f" value="8" id="f" />
  </div>
  <div>
    <input type="submit" name="g" value="Submit" id="g" />
  </div>
</form>

The method uses the standard W3C rules for to determine which elements it should include; in particular the element cannot be disabled and must contain a attribute. No submit button value is serialized since the form was not submitted using a button. Data from file select elements is not serialized.

This method can act on a jQuery object that has selected individual form elements, such as , , and . However, it is typically easier to select the tag itself for serialization:

$('form').submit(function() {
  alert($(this).serializeArray());
  return false;
});

This produces the following data structure:

[
  {
    name: a
    value: 1
  },
  {
    name: b
    value: 2
  },
  {
    name: c
    value: 3
  },
  {
    name: d
    value: 4
  },
  {
    name: e
    value: 5
  }
]

Examples:

Example:

Get the values from a form, iterate through them, and append them to a results display.
<!DOCTYPE html>
<html>
<head>
  <style>
  body, select { font-size:14px; }
  form { margin:5px; }
  p { color:red; margin:5px; }
  b { color:blue; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p><b>Results:</b> <span id="results"></span></p>

  <form>
    <select name="single">
      <option>Single</option>
      <option>Single2</option>

    </select>
    <select name="multiple" multiple="multiple">
      <option selected="selected">Multiple</option>
      <option>Multiple2</option>

      <option selected="selected">Multiple3</option>
    </select><br/>
    <input type="checkbox" name="check" value="check1" id="ch1"/>

    <label for="ch1">check1</label>
    <input type="checkbox" name="check" value="check2" checked="checked" id="ch2"/>

    <label for="ch2">check2</label>
    <input type="radio" name="radio" value="radio1" checked="checked" id="r1"/>

    <label for="r1">radio1</label>
    <input type="radio" name="radio" value="radio2" id="r2"/>

    <label for="r2">radio2</label>
  </form>
  <script>

    function showValues() {
      var fields = $(":input").serializeArray();
      $("#results").empty();
      jQuery.each(fields, function(i, field){
        $("#results").append(field.value + " ");
      });
    }

    $(":checkbox, :radio").click(showValues);
    $("select").change(showValues);
    showValues();
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


serialize – jQuery API

Returns: StringString .serialize( )

Categories: Forms, Helper Functions, Version 1.0
Description: Encode a set of form elements as a string for submission.
  • version added: 1.0

  • .serialize( )

The method creates a text string in standard URL-encoded notation. It operates on a jQuery object representing a set of form elements. The form elements can be of several types:

<form>
  <div><input type="text" name="a" value="1" id="a" /></div>
  <div><input type="text" name="b" value="2" id="b" /></div>
  <div><input type="hidden" name="c" value="3" id="c" /></div>
  <div>
    <textarea name="d" rows="8" cols="40">4</textarea>
  </div>
  <div><select name="e">
    <option value="5" selected="selected">5</option>
    <option value="6">6</option>
    <option value="7">7</option>
  </select></div>
  <div>
    <input type="checkbox" name="f" value="8" id="f" />
  </div>
  <div>
    <input type="submit" name="g" value="Submit" id="g" />
  </div>
</form>

The method can act on a jQuery object that has selected individual form elements, such as , , and . However, it is typically easier to select the tag itself for serialization:

$('form').submit(function() {
  alert($(this).serialize());
  return false;
});

This produces a standard-looking query string:

a=1&b=2&c=3&d=4&e=5

Note: Only are serialized to the string. No submit button value is serialized since the form was not submitted using a button. For a form element's value to be included in the serialized string, the element must have a attribute. Data from file select elements is not serialized.

Examples:

Example:

Serialize a form to a query string, that could be sent to a server in an Ajax request.
<!DOCTYPE html>
<html>
<head>
  <style>
  body, select { font-size:12px; }
  form { margin:5px; }
  p { color:red; margin:5px; font-size:14px; }
  b { color:blue; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<form>
    <select name="single">
      <option>Single</option>
      <option>Single2</option>
    </select>

<br />
    <select name="multiple" multiple="multiple">
      <option selected="selected">Multiple</option>
      <option>Multiple2</option>

      <option selected="selected">Multiple3</option>
    </select>
<br/>
    <input type="checkbox" name="check" value="check1" id="ch1"/>

    <label for="ch1">check1</label>

    <input type="checkbox" name="check" value="check2" checked="checked" id="ch2"/>

    <label for="ch2">check2</label>
<br />
    <input type="radio" name="radio" value="radio1" checked="checked" id="r1"/>

    <label for="r1">radio1</label>
    <input type="radio" name="radio" value="radio2" id="r2"/>

    <label for="r2">radio2</label>
  </form>
  <p><tt id="results"></tt></p>
  <script>
    function showValues() {
      var str = $("form").serialize();
      $("#results").text(str);
    }
    $(":checkbox, :radio").click(showValues);
    $("select").change(showValues);
    showValues();
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


jQuery.param – jQuery API

  • jQuery.param( [Array|Object] obj )

    • 1.2jQuery.param( [Array|Object] obj )

  • jQuery.param( [Array|Object] obj, [Boolean] traditional )

    • 1.4jQuery.param( [Array|Object] obj, [Boolean] traditional )

Returns: StringString jQuery.param( [Array|Object] obj, [Boolean] traditional )

Categories: Collection Manipulation, Forms, Helper Functions, Version 1.2, Version 1.4
Description: Create a serialized representation of an array or object, suitable for use in a URL query string or Ajax request.
  • version added: 1.2

  • jQuery.param( [Array|Object] obj )

  • obj An array or object to serialize.
  • version added: 1.4

  • jQuery.param( [Array|Object] obj, [Boolean] traditional )

  • obj An array or object to serialize.
  • traditional A Boolean indicating whether to perform a traditional "shallow" serialization.

This function is used internally to convert form element values into a serialized string representation (See for more information).

As of jQuery 1.3, the return value of a function is used instead of the function as a String.

As of jQuery 1.4, the method serializes deep objects recursively to accommodate modern scripting languages and frameworks such as PHP and Ruby on Rails. You can disable this functionality globally by setting .

If the object passed is in an Array, it must be an array of objects in the format returned by

[{name:"first",value:"Rick"},
{name:"last",value:"Astley"},
{name:"job",value:"Rock Star"}]

Note: Because some frameworks have limited ability to parse serialized arrays, we should exercise caution when passing an argument that contains objects or arrays nested within another array.

In jQuery 1.4 HTML5 input elements are serialized, as well.

We can display a query string representation of an object and a URI-decoded version of the same as follows:

var myObject = {
  a: {
    one: 1,
    two: 2,
    three: 3
  },
  b: [1,2,3]
};
var recursiveEncoded = $.param(myObject);
var recursiveDecoded = decodeURIComponent($.param(myObject));

alert(recursiveEncoded);
alert(recursiveDecoded);

The values of and are alerted as follows:

To emulate the behavior of prior to jQuery 1.4, we can set the argument to :

var myObject = {
  a: {
    one: 1,
    two: 2,
    three: 3
  },
  b: [1,2,3]
};
var shallowEncoded = $.param(myObject, true);
var shallowDecoded = decodeURIComponent(shallowEncoded);

alert(shallowEncoded);
alert(shallowDecoded);

The values of and are alerted as follows:

Examples:

Example:

Serialize a key/value object.
<!DOCTYPE html>
<html>
<head>
  <style>
div { color:red; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div id="results"></div>
  <script>

    var params = { width:1680, height:1050 };
    var str = jQuery.param(params);
    $("#results").text(str);
</script>
</body>
</html>

Demo:

Example:

Serialize a few complex objects
<script>
// <=1.3.2:
$.param({ a: [2,3,4] }) // "a=2&a=3&a=4"
// >=1.4:
$.param({ a: [2,3,4] }) // "a[]=2&a[]=3&a[]=4"

// <=1.3.2:
$.param({ a: { b:1,c:2 }, d: [3,4,{ e:5 }] }) // "a=[object+Object]&d=3&d=4&d=[object+Object]"
// >=1.4:
$.param({ a: { b:1,c:2 }, d: [3,4,{ e:5 }] }) // "a[b]=1&a[c]=2&d[]=3&d[]=4&d[2][e]=5"

</script>

Comments

© 2010 The jQuery Project


Low-Level Interface – jQuery API

Low-Level Interface

  • jQuery.ajaxSetup( [Options] options )

    New in 1.1 !

    Set default values for future Ajax requests.

  • XMLHttpRequest jQuery.ajax( [Map] settings )

    New in 1.0 !

    Perform an asynchronous HTTP (Ajax) request.


jQuery.ajaxSetup – jQuery API

Returns: jQuery.ajaxSetup( [Options] options )

Categories: Low-Level Interface, Version 1.1
Description: Set default values for future Ajax requests.
  • version added: 1.1

  • jQuery.ajaxSetup( [Options] options )

  • options A set of key/value pairs that configure the default Ajax request. All options are optional.

For details on the settings available for , see .

All subsequent Ajax calls using any function will use the new settings, unless overridden by the individual calls, until the next invocation of .

For example, we could set a default for the URL parameter before pinging the server repeatedly:

$.ajaxSetup({
  url: 'ping.php',
});

Now each time an Ajax request is made, this URL will be used automatically:

$.ajax({
  data: {'name': 'Tim'},
});

Examples:

Example:

Sets the defaults for Ajax requests to the url "/xmlhttp/", disables global handlers and uses POST instead of GET. The following Ajax requests then sends some data without having to set anything else.
<script>$.ajaxSetup({
   url: "/xmlhttp/",
   global: false,
   type: "POST"

 });
 $.ajax({ data: myData });</script>

Comments

© 2010 The jQuery Project


jQuery.ajax – jQuery API

Returns: XMLHttpRequestXMLHttpRequest jQuery.ajax( [Map] settings )

Categories: Low-Level Interface, Version 1.0
Description: Perform an asynchronous HTTP (Ajax) request.
  • version added: 1.0

  • jQuery.ajax( [Map] settings )

  • settings A set of key/value pairs that configure the Ajax request. All options are optional. A default can be set for any option with .

The function underlies all Ajax requests sent by jQuery. It is often unnecessary to directly call this function, as several higher-level alternatives like and are available and are easier to use. If less common options are required, though, can be used more flexibly.

At its simplest, the function can be called with no arguments:

$.ajax();

Default settings can be set globally by using the function.

This example, using no options, loads the contents of the current page, but does nothing with the result. To use the result, we can implement one of the callback functions.

Callback Functions

The , , , and options all take callback functions that are invoked at the appropriate times:

To make use of the returned HTML, we can implement a handler:

$.ajax({
  url: 'ajax/test.html',
  success: function(data) {
    $('.result').html(data);
    alert('Load was performed.');
  }
});

Such a simple example would generally be better served by using or .

Data Types

The function relies on the server to provide information about the retrieved data. If the server reports the return data as XML, the result can be traversed using normal XML methods or jQuery's selectors. If another type is detected, such as HTML in the example above, the data is treated as text.

Different data handling can be achieved by using the option. Besides plain , the can be , , , , or .

The and types return the data with no processing. The data is simply passed on to the success handler, either through the or property of the object, respectively.

We must ensure that the MIME type reported by the web server matches our choice of . In particular, XML must be declared by the server as or for consistent results.

If is specified, any embedded JavaScript inside the retrieved data is executed before the HTML is returned as a string. Similarly, will execute the JavaScript that is pulled back from the server, then return the script itself as textual data.

The type parses the fetched data file as a JavaScript object and returns the constructed object as the result data. To do so, it uses when the browser supports it; otherwise it uses a . Malformed JSON data will throw a parse error (see for more information). JSON data is convenient for communicating structured data in a way that is concise and easy for JavaScript to parse. If the fetched data file exists on a remote server, specify the type instead.

The type appends a query string parameter of to the URL. The server should prepend the JSON data with the callback name to form a valid JSONP response. We can specify a parameter name other than with the option to .

JSONP is an extension of the JSON format, requiring some server-side code to detect and handle the query string parameter. More information about it can be found in the .

When data is retrieved from remote servers (which is only possible using the or data types), the operation is performed using a tag rather than an object. In this case, no object is returned from , nor is one passed to the handler functions such as .

Sending Data to the Server

By default, Ajax requests are sent using the GET HTTP method. If the POST method is required, the method can be specified by setting a value for the option. This option affects how the contents of the option are sent to the server. POST data will always be transmitted to the server using UTF-8 charset, per the W3C XMLHTTPRequest standard.

The option can contain either a query string of the form , or a map of the form . If the latter form is used, the data is converted into a query string before it is sent. This processing can be circumvented by setting to . The processing might be undesirable if we wish to send an XML object to the server; in this case, we would also want to change the option from to a more appropriate MIME type.

Advanced Options

The option prevents handlers registered using , , and similar methods from firing when this request would trigger them. This can be useful to, for example, suppress a loading indicator that was implemented with if the requests are frequent and brief. See the descriptions of these methods below for more details.

If the server performs HTTP authentication before providing a response, the user name and password pair can be sent via the and options.

Ajax requests are time-limited, so errors can be caught and handled to provide a better user experience. Request timeouts are usually either left at their default or set as a global default using rather than being overridden for specific requests with the option.

By default, requests are always issued, but the browser may serve results out of its cache. To disallow use of the cached results, set to . To cause the request to report failure if the asset has not been modified since the last request, set to .

The allows the character set to be explicitly specified for requests that use a tag (that is, a type of or ). This is useful if the script and host page have differing character sets.

The first letter in Ajax stands for "asynchronous," meaning that the operation occurs in parallel and the order of completion is not guaranteed. The option to defaults to , indicating that code execution can continue after the request is made. Setting this option to (and thus making the call no longer asynchronous) is strongly discouraged, as it can cause the browser to become unresponsive.

The function returns the object that it creates. Normally jQuery handles the creation of this object internally, but a custom function for manufacturing one can be specified using the option. The returned object can generally be discarded, but does provide a lower-level interface for observing and manipulating the request. In particular, calling on the object will halt the request before it completes.

Examples:

Example:

Load and execute a JavaScript file.
<script>$.ajax({
   type: "GET",
   url: "test.js",
   dataType: "script"
 });</script>

Example:

Save some data to the server and notify the user once it's complete.
<script>$.ajax({
   type: "POST",
   url: "some.php",
   data: "name=John&location=Boston",
   success: function(msg){
     alert( "Data Saved: " + msg );
   }
 });</script>

Example:

Retrieve the latest version of an HTML page.
<script>$.ajax({
  url: "test.html",
  cache: false,
  success: function(html){
    $("#results").append(html);
  }
});</script>

Example:

Loads data synchronously. Blocks the browser while the requests is active. It is better to block user interaction by other means when synchronization is necessary.
<script>var html = $.ajax({
  url: "some.php",
  async: false
 }).responseText;</script>

Example:

Sends an xml document as data to the server. By setting the processData option to false, the automatic conversion of data to strings is prevented.
<script>var xmlDocument = [create xml document];
 $.ajax({
   url: "page.php",
   processData: false,
   data: xmlDocument,
   success: handleResponse
 });</script>

Example:

Sends an id as data to the server, save some data to the server and notify the user once it's complete.
<script>bodyContent = $.ajax({
      url: "script.php",
      global: false,
      type: "POST",
      data: ({id : this.getAttribute('id')}),
      dataType: "html",
      async:false,
      success: function(msg){
         alert(msg);
      }
   }
).responseText;</script>

Comments

© 2010 The jQuery Project


Shorthand Methods – jQuery API

Shorthand Methods

  • XMLHttpRequest jQuery.post( [String] url, [Map|String] data, [Function] success(data, textStatus, XMLHttpRequest), [String] dataType )

    New in 1.0 !

    Load data from the server using a HTTP POST request.

  • XMLHttpRequest jQuery.getScript( [String] url, [Function] success(data, textStatus) )

    New in 1.0 !

    Load a JavaScript file from the server using a GET HTTP request, then execute it.

  • XMLHttpRequest jQuery.getJSON( [String] url, [Map] data, [Function] callback(data, textStatus) )

    New in 1.0 !

    Load JSON-encoded data from the server using a GET HTTP request.

  • XMLHttpRequest jQuery.get( [String] url, [Map|String] data, [Function] callback(data, textStatus, XMLHttpRequest), [String] dataType )

    New in 1.0 !

    Load data from the server using a HTTP GET request.

  • jQuery .load( [String] url, [Map|String] data, [Function] complete(responseText, textStatus, XMLHttpRequest) )

    New in 1.0 !

    Load data from the server and place the returned HTML into the matched element.


jQuery.post – jQuery API

Returns: XMLHttpRequestXMLHttpRequest jQuery.post( [String] url, [Map|String] data, [Function] success(data, textStatus, XMLHttpRequest), [String] dataType )

Categories: Shorthand Methods, Version 1.0
Description: Load data from the server using a HTTP POST request.
  • version added: 1.0

  • jQuery.post( [String] url, [Map|String] data, [Function] success(data, textStatus, XMLHttpRequest), [String] dataType )

  • url A string containing the URL to which the request is sent.
  • data A map or string that is sent to the server with the request.
  • success(data, textStatus, XMLHttpRequest) A callback function that is executed if the request succeeds.
  • dataType The type of data expected from the server.

This is a shorthand Ajax function, which is equivalent to:

$.ajax({
  type: 'POST',
  url: ,
  data: ,
  success:
  dataType:
});

The callback function is passed the returned data, which will be an XML root element or a text string depending on the MIME type of the response. It is also passed the text status of the response.

As of jQuery 1.4, the callback function is also passed the XMLHttpRequest object.

Most implementations will specify a success handler:

$.post('ajax/test.html', function(data) {
  $('.result').html(data);
});

This example fetches the requested HTML snippet and inserts it on the page.

Pages fetched with are never cached, so the and options in have no effect on these requests.

Examples:

Example:

Request the test.php page, but ignore the return results.
<script>$.post("test.php");</script>

Example:

Request the test.php page and send some additional data along (while still ignoring the return results).
<script>$.post("test.php", { name: "John", time: "2pm" } );</script>

Example:

pass arrays of data to the server (while still ignoring the return results).
<script>$.post("test.php", { 'choices[]': ["Jon", "Susan"] });</script>

Example:

send form data using ajax requests
<script>$.post("test.php", $("#testform").serialize());</script>

Example:

Alert out the results from requesting test.php (HTML or XML, depending on what was returned).
<script>$.post("test.php", function(data){
   alert("Data Loaded: " + data);
 });</script>

Example:

Alert out the results from requesting test.php with an additional payload of data (HTML or XML, depending on what was returned).
<script>$.post("test.php", { name: "John", time: "2pm" },
   function(data){
     alert("Data Loaded: " + data);
   });</script>

Example:

Gets the test.php page content, store it in a XMLHttpResponse object and applies the process() JavaScript function.
<script>$.post("test.php", { name: "John", time: "2pm" },
   function(data){
     process(data);
   }, "xml");</script>

Example:

Gets the test.php page contents which has been returned in json format ()
<script>$.post("test.php", { "func": "getNameAndTime" },
   function(data){
     alert(data.name); // John
     console.log(data.time); //  2pm
   }, "json");</script>

Comments

© 2010 The jQuery Project


jQuery.getScript – jQuery API

Returns: XMLHttpRequestXMLHttpRequest jQuery.getScript( [String] url, [Function] success(data, textStatus) )

Categories: Shorthand Methods, Version 1.0
Description: Load a JavaScript file from the server using a GET HTTP request, then execute it.
  • version added: 1.0

  • jQuery.getScript( [String] url, [Function] success(data, textStatus) )

  • url A string containing the URL to which the request is sent.
  • success(data, textStatus) A callback function that is executed if the request succeeds.

This is a shorthand Ajax function, which is equivalent to:

$.ajax({
  url: ,
  dataType: 'script',
  success:
});

The callback is passed the returned JavaScript file. This is generally not useful as the script will already have run at this point.

The script is executed in the global context, so it can refer to other variables and use jQuery functions. Included scripts should have some impact on the current page:

$('.result').html('<p>Lorem ipsum dolor sit amet.</p>');

The script can then be included and run by referencing the file name:

$.getScript('ajax/test.js', function() {
  alert('Load was performed.');
});

Examples:

Example:

We load the new dynamically and bind some color animations to occur once the new functionality is loaded.
<!DOCTYPE html>
<html>
<head>
  <style>
.block {
   background-color: blue;
   width: 150px;
   height: 70px;
   margin: 10px;
}</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button id="go">&raquo; Run</button>

<div class="block"></div>

  <script>$.getScript("http://dev.jquery.com/view/trunk/plugins/color/jquery.color.js", function(){
  $("#go").click(function(){
    $(".block").animate( { backgroundColor: 'pink' }, 1000)
      .animate( { backgroundColor: 'blue' }, 1000);
  });
});</script>
</body>
</html>

Demo:

Example:

Load the test.js JavaScript file and execute it.
<script>$.getScript("test.js");</script>

Example:

Load the test.js JavaScript file and execute it, displaying an alert message when the execution is complete.
<script>$.getScript("test.js", function(){
   alert("Script loaded and executed.");
 });</script>

Comments

© 2010 The jQuery Project


jQuery.getJSON – jQuery API

Returns: XMLHttpRequestXMLHttpRequest jQuery.getJSON( [String] url, [Map] data, [Function] callback(data, textStatus) )

Categories: Shorthand Methods, Version 1.0
Description: Load JSON-encoded data from the server using a GET HTTP request.
  • version added: 1.0

  • jQuery.getJSON( [String] url, [Map] data, [Function] callback(data, textStatus) )

  • url A string containing the URL to which the request is sent.
  • data A map or string that is sent to the server with the request.
  • callback(data, textStatus) A callback function that is executed if the request succeeds.

This is a shorthand Ajax function, which is equivalent to:

$.ajax({
  url: ,
  dataType: 'json',
  data: ,
  success:
});

The callback is passed the returned data, which will be a JavaScript object or array as defined by the JSON structure and parsed using the method.

Most implementations will specify a success handler:

$.getJSON('ajax/test.json', function(data) {
  $('.result').html('<p>' + data.foo + '</p>'
    + '<p>' + data.baz[1] + '</p>');
});

This example, of course, relies on the structure of the JSON file:

{
  "foo": "The quick brown fox jumps over the lazy dog.",
  "bar": "ABCDEFG",
  "baz": [52, 97]
}

Using this structure, the example inserts the first string and second number from the file onto the page.

JSONP

If the URL includes the string "callback=?" in the URL, the request is treated as JSONP instead. See the discussion of the data type in for more details.

Examples:

Example:

Loads the four most recent cat pictures from the Flickr JSONP API.
<!DOCTYPE html>
<html>
<head>
  <style>
img{ height: 100px; float: left; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div id="images">

</div>
  <script>$.getJSON("http://api.flickr.com/services/feeds/photos_public.gne?tags=cat&tagmode=any&format=json&jsoncallback=?",
        function(data){
          $.each(data.items, function(i,item){
            $("<img/>").attr("src", item.media.m).appendTo("#images");
            if ( i == 3 ) return false;
          });
        });</script>
</body>
</html>

Demo:

Example:

Load the JSON data from test.js and access a name from the returned JSON data.
<script>$.getJSON("test.js", function(json){
   alert("JSON Data: " + json.users[3].name);
 });</script>

Example:

Load the JSON data from test.js, passing along additional data, and access a name from the returned JSON data.
<script>$.getJSON("test.js", { name: "John", time: "2pm" }, function(json){
    alert("JSON Data: " + json.users[3].name);
    });</script>

Example:

List the result of a consultation of pages.php in HTML as an array. By Manuel Gonzalez.
<script>

var id=$("#id").attr("value");
$.getJSON("pages.php",{id:id},dates);

function dates(datos) {

  $("#list").html("Name:"+datos[1].name+"<br>"+"Last Name:"+datos[1].lastname+"<br>"+"Address:"+datos[1].address);
}

</script>

Comments

© 2010 The jQuery Project


jQuery.get – jQuery API

Returns: XMLHttpRequestXMLHttpRequest jQuery.get( [String] url, [Map|String] data, [Function] callback(data, textStatus, XMLHttpRequest), [String] dataType )

Categories: Shorthand Methods, Version 1.0
Description: Load data from the server using a HTTP GET request.
  • version added: 1.0

  • jQuery.get( [String] url, [Map|String] data, [Function] callback(data, textStatus, XMLHttpRequest), [String] dataType )

  • url A string containing the URL to which the request is sent.
  • data A map or string that is sent to the server with the request.
  • callback(data, textStatus, XMLHttpRequest) A callback function that is executed if the request succeeds.
  • dataType The type of data expected from the server.

This is a shorthand Ajax function, which is equivalent to:

$.ajax({
  url: ,
  data: ,
  success: ,
  dataType:
});

The callback function is passed the returned data, which will be an XML root element, text string, JavaScript file, or JSON object, depending on the MIME type of the response. It is also passed the text status of the response.

As of jQuery 1.4, the callback function is also passed the XMLHttpRequest object.

Most implementations will specify a success handler:

$.get('ajax/test.html', function(data) {
  $('.result').html(data);
  alert('Load was performed.');
});

This example fetches the requested HTML snippet and inserts it on the page.

Examples:

Example:

Request the test.php page, but ignore the return results.
<script>$.get("test.php");</script>

Example:

Request the test.php page and send some additional data along (while still ignoring the return results).
<script>$.get("test.php", { name: "John", time: "2pm" } );</script>

Example:

pass arrays of data to the server (while still ignoring the return results).
<script>$.get("test.php", { 'choices[]': ["Jon", "Susan"]} );</script>

Example:

Alert out the results from requesting test.php (HTML or XML, depending on what was returned).
<script>$.get("test.php", function(data){
   alert("Data Loaded: " + data);
 });</script>

Example:

Alert out the results from requesting test.cgi with an additional payload of data (HTML or XML, depending on what was returned).
<script>$.get("test.cgi", { name: "John", time: "2pm" },
   function(data){
     alert("Data Loaded: " + data);
   });</script>

Comments

© 2010 The jQuery Project


load – jQuery API

  • load( [Function] handler(eventObject) )

    • 1.0load( [Function] handler(eventObject) )

  • load( [String] url, [Map|String] data, [Function] complete(responseText, textStatus, XMLHttpRequest) )

    • 1.0load( [String] url, [Map|String] data, [Function] complete(responseText, textStatus, XMLHttpRequest) )

Returns: jQueryjQuery .load( [Function] handler(eventObject) )

Categories: Document Loading, Version 1.0
Description: Bind an event handler to the "load" JavaScript event.
  • version added: 1.0

  • .load( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute when the event is triggered.

This method is a shortcut for .

The event is sent to an element when it and all sub-elements have been completely loaded. This event can be sent to any element associated with a URL: images, scripts, frames, iframes, and the object.

For example, consider a page with a simple image:

<img src="book.png" alt="Book" id="book" />

The event handler can be bound to the image:

$('#book').load(function() {
  // Handler for .load() called.
});

As soon as the image has been loaded, the handler is called.

In general, it is not necessary to wait for all images to be fully loaded. If code can be executed earlier, it is usually best to place it in a handler sent to the method.

Examples:

Example:

Run a function when the page is fully loaded including graphics.
<script>$(window).load(function () {
  // run code
});</script>

Example:

Add the class bigImg to all images with height greater then 100 upon each image load.
<script>$('img.userIcon').load(function(){
  if($(this).height() > 100) {
    $(this).addClass('bigImg');
  }
});</script>

Returns: jQueryjQuery .load( [String] url, [Map|String] data, [Function] complete(responseText, textStatus, XMLHttpRequest) )

Categories: Shorthand Methods, Version 1.0
Description: Load data from the server and place the returned HTML into the matched element.
  • version added: 1.0

  • .load( [String] url, [Map|String] data, [Function] complete(responseText, textStatus, XMLHttpRequest) )

  • url A string containing the URL to which the request is sent.
  • data A map or string that is sent to the server with the request.
  • complete(responseText, textStatus, XMLHttpRequest) A callback function that is executed when the request completes.

This method is the simplest way to fetch data from the server. It is roughly equivalent to except that it is a method rather than global function and it has an implicit callback function. When a successful response is detected (i.e. when is "success" or "notmodified"), sets the HTML contents of the matched element to the returned data. This means that most uses of the method can be quite simple:

$('#result').load('ajax/test.html');

The provided callback, if any, is executed after this post-processing has been performed:

$('#result').load('ajax/test.html', function() {
  alert('Load was performed.');
});

In the two examples above, if the current document does not contain an element with an ID of "result," the method is not executed.

The POST method is used if data is provided as an object; otherwise, GET is assumed.

Loading Page Fragments

The method, unlike , allows us to specify a portion of the remote document to be inserted. This is achieved with a special syntax for the parameter. If one or more space characters are included in the string, the portion of the string following the first space is assumed to be a jQuery selector that determines the content to be loaded.

We could modify the example above to use only part of the document that is fetched:

$('#result').load('ajax/test.html #container');

When this method executes, it retrieves the content of , but then jQuery parses the returned document to find the element with an ID of . This element, along with its contents, is inserted into the element with an ID of , and the rest of the retrieved document is discarded.

jQuery uses the browser's property to parse the retrieved document and insert it into the current document. During this process, browsers often filter elements from the document such as , , or elements. As a result, the elements retrieved by may not be exactly the same as if the document were retrieved directly by the browser.

Examples:

Example:

Load the main page's footer navigation into an ordered list.
<!DOCTYPE html>
<html>
<head>
  <style>
 body{ font-size: 12px; font-family: Arial; }
 </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<b>Footer navigation:</b>
<ol id="new-nav"></ol>

  <script>
  $("#new-nav").load("/ #jq-footerNavigation li");
</script>
</body>
</html>

Demo:

Example:

Display a notice if the Ajax request encounters an error.
<!DOCTYPE html>
<html>
<head>
  <style>
  body{ font-size: 12px; font-family: Arial; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<b>Successful Response (should be blank):</b>
<div id="success"></div>
<b>Error Response:</b>
<div id="error"></div>

  <script>
$("#success").load("/not-here.php", function(response, status, xhr) {
  if (status == "error") {
    var msg = "Sorry but there was an error: ";
    $("#error").html(msg + xhr.status + " " + xhr.statusText);
  }
});
  </script>
</body>
</html>

Demo:

Example:

Load the feeds.html file into the div with the ID of feeds.
<script>$("#feeds").load("feeds.html");</script>

Example:

pass arrays of data to the server.
<script>$("#objectID").load("test.php", { 'choices[]': ["Jon", "Susan"] } );</script>

Example:

Same as above, but will POST the additional parameters to the server and a callback that is executed when the server is finished responding.
<script>$("#feeds").load("feeds.php", {limit: 25}, function(){
alert("The last 25 entries in the feed have been loaded");
});</script>

Comments

© 2010 The jQuery Project


Attributes – jQuery API

Attributes

  • jQuery .val( [Function] function(index, value) )

    New in 1.4 !

    Set the value of each element in the set of matched elements.

  • jQuery .html( [Function] function(index, oldhtml) )

    New in 1.4 !

    Set the HTML contents of each element in the set of matched elements.

  • jQuery .toggleClass( [Function] function(index, class), [Boolean] switch )

    New in 1.4 !

    Add or remove one or more classes from each element in the set of matched elements, depending on either the class's presence or the value of the switch argument.

  • jQuery .removeClass( [Function] function(index, class) )

    New in 1.4 !

    Remove a single class, multiple classes, or all classes from each element in the set of matched elements.

  • Boolean .hasClass( [String] className )

    New in 1.2 !

    Determine whether any of the matched elements are assigned the given class.

  • jQuery .removeAttr( [String] attributeName )

    New in 1.0 !

    Remove an attribute from each element in the set of matched elements.

  • jQuery .attr( [String] attributeName, [Function] function(index, attr) )

    New in 1.1 !

    Set one or more attributes for the set of matched elements.

  • jQuery .addClass( [Function] function(index, class) )

    New in 1.4 !

    Adds the specified class(es) to each of the set of matched elements.


val – jQuery API

  • val( )

    • 1.0val( )

  • val( [String] value )

    • 1.0val( [String] value )
    • 1.4val( [Function] function(index, value) )

Returns: String, ArrayString, Array .val( )

Categories: Attributes, Forms, General Attributes, Version 1.0, Version 1.4
Description: Get the current value of the first element in the set of matched elements.
  • version added: 1.0

  • .val( )

The method is primarily used to get the values of form elements. In the case of elements, the method returns an array containing each selected option.

For selects and checkboxes, you can also use the and selectors to get at values, for example:

$('select.foo option:selected').val();    // get the value from a dropdown select
$('select.foo').val();                    // get the value from a dropdown select even easier
$('input:checkbox:checked').val();        // get the value from a checked checkbox
$('input:radio[name=bar]:checked').val(); // get the value from a set of radio buttons

Examples:

Example:

Get the single value from a single select and an array of values from a multiple select and display their values.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { color:red; margin:4px; }
  b { color:blue; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p></p>
  <select id="single">
    <option>Single</option>
    <option>Single2</option>

  </select>
  <select id="multiple" multiple="multiple">
    <option selected="selected">Multiple</option>
    <option>Multiple2</option>

    <option selected="selected">Multiple3</option>
  </select>
  <script>
    function displayVals() {
      var singleValues = $("#single").val();
      var multipleValues = $("#multiple").val() || [];
      $("p").html("<b>Single:</b> " +
                  singleValues +
                  " <b>Multiple:</b> " +
                  multipleValues.join(", "));
    }

    $("select").change(displayVals);
    displayVals();

</script>
</body>
</html>

Demo:

Example:

Find the value of an input box.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { color:blue; margin:8px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <input type="text" value="some text"/>
  <p></p>
  <script>
    $("input").keyup(function () {
      var value = $(this).val();
      $("p").text(value);
    }).keyup();
</script>
</body>
</html>

Demo:

Returns: jQueryjQuery .val( [Function] function(index, value) )

Categories: Attributes, Forms, General Attributes, Version 1.0, Version 1.4
Description: Set the value of each element in the set of matched elements.
  • version added: 1.0

  • .val( [String] value )

  • value A string of text or an array of strings to set as the value property of each matched element.
  • version added: 1.4

  • .val( [Function] function(index, value) )

  • function(index, value) A function returning the value to set.

This method is typically used to set the values of form fields. For elements, multiple s can be selected by passing in an array.

The method allows us to set the value by passing in a function. As of jQuery 1.4, the function is passed two arguments, the current element's index and its current value:

$('input:text.items').val(function(index, value) {
  return value + ' ' + this.className;
});

This example appends the string " items" to the text inputs' values.

Examples:

Example:

Set the value of an input box.
<!DOCTYPE html>
<html>
<head>
  <style>
  button { margin:4px; cursor:pointer; }
  input { margin:4px; color:blue; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>
    <button>Feed</button>
    <button>the</button>

    <button>Input</button>
  </div>
  <input type="text" value="click a button" />
  <script>
    $("button").click(function () {
      var text = $(this).text();
      $("input").val(text);
    });
</script>
</body>
</html>

Demo:

Example:

Set a single select and a multiple select .
<!DOCTYPE html>
<html>
<head>
  <style>
  body { color:blue; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <select id="single">
    <option>Single</option>
    <option>Single2</option>
  </select>

  <select id="multiple" multiple="multiple">
    <option selected="selected">Multiple</option>
    <option>Multiple2</option>

    <option selected="selected">Multiple3</option>
  </select><br/>
  <input type="checkbox" name="checkboxname" value="check1"/> check1
  <input type="checkbox" name="checkboxname" value="check2"/> check2
  <input type="radio"  name="r" value="radio1"/> radio1
  <input type="radio"  name="r" value="radio2"/> radio2
  <script>

    $("#single").val("Single2");
    $("#multiple").val(["Multiple2", "Multiple3"]);
    $("input").val(["check1","check2", "radio1" ]);

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


html – jQuery API

  • html( )

    • 1.0html( )

  • html( [String] htmlString )

    • 1.0html( [String] htmlString )
    • 1.4html( [Function] function(index, oldhtml) )

Returns: StringString .html( )

Categories: Attributes, DOM Insertion, Inside, Version 1.0, Version 1.4
Description: Get the HTML contents of the first element in the set of matched elements.
  • version added: 1.0

  • .html( )

This method is not available on XML documents.

In an HTML document, we can use to get the contents of any element. If the selector expression matches more than one element, only the first one's HTML content is returned. Consider this code:

$('div.demo-container').html();

In order for the following 's content to be retrieved, it would have to be the first one with in the document:

<div class="demo-container">
  <div class="demo-box">Demonstration Box</div>
</div>

The result would look like this:

<div class="demo-box">Demonstration Box</div>

This method uses the browser's property. Some browsers may not return HTML that exactly replicates the HTML source in an original document. For example, Internet Explorer sometimes leaves off the quotes around attribute values if they contain only alphanumeric characters.

Examples:

Example:

Click a paragraph to convert it from html to text.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { margin:8px; font-size:20px; color:blue;
      cursor:pointer; }
  b { text-decoration:underline; }
  button { cursor:pointer; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>

    <b>Click</b> to change the <span id="tag">html</span>
  </p>
  <p>

    to a <span id="text">text</span> node.
  </p>
  <p>
    This <button name="nada">button</button> does nothing.
  </p>
  <script>
    $("p").click(function () {
      var htmlStr = $(this).html();
      $(this).text(htmlStr);
    });
</script>
</body>
</html>

Demo:

Returns: jQueryjQuery .html( [Function] function(index, oldhtml) )

Categories: Attributes, DOM Insertion, Inside, Version 1.0, Version 1.4
Description: Set the HTML contents of each element in the set of matched elements.
  • version added: 1.0

  • .html( [String] htmlString )

  • htmlString A string of HTML to set as the content of each matched element.
  • version added: 1.4

  • .html( [Function] function(index, oldhtml) )

  • function(index, oldhtml) A function returning the HTML content to set. Receives the index position of the element in the set and the old HTML value as arguments. jQuery empties the element before calling the function; use the oldhtml argument to reference the previous content.

The method is not available in XML documents.

When we use to set elements' contents, any contents that were in those elements is completely replaced by the new contents. Consider the following HTML:

<div class="demo-container">
  <div class="demo-box">Demonstration Box</div>
</div>

We can set the HTML contents of like so:

$('div.demo-container')
  .html('<p>All new content. <em>You bet!</em></p>');

That line of code will replace everything inside :

<div class="demo-container">
  <p>All new content. <em>You bet!</em></p>
</div>

As of jQuery 1.4, the method allows us to set the HTML content by passing in a function.

$('div.demo-container').html(function() {
  var emph = '<em>' + $('p').length + ' paragraphs!</em>';
  return '<p>All new content for ' + emph + '</p>';
});

Given a document with six paragraphs, this example will set the HTML of to .

Examples:

Example:

Add some html to each div.
<!DOCTYPE html>
<html>
<head>
  <style>
  .red { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <span>Hello</span>
  <div></div>
  <div></div>
  <div></div>
  <script>$("div").html("<span class='red'>Hello <b>Again</b></span>");</script>
</body>
</html>

Demo:

Example:

Add some html to each div then immediately do further manipulations to the inserted html.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { color:blue; font-size:18px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div></div>
  <div></div>
  <div></div>
  <script>

    $("div").html("<b>Wow!</b> Such excitement...");
    $("div b").append(document.createTextNode("!!!"))
              .css("color", "red");

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


toggleClass – jQuery API

  • toggleClass( [String] className )

    • 1.0toggleClass( [String] className )

  • toggleClass( [String] className, [Boolean] switch )

    • 1.3toggleClass( [String] className, [Boolean] switch )
    • 1.4toggleClass( [Function] function(index, class), [Boolean] switch )

Returns: jQueryjQuery .toggleClass( [Function] function(index, class), [Boolean] switch )

Categories: Attributes, CSS, Class Attribute, Version 1.0, Version 1.3, Version 1.4
Description: Add or remove one or more classes from each element in the set of matched elements, depending on either the class's presence or the value of the switch argument.
  • version added: 1.0

  • .toggleClass( [String] className )

  • className One or more class names (separated by spaces) to be toggled for each element in the matched set.
  • version added: 1.3

  • .toggleClass( [String] className, [Boolean] switch )

  • className One or more class names (separated by spaces) to be toggled for each element in the matched set.
  • switch A boolean value to determine whether the class should be added or removed.
  • version added: 1.4

  • .toggleClass( [Function] function(index, class), [Boolean] switch )

  • function(index, class) A function that returns class names to be toggled in the class attribute of each element in the matched set. Receives the index position of the element in the set and the old class value as arguments.
  • switch A boolean value to determine whether the class should be added or removed.

This method takes one or more class names as its parameter. In the first version, if an element in the matched set of elements already has the class, then it is removed; if an element does not have the class, then it is added. For example, we can apply to a simple :

<div class="tumble">Some text.</div>

The first time we apply , we get the following:

<div class="tumble bounce">Some text.</div>

The second time we apply , the class is returned to the single value:

<div class="tumble">Some text.</div>

Applying to the same alternates between and .

The second version of uses the second parameter for determining whether the class should be added or removed. If this parameter's value is , then the class is added; if , the class is removed. In essence, the statement:

$('#foo').toggleClass(className, addOrRemove);

is equivalent to:

if (addOrRemove) {
    $('#foo').addClass(className);
  }
  else {
    $('#foo').removeClass(className);
  }

As of jQuery 1.4, the method allows us to indicate the class name to be toggled by passing in a function.

$('div.foo').toggleClass(function() {
  if ($(this).parent().is('.bar')) {
    return 'happy';
  } else {
    return 'sad';
  }
});

This example will toggle the class for elements if their parent element has a class of ; otherwise, it will toggle the class.

Examples:

Example:

Toggle the class 'highlight' when a paragraph is clicked.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { margin: 4px; font-size:16px; font-weight:bolder;
      cursor:pointer; }
  .blue { color:blue; }
  .highlight { background:yellow; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p class="blue">Click to toggle</p>
  <p class="blue highlight">highlight</p>
  <p class="blue">on these</p>
  <p class="blue">paragraphs</p>
  <script>
    $("p").click(function () {
      $(this).toggleClass("highlight");
    });
</script>
</body>
</html>

Demo:

Example:

Add the "highlight" class to the clicked paragraph on every third click of that paragraph, remove it every first and second click.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { margin: 4px; font-size:16px; font-weight:bolder;
      cursor:pointer; }
  .blue { color:blue; }
  .highlight { background:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p class="blue">Click to toggle (<span>clicks: 0</span>)</p>
  <p class="blue highlight">highlight (<span>clicks: 0</span>)</p>
  <p class="blue">on these (<span>clicks: 0</span>)</p>

  <p class="blue">paragraphs (<span>clicks: 0</span>)</p>
  <script>
var count = 0;
$("p").each(function() {
  var $thisParagraph = $(this);
  var count = 0;
  $thisParagraph.click(function() {
    count++;
    $thisParagraph.find("span").text('clicks: ' + count);
    $thisParagraph.toggleClass("highlight", count % 3 == 0);
  });
});

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


removeClass – jQuery API

Returns: jQueryjQuery .removeClass( [Function] function(index, class) )

Categories: Attributes, CSS, Class Attribute, Version 1.0, Version 1.4
Description: Remove a single class, multiple classes, or all classes from each element in the set of matched elements.
  • version added: 1.0

  • .removeClass( [String] className )

  • className A class name to be removed from the class attribute of each matched element.
  • version added: 1.4

  • .removeClass( [Function] function(index, class) )

  • function(index, class) A function returning one or more space-separated class names to be removed. Receives the index position of the element in the set and the old class value as arguments.

If a class name is included as a parameter, then only that class will be removed from the set of matched elements. If no class names are specified in the parameter, all classes will be removed.

More than one class may be removed at a time, separated by a space, from the set of matched elements, like so:

$('p').removeClass('myClass yourClass')

This method is often used with to switch elements' classes from one to another, like so:

$('p').removeClass('myClass noClass').addClass('yourClass');

Here, the and classes are removed from all paragraphs, while is added.

To replace all existing classes with another class, we can use instead.

As of jQuery 1.4, the method allows us to indicate the class to be removed by passing in a function.

$('li:last').removeClass(function() {
          return $(this).prev().attr('class');
        });

This example removes the class name of the penultimate from the last .

Examples:

Example:

Remove the class 'blue' from the matched elements.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { margin: 4px; font-size:16px; font-weight:bolder; }
  .blue { color:blue; }
  .under { text-decoration:underline; }
  .highlight { background:yellow; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p class="blue under">Hello</p>
  <p class="blue under highlight">and</p>
  <p class="blue under">then</p>

  <p class="blue under">Goodbye</p>
  <script>$("p:even").removeClass("blue");</script>
</body>
</html>

Demo:

Example:

Remove the class 'blue' and 'under' from the matched elements.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { margin: 4px; font-size:16px; font-weight:bolder; }
  .blue { color:blue; }
  .under { text-decoration:underline; }
  .highlight { background:yellow; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p class="blue under">Hello</p>

  <p class="blue under highlight">and</p>
  <p class="blue under">then</p>
  <p class="blue under">Goodbye</p>
  <script>$("p:odd").removeClass("blue under");</script>
</body>
</html>

Demo:

Example:

Remove all the classes from the matched elements.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { margin: 4px; font-size:16px; font-weight:bolder; }
  .blue { color:blue; }
  .under { text-decoration:underline; }
  .highlight { background:yellow; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p class="blue under">Hello</p>
  <p class="blue under highlight">and</p>
  <p class="blue under">then</p>

  <p class="blue under">Goodbye</p>
  <script>$("p:eq(1)").removeClass();</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


hasClass – jQuery API

Returns: BooleanBoolean .hasClass( [String] className )

Categories: Attributes, CSS, Class Attribute, Version 1.2
Description: Determine whether any of the matched elements are assigned the given class.
  • version added: 1.2

  • .hasClass( [String] className )

  • className The class name to search for.

Elements may have more than one class assigned to them. In HTML, this is represented by separating the class names with a space:

<div id="mydiv" class="foo bar"></div>

The method will return if the class is assigned to an element, even if other classes also are. For example, given the HTML above, the following will return :

$('#mydiv').hasClass('foo')

as would:

$('#mydiv').hasClass('bar')

Examples:

Example:

Looks for the class 'selected' on the matched elements.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { margin: 8px; font-size:16px; }
  .selected { color:red; }
  .highlight { background:yellow; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p>
  <p class="selected">Goodbye</p>
  <div id="result1">First paragraph has selected class: </div>

  <div id="result2">Last paragraph has selected class: </div>
  <div id="result3">Some paragraph has selected class: </div>
  <script>$("div#result1").append($("p:first").hasClass("selected").toString());
$("div#result2").append($("p:last").hasClass("selected").toString());
$("div#result3").append($("p").hasClass("selected").toString());</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


removeAttr – jQuery API

Returns: jQueryjQuery .removeAttr( [String] attributeName )

Categories: Attributes, General Attributes, Version 1.0, Version 1.4
Description: Remove an attribute from each element in the set of matched elements.
  • version added: 1.0

  • .removeAttr( [String] attributeName )

  • attributeName An attribute to remove.

The method uses the JavaScript function, but it has the advantage of being able to be called directly on a jQuery object and it accounts for different attribute naming across browsers.

Examples:

Example:

Clicking the button enables the input next to it.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button>Enable</button>
<input type="text" disabled="disabled" value="can't edit this" />
  <script>
$("button").click(function () {
  $(this).next().removeAttr("disabled")
  .focus()
  .val("editable now");
});
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


attr – jQuery API

  • attr( [Map] map )

    • 1.0attr( [Map] map )

  • attr( [String] attributeName, [Object] value )

    • 1.0attr( [String] attributeName, [Object] value )
    • 1.1attr( [String] attributeName, [Function] function(index, attr) )

Returns: StringString .attr( [String] attributeName )

Categories: Attributes, General Attributes, Version 1.0, Version 1.1
Description: Get the value of an attribute for the first element in the set of matched elements.
  • version added: 1.0

  • .attr( [String] attributeName )

  • attributeName The name of the attribute to get.

It's important to note that the method gets the attribute value for only the element in the matched set. To get the value for each element individually, we need to rely on a looping construct such as jQuery's or method.

Using jQuery's method to get the value of an element's attribute has two main benefits:

If we try to get the value of an attribute that has not been set, the method returns .

Examples:

Example:

Finds the title attribute of the first in the page.
<!DOCTYPE html>
<html>
<head>
  <style>
em { color:blue; font-weight;bold; }
  div { color:red; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>
    Once there was a <em title="huge, gigantic">large</em> dinosaur...
  </p>

  The title of the emphasis is:<div></div>
  <script>var title = $("em").attr("title");
    $("div").text(title);
</script>
</body>
</html>

Demo:

Returns: jQueryjQuery .attr( [String] attributeName, [Function] function(index, attr) )

Categories: Attributes, General Attributes, Version 1.0, Version 1.1
Description: Set one or more attributes for the set of matched elements.
  • version added: 1.0

  • .attr( [String] attributeName, [Object] value )

  • attributeName The name of the attribute to set.
  • value A value to set for the attribute.
  • version added: 1.0

  • .attr( [Map] map )

  • map A map of attribute-value pairs to set.
  • version added: 1.1

  • .attr( [String] attributeName, [Function] function(index, attr) )

  • attributeName The name of the attribute to set.
  • function(index, attr) A function returning the value to set. is the current element. Receives the index position of the element in the set and the old attribute value as arguments.

The method is a convenient and powerful way to set the value of attributes—especially when setting multiple attributes or using values returned by a function. Let's consider the following image:

<img id="greatphoto" src="brush-seller.jpg" alt="brush seller" />

Setting a simple attribute

We can change the attribute by simply passing the name of the attribute and its new value to the method:

$('#greatphoto').attr('alt', 'Beijing Brush Seller');

We can an attribute the same way:

$('#greatphoto')
  .attr('title', 'Photo by Kelly Clark');

Setting several attributes at once

To change the attribute and add the attribute at the same time, we can pass both sets of names and values into the method at once using a map (JavaScript object literal). Each key-value pair in the map adds or modifies an attribute:

$('#greatphoto').attr({
  alt: 'Beijing Brush Seller',
  title: 'photo by Kelly Clark'
});

When setting multiple attributes, the quotes around attribute names are optional.

When setting the 'class' attribute, you must always use quotes!

Computed attribute values

By using a function to set attributes, we can compute the value based on other properties of the element. For example, we could concatenate a new value with an existing value:

$('#greatphoto').attr('title', function() {
  return this.alt + ' - photo by Kelly Clark'
});

This use of a function to compute attribute values can be particularly useful when we modify the attributes of multiple elements at once.

Examples:

Example:

Set some attributes for all [image] s in the page.
<!DOCTYPE html>
<html>
<head>
  <style>
  img { padding:10px; }
  div { color:red; font-size:24px; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <img />
  <img />
  <img />

  <div><B>Attribute of Ajax</B></div>
  <script>$("img").attr({
          src: "/images/hat.gif",
          title: "jQuery",
          alt: "jQuery Logo"
        });
    $("div").text($("img").attr("alt"));</script>
</body>
</html>

Demo:

Example:

Disables buttons greater than the 1st button.
<!DOCTYPE html>
<html>
<head>
  <style>
button { margin:10px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button>0th Button</button>
  <button>1st Button</button>
  <button>2nd Button</button>
  <script>$("button:gt(1)").attr("disabled","disabled");</script>
</body>
</html>

Demo:

Example:

Sets id for divs based on the position in the page.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { color:blue; }
  span { color:red; }
  b { font-weight:bolder; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>Zero-th <span></span></div>
  <div>First <span></span></div>
  <div>Second <span></span></div>
  <script>$("div").attr("id", function (arr) {
          return "div-id" + arr;
        })
        .each(function () {
          $("span", this).html("(ID = '<b>" + this.id + "</b>')");
        });</script>
</body>
</html>

Demo:

Example:

Sets src attribute from title attribute on the image.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <img title="hat.gif"/>
  <script>$("img").attr("src", function() {
          return "/images/" + this.title;
        });
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


addClass – jQuery API

Returns: jQueryjQuery .addClass( [Function] function(index, class) )

Categories: Attributes, CSS, Class Attribute, Version 1.0, Version 1.4
Description: Adds the specified class(es) to each of the set of matched elements.
  • version added: 1.0

  • .addClass( [String] className )

  • className One or more class names to be added to the class attribute of each matched element.
  • version added: 1.4

  • .addClass( [Function] function(index, class) )

  • function(index, class) A function returning one or more space-separated class names to be added. Receives the index position of the element in the set and the old class value as arguments.

It's important to note that this method does not replace a class. It simply adds the class, appending it to any which may already be assigned to the elements.

More than one class may be added at a time, separated by a space, to the set of matched elements, like so:

$('p').addClass('myClass yourClass');

This method is often used with to switch elements' classes from one to another, like so:

$('p').removeClass('myClass noClass').addClass('yourClass');

Here, the and classes are removed from all paragraphs, while is added.

As of jQuery 1.4, the method allows us to set the class name by passing in a function.

$('ul li:last').addClass(function() {
  return 'item-' + $(this).index();
});

Given an unordered list with five elements, this example adds the class "item-4" to the last .

Examples:

Example:

Adds the class 'selected' to the matched elements.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { margin: 8px; font-size:16px; }
  .selected { color:blue; }
  .highlight { background:yellow; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p>
  <p>and</p>
  <p>Goodbye</p>
  <script>$("p:last").addClass("selected");</script>
</body>
</html>

Demo:

Example:

Adds the classes 'selected' and 'highlight' to the matched elements.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { margin: 8px; font-size:16px; }
  .selected { color:red; }
  .highlight { background:yellow; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p>
  <p>and</p>
  <p>Goodbye</p>
  <script>$("p:last").addClass("selected highlight");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Core – jQuery API

Core

  • Object jQuery.noConflict( [Boolean] removeAll )

    New in 1.0 !

    Relinquish jQuery's control of the variable.

  • jQuery jQuery( [Function] callback )

    New in 1.0 !

    Binds a function to be executed when the DOM has finished loading.


jQuery.noConflict – jQuery API

Returns: ObjectObject jQuery.noConflict( [Boolean] removeAll )

Categories: Core, Setup Methods, Version 1.0
Description: Relinquish jQuery's control of the variable.
  • version added: 1.0

  • jQuery.noConflict( [Boolean] removeAll )

  • removeAll A Boolean indicating whether to remove all jQuery variables from the global scope (including jQuery itself).

Many JavaScript libraries use as a function or variable name, just as jQuery does. In jQuery's case, is just an alias for , so all functionality is available without using . If we need to use another JavaScript library alongside jQuery, we can return control of back to the other library with a call to :

<script type="text/javascript" src="other_lib.js"></script>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript">
  $.noConflict();
  // Code that uses other library's $ can follow here.
</script>

This technique is especially effective in conjunction with the .ready() method's ability to alias the jQuery object, as within callback passed to .ready() we can use $ if we wish without fear of conflicts later:

<script type="text/javascript" src="other_lib.js"></script>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript">
  $.noConflict();
  jQuery(document).ready(function($) {
    // Code that uses jQuery's $ can follow here.
  });
  // Code that uses other library's $ can follow here.
</script>

If necessary, we can free up the name as well by passing as an argument to the method. This is rarely necessary, and if we must do this (for example, if we need to use multiple versions of the library on the same page), we need to consider that most plug-ins rely on the presence of the jQuery variable and may not operate correctly in this situation.

Examples:

Example:

Maps the original object that was referenced by $ back to $.
<script>jQuery.noConflict();
// Do something with jQuery
jQuery("div p").hide();
// Do something with another library's $()
$("content").style.display = 'none';</script>

Example:

Reverts the $ alias and then creates and executes a function to provide the $ as a jQuery alias inside the functions scope. Inside the function the original $ object is not available. This works well for most plugins that don't rely on any other library.
<script>jQuery.noConflict();
(function($) {
  $(function() {
    // more code using $ as alias to jQuery
  });
})(jQuery);
// other code using $ as an alias to the other library</script>

Example:

You can chain the jQuery.noConflict() with the shorthand ready for a compact code.
<script>jQuery.noConflict()(function(){
    // code using jQuery
});
// other code using $ as an alias to the other library</script>

Example:

Creates a different alias instead of jQuery to use in the rest of the script.
<script>var j = jQuery.noConflict();
// Do something with jQuery
j("div p").hide();
// Do something with another library's $()
$("content").style.display = 'none';</script>

Example:

Completely move jQuery to a new namespace in another object.
<script>var dom = {};
dom.query = jQuery.noConflict(true);</script>

Comments

© 2010 The jQuery Project


jQuery – jQuery API

  • jQuery( [String] html, [document] ownerDocument )

    • 1.0jQuery( [String] html, [document] ownerDocument )
    • 1.4jQuery( [String] html, [Object] props )

  • jQuery( [Function] callback )

    • 1.0jQuery( [Function] callback )

  • jQuery( )

    • 1.4jQuery( )

Returns: jQueryjQuery jQuery( )

Categories: Core, Version 1.0, Version 1.4
Description: Accepts a string containing a CSS selector which is then used to match a set of elements.
  • version added: 1.0

  • jQuery( [selector] selector, [Element|jQuery] context )

  • selector A string containing a selector expression
  • context A DOM Element, Document, or jQuery to use as context
  • version added: 1.0

  • jQuery( [Element] element )

  • element A DOM element to wrap in a jQuery object.
  • version added: 1.0

  • jQuery( [Array] elementArray )

  • elementArray An array containing a set of DOM elements to wrap in a jQuery object.
  • version added: 1.0

  • jQuery( [Object] jQuery object )

  • jQuery object An existing jQuery object to clone.
  • version added: 1.4

  • jQuery( )

In the first formulation listed above, — which can also be written as — searches through the DOM for any elements that match the provided selector and creates a new jQuery object that references these elements:

$('div.foo');

Selector Context

By default, selectors perform their searches within the DOM starting at the document root. However, an alternate context can be given for the search by using the optional second parameter to the function. For example, if within a callback function we wish to do a search for an element, we can restrict that search:

$('div.foo').click(function() {
  $('span', this).addClass('bar');
});

Since we've restricted the span selector to the context of , only spans within the clicked element will get the additional class.

Internally, selector context is implemented with the method, so is equivalent to .

Using DOM elements

The second and third formulations of this function allow us to create a jQuery object using a DOM element or elements that we have already found in some other way. A common use of this facility is to call jQuery methods on an element that has been passed to a callback function through the keyword :

$('div.foo').click(function() {
  $(this).slideUp();
});

This example causes elements to be hidden with a sliding animation when clicked. Because the handler receives the clicked item in the keyword as a bare DOM element, the element must be wrapped in a jQuery object before we can call jQuery methods on it.

When XML data is returned from an Ajax call, we can use the function to wrap it in a jQuery object that we can easily work with. Once this is done, we can retrieve individual elements of the XML structure using and other DOM traversal methods.

Cloning jQuery Objects

When a jQuery object is passed as a parameter to the function, a clone of the object is created. This new jQuery object references the same DOM elements as the initial one.

Returning an Empty Set

As of jQuery 1.4, calling the method with returns an empty jQuery set. In previous versions of jQuery, this would return a set containing the document node.

Examples:

Example:

Finds all p elements that are children of a div element.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>one</p> <div><p>two</p></div> <p>three</p>
  <script>$("div > p").css("border", "1px solid gray");</script>
</body>
</html>

Demo:

Example:

Finds all inputs of type radio within the first form in the document.
<script>$("input:radio", document.forms[0]);</script>

Example:

Finds all div elements within an XML document from an Ajax response.
<script>$("div", xml.responseXML);</script>

Example:

Sets the background color of the page to black.
<script>$(document.body).css( "background", "black" );</script>

Example:

Hides all the input elements within a form.
<script>$(myForm.elements).hide()</script>

Returns: jQueryjQuery jQuery( [String] html, [Object] props )

Categories: Core, Version 1.0, Version 1.4
Description: Creates DOM elements on the fly from the provided string of raw HTML.
  • version added: 1.0

  • jQuery( [String] html, [document] ownerDocument )

  • html A string of HTML to create on the fly. Note that this parses HTML, XML.
  • ownerDocument A document in which the new elements will be created
  • version added: 1.4

  • jQuery( [String] html, [Object] props )

  • html A string defining a single, standalone, HTML element (e.g.
    or
    ).
  • props An map of attributes, events, and methods to call on the newly-created element.

Creating New Elements

If a string is passed as the parameter to , jQuery examines the string to see if it looks like HTML (i.e., it has somewhere within the string). If not, the string is interpreted as a selector expression, as explained above. But if the string appears to be an HTML snippet, jQuery attempts to create new DOM elements as described by the HTML. Then a jQuery object is created and returned that refers to these elements. We can perform any of the usual jQuery methods on this object:

$('<p id="test">My <em>new</em> text</p>').appendTo('body');

When the HTML is more complex than a single tag without attributes, as it is in the above example, the actual creation of the elements is handled by the browser's mechanism. Specifically, jQuery creates a new <div> element and sets the innerHTML property of the element to the HTML snippet that was passed in. When the parameter has a single tag, such as or , jQuery creates the element using the native JavaScript function.

To ensure cross-platform compatibility, the snippet must be well-formed. Tags that can contain other elements should be paired with a closing tag:

$('<a href="http://jquery.com"></a>');

Alternatively, jQuery allows XML-like tag syntax (with or without a space before the slash):

$('<a/>');

Tags that cannot contain elements may be quick-closed or not:

$('<img />');
$('<input>');

As of jQuery 1.4, we can pass a map of properties to the second argument. This argument accepts a superset of properties that can be passed to the method. Furthermore, any can be passed in, and the following jQuery methods can be called: , , , , , , , or . Note that Internet Explorer will not allow you to create an element and change its type; you must specify the type using for example.

Examples:

Example:

Creates a div element (and all of its contents) dynamically, and appends it to the body element. Internally, an element is created and its innerHTML property set to the given markup. It is therefore both quite flexible and limited.
<script>$("<div><p>Hello</p></div>").appendTo("body")</script>

Example:

Create some DOM elements.
<script>$("<div/>", {
  "class": "test",
  text: "Click me!",
  click: function(){
    $(this).toggleClass("test");
  }
}).appendTo("body");

$("<input>", {
  type: "text",
  val: "Test",
  focusin: function() {
    $(this).addClass("active");
  },
  focusout: function() {
    $(this).removeClass("active");
  }
}).appendTo("form");</script>

Returns: jQueryjQuery jQuery( [Function] callback )

Categories: Core, Version 1.0, Version 1.4
Description: Binds a function to be executed when the DOM has finished loading.
  • version added: 1.0

  • jQuery( [Function] callback )

  • callback The function to execute when the DOM is ready.

This function behaves just like , in that it should be used to wrap other operations on your page that depend on the DOM being ready. While this function is, technically, chainable, there really isn't much use for chaining against it.

Examples:

Example:

Executes the function when the DOM is ready to be used.
<script>$(function(){
  // Document is ready
});</script>

Example:

Uses both the shortcut for $(document).ready() and the argument to write failsafe jQuery code using the $ alias, without relying on the global alias.
<script>jQuery(function($) {
  // Your code using failsafe $ alias here...
});</script>

Comments

© 2010 The jQuery Project


CSS – jQuery API

CSS

  • Integer .outerWidth( [Boolean] includeMargin )

    New in 1.2.6 !

    Get the current computed width for the first element in the set of matched elements, including padding and border.

  • Integer .outerHeight( [Boolean] includeMargin )

    New in 1.2.6 !

    Get the current computed height for the first element in the set of matched elements, including padding, border, and optionally margin.

  • Integer .innerWidth( )

    New in 1.2.6 !

    Get the current computed width for the first element in the set of matched elements, including padding but not border.

  • Integer .innerHeight( )

    New in 1.2.6 !

    Get the current computed height for the first element in the set of matched elements, including padding but not border.

  • jQuery .width( [Function] function(index, width) )

    New in 1.4.1 !

    Set the CSS width of each element in the set of matched elements.

  • jQuery .height( [Function] function(index, height) )

    New in 1.4.1 !

    Set the CSS height of every matched element.

  • jQuery .scrollLeft( [Number] value )

    New in 1.2.6 !

    Set the current horizontal position of the scroll bar for each of the set of matched elements.

  • jQuery .scrollTop( [Number] value )

    New in 1.2.6 !

    Set the current vertical position of the scroll bar for each of the set of matched elements.

  • Object .position( )

    New in 1.2 !

    Get the current coordinates of the first element in the set of matched elements, relative to the offset parent.

  • jQuery .offset( [Function] function(index, coords) )

    New in 1.4 !

    Set the current coordinates of every element in the set of matched elements, relative to the document.

  • jQuery .css( [Map] map )

    New in 1.0 !

    Set one or more CSS properties for the set of matched elements.

  • jQuery .toggleClass( [Function] function(index, class), [Boolean] switch )

    New in 1.4 !

    Add or remove one or more classes from each element in the set of matched elements, depending on either the class's presence or the value of the switch argument.

  • jQuery .removeClass( [Function] function(index, class) )

    New in 1.4 !

    Remove a single class, multiple classes, or all classes from each element in the set of matched elements.

  • Boolean .hasClass( [String] className )

    New in 1.2 !

    Determine whether any of the matched elements are assigned the given class.

  • jQuery .addClass( [Function] function(index, class) )

    New in 1.4 !

    Adds the specified class(es) to each of the set of matched elements.


outerWidth – jQuery API

Returns: IntegerInteger .outerWidth( [Boolean] includeMargin )

Categories: CSS, Dimensions, Style Properties, Version 1.2.6
Description: Get the current computed width for the first element in the set of matched elements, including padding and border.
  • version added: 1.2.6

  • .outerWidth( [Boolean] includeMargin )

  • includeMargin A Boolean indicating whether to include the element's margin in the calculation.

Returns the width of the element, along with left and right padding, border, and optionally margin, in pixels.

If is omitted or , the padding and border are included in the calculation; if , the margin is also included.

This method is not applicable to and objects; for these, use instead.

Examples:

Example:

Get the outerWidth of a paragraph.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { margin:10px;padding:5px;border:2px solid #666; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p><p></p>
  <script>var p = $("p:first");
$("p:last").text( "outerWidth:" + p.outerWidth()+ " , outerWidth(true):" + p.outerWidth(true) );

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


outerHeight – jQuery API

Returns: IntegerInteger .outerHeight( [Boolean] includeMargin )

Categories: CSS, Dimensions, Style Properties, Version 1.2.6
Description: Get the current computed height for the first element in the set of matched elements, including padding, border, and optionally margin.
  • version added: 1.2.6

  • .outerHeight( [Boolean] includeMargin )

  • includeMargin A Boolean indicating whether to include the element's margin in the calculation.

The top and bottom padding and border are always included in the calculation; if the argument is set to , the margin (top and bottom) is also included.

This method is not applicable to and objects; for these, use instead.

Examples:

Example:

Get the outerHeight of a paragraph.
<!DOCTYPE html>
<html>
<head>
  <style>
p { margin:10px;padding:5px;border:2px solid #666; } </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p><p></p>
  <script>var p = $("p:first");
$("p:last").text( "outerHeight:" + p.outerHeight() + " , outerHeight(true):" + p.outerHeight(true) );</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


innerWidth – jQuery API

Returns: IntegerInteger .innerWidth( )

Categories: CSS, Dimensions, Style Properties, Version 1.2.6
Description: Get the current computed width for the first element in the set of matched elements, including padding but not border.
  • version added: 1.2.6

  • .innerWidth( )

This method returns the width of the element, including left and right padding, in pixels.

This method is not applicable to and objects; for these, use instead.

Examples:

Example:

Get the innerWidth of a paragraph.
<!DOCTYPE html>
<html>
<head>
  <style>
p { margin:10px;padding:5px;border:2px solid #666; } </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p><p></p>
  <script>var p = $("p:first");
$("p:last").text( "innerWidth:" + p.innerWidth() );</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


innerHeight – jQuery API

Returns: IntegerInteger .innerHeight( )

Categories: CSS, Dimensions, Style Properties, Version 1.2.6
Description: Get the current computed height for the first element in the set of matched elements, including padding but not border.
  • version added: 1.2.6

  • .innerHeight( )

This method returns the height of the element, including top and bottom padding, in pixels.

This method is not applicable to and objects; for these, use instead.

Examples:

Example:

Get the innerHeight of a paragraph.
<!DOCTYPE html>
<html>
<head>
  <style>
p { margin:10px;padding:5px;border:2px solid #666; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p><p></p>
  <script>var p = $("p:first");
$("p:last").text( "innerHeight:" + p.innerHeight() );</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


width – jQuery API

  • width( )

    • 1.0width( )

  • width( [String|Number] value )

    • 1.0width( [String|Number] value )
    • 1.4.1width( [Function] function(index, width) )

Returns: IntegerInteger .width( )

Categories: CSS, Dimensions, Style Properties, Version 1.0, Version 1.4.1
Description: Get the current computed width for the first element in the set of matched elements.
  • version added: 1.0

  • .width( )

The difference between and is that the latter returns a unit-less pixel value (for example, ) while the former returns a value with units intact (for example, ). The method is recommended when an element's width needs to be used in a mathematical calculation.

This method is also able to find the width of the window and document.

$(window).width();   // returns width of browser viewport
$(document).width(); // returns width of HTML document

Examples:

Example:

Show various widths. Note the values are from the iframe so might be smaller than you expected. The yellow highlight shows the iframe body.
<!DOCTYPE html>
<html>
<head>
  <style>
  body { background:yellow; }
  button { font-size:12px; margin:2px; }
  p { width:150px; border:1px red solid; }
  div { color:red; font-weight:bold;  }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button id="getp">Get Paragraph Width</button>
  <button id="getd">Get Document Width</button>
  <button id="getw">Get Window Width</button>

  <div>&nbsp;</div>
  <p>
    Sample paragraph to test width
  </p>
  <script>
    function showWidth(ele, w) {
      $("div").text("The width for the " + ele +
                    " is " + w + "px.");
    }
    $("#getp").click(function () {
      showWidth("paragraph", $("p").width());
    });
    $("#getd").click(function () {
      showWidth("document", $(document).width());
    });
    $("#getw").click(function () {
      showWidth("window", $(window).width());
    });

</script>
</body>
</html>

Demo:

Returns: jQueryjQuery .width( [Function] function(index, width) )

Categories: CSS, Dimensions, Style Properties, Version 1.0, Version 1.4.1
Description: Set the CSS width of each element in the set of matched elements.
  • version added: 1.0

  • .width( [String|Number] value )

  • value An integer representing the number of pixels, or an integer along with an optional unit of measure appended (as a string).
  • version added: 1.4.1

  • .width( [Function] function(index, width) )

  • function(index, width) A function returning the width to set. Receives the index position of the element in the set and the old width as arguments.

When calling , the value can be either a string (number and unit) or a number. If only a number is provided for the value, jQuery assumes a pixel unit. If a string is provided, however, any valid CSS measurement may be used for the width (such as , , or ). Note that in modern browsers, the CSS width property does not include padding, border, or margin.

If no explicit unit was specified (like 'em' or '%') then "px" is concatenated to the value.

Examples:

Example:

To set the width of each div on click to 30px plus a color change.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { width:70px; height:50px; float:left; margin:5px;
        background:red; cursor:pointer; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div></div>
  <div>d</div>

  <div>d</div>
  <div>d</div>
  <div>d</div>
  <script>

    $("div").one('click', function () {
      $(this).width(30)
             .css({cursor:"auto", "background-color":"blue"});
    });
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


height – jQuery API

  • height( )

    • 1.0height( )

  • height( [String|Number] value )

    • 1.0height( [String|Number] value )
    • 1.4.1height( [Function] function(index, height) )

Returns: IntegerInteger .height( )

Categories: CSS, Dimensions, Style Properties, Version 1.0, Version 1.4.1
Description: Get the current computed height for the first element in the set of matched elements.
  • version added: 1.0

  • .height( )

The difference between and is that the latter returns a unit-less pixel value (for example, ) while the former returns a value with units intact (for example, ). The method is recommended when an element's height needs to be used in a mathematical calculation.

This method is also able to find the height of the window and document.

$(window).height();   // returns height of browser viewport
$(document).height(); // returns height of HTML document

Examples:

Example:

Show various heights. Note the values are from the iframe so might be smaller than you expected. The yellow highlight shows the iframe body.
<!DOCTYPE html>
<html>
<head>
  <style>
  body { background:yellow; }
  button { font-size:12px; margin:2px; }
  p { width:150px; border:1px red solid; }
  div { color:red; font-weight:bold; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button id="getp">Get Paragraph Height</button>
  <button id="getd">Get Document Height</button>
  <button id="getw">Get Window Height</button>

  <div>&nbsp;</div>
  <p>
    Sample paragraph to test height
  </p>
  <script>
    function showHeight(ele, h) {
      $("div").text("The height for the " + ele +
                    " is " + h + "px.");
    }
    $("#getp").click(function () {
      showHeight("paragraph", $("p").height());
    });
    $("#getd").click(function () {
      showHeight("document", $(document).height());
    });
    $("#getw").click(function () {
      showHeight("window", $(window).height());
    });

</script>
</body>
</html>

Demo:

Returns: jQueryjQuery .height( [Function] function(index, height) )

Categories: CSS, Dimensions, Style Properties, Version 1.0, Version 1.4.1
Description: Set the CSS height of every matched element.
  • version added: 1.0

  • .height( [String|Number] value )

  • value An integer representing the number of pixels, or an integer with an optional unit of measure appended (as a string).
  • version added: 1.4.1

  • .height( [Function] function(index, height) )

  • function(index, height) A function returning the height to set. Receives the index position of the element in the set and the old height as arguments.

When calling , the value can be either a string (number and unit) or a number. If only a number is provided for the value, jQuery assumes a pixel unit. If a string is provided, however, any valid CSS measurement may be used for the height (such as , , or ). Note that in modern browsers, the CSS height property does not include padding, border, or margin.

If no explicit unit was specified (like 'em' or '%') then "px" is concatenated to the value.

Examples:

Example:

To set the height of each div on click to 30px plus a color change.
<!DOCTYPE html>
<html>
<head>
  <style>
div { width:50px; height:70px; float:left; margin:5px;
        background:rgb(255,140,0); cursor:pointer; }  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div></div>
  <div></div>

  <div></div>
  <div></div>
  <div></div>
  <script>$("div").one('click', function () {
      $(this).height(30)
             .css({cursor:"auto", backgroundColor:"green"});
    });</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


scrollLeft – jQuery API

  • scrollLeft( )

    • 1.2.6scrollLeft( )

  • scrollLeft( [Number] value )

    • 1.2.6scrollLeft( [Number] value )

Returns: IntegerInteger .scrollLeft( )

Categories: CSS, Offset, Style Properties, Version 1.2.6
Description: Get the current horizontal position of the scroll bar for the first element in the set of matched elements.
  • version added: 1.2.6

  • .scrollLeft( )

The horizontal scroll position is the same as the number of pixels that are hidden from view above the scrollable area. If the scroll bar is at the very left, or if the element is not scrollable, this number will be .

Examples:

Example:

Get the scrollLeft of a paragraph.
<!DOCTYPE html>
<html>
<head>
  <style>
    p { margin:10px;padding:5px;border:2px solid #666; }
    </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p><p></p>
  <script>var p = $("p:first");
            $("p:last").text( "scrollLeft:" + p.scrollLeft() );

            </script>
</body>
</html>

Demo:

Returns: jQueryjQuery .scrollLeft( [Number] value )

Categories: CSS, Offset, Style Properties, Version 1.2.6
Description: Set the current horizontal position of the scroll bar for each of the set of matched elements.
  • version added: 1.2.6

  • .scrollLeft( [Number] value )

  • value An integer indicating the new position to set the scroll bar to.

The horizontal scroll position is the same as the number of pixels that are hidden from view above the scrollable area. Setting the positions the horizontal scroll of each matched element.

Examples:

Example:

Set the scrollLeft of a div.
<!DOCTYPE html>
<html>
<head>
  <style>
  div.demo {
  background:#CCCCCC none repeat scroll 0 0;
  border:3px solid #666666;
  margin:5px;
  padding:5px;
  position:relative;
  width:200px;
  height:100px;
  overflow:auto;
  }
  p { margin:10px;padding:5px;border:2px solid #666;width:1000px;height:1000px; }
    </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div class="demo"><h1>lalala</h1><p>Hello</p></div>
  <script>$("div.demo").scrollLeft(300);
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


scrollTop – jQuery API

  • scrollTop( )

    • 1.2.6scrollTop( )

  • scrollTop( [Number] value )

    • 1.2.6scrollTop( [Number] value )

Returns: IntegerInteger .scrollTop( )

Categories: CSS, Offset, Style Properties, Version 1.2.6
Description: Get the current vertical position of the scroll bar for the first element in the set of matched elements.
  • version added: 1.2.6

  • .scrollTop( )

The vertical scroll position is the same as the number of pixels that are hidden from view above the scrollable area. If the scroll bar is at the very top, or if the element is not scrollable, this number will be .

Examples:

Example:

Get the scrollTop of a paragraph.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { margin:10px;padding:5px;border:2px solid #666; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p><p></p>
  <script>var p = $("p:first");
$("p:last").text( "scrollTop:" + p.scrollTop() );

</script>
</body>
</html>

Demo:

Returns: jQueryjQuery .scrollTop( [Number] value )

Categories: CSS, Offset, Style Properties, Version 1.2.6
Description: Set the current vertical position of the scroll bar for each of the set of matched elements.
  • version added: 1.2.6

  • .scrollTop( [Number] value )

  • value An integer indicating the new position to set the scroll bar to.

The vertical scroll position is the same as the number of pixels that are hidden from view above the scrollable area. Setting the positions the vertical scroll of each matched element.

Examples:

Example:

Set the scrollTop of a div.
<!DOCTYPE html>
<html>
<head>
  <style>
div.demo {
background:#CCCCCC none repeat scroll 0 0;
border:3px solid #666666;
margin:5px;
padding:5px;
position:relative;
width:200px;
height:100px;
overflow:auto;
}
  p { margin:10px;padding:5px;border:2px solid #666;width:1000px;height:1000px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div class="demo"><h1>lalala</h1><p>Hello</p></div>
  <script>$("div.demo").scrollTop(300);
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


position – jQuery API

Returns: ObjectObject .position( )

Categories: CSS, Offset, Style Properties, Version 1.2
Description: Get the current coordinates of the first element in the set of matched elements, relative to the offset parent.
  • version added: 1.2

  • .position( )

The method allows us to retrieve the current position of an element . Contrast this with , which retrieves the current position . When positioning a new element near another one and within the same containing DOM element, is the more useful.

Returns an object containing the properties and .

Examples:

Example:

Access the position of the second paragraph:
<!DOCTYPE html>
<html>
<head>
  <style>
  div { padding: 15px;}
  p { margin-left:10px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<div>
  <p>Hello</p>
</div>
<p></p>

  <script>
var p = $("p:first");
var position = p.position();
$("p:last").text( "left: " + position.left + ", top: " + position.top );
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


offset – jQuery API

  • offset( )

    • 1.2offset( )

  • offset( [Function] function(index, coords) )

    • 1.4offset( [Function] function(index, coords) )

Returns: ObjectObject .offset( )

Categories: CSS, Offset, Style Properties, Version 1.2, Version 1.4
Description: Get the current coordinates of the first element in the set of matched elements, relative to the document.
  • version added: 1.2

  • .offset( )

The method allows us to retrieve the current position of an element . Contrast this with , which retrieves the current position . When positioning a new element on top of an existing one for global manipulation (in particular, for implementing drag-and-drop), is the more useful.

returns an object containing the properties and .

Examples:

Example:

Access the offset of the second paragraph:
<!DOCTYPE html>
<html>
<head>
  <style>
p { margin-left:10px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p><p>2nd Paragraph</p>
  <script>var p = $("p:last");
var offset = p.offset();
p.html( "left: " + offset.left + ", top: " + offset.top );</script>
</body>
</html>

Demo:

Example:

Click to see the offset.
<!DOCTYPE html>
<html>
<head>
  <style>
p { margin-left:10px; color:blue; width:200px;
    cursor:pointer; }
span { color:red; cursor:pointer; }
div.abs { width:50px; height:50px; position:absolute;
          left:220px; top:35px; background-color:green;
          cursor:pointer; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div id="result">Click an element.</div>
<p>
  This is the best way to <span>find</span> an offset.
</p>

<div class="abs">
</div>

  <script>
$("*", document.body).click(function (e) {
  var offset = $(this).offset();
  e.stopPropagation();
  $("#result").text(this.tagName + " coords ( " + offset.left + ", " +
                                  offset.top + " )");
});

</script>
</body>
</html>

Demo:

Returns: jQueryjQuery .offset( [Function] function(index, coords) )

Categories: CSS, Offset, Style Properties, Version 1.2, Version 1.4
Description: Set the current coordinates of every element in the set of matched elements, relative to the document.
  • version added: 1.4

  • .offset( [Object] coordinates )

  • coordinates An object containing the properties and , which are integers indicating the new top and left coordinates for the elements.
  • version added: 1.4

  • .offset( [Function] function(index, coords) )

  • function(index, coords) A function to return the coordinates to set. Receives the index of the element in the collection as the first argument and the current coordinates as the second argument. The function should return an object with the new and properties.

The setter method allows us to reposition an element. The element's position is specified . If the element's style property is currently , it will be set to to allow for this repositioning.

Examples:

Example:

Set the offset of the second paragraph:
<!DOCTYPE html>
<html>
<head>
  <style>
p { margin-left:10px; } </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p><p>2nd Paragraph</p>
  <script>$("p:last").offset({ top: 10, left: 30 });</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


css – jQuery API

  • css( [Map] map )

    • 1.0css( [Map] map )

  • css( [String] propertyName, [String|Number] value )

    • 1.0css( [String] propertyName, [String|Number] value )
    • 1.4css( [String] propertyName, [Function] function(index, value) )

Returns: StringString .css( [String] propertyName )

Categories: CSS, Style Properties, Version 1.0, Version 1.4
Description: Get the value of a style property for the first element in the set of matched elements.
  • version added: 1.0

  • .css( [String] propertyName )

  • propertyName A CSS property.

The method is a convenient way to get a style property from the first matched element, especially in light of the different ways browsers access most of those properties (the method in standards-based browsers versus the and properties in Internet Explorer) and the different terms browsers use for certain properties. For example, Internet Explorer's DOM implementation refers to the property as , while W3C standards-compliant browsers refer to it as . The method accounts for such differences, producing the same result no matter which term we use. For example, an element that is floated left will return the string for each of the following three lines:

Also, jQuery can equally interpret the CSS and DOM formatting of multiple-word properties. For example, jQuery understands and returns the correct value for both and .

Shorthand CSS properties (e.g. margin, background, border) are not supported. For example, if you want to retrieve the rendered margin, use: and , and so on.

Examples:

Example:

To access the background color of a clicked div.
<!DOCTYPE html>
<html>
<head>
  <style>
div { width:60px; height:60px; margin:5px; float:left; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<span id="result">&nbsp;</span>
<div style="background-color:blue;"></div>
<div style="background-color:rgb(15,99,30);"></div>

<div style="background-color:#123456;"></div>
<div style="background-color:#f11;"></div>
  <script>
$("div").click(function () {
  var color = $(this).css("background-color");
  $("#result").html("That div is <span style='color:" +
                     color + ";'>" + color + "</span>.");
});

</script>
</body>
</html>

Demo:

Returns: jQueryjQuery .css( [Map] map )

Categories: CSS, Style Properties, Version 1.0, Version 1.4
Description: Set one or more CSS properties for the set of matched elements.
  • version added: 1.0

  • .css( [String] propertyName, [String|Number] value )

  • propertyName A CSS property name.
  • value A value to set for the property.
  • version added: 1.4

  • .css( [String] propertyName, [Function] function(index, value) )

  • propertyName A CSS property name.
  • function(index, value) A function returning the value to set. Receives the index position of the element in the set and the old value as arguments.
  • version added: 1.0

  • .css( [Map] map )

  • map A map of property-value pairs to set.

As with the method, the method makes setting properties of elements quick and easy. This method can take either a property name and value as separate parameters, or a single map of key-value pairs (JavaScript object notation).

Also, jQuery can equally interpret the CSS and DOM formatting of multiple-word properties. For example, jQuery understands and returns the correct value for both and . Notice that with the DOM notation, quotation marks around the property names are optional, but with CSS notation they're required due to the hyphen in the name.

As with , allows us to pass a function as the property value:

$('div.example').css('width', function(index) {
  return index * 50;
});

This example sets the widths of the matched elements to incrementally larger values.

Examples:

Example:

To change the color of any paragraph to red on mouseover event.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { color:blue; width:200px; font-size:14px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

  <p>Just roll the mouse over me.</p>

  <p>Or me to see a color change.</p>

  <script>
  $("p").mouseover(function () {
    $(this).css("color","red");
  });
</script>
</body>
</html>

Demo:

Example:

To highlight a clicked word in the paragraph.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { color:blue; font-weight:bold; cursor:pointer; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<p>
  Once upon a time there was a man
  who lived in a pizza parlor. This
  man just loved pizza and ate it all
  the time.  He went on to be the
  happiest man in the world.  The end.
</p>
  <script>
  var words = $("p:first").text().split(" ");
  var text = words.join("</span> <span>");
  $("p:first").html("<span>" + text + "</span>");
  $("span").click(function () {
    $(this).css("background-color","yellow");
  });

</script>
</body>
</html>

Demo:

Example:

To set the color of all paragraphs to red and background to blue:
<!DOCTYPE html>
<html>
<head>
  <style>
  p { color:green; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

  <p>Move the mouse over a paragraph.</p>
  <p>Like this one or the one above.</p>

  <script>
  $("p").hover(function () {
    $(this).css({'background-color' : 'yellow', 'font-weight' : 'bolder'});
  }, function () {
    var cssObj = {
      'background-color' : '#ddd',
      'font-weight' : '',
      'color' : 'rgb(0,40,244)'
    }
    $(this).css(cssObj);
  });
</script>
</body>
</html>

Demo:

Example:

Increase the size of a div when you click it:
<!DOCTYPE html>
<html>
<head>
  <style>
  div { width: 20px; height: 15px; background-color: #f33; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

  <div>click</div>
  <div>click</div>

  <script>
  $("div").click(function() {
    $(this).css({
      width: function(index, value) {
        return parseFloat(value) * 1.2;
      },
      height: function(index, value) {
        return parseFloat(value) * 1.2;
      }

    });
  });
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Data – jQuery API

Data

  • jQuery jQuery.removeData( [Element] element, [String] name )

    New in 1.2.3 !

    Remove a previously-stored piece of data.

  • Object jQuery.data( [Element] element )

    New in 1.4 !

    Returns value at named data store for the element, as set by , or the full data store for the element.

  • jQuery jQuery.dequeue( [Element] element, [String] queueName )

    New in 1.3 !

    Execute the next function on the queue for the matched element.

  • jQuery jQuery.queue( [Element] element, [String] queueName, [Function] callback() )

    New in 1.3 !

    Manipulate the queue of functions to be executed on the matched element.

  • jQuery .clearQueue( [String] queueName )

    New in 1.4 !

    Remove from the queue all items that have not yet been run.

  • jQuery .removeData( [String] name )

    New in 1.2.3 !

    Remove a previously-stored piece of data.

  • Object .data( )

    New in 1.4 !

    Returns value at named data store for the element, as set by data(name, value).

  • jQuery .dequeue( [String] queueName )

    New in 1.2 !

    Execute the next function on the queue for the matched elements.

  • jQuery .queue( [String] queueName, [Function] callback( next ) )

    New in 1.2 !

    Manipulate the queue of functions to be executed on the matched elements.


jQuery.removeData – jQuery API

Returns: jQueryjQuery jQuery.removeData( [Element] element, [String] name )

Categories: Data, Utilities, Version 1.2.3
Description: Remove a previously-stored piece of data.
  • version added: 1.2.3

  • jQuery.removeData( [Element] element, [String] name )

  • element A DOM element from which to remove data.
  • name A string naming the piece of data to remove.

This is a low-level method, you should probably use instead.

The method allows us to remove values that were previously set using . When called with the name of a key, deletes that particular value; when called with no arguments, all values are removed.

Examples:

Example:

Set a data store for 2 names then remove one of them.
<!DOCTYPE html>
<html>
<head>
  <style>
        div { margin:2px; color:blue; }
        span { color:red; }
        </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>value1 before creation: <span></span></div>
        <div>value1 after creation: <span></span></div>
        <div>value1 after removal: <span></span></div>
        <div>value2 after removal: <span></span></div>
  <script>
var div = $("div")[0];
$("span:eq(0)").text("" + $("div").data("test1"));
jQuery.data(div, "test1", "VALUE-1");
jQuery.data(div, "test2", "VALUE-2");
$("span:eq(1)").text("" + jQuery.data(div, "test1"));
jQuery.removeData(div, "test1");
$("span:eq(2)").text("" + jQuery.data(div, "test1"));
$("span:eq(3)").text("" + jQuery.data(div, "test2"));</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


jQuery.data – jQuery API

  • jQuery.data( [Element] element, [String] key, [Object] value )

    • 1.2.3jQuery.data( [Element] element, [String] key, [Object] value )

  • jQuery.data( [Element] element, [String] key )

    • 1.2.3jQuery.data( [Element] element, [String] key )

  • jQuery.data( [Element] element )

    • 1.4jQuery.data( [Element] element )

Returns: jQueryjQuery jQuery.data( [Element] element, [String] key, [Object] value )

Categories: Data, Utilities, Version 1.2.3, Version 1.4
Description: Store arbitrary data associated with the specified element.
  • version added: 1.2.3

  • jQuery.data( [Element] element, [String] key, [Object] value )

  • element The DOM element to associate with the data.
  • key A string naming the piece of data to set.
  • value The new data value.

This is a low-level method; you should probably use instead.

The method allows us to attach data of any type to DOM elements in a way that is safe from circular references and therefore from memory leaks. We can set several distinct values for a single element and retrieve them later:

jQuery.data(document.body, 'foo', 52);
        jQuery.data(document.body, 'bar', 'test');

Examples:

Example:

Store then retrieve a value from the div element.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { color:blue; }
  span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>
    The values stored were
    <span></span>
    and
    <span></span>
  </div>
  <script>var div = $("div")[0];
    jQuery.data(div, "test", { first: 16, last: "pizza!" });
    $("span:first").text(jQuery.data(div, "test").first);
    $("span:last").text(jQuery.data(div, "test").last);</script>
</body>
</html>

Demo:

Returns: ObjectObject jQuery.data( [Element] element )

Categories: Data, Utilities, Version 1.2.3, Version 1.4
Description: Returns value at named data store for the element, as set by , or the full data store for the element.
  • version added: 1.2.3

  • jQuery.data( [Element] element, [String] key )

  • element The DOM element to query for the data.
  • key Name of the data stored.
  • version added: 1.4

  • jQuery.data( [Element] element )

  • element The DOM element to query for the data.

This is a low-level method; you should probably use instead.

The method allows us to attach data of any type to DOM elements in a way that is safe from circular references and therefore from memory leaks. We can retrieve several distinct values for a single element one at a time, or as a set:

alert(jQuery.data( document.body, 'foo' ));
alert(jQuery.data( document.body ));

The above lines alert the data values that were set on the element. If nothing was set on that element, an empty string is returned.

Calling retrieves all of the element's associated values as a JavaScript object. Note that jQuery itself uses this method to store data for internal use, such as event handlers, so do not assume that it contains only data that your own code has stored.

Examples:

Example:

Get the data named "blah" stored at for an element.
<!DOCTYPE html>
<html>
<head>
  <style>
div { margin:5px; background:yellow; }
button { margin:5px; font-size:14px; }
p { margin:5px; color:blue; }
span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>A div</div>
<button>Get "blah" from the div</button>
<button>Set "blah" to "hello"</button>

<button>Set "blah" to 86</button>
<button>Remove "blah" from the div</button>
<p>The "blah" value of this div is <span>?</span></p>
  <script>
$("button").click(function(e) {
  var value, div = $("div")[0];

  switch ($("button").index(this)) {
    case 0 :
      value = jQuery.data(div, "blah");
      break;
    case 1 :
      jQuery.data(div, "blah", "hello");
      value = "Stored!";
      break;
    case 2 :
      jQuery.data(div, "blah", 86);
      value = "Stored!";
      break;
    case 3 :
      jQuery.removeData(div, "blah");
      value = "Removed!";
      break;
  }

  $("span").text("" + value);
});

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


jQuery.dequeue – jQuery API

Returns: jQueryjQuery jQuery.dequeue( [Element] element, [String] queueName )

Categories: Data, Utilities, Version 1.3
Description: Execute the next function on the queue for the matched element.
  • version added: 1.3

  • jQuery.dequeue( [Element] element, [String] queueName )

  • element A DOM element from which to remove and execute a queued function.
  • queueName A string containing the name of the queue. Defaults to , the standard effects queue.

This is a low-level method, you should probably use instead.

When is called, the next function on the queue is removed from the queue, and then executed. This function should in turn (directly or indirectly) cause to be called, so that the sequence can continue.

Examples:

Example:

Use dequeue to end a custom queue function which allows the queue to keep going.
<!DOCTYPE html>
<html>
<head>
  <style>
div { margin:3px; width:50px; position:absolute;
        height:50px; left:10px; top:30px;
        background-color:yellow; }
  div.red { background-color:red; }  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button>Start</button>  <div></div>
  <script>$("button").click(function () {
      $("div").animate({left:'+=200px'}, 2000);
      $("div").animate({top:'0px'}, 600);
      $("div").queue(function () {
        $(this).toggleClass("red");
         $.dequeue( this );
              });
      $("div").animate({left:'10px', top:'30px'}, 700);
    });</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


jQuery.queue – jQuery API

  • jQuery.queue( [Element] element, [String] queueName )

    • 1.3jQuery.queue( [Element] element, [String] queueName )

  • jQuery.queue( [Element] element, [String] queueName, [Function] callback() )

    • 1.3jQuery.queue( [Element] element, [String] queueName, [Function] callback() )

Returns: ArrayArray jQuery.queue( [Element] element, [String] queueName )

Categories: Data, Utilities, Version 1.3
Description: Show the queue of functions to be executed on the matched element.
  • version added: 1.3

  • jQuery.queue( [Element] element, [String] queueName )

  • element A DOM element to inspect for an attached queue.
  • queueName A string containing the name of the queue. Defaults to , the standard effects queue.

This is a low-level method, you should probably use instead.

Examples:

Example:

Show the length of the queue.
<!DOCTYPE html>
<html>
<head>
  <style>
div { margin:3px; width:40px; height:40px;
        position:absolute; left:0px; top:30px;
        background:green; display:none; }
  div.newcolor { background:blue; }
  span { color:red; }  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button id="show">Show Length of Queue</button>
  <span></span>
  <div></div>
  <script>$("#show").click(function () {
      var n = jQuery.queue( $("div")[0], "fx" );
      $("span").text("Queue length is: " + n.length);
    });
    function runIt() {
      $("div").show("slow");
      $("div").animate({left:'+=200'},2000);
      $("div").slideToggle(1000);
      $("div").slideToggle("fast");
      $("div").animate({left:'-=200'},1500);
      $("div").hide("slow");
      $("div").show(1200);
      $("div").slideUp("normal", runIt);
    }
    runIt();</script>
</body>
</html>

Demo:

Returns: jQueryjQuery jQuery.queue( [Element] element, [String] queueName, [Function] callback() )

Categories: Data, Utilities, Version 1.3
Description: Manipulate the queue of functions to be executed on the matched element.
  • version added: 1.3

  • jQuery.queue( [Element] element, [String] queueName, [Array] newQueue )

  • element A DOM element where the array of queued functions is attached.
  • queueName A string containing the name of the queue. Defaults to , the standard effects queue.
  • newQueue An array of functions to replace the current queue contents.
  • version added: 1.3

  • jQuery.queue( [Element] element, [String] queueName, [Function] callback() )

  • element A DOM element on which to add a queued function.
  • queueName A string containing the name of the queue. Defaults to , the standard effects queue.
  • callback() The new function to add to the queue.

This is a low-level method, you should probably use instead.

Every element can have one or more queues of functions attached to it by jQuery. In most applications, only one queue (called ) is used. Queues allow a sequence of actions to be called on an element asynchronously, without halting program execution.

The method allows us to directly manipulate this queue of functions. Calling with a callback is particularly useful; it allows us to place a new function at the end of the queue.

Note that when adding a function with , we should ensure that is eventually called so that the next function in line executes.

Examples:

Example:

Queue a custom function.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { margin:3px; width:40px; height:40px;
        position:absolute; left:0px; top:30px;
        background:green; display:none; }
  div.newcolor { background:blue; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  Click here...
  <div></div>
  <script>
   $(document.body).click(function () {
      $("div").show("slow");
      $("div").animate({left:'+=200'},2000);
      jQuery.queue( $("div")[0], "fx", function () {
        $(this).addClass("newcolor");
        jQuery.dequeue( this );
      });
      $("div").animate({left:'-=200'},500);
      jQuery.queue( $("div")[0], "fx", function () {
        $(this).removeClass("newcolor");
        jQuery.dequeue( this );
      });
      $("div").slideUp();
    });</script>
</body>
</html>

Demo:

Example:

Set a queue array to delete the queue.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { margin:3px; width:40px; height:40px;
        position:absolute; left:0px; top:30px;
        background:green; display:none; }
  div.newcolor { background:blue; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

  <button id="start">Start</button>
  <button id="stop">Stop</button>
  <div></div>
  <script>
   $("#start").click(function () {
      $("div").show("slow");
      $("div").animate({left:'+=200'},5000);
      jQuery.queue( $("div")[0], "fx", function () {
        $(this).addClass("newcolor");
        jQuery.dequeue( this );
      });
      $("div").animate({left:'-=200'},1500);
      jQuery.queue( $("div")[0], "fx", function () {
        $(this).removeClass("newcolor");
        jQuery.dequeue( this );
      });
      $("div").slideUp();
    });
    $("#stop").click(function () {
      jQuery.queue( $("div")[0], "fx", [] );
      $("div").stop();
    });
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


clearQueue – jQuery API

Returns: jQueryjQuery .clearQueue( [String] queueName )

Categories: Custom, Data, Utilities, Version 1.4
Description: Remove from the queue all items that have not yet been run.
  • version added: 1.4

  • .clearQueue( [String] queueName )

  • queueName A string containing the name of the queue. Defaults to , the standard effects queue.

When the method is called, all functions on the queue that have not been executed are removed from the queue. When used without an argument, removes the remaining functions from , the standard effects queue. In this way it is similar to . However, while the method is meant to be used only with animations, can also be used to remove any function that has been added to a generic jQuery queue with the method.

Examples:

Example:

Empty the queue.
<!DOCTYPE html>
<html>
<head>
  <style>
div { margin:3px; width:40px; height:40px;
    position:absolute; left:0px; top:30px;
    background:green; display:none; }
div.newcolor { background:blue; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button id="start">Start</button>
<button id="stop">Stop</button>
<div></div>
  <script>$("#start").click(function () {
  $("div").show("slow");
  $("div").animate({left:'+=200'},5000);
  $("div").queue(function () {
    $(this).addClass("newcolor");
    $(this).dequeue();
  });
  $("div").animate({left:'-=200'},1500);
  $("div").queue(function () {
    $(this).removeClass("newcolor");
    $(this).dequeue();
  });
  $("div").slideUp();
});
$("#stop").click(function () {
  $("div").clearQueue();
  $("div").stop();
});</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


removeData – jQuery API

Returns: jQueryjQuery .removeData( [String] name )

Categories: Data, Data Storage, Version 1.2.3
Description: Remove a previously-stored piece of data.
  • version added: 1.2.3

  • .removeData( [String] name )

  • name A string naming the piece of data to delete.

The method allows us to remove values that were previously set using . When called with the name of a key, deletes that particular value; when called with no arguments, all values are removed.

Examples:

Example:

Set a data store for 2 names then remove one of them.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { margin:2px; color:blue; }
  span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>value1 before creation: <span></span></div>
  <div>value1 after creation: <span></span></div>
  <div>value1 after removal: <span></span></div>

  <div>value2 after removal: <span></span></div>
  <script>

    $("span:eq(0)").text("" + $("div").data("test1"));
    $("div").data("test1", "VALUE-1");
    $("div").data("test2", "VALUE-2");
    $("span:eq(1)").text("" + $("div").data("test1"));
    $("div").removeData("test1");
    $("span:eq(2)").text("" + $("div").data("test1"));
    $("span:eq(3)").text("" + $("div").data("test2"));

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


data – jQuery API

  • data( [String] key, [Object] value )

    • 1.2.3data( [String] key, [Object] value )

  • data( [Object] obj )

    • 1.4data( [Object] obj )
    • 1.2.3data( [String] key )

  • data( )

    • 1.4data( )

Returns: jQueryjQuery .data( [Object] obj )

Categories: Data, Data Storage, Version 1.2.3, Version 1.4
Description: Store arbitrary data associated with the matched elements.
  • version added: 1.2.3

  • .data( [String] key, [Object] value )

  • key A string naming the piece of data to set.
  • value The new data value; it can be any Javascript type including Array or Object.
  • version added: 1.4

  • .data( [Object] obj )

  • obj An object of key-value pairs of data to set.

The method allows us to attach data of any type to DOM elements in a way that is safe from circular references and therefore from memory leaks.

We can set several distinct values for a single element and retrieve them later:

$('body').data('foo', 52);
$('body').data('bar', { myType: 'test', count: 40 });

$('body').data('foo'); // 52
$('body').data(); // {foo: 52, bar: { myType: 'test', count: 40 }}

Setting an element's data object with replaces all data previously stored with that element. If you are using third-party plugins it may not be advisable to completely replace the element's data object, since plugins may have also set data. Until jQuery 1.4.2, jQuery itself used the method to save information about events that have been bound to the element, using a data item named 'events'.

$('body').data('foo', 52);
$('body').data({one: 1, two: 2});

$('body').data('foo'); // undefined
$('body').data(); // {one: 1, two: 2}

Due to the way browsers interact with plugins and external code, the method cannot be used on , or elements.

Examples:

Example:

Store then retrieve a value from the div element.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { color:blue; }
  span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>
    The values stored were
    <span></span>
    and
    <span></span>
  </div>
  <script>
$("div").data("test", { first: 16, last: "pizza!" });
$("span:first").text($("div").data("test").first);
$("span:last").text($("div").data("test").last);
</script>
</body>
</html>

Demo:

Returns: ObjectObject .data( )

Categories: Data, Data Storage, Version 1.2.3, Version 1.4
Description: Returns value at named data store for the element, as set by data(name, value).
  • version added: 1.2.3

  • .data( [String] key )

  • key Name of the data stored.
  • version added: 1.4

  • .data( )

The method allows us to attach data of any type to DOM elements in a way that is safe from circular references and therefore from memory leaks. We can retrieve several distinct values for a single element one at a time, or as a set:

alert($('body').data('foo'));
alert($('body').data());

The above lines alert the data values that were set on the element. If nothing was set on that element, an empty string is returned:

Calling with no parameters retrieves all of the values as a JavaScript object. This object can be safely cached in a variable as long as a new object is not set with .

Examples:

Example:

Get the data named "blah" stored at for an element.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { margin:5px; background:yellow; }
  button { margin:5px; font-size:14px; }
  p { margin:5px; color:blue; }
  span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>A div</div>
  <button>Get "blah" from the div</button>
  <button>Set "blah" to "hello"</button>

  <button>Set "blah" to 86</button>
  <button>Remove "blah" from the div</button>
  <p>The "blah" value of this div is <span>?</span></p>
  <script>
$("button").click(function(e) {
  var value;

  switch ($("button").index(this)) {
    case 0 :
      value = $("div").data("blah");
      break;
    case 1 :
      $("div").data("blah", "hello");
      value = "Stored!";
      break;
    case 2 :
      $("div").data("blah", 86);
      value = "Stored!";
      break;
    case 3 :
      $("div").removeData("blah");
      value = "Removed!";
      break;
  }

  $("span").text("" + value);
});

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


dequeue – jQuery API

Returns: jQueryjQuery .dequeue( [String] queueName )

Categories: Custom, Data, Utilities, Version 1.2
Description: Execute the next function on the queue for the matched elements.
  • version added: 1.2

  • .dequeue( [String] queueName )

  • queueName A string containing the name of the queue. Defaults to , the standard effects queue.

When is called, the next function on the queue is removed from the queue, and then executed. This function should in turn (directly or indirectly) cause to be called, so that the sequence can continue.

Examples:

Example:

Use dequeue to end a custom queue function which allows the queue to keep going.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { margin:3px; width:50px; position:absolute;
  height:50px; left:10px; top:30px;
  background-color:yellow; }
  div.red { background-color:red; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button>Start</button>
<div></div>
  <script>
$("button").click(function () {
  $("div").animate({left:'+=200px'}, 2000);
  $("div").animate({top:'0px'}, 600);
  $("div").queue(function () {
    $(this).toggleClass("red");
    $(this).dequeue();
  });
  $("div").animate({left:'10px', top:'30px'}, 700);
});
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


queue – jQuery API

  • queue( [String] queueName )

    • 1.2queue( [String] queueName )

  • queue( [String] queueName, [Function] callback( next ) )

    • 1.2queue( [String] queueName, [Function] callback( next ) )

Returns: ArrayArray .queue( [String] queueName )

Categories: Custom, Data, Utilities, Version 1.2
Description: Show the queue of functions to be executed on the matched elements.
  • version added: 1.2

  • .queue( [String] queueName )

  • queueName A string containing the name of the queue. Defaults to , the standard effects queue.

Examples:

Example:

Show the length of the queue.
<!DOCTYPE html>
<html>
<head>
  <style>
div { margin:3px; width:40px; height:40px;
        position:absolute; left:0px; top:30px;
        background:green; display:none; }
  div.newcolor { background:blue; }
  span { color:red; }  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button id="show">Show Length of Queue</button>
  <span></span>
  <div></div>
  <script>$("#show").click(function () {
      var n = $("div").queue("fx");
      $("span").text("Queue length is: " + n.length);
    });
    function runIt() {
      $("div").show("slow");
      $("div").animate({left:'+=200'},2000);
      $("div").slideToggle(1000);
      $("div").slideToggle("fast");
      $("div").animate({left:'-=200'},1500);
      $("div").hide("slow");
      $("div").show(1200);
      $("div").slideUp("normal", runIt);
    }
    runIt();</script>
</body>
</html>

Demo:

Returns: jQueryjQuery .queue( [String] queueName, [Function] callback( next ) )

Categories: Custom, Data, Utilities, Version 1.2
Description: Manipulate the queue of functions to be executed on the matched elements.
  • version added: 1.2

  • .queue( [String] queueName, [Array] newQueue )

  • queueName A string containing the name of the queue. Defaults to , the standard effects queue.
  • newQueue An array of functions to replace the current queue contents.
  • version added: 1.2

  • .queue( [String] queueName, [Function] callback( next ) )

  • queueName A string containing the name of the queue. Defaults to , the standard effects queue.
  • callback( next ) The new function to add to the queue, with a function to call that will dequeue the next item.

Every element can have one to many queues of functions attached to it by jQuery. In most applications, only one queue (called ) is used. Queues allow a sequence of actions to be called on an element asynchronously, without halting program execution. The typical example of this is calling multiple animation methods on an element. For example:

$('#foo').slideUp().fadeIn();

When this statement is executed, the element begins its sliding animation immediately, but the fading transition is placed on the queue to be called only once the sliding transition is complete.

The method allows us to directly manipulate this queue of functions. Calling with a callback is particularly useful; it allows us to place a new function at the end of the queue.

This feature is similar to providing a callback function with an animation method, but does not require the callback to be given at the time the animation is performed.

$('#foo').slideUp();
$('#foo').queue(function() {
  alert('Animation complete.');
  $(this).dequeue();
});

This is equivalent to:

$('#foo').slideUp(function() {
  alert('Animation complete.');
});

Note that when adding a function with , we should ensure that is eventually called so that the next function in line executes.

In jQuery 1.4 the function that's called is passed in another function, as the first argument, that when called automatically dequeues the next item and keeps the queue moving. You would use it like so:

$("#test").queue(function(next) {
    // Do some stuff...
    next();
});

Examples:

Example:

Queue a custom function.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { margin:3px; width:40px; height:40px;
        position:absolute; left:0px; top:30px;
        background:green; display:none; }
  div.newcolor { background:blue; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  Click here...
  <div></div>
  <script>$(document.body).click(function () {
      $("div").show("slow");
      $("div").animate({left:'+=200'},2000);
      $("div").queue(function () {
        $(this).addClass("newcolor");
        $(this).dequeue();
      });
      $("div").animate({left:'-=200'},500);
      $("div").queue(function () {
        $(this).removeClass("newcolor");
        $(this).dequeue();
      });
      $("div").slideUp();
    });</script>
</body>
</html>

Demo:

Example:

Set a queue array to delete the queue.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { margin:3px; width:40px; height:40px;
        position:absolute; left:0px; top:30px;
        background:green; display:none; }
  div.newcolor { background:blue; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button id="start">Start</button>
  <button id="stop">Stop</button>
  <div></div>
  <script>$("#start").click(function () {
      $("div").show("slow");
      $("div").animate({left:'+=200'},5000);
      $("div").queue(function () {
        $(this).addClass("newcolor");
        $(this).dequeue();
      });
      $("div").animate({left:'-=200'},1500);
      $("div").queue(function () {
        $(this).removeClass("newcolor");
        $(this).dequeue();
      });
      $("div").slideUp();
    });
    $("#stop").click(function () {
      $("div").queue("fx", []);
      $("div").stop();
    });</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Dimensions – jQuery API

Dimensions

  • Integer .outerWidth( [Boolean] includeMargin )

    New in 1.2.6 !

    Get the current computed width for the first element in the set of matched elements, including padding and border.

  • Integer .outerHeight( [Boolean] includeMargin )

    New in 1.2.6 !

    Get the current computed height for the first element in the set of matched elements, including padding, border, and optionally margin.

  • Integer .innerWidth( )

    New in 1.2.6 !

    Get the current computed width for the first element in the set of matched elements, including padding but not border.

  • Integer .innerHeight( )

    New in 1.2.6 !

    Get the current computed height for the first element in the set of matched elements, including padding but not border.

  • jQuery .width( [Function] function(index, width) )

    New in 1.4.1 !

    Set the CSS width of each element in the set of matched elements.

  • jQuery .height( [Function] function(index, height) )

    New in 1.4.1 !

    Set the CSS height of every matched element.


Effects – jQuery API

Effects

  • jQuery .toggle( [Boolean] showOrHide )

    New in 1.3 !

    Display or hide the matched elements.

  • jQuery .hide( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Hide the matched elements.

  • jQuery .show( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display the matched elements.

  • jQuery .delay( [Integer] duration, [String] queueName )

    New in 1.4 !

    Set a timer to delay execution of subsequent items in the queue.

  • Boolean jQuery.fx.off

    New in 1.3 !

    Globally disable all animations.

  • jQuery .clearQueue( [String] queueName )

    New in 1.4 !

    Remove from the queue all items that have not yet been run.

  • jQuery .dequeue( [String] queueName )

    New in 1.2 !

    Execute the next function on the queue for the matched elements.

  • jQuery .queue( [String] queueName, [Function] callback( next ) )

    New in 1.2 !

    Manipulate the queue of functions to be executed on the matched elements.

  • jQuery .stop( [Boolean] clearQueue, [Boolean] jumpToEnd )

    New in 1.2 !

    Stop the currently-running animation on the matched elements.

  • jQuery .animate( [Options] properties, [Options] options )

    New in 1.0 !

    Perform a custom animation of a set of CSS properties.

  • jQuery .fadeTo( [String,Number] duration, [Number] opacity, [Callback] callback )

    New in 1.0 !

    Adjust the opacity of the matched elements.

  • jQuery .fadeOut( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Hide the matched elements by fading them to transparent.

  • jQuery .fadeIn( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display the matched elements by fading them to opaque.

  • jQuery .slideToggle( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display or hide the matched elements with a sliding motion.

  • jQuery .slideUp( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Hide the matched elements with a sliding motion.

  • jQuery .slideDown( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display the matched elements with a sliding motion.


Basics – jQuery API

Basics

  • jQuery .toggle( [Boolean] showOrHide )

    New in 1.3 !

    Display or hide the matched elements.

  • jQuery .hide( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Hide the matched elements.

  • jQuery .show( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display the matched elements.


toggle – jQuery API

  • toggle( [Function] handler(eventObject), [Function] handler(eventObject), [Function] handler(eventObject) )

    • 1.0toggle( [Function] handler(eventObject), [Function] handler(eventObject), [Function] handler(eventObject) )

  • toggle( [String,Number] duration, [Callback] callback )

    • 1.0toggle( [String,Number] duration, [Callback] callback )

  • toggle( [Boolean] showOrHide )

    • 1.3toggle( [Boolean] showOrHide )

Returns: jQueryjQuery .toggle( [Function] handler(eventObject), [Function] handler(eventObject), [Function] handler(eventObject) )

Categories: Basics, Mouse Events, Version 1.0, Version 1.3
Description: Bind two or more handlers to the matched elements, to be executed on alternate clicks.
  • version added: 1.0

  • .toggle( [Function] handler(eventObject), [Function] handler(eventObject), [Function] handler(eventObject) )

  • handler(eventObject) A function to execute every even time the element is clicked.
  • handler(eventObject) A function to execute every odd time the element is clicked.
  • handler(eventObject) Additional handlers to cycle through after clicks.

The method binds a handler for the event, so the rules outlined for the triggering of apply here as well.

For example, consider the HTML:
<div id="target">
  Click here
</div>

Event handlers can then be bound to the :

$('#target').toggle(function() {
  alert('First handler for .toggle() called.');
}, function() {
  alert('Second handler for .toggle() called.');
});

As the element is clicked repeatedly, the messages alternate:

If more than two handlers are provided, will cycle among all of them. For example, if there are three handlers, then the first handler will be called on the first click, the fourth click, the seventh click, and so on.

The method is provided for convenience. It is relatively straightforward to implement the same behavior by hand, and this can be necessary if the assumptions built into prove limiting. For example, is not guaranteed to work correctly if applied twice to the same element. Since internally uses a handler to do its work, we must unbind to remove a behavior attached with , so other handlers can be caught in the crossfire. The implementation also calls on the event, so links will not be followed and buttons will not be clicked if has been called on the element.

Examples:

Example:

Click to toggle highlight on the list item.
<!DOCTYPE html>
<html>
<head>
  <style>
  ul { margin:10px; list-style:inside circle; font-weight:bold; }
  li { cursor:pointer; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <ul>
    <li>Go to the store</li>
    <li>Pick up dinner</li>
    <li>Debug crash</li>

    <li>Take a jog</li>
  </ul>
  <script>
    $("li").toggle(
      function () {
        $(this).css({"list-style-type":"disc", "color":"blue"});
      },
      function () {
        $(this).css({"list-style-type":"disc", "color":"red"});
      },
      function () {
        $(this).css({"list-style-type":"", "color":""});
      }
    );

</script>
</body>
</html>

Demo:

Example:

To toggle a style on table cells:
<script>$("td").toggle(
  function () {
    $(this).addClass("selected");
  },
  function () {
    $(this).removeClass("selected");
  }
);</script>

Returns: jQueryjQuery .toggle( [Boolean] showOrHide )

Categories: Basics, Mouse Events, Version 1.0, Version 1.3
Description: Display or hide the matched elements.
  • version added: 1.0

  • .toggle( [String,Number] duration, [Callback] callback )

  • duration A string or number determining how long the animation will run.
  • callback A function to call once the animation is complete.
  • version added: 1.3

  • .toggle( [Boolean] showOrHide )

  • showOrHide A Boolean indicating whether to show or hide the elements.

Examples:

Example:

Toggles all paragraphs.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button>Toggle</button>
<p>Hello</p>
<p style="display: none">Good Bye</p>
  <script>

$("button").click(function () {
$("p").toggle();
});
</script>
</body>
</html>

Demo:

Example:

Animates all paragraphs to be shown if they are hidden and hidden if they are visible, completing the animation within 600 milliseconds.
<!DOCTYPE html>
<html>
<head>
  <style>
p { background:#dad;
font-weight:bold;
font-size:16px; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button>Toggle 'em</button>

<p>Hiya</p>
<p>Such interesting text, eh?</p>
  <script>
$("button").click(function () {
$("p").toggle("slow");
});
</script>
</body>
</html>

Demo:

Example:

Shows all paragraphs, then hides them all, back and forth.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button>Toggle</button>
<p>Hello</p>
<p style="display: none">Good Bye</p>
  <script>

var flip = 0;
$("button").click(function () {
$("p").toggle( flip++ % 2 == 0 );
});
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


hide – jQuery API

  • hide( )

    • 1.0hide( )

  • hide( [String,Number] duration, [Callback] callback )

    • 1.0hide( [String,Number] duration, [Callback] callback )

Returns: jQueryjQuery .hide( [String,Number] duration, [Callback] callback )

Categories: Basics, Version 1.0
Description: Hide the matched elements.
  • version added: 1.0

  • .hide( )

  • version added: 1.0

  • .hide( [String,Number] duration, [Callback] callback )

  • duration A string or number determining how long the animation will run.
  • callback A function to call once the animation is complete.

With no parameters, the method is the simplest way to hide an element:

$('.target').hide();

The matched elements will be hidden immediately, with no animation. This is roughly equivalent to calling , except that the value of the property is saved in jQuery's data cache so that can later be restored to its initial value. If an element has a value of , then is hidden and shown, it will once again be displayed .

When a duration is provided, becomes an animation method. The method animates the width, height, and opacity of the matched elements simultaneously. When these properties reach 0, the style property is set to to ensure that the element no longer affects the layout of the page.

Durations are given in milliseconds; higher values indicate slower animations, not faster ones. The strings and can be supplied to indicate durations of and milliseconds, respectively.

If supplied, the callback is fired once the animation is complete. This can be useful for stringing different animations together in sequence. The callback is not sent any arguments, but is set to the DOM element being animated. If multiple elements are animated, it is important to note that the callback is executed once per matched element, not once for the animation as a whole.

We can animate any element, such as a simple image:

<div id="clickme">
  Click here
</div>
<img id="book" src="book.png" alt="" width="100" height="123" />
With the element initially shown, we can hide it slowly:
$('#clickme').click(function() {
  $('#book').hide('slow', function() {
    alert('Animation complete.');
  });
});

Examples:

Example:

Hides all paragraphs then the link on click.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p>
  <a href="#">Click to hide me too</a>
  <p>Here is another paragraph</p>
  <script>

    $("p").hide();
    $("a").click(function () {
      $(this).hide();
      return true;
    });
</script>
</body>
</html>

Demo:

Example:

Animates all shown paragraphs to hide slowly, completing the animation within 600 milliseconds.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { background:#dad; font-weight:bold; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button>Hide 'em</button>

  <p>Hiya</p>
  <p>Such interesting text, eh?</p>
  <script>
    $("button").click(function () {
      $("p").hide("slow");
    });
</script>
</body>
</html>

Demo:

Example:

Animates all spans (words in this case) to hide fastly, completing each animation within 200 milliseconds. Once each animation is done, it starts the next one.
<!DOCTYPE html>
<html>
<head>
  <style>
  span { background:#def3ca; padding:3px; float:left; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button id="hidr">Hide</button>
  <button id="showr">Show</button>
  <div>

    <span>Once</span> <span>upon</span> <span>a</span>
    <span>time</span> <span>there</span> <span>were</span>
    <span>three</span> <span>programmers...</span>

  </div>
  <script>
    $("#hidr").click(function () {
      $("span:last-child").hide("fast", function () {
        // use callee so don't have to name the function
        $(this).prev().hide("fast", arguments.callee);
      });
    });
    $("#showr").click(function () {
      $("span").show(2000);
    });

</script>
</body>
</html>

Demo:

Example:

Hides the divs when clicked over 2 seconds, then removes the div element when its hidden. Try clicking on more than one box at a time.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { background:#ece023; width:30px;
        height:40px; margin:2px; float:left; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div></div>
  <script>
    for (var i = 0; i < 5; i++) {
      $("<div>").appendTo(document.body);
    }
    $("div").click(function () {
      $(this).hide(2000, function () {
        $(this).remove();
      });
    });
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


show – jQuery API

  • show( )

    • 1.0show( )

  • show( [String,Number] duration, [Callback] callback )

    • 1.0show( [String,Number] duration, [Callback] callback )

Returns: jQueryjQuery .show( [String,Number] duration, [Callback] callback )

Categories: Basics, Version 1.0
Description: Display the matched elements.
  • version added: 1.0

  • .show( )

  • version added: 1.0

  • .show( [String,Number] duration, [Callback] callback )

  • duration A string or number determining how long the animation will run.
  • callback A function to call once the animation is complete.

With no parameters, the method is the simplest way to display an element:

$('.target').show();

The matched elements will be revealed immediately, with no animation. This is roughly equivalent to calling , except that the property is restored to whatever it was initially. If an element has a value of , then is hidden and shown, it will once again be displayed .

When a duration is provided, becomes an animation method. The method animates the width, height, and opacity of the matched elements simultaneously.

Durations are given in milliseconds; higher values indicate slower animations, not faster ones. The strings and can be supplied to indicate durations of and milliseconds, respectively.

If supplied, the callback is fired once the animation is complete. This can be useful for stringing different animations together in sequence. The callback is not sent any arguments, but is set to the DOM element being animated. If multiple elements are animated, it is important to note that the callback is executed once per matched element, not once for the animation as a whole.

We can animate any element, such as a simple image:

<div id="clickme">
  Click here
</div>
<img id="book" src="book.png" alt="" width="100" height="123" />
With the element initially hidden, we can show it slowly:
$('#clickme').click(function() {
  $('#book').show('slow', function() {
    // Animation complete.
  });
});

Examples:

Example:

Animates all hidden paragraphs to show slowly, completing the animation within 600 milliseconds.
<!DOCTYPE html>
<html>
<head>
  <style>
      p { background:yellow; }
      </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button>Show it</button>

      <p style="display: none">Hello  2</p>
  <script>
    $("button").click(function () {
    $("p").show("slow");
    });
    </script>
</body>
</html>

Demo:

Example:

Animates all hidden divs to show fastly in order, completing each animation within 200 milliseconds. Once each animation is done, it starts the next one.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { background:#def3ca; margin:3px; width:80px;
  display:none; float:left; text-align:center; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

  <button id="showr">Show</button>
  <button id="hidr">Hide</button>
  <div>Hello 3,</div>

  <div>how</div>
  <div>are</div>
  <div>you?</div>
  <script>
$("#showr").click(function () {
  $("div:eq(0)").show("fast", function () {
    /* use callee so don't have to name the function */
    $(this).next("div").show("fast", arguments.callee);
  });
});
$("#hidr").click(function () {
  $("div").hide(2000);
});

</script>
</body>
</html>

Demo:

Example:

Shows all span and input elements with an animation. Once the animation is done, it changes the text.
<!DOCTYPE html>
<html>
<head>
  <style>
  span { display:none; }
  div { display:none; }
  p { font-weight:bold; background-color:#fcd; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button>Do it!</button>
  <span>Are you sure? (type 'yes' if you are) </span>
  <div>
    <form>
      <input type="text"  value="as;ldkfjalsdf"/>
    </form>
  </div>
  <p style="display:none;">I'm hidden...</p>

  <script>
function doIt() {
  $("span,div").show("slow");
}
/* can pass in function name */
$("button").click(doIt);

$("form").submit(function () {
  if ($("input").val() == "yes") {
    $("p").show(4000, function () {
      $(this).text("Ok, DONE! (now showing)");
    });
  }
  $("span,div").hide("fast");
  /* to stop the submit */
  return false;
});
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Custom – jQuery API

Custom

  • jQuery .delay( [Integer] duration, [String] queueName )

    New in 1.4 !

    Set a timer to delay execution of subsequent items in the queue.

  • Boolean jQuery.fx.off

    New in 1.3 !

    Globally disable all animations.

  • jQuery .clearQueue( [String] queueName )

    New in 1.4 !

    Remove from the queue all items that have not yet been run.

  • jQuery .dequeue( [String] queueName )

    New in 1.2 !

    Execute the next function on the queue for the matched elements.

  • jQuery .queue( [String] queueName, [Function] callback( next ) )

    New in 1.2 !

    Manipulate the queue of functions to be executed on the matched elements.

  • jQuery .stop( [Boolean] clearQueue, [Boolean] jumpToEnd )

    New in 1.2 !

    Stop the currently-running animation on the matched elements.

  • jQuery .animate( [Options] properties, [Options] options )

    New in 1.0 !

    Perform a custom animation of a set of CSS properties.


delay – jQuery API

Returns: jQueryjQuery .delay( [Integer] duration, [String] queueName )

Categories: Custom, Version 1.4
Description: Set a timer to delay execution of subsequent items in the queue.
  • version added: 1.4

  • .delay( [Integer] duration, [String] queueName )

  • duration An integer indicating the number of milliseconds to delay execution of the next item in the queue.
  • queueName A string containing the name of the queue. Defaults to , the standard effects queue.

Added to jQuery in version 1.4, the method allows us to delay the execution of functions that follow it in the queue. It can be used with the standard effects queue or with a custom queue.

Durations are given in milliseconds; higher values indicate slower animations, not faster ones. The strings and can be supplied to indicate durations of 200 and 600 milliseconds, respectively.

Using the standard effects queue, we can, for example, set an 800-millisecond delay between the and of :

$('#foo').slideUp(300).delay(800).fadeIn(400);

When this statement is executed, the element slides up for 300 milliseconds and then pauses for 800 milliseconds before fading in for 400 milliseconds.

Examples:

Example:

Animate the hiding and showing of two divs, delaying the first before showing it.
<!DOCTYPE html>
<html>
<head>
  <style>
div { width: 60px; height: 60px; float: left; }
.first { background-color: #3f3; }
.second { background-color: #33f;}
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<p><button>Run</button></p>
<div class="first"></div>
<div class="second"></div>

  <script>
    $("button").click(function() {
      $("div.first").slideUp(300).delay(800).fadeIn(400);
      $("div.second").slideUp(300).fadeIn(400);
    });
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


jQuery.fx.off – jQuery API

Returns: BooleanBoolean jQuery.fx.off

Categories: Custom, Properties of the Global jQuery Object, Version 1.3
Description: Globally disable all animations.
  • version added: 1.3

  • jQuery.fx.off

When this property is set to , all animation methods will immediately set elements to their final state when called, rather than displaying an effect. This may be desirable for a couple reasons:

Animations can be turned back on by setting the property to .

Examples:

Example:

Toggle animation on and off
<!DOCTYPE html>
<html>
<head>
  <style>
    div { width:50px; height:30px; margin:5px; float:left;
          background:green; }
    </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p><input type="button" value="Run"/> <button>Toggle fx</button></p>
<div></div>
  <script>
var toggleFx = function() {
  $.fx.off = !$.fx.off;
};
toggleFx();

$("button").click(toggleFx)

$("input").click(function(){
  $("div").toggle("slow");
});
  </script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


stop – jQuery API

Returns: jQueryjQuery .stop( [Boolean] clearQueue, [Boolean] jumpToEnd )

Categories: Custom, Version 1.2
Description: Stop the currently-running animation on the matched elements.
  • version added: 1.2

  • .stop( [Boolean] clearQueue, [Boolean] jumpToEnd )

  • clearQueue A Boolean indicating whether to remove queued animation as well. Defaults to .
  • jumpToEnd A Boolean indicating whether to complete the current animation immediately. Defaults to .

When is called on an element, the currently-running animation (if any) is immediately stopped. If, for instance, an element is being hidden with when is called, the element will now still be displayed, but will be a fraction of its previous height. Callback functions are not called.

If more than one animation method is called on the same element, the later animations are placed in the effects queue for the element. These animations will not begin until the first one completes. When is called, the next animation in the queue begins immediately. If the parameter is provided with a value of , then the rest of the animations in the queue are removed and never run.

If the property is provided with a value of , the current animation stops, but the element is immediately given its target values for each CSS property. In our above example, the element would be immediately hidden. The callback function is then immediately called, if provided.

The usefulness of the method is evident when we need to animate an element on and :

<div id="hoverme">
  Hover me
  <img id="hoverme" src="book.png" alt="" width="100" height="123" />
</div>

We can create a nice fade effect without the common problem of multiple queued animations by adding to the chain:

$('#hoverme-stop-2').hover(function() {
  $(this).find('img').stop(true, true).fadeOut();
}, function() {
  $(this).find('img').stop(true, true).fadeIn();
});

Examples:

Example:

Click the Go button once to start the animation, then click the STOP button to stop it where it's currently positioned. Another option is to click several buttons to queue them up and see that stop just kills the currently playing one.
<!DOCTYPE html>
<html>
<head>
  <style>
div {
position: absolute;
background-color: #abc;
left: 0px;
top:30px;
width: 60px;
height: 60px;
margin: 5px;
}
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button id="go">Go</button>
<button id="stop">STOP!</button>
<button id="back">Back</button>
<div class="block"></div>
  <script>
// Start animation
$("#go").click(function(){
$(".block").animate({left: '+=100px'}, 2000);
});

// Stop animation when button is clicked
$("#stop").click(function(){
$(".block").stop();
});

// Start animation in the opposite direction
$("#back").click(function(){
$(".block").animate({left: '-=100px'}, 2000);
});

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


animate – jQuery API

  • animate( [Options] properties, [String,Number] duration, [String] easing, [Callback] callback )

    • 1.0animate( [Options] properties, [String,Number] duration, [String] easing, [Callback] callback )

  • animate( [Options] properties, [Options] options )

    • 1.0animate( [Options] properties, [Options] options )

Returns: jQueryjQuery .animate( [Options] properties, [Options] options )

Categories: Custom, Version 1.0
Description: Perform a custom animation of a set of CSS properties.
  • version added: 1.0

  • .animate( [Options] properties, [String,Number] duration, [String] easing, [Callback] callback )

  • properties A map of CSS properties that the animation will move toward.
  • duration A string or number determining how long the animation will run.
  • easing A string indicating which easing function to use for the transition.
  • callback A function to call once the animation is complete.
  • version added: 1.0

  • .animate( [Options] properties, [Options] options )

  • properties A map of CSS properties that the animation will move toward.
  • options A map of additional options to pass to the method. Supported keys:

The method allows us to create animation effects on any numeric CSS property. The only required parameter is a map of CSS properties. This map is similar to the one that can be sent to the method, except that the range of properties is more restrictive.

All animated properties should be numeric (except as noted below); properties that are non-numeric cannot be animated using basic jQuery functionality. (For example, , , or can be animated but cannot be.) Property values are treated as a number of pixels unless otherwise specified. The units and can be specified where applicable.

In addition to numeric values, each property can take the strings , , and . These shortcuts allow for custom hiding and showing animations that take into account the display type of the element.

Animated properties can also be relative. If a value is supplied with a leading or sequence of characters, then the target value is computed by adding or subtracting the given number from the current value of the property.

Duration

Durations are given in milliseconds; higher values indicate slower animations, not faster ones. The strings and can be supplied to indicate durations of and milliseconds, respectively.

Callback Function

If supplied, the callback is fired once the animation is complete. This can be useful for stringing different animations together in sequence. The callback is not sent any arguments, but is set to the DOM element being animated. If multiple elements are animated, it is important to note that the callback is executed once per matched element, not once for the animation as a whole.

We can animate any element, such as a simple image:

<div id="clickme">
  Click here
</div>
<img id="book" src="book.png" alt="" width="100" height="123"
  style="position: relative; left: 10px;" />

We can animate the opacity, left offset, and height of the image simultaneously:

$('#clickme').click(function() {
  $('#book').animate({
    opacity: 0.25,
    left: '+=50',
    height: 'toggle'
  }, 5000, function() {
    // Animation complete.
  });
});

Note that we have specified as the target value of the property. Since the image was visible before, the animation shrinks the height to 0 to hide it. A second click then reverses this transition:

The of the image is already at its target value, so this property is not animated by the second click. Since we specified the target value for as a relative value, the image moves even farther to the right during this second animation.

The attribute of the element must not be if we wish to animate the property as we do in the example.

Easing

The remaining parameter of is a string naming an easing function to use. An easing function specifies the speed at which the animation progresses at different points within the animation. The only easing implementations in the jQuery library are the default, called , and one that progresses at a constant pace, called . More easing functions are available with the use of plug-ins, most notably the .

Per-property Easing

As of jQuery version 1.4, we can set per-property easing functions within a single call. In the first version of , each property can take an array as its value: The first member of the array is the CSS property and the second member is an easing function. If a per-property easing function is not defined for a particular property, it uses the value of the method's optional easing argument. If the easing argument is not defined, the default function is used.

We can, for example, simultaneously animate the width and height with the easing function and the opacity with the easing function:

$('#clickme').click(function() {
  $('#book').animate({
    width: ['toggle', 'swing'],
    height: ['toggle', 'swing'],
    opacity: 'toggle'
  }, 5000, 'linear', function() {
      $(this).after('<div>Animation complete.</div>');
  });
});

In the second version of , the options map can include the property, which is itself a map of CSS properties and their corresponding easing functions. We can simultaneously animate the width using the easing function and the height using the easing function.

$('#clickme').click(function() {
  $('#book').animate({
    width: 'toggle',
    height: 'toggle'
  }, {
    duration: 5000,
    specialEasing: {
      width: 'linear',
      height: 'easeOutBounce'
    },
    complete: function() {
      $(this).after('<div>Animation complete.</div>');
    }
  });
});

As previously noted, a plug-in is required for the function.

Examples:

Example:

Click the button to animate the div with a number of different properties.
<!DOCTYPE html>
<html>
<head>
  <style>
div {
background-color:#bca;
width:100px;
border:1px solid green;
}
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button id="go">&raquo; Run</button>

<div id="block">Hello!</div>
  <script>

// Using multiple unit types within one animation.
$("#go").click(function(){
  $("#block").animate({
    width: "70%",
    opacity: 0.4,
    marginLeft: "0.6in",
    fontSize: "3em",
    borderWidth: "10px"
  }, 1500 );
});
</script>
</body>
</html>

Demo:

Example:

Shows a div animate with a relative move. Click several times on the buttons to see the relative animations queued up.
<!DOCTYPE html>
<html>
<head>
  <style>
div {
position:absolute;
background-color:#abc;
left:50px;
width:90px;
height:90px;
margin:5px;
}
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button id="left">&laquo;</button> <button id="right">&raquo;</button>
<div class="block"></div>

  <script>
$("#right").click(function(){
  $(".block").animate({"left": "+=50px"}, "slow");
});

$("#left").click(function(){
  $(".block").animate({"left": "-=50px"}, "slow");
});

</script>
</body>
</html>

Demo:

Example:

Animates all paragraphs to toggle both height and opacity, completing the animation within 600 milliseconds.
<script>$("p").animate({
  "height": "toggle", "opacity": "toggle"

}, "slow");</script>

Example:

Animates all paragraph to a left style of 50 and opacity of 1 (opaque, visible), completing the animation within 500 milliseconds.
<script>$("p").animate({
  "left": "50", "opacity": 1
}, 500);
</script>

Example:

An example of using an 'easing' function to provide a different style of animation. This will only work if you have a plugin that provides this easing function. Note, this code will do nothing unless the paragraph element is hidden.
<script>$("p").animate({
  "opacity": "show"

}, "slow", "easein");</script>

Example:

The first button shows how an unqueued animation works. It expands the div out to 90% width the font-size is increasing. Once the font-size change is complete, the border animation will begin. The second button starts a traditional chained animation, where each animation will start once the previous animation on the element has completed.
<!DOCTYPE html>
<html>
<head>
  <style>
div {
  background-color:#bca;
  width:200px;
  height:1.1em;
  text-align:center;
  border:2px solid green;
  margin:3px;
  font-size:14px;
}
button {
  font-size:14px;
}
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button id="go1">&raquo; Animate Block1</button>
<button id="go2">&raquo; Animate Block2</button>
<button id="go3">&raquo; Animate Both</button>

<button id="go4">&raquo; Reset</button>
<div id="block1">Block1</div>
<div id="block2">Block2</div>
  <script>

$("#go1").click(function(){
  $("#block1").animate( { width:"90%" }, { queue:false, duration:3000 } )
     .animate( { fontSize:"24px" }, 1500 )
     .animate( { borderRightWidth:"15px" }, 1500);
});

$("#go2").click(function(){
  $("#block2").animate( { width:"90%"}, 1000 )
     .animate( { fontSize:"24px" } , 1000 )
     .animate( { borderLeftWidth:"15px" }, 1000);
});

$("#go3").click(function(){
  $("#go1").add("#go2").click();
});

$("#go4").click(function(){
  $("div").css({width:"", fontSize:"", borderWidth:""});
});

</script>
</body>
</html>

Demo:

Example:

Animates all paragraphs to toggle both height and opacity, completing the animation within 600 milliseconds.
<script>$("p").animate({
"height": "toggle", "opacity": "toggle"

}, { duration: "slow" });</script>

Example:

Animates all paragraph to a left style of 50 and opacity of 1 (opaque, visible), completing the animation within 500 milliseconds. It also will do it the queue, meaning it will automatically start without waiting for its turn.
<script>$("p").animate({
left: "50px", opacity: 1
}, { duration: 500, queue: false });</script>

Example:

An example of using an 'easing' function to provide a different style of animation. This will only work if you have a plugin that provides this easing function.
<script>$("p").animate({
"opacity": "show"

}, { "duration": "slow", "easing": "easein" });</script>

Example:

An example of using a callback function. The first argument is an array of CSS properties, the second specifies that the animation should take 1000 milliseconds to complete, the third states the easing type, and the fourth argument is an anonymous callback function.
<script>$("p").animate({
height:200, width:400, opacity: .5
}, 1000, "linear", function(){alert("all done");} );

</script>

Comments

© 2010 The jQuery Project


Fading – jQuery API

Fading

  • jQuery .fadeTo( [String,Number] duration, [Number] opacity, [Callback] callback )

    New in 1.0 !

    Adjust the opacity of the matched elements.

  • jQuery .fadeOut( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Hide the matched elements by fading them to transparent.

  • jQuery .fadeIn( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display the matched elements by fading them to opaque.


fadeTo – jQuery API

Returns: jQueryjQuery .fadeTo( [String,Number] duration, [Number] opacity, [Callback] callback )

Categories: Fading, Version 1.0
Description: Adjust the opacity of the matched elements.
  • version added: 1.0

  • .fadeTo( [String,Number] duration, [Number] opacity, [Callback] callback )

  • duration A string or number determining how long the animation will run.
  • opacity A number between 0 and 1 denoting the target opacity.
  • callback A function to call once the animation is complete.

The method animates the opacity of the matched elements.

Durations are given in milliseconds; higher values indicate slower animations, not faster ones. The strings and can be supplied to indicate durations of and milliseconds, respectively. If any other string is supplied, the default duration of milliseconds is used. Unlike the other effect methods, requires that be explicitly specified.

If supplied, the callback is fired once the animation is complete. This can be useful for stringing different animations together in sequence. The callback is not sent any arguments, but is set to the DOM element being animated. If multiple elements are animated, it is important to note that the callback is executed once per matched element, not once for the animation as a whole.

We can animate any element, such as a simple image:

<div id="clickme">
    Click here
  </div>
  <img id="book" src="book.png" alt="" width="100" height="123" />
  With the element initially shown, we can dim it slowly:
  $('#clickme').click(function() {
    $('#book').fadeTo('slow', 0.5, function() {
      // Animation complete.
    });
  });

With set to , this method just changes the CSS property, so is the same as .

Examples:

Example:

Animates first paragraph to fade to an opacity of 0.33 (33%, about one third visible), completing the animation within 600 milliseconds.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>
Click this paragraph to see it fade.
</p>

<p>
Compare to this one that won't fade.
</p>
  <script>
$("p:first").click(function () {
$(this).fadeTo("slow", 0.33);
});
</script>
</body>
</html>

Demo:

Example:

Fade div to a random opacity on each click, completing the animation within 200 milliseconds.
<!DOCTYPE html>
<html>
<head>
  <style>
p { width:80px; margin:0; padding:5px; }
div { width:40px; height:40px; position:absolute; }
div#one { top:0; left:0; background:#f00; }
div#two { top:20px; left:20px; background:#0f0; }
div#three { top:40px; left:40px; background:#00f; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>And this is the library that John built...</p>

<div id="one"></div>
<div id="two"></div>
<div id="three"></div>
  <script>
$("div").click(function () {
$(this).fadeTo("fast", Math.random());
});
</script>
</body>
</html>

Demo:

Example:

Find the right answer! The fade will take 250 milliseconds and change various styles when it completes.
<!DOCTYPE html>
<html>
<head>
  <style>
div, p { width:80px; height:40px; top:0; margin:0;
position:absolute; padding-top:8px; }
p { background:#fcc; text-align:center; }
div { background:blue; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Wrong</p>
<div></div>
<p>Wrong</p>
<div></div>

<p>Right!</p>
<div></div>
  <script>
var getPos = function (n) {
return (Math.floor(n) * 90) + "px";
};
$("p").each(function (n) {
var r = Math.floor(Math.random() * 3);
var tmp = $(this).text();
$(this).text($("p:eq(" + r + ")").text());
$("p:eq(" + r + ")").text(tmp);
$(this).css("left", getPos(n));
});
$("div").each(function (n) {
      $(this).css("left", getPos(n));
    })
.css("cursor", "pointer")
.click(function () {
      $(this).fadeTo(250, 0.25, function () {
            $(this).css("cursor", "")
                   .prev().css({"font-weight": "bolder",
                                "font-style": "italic"});
          });
    });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


fadeOut – jQuery API

Returns: jQueryjQuery .fadeOut( [String,Number] duration, [Callback] callback )

Categories: Fading, Version 1.0
Description: Hide the matched elements by fading them to transparent.
  • version added: 1.0

  • .fadeOut( [String,Number] duration, [Callback] callback )

  • duration A string or number determining how long the animation will run.
  • callback A function to call once the animation is complete.

The method animates the opacity of the matched elements. Once the opacity reaches 0, the style property is set to , so the element no longer affects the layout of the page.

Durations are given in milliseconds; higher values indicate slower animations, not faster ones. The strings and can be supplied to indicate durations of and milliseconds, respectively. If any other string is supplied, or if the parameter is omitted, the default duration of milliseconds is used.

If supplied, the callback is fired once the animation is complete. This can be useful for stringing different animations together in sequence. The callback is not sent any arguments, but is set to the DOM element being animated. If multiple elements are animated, it is important to note that the callback is executed once per matched element, not once for the animation as a whole.

We can animate any element, such as a simple image:

<div id="clickme">
  Click here
</div>
<img id="book" src="book.png" alt="" width="100" height="123" />

With the element initially shown, we can hide it slowly:

$('#clickme').click(function() {
  $('#book').fadeOut('slow', function() {
    // Animation complete.
  });
});

Examples:

Example:

Animates all paragraphs to fade out, completing the animation within 600 milliseconds.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { font-size:150%; cursor:pointer; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>
  If you click on this paragraph
  you'll see it just fade away.
  </p>
  <script>
  $("p").click(function () {
  $("p").fadeOut("slow");
  });
  </script>
</body>
</html>

Demo:

Example:

Fades out spans in one section that you click on.
<!DOCTYPE html>
<html>
<head>
  <style>
  span { cursor:pointer; }
  span.hilite { background:yellow; }
  div { display:inline; color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <h3>Find the modifiers - <div></div></h3>
  <p>
  If you <span>really</span> want to go outside
  <span>in the cold</span> then make sure to wear
  your <span>warm</span> jacket given to you by
  your <span>favorite</span> teacher.
  </p>
  <script>

  $("span").click(function () {
  $(this).fadeOut(1000, function () {
  $("div").text("'" + $(this).text() + "' has faded!");
  $(this).remove();
  });
  });
  $("span").hover(function () {
  $(this).addClass("hilite");
  }, function () {
  $(this).removeClass("hilite");
  });

  </script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


fadeIn – jQuery API

Returns: jQueryjQuery .fadeIn( [String,Number] duration, [Callback] callback )

Categories: Fading, Version 1.0
Description: Display the matched elements by fading them to opaque.
  • version added: 1.0

  • .fadeIn( [String,Number] duration, [Callback] callback )

  • duration A string or number determining how long the animation will run.
  • callback A function to call once the animation is complete.

The method animates the opacity of the matched elements.

Durations are given in milliseconds; higher values indicate slower animations, not faster ones. The strings and can be supplied to indicate durations of and milliseconds, respectively. If any other string is supplied, or if the parameter is omitted, the default duration of milliseconds is used.

If supplied, the callback is fired once the animation is complete. This can be useful for stringing different animations together in sequence. The callback is not sent any arguments, but is set to the DOM element being animated. If multiple elements are animated, it is important to note that the callback is executed once per matched element, not once for the animation as a whole.

We can animate any element, such as a simple image:

<div id="clickme">
      Click here
    </div>
    <img id="book" src="book.png" alt="" width="100" height="123" />
    With the element initially hidden, we can show it slowly:
    $('#clickme').click(function() {
      $('#book').fadeIn('slow', function() {
        // Animation complete
      });
    });

Examples:

Example:

Animates hidden divs to fade in one by one, completing each animation within 600 milliseconds.
<!DOCTYPE html>
<html>
<head>
  <style>
    span { color:red; cursor:pointer; }
    div { margin:3px; width:80px; display:none;
      height:80px; float:left; }
      div#one { background:#f00; }
      div#two { background:#0f0; }
      div#three { background:#00f; }
    </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <span>Click here...</span>

    <div id="one"></div>
    <div id="two"></div>
    <div id="three"></div>
  <script>
      $(document.body).click(function () {
        $("div:hidden:first").fadeIn("slow");
      });
    </script>
</body>
</html>

Demo:

Example:

Fades a red block in over the text. Once the animation is done, it quickly fades in more text on top.
<!DOCTYPE html>
<html>
<head>
  <style>
      p { position:relative; width:400px; height:90px; }
      div { position:absolute; width:400px; height:65px;
        font-size:36px; text-align:center;
        color:yellow; background:red;
        padding-top:25px;
        top:0; left:0; display:none; }
        span { display:none; }
      </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>
        Let it be known that the party of the first part
        and the party of the second part are henceforth
        and hereto directed to assess the allegations
        for factual correctness... (<a href="#">click!</a>)
        <div><span>CENSORED!</span></div>

      </p>
  <script>
        $("a").click(function () {
          $("div").fadeIn(3000, function () {
            $("span").fadeIn(100);
          });
          return false;
        });

      </script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Sliding – jQuery API

Sliding

  • jQuery .slideToggle( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display or hide the matched elements with a sliding motion.

  • jQuery .slideUp( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Hide the matched elements with a sliding motion.

  • jQuery .slideDown( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display the matched elements with a sliding motion.


slideToggle – jQuery API

Returns: jQueryjQuery .slideToggle( [String,Number] duration, [Callback] callback )

Categories: Sliding, Version 1.0
Description: Display or hide the matched elements with a sliding motion.
  • version added: 1.0

  • .slideToggle( [String,Number] duration, [Callback] callback )

  • duration A string or number determining how long the animation will run.
  • callback A function to call once the animation is complete.

The method animates the height of the matched elements. This causes lower parts of the page to slide up or down, appearing to reveal or conceal the items. If the element is initially displayed, it will be hidden; if hidden, it will be shown. The property is saved and restored as needed. If an element has a value of , then is hidden and shown, it will once again be displayed . When the height reaches 0 after a hiding animation, the style property is set to to ensure that the element no longer affects the layout of the page.

Durations are given in milliseconds; higher values indicate slower animations, not faster ones. The strings and can be supplied to indicate durations of and milliseconds, respectively.

If supplied, the callback is fired once the animation is complete. This can be useful for stringing different animations together in sequence. The callback is not sent any arguments, but is set to the DOM element being animated. If multiple elements are animated, it is important to note that the callback is executed once per matched element, not once for the animation as a whole.

We can animate any element, such as a simple image:

<div id="clickme">
  Click here
</div>
<img id="book" src="book.png" alt="" width="100" height="123" />

We will cause to be called when another element is clicked:

$('#clickme').click(function() {
  $('#book').slideToggle('slow', function() {
    // Animation complete.
  });
});

With the element initially shown, we can hide it slowly with the first click:

A second click will show the element once again:

Examples:

Example:

Animates all paragraphs to slide up or down, completing the animation within 600 milliseconds.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { width:400px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button>Toggle</button>

  <p>
    This is the paragraph to end all paragraphs.  You
    should feel <em>lucky</em> to have seen such a paragraph in
    your life.  Congratulations!
  </p>
  <script>
    $("button").click(function () {
      $("p").slideToggle("slow");
    });
</script>
</body>
</html>

Demo:

Example:

Animates divs between dividers with a toggle that makes some appear and some disappear.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { background:#b977d1; margin:3px; width:60px;
        height:60px; float:left; }
  div.still { background:#345; width:5px; }
  div.hider { display:none; }
  span { color:red; }
  p { clear: left; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div></div>
<div class="still"></div>
<div style="display:none;">
</div><div class="still"></div>
<div></div>
<div class="still"></div>
<div class="hider"></div>
<div class="still"></div>
<div class="hider"></div>
<div class="still"></div>
<div></div>
<p><button id="aa">Toggle</button> There have been <span>0</span> toggled divs.</p>
  <script>
  $("#aa").click(function () {
    $("div:not(.still)").slideToggle("slow", function () {
      var n = parseInt($("span").text(), 10);
      $("span").text(n + 1);
    });
  });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


slideUp – jQuery API

Returns: jQueryjQuery .slideUp( [String,Number] duration, [Callback] callback )

Categories: Sliding, Version 1.0
Description: Hide the matched elements with a sliding motion.
  • version added: 1.0

  • .slideUp( [String,Number] duration, [Callback] callback )

  • duration A string or number determining how long the animation will run.
  • callback A function to call once the animation is complete.

The method animates the height of the matched elements. This causes lower parts of the page to slide up, appearing to conceal the items. Once the height reaches 0, the style property is set to to ensure that the element no longer affects the layout of the page.

Durations are given in milliseconds; higher values indicate slower animations, not faster ones. The strings and can be supplied to indicate durations of and milliseconds, respectively. If any other string is supplied, or if the parameter is omitted, the default duration of milliseconds is used.

If supplied, the callback is fired once the animation is complete. This can be useful for stringing different animations together in sequence. The callback is not sent any arguments, but is set to the DOM element being animated. If multiple elements are animated, it is important to note that the callback is executed once per matched element, not once for the animation as a whole.

We can animate any element, such as a simple image:

<div id="clickme">
  Click here
</div>
<img id="book" src="book.png" alt="" width="100" height="123" />

With the element initially shown, we can hide it slowly:

$('#clickme').click(function() {
  $('#book').slideUp('slow', function() {
    // Animation complete.
  });
});

Examples:

Example:

Animates all divs to slide up, completing the animation within 400 milliseconds.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { background:#3d9a44; margin:3px; width:80px;
    height:40px; float:left; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  Click me!
  <div></div>
  <div></div>
  <div></div>
  <div></div>

  <div></div>
  <script>
  $(document.body).click(function () {
    if ($("div:first").is(":hidden")) {
      $("div").show("slow");
    } else {
      $("div").slideUp();
    }
  });

  </script>
</body>
</html>

Demo:

Example:

Animates the parent paragraph to slide up, completing the animation within 200 milliseconds. Once the animation is done, it displays an alert.
<!DOCTYPE html>
<html>
<head>
  <style>
 div { margin:2px; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>
  <button>Hide One</button>
  <input type="text" value="One" />

</div>
<div>
  <button>Hide Two</button>
  <input type="text" value="Two" />

</div>
<div>
  <button>Hide Three</button>
  <input type="text" value="Three" />

</div>
<div id="msg"></div>
  <script>
  $("button").click(function () {
    $(this).parent().slideUp("slow", function () {
      $("#msg").text($("button", this).text() + " has completed.");
    });
  });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


slideDown – jQuery API

Returns: jQueryjQuery .slideDown( [String,Number] duration, [Callback] callback )

Categories: Sliding, Version 1.0
Description: Display the matched elements with a sliding motion.
  • version added: 1.0

  • .slideDown( [String,Number] duration, [Callback] callback )

  • duration A string or number determining how long the animation will run.
  • callback A function to call once the animation is complete.

The method animates the height of the matched elements. This causes lower parts of the page to slide down, making way for the revealed items.

Durations are given in milliseconds; higher values indicate slower animations, not faster ones. The strings and can be supplied to indicate durations of and milliseconds, respectively. If any other string is supplied, or if the parameter is omitted, the default duration of milliseconds is used.

If supplied, the callback is fired once the animation is complete. This can be useful for stringing different animations together in sequence. The callback is not sent any arguments, but is set to the DOM element being animated. If multiple elements are animated, it is important to note that the callback is executed once per matched element, not once for the animation as a whole.

We can animate any element, such as a simple image:

<div id="clickme">
  Click here
</div>
<img id="book" src="book.png" alt="" width="100" height="123" />

With the element initially hidden, we can show it slowly:

$('#clickme').click(function() {
  $('#book').slideDown('slow', function() {
    // Animation complete.
  });
});

Examples:

Example:

Animates all divs to slide down and show themselves over 600 milliseconds.
<!DOCTYPE html>
<html>
<head>
  <style>
div { background:#de9a44; margin:3px; width:80px;
height:40px; display:none; float:left; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  Click me!
<div></div>
<div></div>
<div></div>
  <script>
$(document.body).click(function () {
if ($("div:first").is(":hidden")) {
$("div").slideDown("slow");
} else {
$("div").hide();
}
});

</script>
</body>
</html>

Demo:

Example:

Animates all inputs to slide down, completing the animation within 1000 milliseconds. Once the animation is done, the input look is changed especially if it is the middle input which gets the focus.
<!DOCTYPE html>
<html>
<head>
  <style>
div { background:#cfd; margin:3px; width:50px;
text-align:center; float:left; cursor:pointer;
border:2px outset black; font-weight:bolder; }
input { display:none; width:120px; float:left;
margin:10px; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>Push!</div>
<input type="text" />
<input type="text" class="middle" />

<input type="text" />
  <script>
$("div").click(function () {
$(this).css({ borderStyle:"inset", cursor:"wait" });
$("input").slideDown(1000,function(){
$(this).css("border", "2px red inset")
.filter(".middle")
 .css("background", "yellow")
 .focus();
$("div").css("visibility", "hidden");
});
});

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Events – jQuery API

Events

  • jQuery .scroll( )

    New in 1.0 !

    Bind an event handler to the "scroll" JavaScript event, or trigger that event on an element.

  • jQuery .resize( )

    New in 1.0 !

    Bind an event handler to the "resize" JavaScript event, or trigger that event on an element.

  • jQuery .error( [Function] handler(eventObject) )

    New in 1.0 !

    Bind an event handler to the "error" JavaScript event.

  • jQuery .unload( [Function] handler(eventObject) )

    New in 1.0 !

    Bind an event handler to the "unload" JavaScript event.

  • jQuery .load( [Function] handler(eventObject) )

    New in 1.0 !

    Bind an event handler to the "load" JavaScript event.

  • jQuery .ready( [Function] handler )

    New in 1.0 !

    Specify a function to execute when the DOM is fully loaded.

  • jQuery .undelegate( [String] selector, [String] eventType, [Function] handler )

    New in 1.4.2 !

    Remove a handler from the event for all elements which match the current selector, now or in the future, based upon a specific set of root elements.

  • jQuery .delegate( [String] selector, [String] eventType, [Object] eventData, [Function] handler )

    New in 1.4.2 !

    Attach a handler to one or more events for all elements that match the selector, now or in the future, based on a specific set of root elements.

  • Function jQuery.proxy( [Object] context, [String] name )

    New in 1.4 !

    Takes a function and returns a new one that will always have a particular context.

  • jQuery .die( [String] eventType, [String] handler )

    New in 1.3 !

    Remove an event handler previously attached using from the elements.

  • jQuery .live( [String] eventType, [Object] eventData, [Function] handler )

    New in 1.4 !

    Attach a handler to the event for all elements which match the current selector, now or in the future.

  • Object .triggerHandler( [String] eventType, [Array] extraParameters )

    New in 1.2 !

    Execute all handlers attached to an element for an event.

  • jQuery .trigger( [String] eventType, [Array] extraParameters )

    New in 1.0 !

    Execute all handlers and behaviors attached to the matched elements for the given event type.

  • jQuery .one( [String] eventType, [Object] eventData, [Function] handler(eventObject) )

    New in 1.1 !

    Attach a handler to an event for the elements. The handler is executed at most once per element.

  • jQuery .unbind( [Object] event )

    New in 1.0 !

    Remove a previously-attached event handler from the elements.

  • jQuery .bind( [Object] events )

    New in 1.4 !

    Attach a handler to an event for the elements.

  • Boolean event.isImmediatePropagationStopped( )

    New in 1.3 !

    Returns whether event.stopImmediatePropagation() was ever called on this event object.

  • event.stopImmediatePropagation( )

    New in 1.3 !

    Keeps the rest of the handlers from being executed and prevents the event from bubbling up the DOM tree

  • Boolean event.isPropagationStopped( )

    New in 1.3 !

    Returns whether was ever called on this event object.

  • event.stopPropagation( )

    New in 1.0 !

    Prevents the event from bubbling up the DOM tree, preventing any parent handlers from being notified of the event.

  • Boolean event.isDefaultPrevented( )

    New in 1.3 !

    Returns whether was ever called on this event object.

  • undefined event.preventDefault( )

    New in 1.0 !

    If this method is called, the default action of the event will not be triggered.

  • Number event.timeStamp

    New in 1.2.6 !

    This attribute returns the number of milliseconds since January 1, 1970, when the event is triggered.

  • Object event.result

    New in 1.3 !

    This attribute contains the last value returned by an event handler that was triggered by this event, unless the value was .

  • String event.which

    New in 1.1.3 !

    For key or button events, this attribute indicates the specific button or key that was pressed.

  • Number event.pageY

    New in 1.0.4 !

    The mouse position relative to the top edge of the document.

  • Number event.pageX

    New in 1.0.4 !

    The mouse position relative to the left edge of the document.

  • Element event.currentTarget

    New in 1.3 !

    The current DOM element within the event bubbling phase.

  • Element event.relatedTarget

    New in 1.1.4 !

    The other DOM element involved in the event, if any.

  • Anything event.data

    New in 1.1 !

    Contains the optional data passed to jQuery.fn.bind when the current executing handler was bound.

  • Element event.target

    New in 1.0 !

    The DOM element that initiated the event.

  • String event.type

    New in 1.0 !

    Describes the nature of the event.

  • jQuery .submit( )

    New in 1.0 !

    Bind an event handler to the "submit" JavaScript event, or trigger that event on an element.

  • jQuery .select( )

    New in 1.0 !

    Bind an event handler to the "select" JavaScript event, or trigger that event on an element.

  • jQuery .change( )

    New in 1.0 !

    Bind an event handler to the "change" JavaScript event, or trigger that event on an element.

  • jQuery .blur( )

    New in 1.0 !

    Bind an event handler to the "blur" JavaScript event, or trigger that event on an element.

  • jQuery .focus( )

    New in 1.0 !

    Bind an event handler to the "focus" JavaScript event, or trigger that event on an element.

  • jQuery .focusout( [Function] handler(eventObject) )

    New in 1.4 !

    Bind an event handler to the "focusout" JavaScript event.

  • jQuery .focusin( [Function] handler(eventObject) )

    New in 1.4 !

    Bind an event handler to the "focusin" JavaScript event.

  • jQuery .keydown( )

    New in 1.0 !

    Bind an event handler to the "keydown" JavaScript event, or trigger that event on an element.

  • jQuery .keyup( )

    New in 1.0 !

    Bind an event handler to the "keyup" JavaScript event, or trigger that event on an element.

  • jQuery .keypress( )

    New in 1.0 !

    Bind an event handler to the "keypress" JavaScript event, or trigger that event on an element.

  • jQuery .focusout( [Function] handler(eventObject) )

    New in 1.4 !

    Bind an event handler to the "focusout" JavaScript event.

  • jQuery .focusin( [Function] handler(eventObject) )

    New in 1.4 !

    Bind an event handler to the "focusin" JavaScript event.

  • jQuery .mousemove( )

    New in 1.0 !

    Bind an event handler to the "mousemove" JavaScript event, or trigger that event on an element.

  • jQuery .hover( [Function] handlerInOut(eventObject) )

    New in 1.4 !

    Bind a single handler to the matched elements, to be executed when the mouse pointer enters or leaves the elements.

  • jQuery .mouseleave( )

    New in 1.0 !

    Bind an event handler to be fired when the mouse leaves an element, or trigger that handler on an element.

  • jQuery .mouseenter( )

    New in 1.0 !

    Bind an event handler to be fired when the mouse enters an element, or trigger that handler on an element.

  • jQuery .mouseout( )

    New in 1.0 !

    Bind an event handler to the "mouseout" JavaScript event, or trigger that event on an element.

  • jQuery .mouseover( )

    New in 1.0 !

    Bind an event handler to the "mouseover" JavaScript event, or trigger that event on an element.

  • jQuery .dblclick( )

    New in 1.0 !

    Bind an event handler to the "dblclick" JavaScript event, or trigger that event on an element.

  • jQuery .click( )

    New in 1.0 !

    Bind an event handler to the "click" JavaScript event, or trigger that event on an element.

  • jQuery .mouseup( )

    New in 1.0 !

    Bind an event handler to the "mouseup" JavaScript event, or trigger that event on an element.

  • jQuery .mousedown( )

    New in 1.0 !

    Bind an event handler to the "mousedown" JavaScript event, or trigger that event on an element.

  • jQuery .toggle( [Boolean] showOrHide )

    New in 1.3 !

    Display or hide the matched elements.


Browser Events – jQuery API

Browser Events

  • jQuery .scroll( )

    New in 1.0 !

    Bind an event handler to the "scroll" JavaScript event, or trigger that event on an element.

  • jQuery .resize( )

    New in 1.0 !

    Bind an event handler to the "resize" JavaScript event, or trigger that event on an element.

  • jQuery .error( [Function] handler(eventObject) )

    New in 1.0 !

    Bind an event handler to the "error" JavaScript event.


scroll – jQuery API

  • scroll( [Function] handler(eventObject) )

    • 1.0scroll( [Function] handler(eventObject) )

  • scroll( )

    • 1.0scroll( )

Returns: jQueryjQuery .scroll( )

Categories: Browser Events, Version 1.0
Description: Bind an event handler to the "scroll" JavaScript event, or trigger that event on an element.
  • version added: 1.0

  • .scroll( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute each time the event is triggered.
  • version added: 1.0

  • .scroll( )

This method is a shortcut for in the first variation, and in the second.

The event is sent to an element when the user scrolls to a different place in the element. It applies to objects, but also to scrollable frames and elements with the CSS property set to (or when the element's explicit height is less than the height of its contents).

For example, consider the HTML:

<div id="target" style="overflow: scroll; width: 200px; height: 100px;">
  Lorem ipsum dolor sit amet, consectetur adipisicing elit,
  sed do eiusmod tempor incididunt ut labore et dolore magna
  aliqua. Ut enim ad minim veniam, quis nostrud exercitation
  ullamco laboris nisi ut aliquip ex ea commodo consequat.
  Duis aute irure dolor in reprehenderit in voluptate velit
  esse cillum dolore eu fugiat nulla pariatur. Excepteur
  sint occaecat cupidatat non proident, sunt in culpa qui
  officia deserunt mollit anim id est laborum.
</div>
<div id="other">
  Trigger the handler
</div>
<div id="log"></div>

The style definition is present to make the target element small enough to be scrollable:

The event handler can be bound to this element:

$('#target').scroll(function() {
  $('#log').append('<div>Handler for .scroll() called.</div>');
});

Now when the user scrolls the text up or down, one or more messages are appended to :

We can trigger the event manually when another element is clicked:

$('#other').click(function() {
  $('#target').scroll();
});

After this code executes, clicks on will also append the message.

A event is sent whenever the element's scroll position changes, regardless of the cause. A mouse click or drag on the scroll bar, dragging inside the element, pressing the arrow keys, or using the mouse's scroll wheel could cause this event.

Examples:

Example:

To do something when your page is scrolled:
<!DOCTYPE html>
<html>
<head>
  <style>
  div { color:blue; }
  p { color:green; }
  span { color:red; display:none; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>Try scrolling the iframe.</div>
  <p>Paragraph - <span>Scroll happened!</span></p>
  <script>
    $("p").clone().appendTo(document.body);
    $("p").clone().appendTo(document.body);
    $("p").clone().appendTo(document.body);
    $(window).scroll(function () {
      $("span").css("display", "inline").fadeOut("slow");
    });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


resize – jQuery API

  • resize( [Function] handler(eventObject) )

    • 1.0resize( [Function] handler(eventObject) )

  • resize( )

    • 1.0resize( )

Returns: jQueryjQuery .resize( )

Categories: Browser Events, Version 1.0
Description: Bind an event handler to the "resize" JavaScript event, or trigger that event on an element.
  • version added: 1.0

  • .resize( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute each time the event is triggered.
  • version added: 1.0

  • .resize( )

This method is a shortcut for in the first variation, and in the second.

The event is sent to the element when the size of the browser window changes:

$(window).resize(function() {
  $('#log').append('<div>Handler for .resize() called.</div>');
});

Now whenever the browser window's size is changed, the message is appended to <div id="log"> one or more times, depending on the browser.

Code in a handler should never rely on the number of times the handler is called. Depending on implementation, events can be sent continuously as the resizing is in progress (the typical behavior in Internet Explorer and WebKit-based browsers such as Safari and Chrome), or only once at the end of the resize operation (the typical behavior in Firefox).

Examples:

Example:

To see the window width while (or after) it is resized, try:
<script>
$(window).resize(function() {
  $('body').prepend('<div>' + $(window).width() + '</div>');
});
  </script>

Comments

© 2010 The jQuery Project


error – jQuery API

Returns: jQueryjQuery .error( [Function] handler(eventObject) )

Categories: Browser Events, Version 1.0
Description: Bind an event handler to the "error" JavaScript event.
  • version added: 1.0

  • .error( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute when the event is triggered.

This method is a shortcut for .

The event is sent to elements, such as images, that are referenced by a document and loaded by the browser. It is called if the element was not loaded correctly.

For example, consider a page with a simple image:

<img src="missing.png" alt="Book" id="book" />

The event handler can be bound to the image:

$('#book').error(function() {
  alert('Handler for .error() called.')
});

If the image cannot be loaded (for example, because it is not present at the supplied URL), the alert is displayed:

Note: A jQuery error event handler should not be attached to the window object. The browser fires the window's error event when a script error occurs. However, the window error event receives different arguments and has different return value requirements than conventional event handlers.

Examples:

Example:

To hide JavaScript errors from the user, you can try:
<script>$(window).error(function(){
  return true;
});</script>

Example:

To hide the "broken image" icons for your IE users, you can try:
<script>$("img").error(function(){
  $(this).hide();
});</script>

Comments

© 2010 The jQuery Project


Document Loading – jQuery API

Document Loading

  • jQuery .unload( [Function] handler(eventObject) )

    New in 1.0 !

    Bind an event handler to the "unload" JavaScript event.

  • jQuery .load( [Function] handler(eventObject) )

    New in 1.0 !

    Bind an event handler to the "load" JavaScript event.

  • jQuery .ready( [Function] handler )

    New in 1.0 !

    Specify a function to execute when the DOM is fully loaded.


unload – jQuery API

Returns: jQueryjQuery .unload( [Function] handler(eventObject) )

Categories: Document Loading, Version 1.0
Description: Bind an event handler to the "unload" JavaScript event.
  • version added: 1.0

  • .unload( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute when the event is triggered.

This method is a shortcut for .

The event is sent to the element when the user navigates away from the page. This could mean one of many things. The user could have clicked on a link to leave the page, or typed in a new URL in the address bar. The forward and back buttons will trigger the event. Closing the browser window will cause the event to be triggered. Even a page reload will first create an event.

Any event handler should be bound to the object:

$(window).unload(function() {
  alert('Handler for .unload() called.');
});

After this code executes, the alert will be displayed whenever the browser leaves the current page. It is not possible to cancel the event with . This event is available so that scripts can perform cleanup when the user leaves the page.

Examples:

Example:

To display an alert when a page is unloaded:
<script>$(window).unload( function () { alert("Bye now!"); } );</script>

Comments

© 2010 The jQuery Project


ready – jQuery API

Returns: jQueryjQuery .ready( [Function] handler )

Categories: Document Loading, Version 1.0
Description: Specify a function to execute when the DOM is fully loaded.
  • version added: 1.0

  • .ready( [Function] handler )

  • handler A function to execute after the DOM is ready.

While JavaScript provides the event for executing code when a page is rendered, this event does not get triggered until all assets such as images have been completely received. In most cases, the script can be run as soon as the DOM hierarchy has been fully constructed. The handler passed to is guaranteed to be executed after the DOM is ready, so this is usually the best place to attach all other event handlers and run other jQuery code. When using scripts that rely on the value of CSS style properties, it's important to reference external stylesheets or embed style elements before referencing the scripts.

In cases where code relies on loaded assets (for example, if the dimensions of an image are required), the code should be placed in a handler for the event instead.

All three of the following syntaxes are equivalent:

There is also . This behaves similarly to the ready method but with one exception: If the ready event has already fired and you try to the bound handler will not be executed.

The method can only be called on a jQuery object matching the current document, so the selector can be omitted.

The method is typically used with an anonymous function:

$(document).ready(function() {
  // Handler for .ready() called.
});

If is called after the DOM has been initialized, the new handler passed in will be executed immediately.

Aliasing the jQuery Namespace

When using another JavaScript library, we may wish to call to avoid namespace difficulties. When this function is called, the shortcut is no longer available, forcing us to write each time we would normally write . However, the handler passed to the method can take an argument, which is passed the global object. This means we can rename the object within the context of our handler without affecting other code:

jQuery(document).ready(function($) {
  // Code using $ as usual goes here.
});

Examples:

Example:

Display a message when the DOM is loaded.
<!DOCTYPE html>
<html>
<head>
  <style>
p { color:red; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Not loaded yet.</p>
  <script>$(document).ready(function () {
  $("p").text("The DOM is now loaded and can be manipulated.");
});</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Event Handler Attachment – jQuery API

Event Handler Attachment

  • jQuery .undelegate( [String] selector, [String] eventType, [Function] handler )

    New in 1.4.2 !

    Remove a handler from the event for all elements which match the current selector, now or in the future, based upon a specific set of root elements.

  • jQuery .delegate( [String] selector, [String] eventType, [Object] eventData, [Function] handler )

    New in 1.4.2 !

    Attach a handler to one or more events for all elements that match the selector, now or in the future, based on a specific set of root elements.

  • Function jQuery.proxy( [Object] context, [String] name )

    New in 1.4 !

    Takes a function and returns a new one that will always have a particular context.

  • jQuery .die( [String] eventType, [String] handler )

    New in 1.3 !

    Remove an event handler previously attached using from the elements.

  • jQuery .live( [String] eventType, [Object] eventData, [Function] handler )

    New in 1.4 !

    Attach a handler to the event for all elements which match the current selector, now or in the future.

  • Object .triggerHandler( [String] eventType, [Array] extraParameters )

    New in 1.2 !

    Execute all handlers attached to an element for an event.

  • jQuery .trigger( [String] eventType, [Array] extraParameters )

    New in 1.0 !

    Execute all handlers and behaviors attached to the matched elements for the given event type.

  • jQuery .one( [String] eventType, [Object] eventData, [Function] handler(eventObject) )

    New in 1.1 !

    Attach a handler to an event for the elements. The handler is executed at most once per element.

  • jQuery .unbind( [Object] event )

    New in 1.0 !

    Remove a previously-attached event handler from the elements.

  • jQuery .bind( [Object] events )

    New in 1.4 !

    Attach a handler to an event for the elements.


undelegate – jQuery API

  • undelegate( )

    • 1.4.2undelegate( )

  • undelegate( [String] selector, [String] eventType )

    • 1.4.2undelegate( [String] selector, [String] eventType )

  • undelegate( [String] selector, [String] eventType, [Function] handler )

    • 1.4.2undelegate( [String] selector, [String] eventType, [Function] handler )

Returns: jQueryjQuery .undelegate( [String] selector, [String] eventType, [Function] handler )

Categories: Event Handler Attachment, Version 1.4.2
Description: Remove a handler from the event for all elements which match the current selector, now or in the future, based upon a specific set of root elements.
  • version added: 1.4.2

  • .undelegate( )

  • version added: 1.4.2

  • .undelegate( [String] selector, [String] eventType )

  • selector A selector which will be used to filter the event results.
  • eventType A string containing a JavaScript event type, such as "click" or "keydown"
  • version added: 1.4.2

  • .undelegate( [String] selector, [String] eventType, [Function] handler )

  • selector A selector which will be used to filter the event results.
  • eventType A string containing a JavaScript event type, such as "click" or "keydown"
  • handler A function to execute at the time the event is triggered.

Undelegate is a way of removing event handlers that have been bound using . It works virtually identically to with the addition of a selector filter argument (which is required for delegation to work).

Examples:

Example:

Can bind and unbind events to the colored button.
<!DOCTYPE html>
<html>
<head>
  <style>
button { margin:5px; }
button#theone { color:red; background:yellow; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button id="theone">Does nothing...</button>
<button id="bind">Bind Click</button>
<button id="unbind">Unbind Click</button>
<div style="display:none;">Click!</div>
  <script>
function aClick() {
  $("div").show().fadeOut("slow");
}
$("#bind").click(function () {
  $("body").delegate("#theone", "click", aClick)
    .find("#theone").text("Can Click!");
});
$("#unbind").click(function () {
  $("body").undelegate("#theone", "click", aClick)
    .find("#theone").text("Does nothing...");
});
</script>
</body>
</html>

Demo:

Example:

To unbind all delegated events from all paragraphs, write:
<script>$("p").undelegate()</script>

Example:

To unbind all delegated click events from all paragraphs, write:
<script>$("p").undelegate( "click" )</script>

Example:

To undelegate just one previously bound handler, pass the function in as the third argument:
<script>var foo = function () {
// code to handle some kind of event
};

$("body").delegate("p", "click", foo); // ... now foo will be called when paragraphs are clicked ...

$("body").undelegate("p", "click", foo); // ... foo will no longer be called.</script>

Comments

© 2010 The jQuery Project


delegate – jQuery API

  • delegate( [String] selector, [String] eventType, [Function] handler )

    • 1.4.2delegate( [String] selector, [String] eventType, [Function] handler )

  • delegate( [String] selector, [String] eventType, [Object] eventData, [Function] handler )

    • 1.4.2delegate( [String] selector, [String] eventType, [Object] eventData, [Function] handler )

Returns: jQueryjQuery .delegate( [String] selector, [String] eventType, [Object] eventData, [Function] handler )

Categories: Event Handler Attachment, Version 1.4.2
Description: Attach a handler to one or more events for all elements that match the selector, now or in the future, based on a specific set of root elements.
  • version added: 1.4.2

  • .delegate( [String] selector, [String] eventType, [Function] handler )

  • selector A selector to filter the elements that trigger the event.
  • eventType A string containing one or more space-separated JavaScript event types, such as "click" or "keydown," or custom event names.
  • handler A function to execute at the time the event is triggered.
  • version added: 1.4.2

  • .delegate( [String] selector, [String] eventType, [Object] eventData, [Function] handler )

  • selector A selector to filter the elements that trigger the event.
  • eventType A string containing one or more space-separated JavaScript event types, such as "click" or "keydown," or custom event names.
  • eventData A map of data that will be passed to the event handler.
  • handler A function to execute at the time the event is triggered.

Delegate is an alternative to using the method, allowing for each binding of event delegation to specific DOM elements. For example the following delegate code:

$("table").delegate("td", "hover", function(){
    $(this).toggleClass("hover");
});

Is equivalent to the following code written using :

$("table").each(function(){
    $("td", this).live("hover", function(){
        $(this).toggleClass("hover");
    });
});

See also the method for a way of removing event handlers added in .

Examples:

Example:

Click a paragraph to add another. Note that .delegate() binds the click event to all paragraphs - even new ones.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { background:yellow; font-weight:bold; cursor:pointer;
      padding:5px; }
  p.over { background: #ccc; }
  span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Click me!</p>

  <span></span>
  <script>
    $("body").delegate("p", "click", function(){
      $(this).after("<p>Another paragraph!</p>");
    });
</script>
</body>
</html>

Demo:

Example:

To display each paragraph's text in an alert box whenever it is clicked:
<script>$("body").delegate("p", "click", function(){
  alert( $(this).text() );
});</script>

Example:

To cancel a default action and prevent it from bubbling up, return false:
<script>$("body").delegate("a", "click", function() { return false; })</script>

Example:

To cancel only the default action by using the preventDefault method.
<script>$("body").delegate("a", "click", function(event){
  event.preventDefault();
});</script>

Example:

Can bind custom events too.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { color:red; }
  span { color:blue; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Has an attached custom event.</p>
  <button>Trigger custom event</button>
  <span style="display:none;"></span>
  <script>

    $("body").delegate("p", "myCustomEvent", function(e, myName, myValue){
      $(this).text("Hi there!");
      $("span").stop().css("opacity", 1)
               .text("myName = " + myName)
               .fadeIn(30).fadeOut(1000);
    });
    $("button").click(function () {
      $("p").trigger("myCustomEvent");
    });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


jQuery.proxy – jQuery API

Returns: FunctionFunction jQuery.proxy( [Object] context, [String] name )

Categories: Event Handler Attachment, Utilities, Version 1.4
Description: Takes a function and returns a new one that will always have a particular context.
  • version added: 1.4

  • jQuery.proxy( [Function] function, [Object] context )

  • function The function whose context will be changed.
  • context The object to which the context (`this`) of the function should be set.
  • version added: 1.4

  • jQuery.proxy( [Object] context, [String] name )

  • context The object to which the context of the function should be set.
  • name The name of the function whose context will be changed (should be a property of the 'context' object.

This method is most useful for attaching event handlers to an element where the context is pointing back to a different object. Additionally, jQuery makes sure that even if you bind the function returned from jQuery.proxy() it will still unbind the correct function, if passed the original.

Examples:

Example:

Enforce the context of the function.
<script>var obj = {
  name: "John",
  test: function() {
    alert( this.name );
    $("#test").unbind("click", obj.test);
  }
};

$("#test").click( jQuery.proxy( obj, "test" ) );

// This also works:
// $("#test").click( jQuery.proxy( obj.test, obj ) );</script>

Comments

© 2010 The jQuery Project


die – jQuery API

  • die( )

    • 1.4.1die( )

  • die( [String] eventType, [String] handler )

    • 1.3die( [String] eventType, [String] handler )

Returns: jQueryjQuery .die( )

Categories: Event Handler Attachment, Version 1.3, Version 1.4.1
Description: Remove all event handlers previously attached using from the elements.
  • version added: 1.4.1

  • .die( )

Any handler that has been attached with can be removed with . This method is analogous to calling with no arguments, which is used to remove all handlers attached with . See the discussions of and for further details.

Examples:

Returns: jQueryjQuery .die( [String] eventType, [String] handler )

Categories: Event Handler Attachment, Version 1.3, Version 1.4.1
Description: Remove an event handler previously attached using from the elements.
  • version added: 1.3

  • .die( [String] eventType, [String] handler )

  • eventType A string containing a JavaScript event type, such as or .
  • handler The function that is to be no longer executed.

Any handler that has been attached with can be removed with . This method is analogous to , which is used to remove handlers attached with . See the discussions of and for further details.

Examples:

Example:

Can bind and unbind events to the colored button.
<!DOCTYPE html>
<html>
<head>
  <style>
button { margin:5px; }
button#theone { color:red; background:yellow; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button id="theone">Does nothing...</button>
<button id="bind">Bind Click</button>
<button id="unbind">Unbind Click</button>

<div style="display:none;">Click!</div>
  <script>

function aClick() {
  $("div").show().fadeOut("slow");
}
$("#bind").click(function () {
  $("#theone").live("click", aClick)
              .text("Can Click!");
});
$("#unbind").click(function () {
  $("#theone").die("click", aClick)
              .text("Does nothing...");
});

</script>
</body>
</html>

Demo:

Example:

To unbind all live events from all paragraphs, write:
<script>$("p").die()</script>

Example:

To unbind all live click events from all paragraphs, write:
<script>$("p").die( "click" )</script>

Example:

To unbind just one previously bound handler, pass the function in as the second argument:
<script>var foo = function () {
// code to handle some kind of event
};

$("p").live("click", foo); // ... now foo will be called when paragraphs are clicked ...

$("p").die("click", foo); // ... foo will no longer be called.</script>

Comments

© 2010 The jQuery Project


live – jQuery API

  • live( [String] eventType, [Function] handler )

    • 1.3live( [String] eventType, [Function] handler )

  • live( [String] eventType, [Object] eventData, [Function] handler )

    • 1.4live( [String] eventType, [Object] eventData, [Function] handler )

Returns: jQueryjQuery .live( [String] eventType, [Object] eventData, [Function] handler )

Categories: Event Handler Attachment, Version 1.3
Description: Attach a handler to the event for all elements which match the current selector, now or in the future.
  • version added: 1.3

  • .live( [String] eventType, [Function] handler )

  • eventType A string containing a JavaScript event type, such as "click" or "keydown." As of jQuery 1.4 the string can contain multiple, space-separated event types or custom event names, as well.
  • handler A function to execute at the time the event is triggered.
  • version added: 1.4

  • .live( [String] eventType, [Object] eventData, [Function] handler )

  • eventType A string containing a JavaScript event type, such as "click" or "keydown." As of jQuery 1.4 the string can contain multiple, space-separated event types or custom event names, as well.
  • eventData A map of data that will be passed to the event handler.
  • handler A function to execute at the time the event is triggered.

This method is a variation on the basic method for attaching event handlers to elements. When is called, the elements that the jQuery object refers to get the handler attached; elements that get introduced later do not, so they would require another call. For instance, consider the HTML:

<body>
  <div class="clickme">
    Click here
  </div>
</body>

We can bind a simple click handler to this element:

$('.clickme').bind('click', function() {
  // Bound handler called.
});

When the element is clicked, the handler is called. However, suppose that after this, another element is added:

$('body').append('<div class="clickme">Another target</div>');

This new element also matches the selector , but since it was added after the call to , clicks on it will do nothing.

The method provides an alternative to this behavior. If we bind a click handler to the target element using this method:

$('.clickme').live('click', function() {
  // Live handler called.
});

And then later add a new element:

$('body').append('<div class="clickme">Another target</div>');

Then clicks on the new element will also trigger the handler.

Event Delegation

The method is able to affect elements that have not yet been added to the DOM through the use of event delegation: a handler bound to an ancestor element is responsible for events that are triggered on its descendants. The handler passed to is never bound to an element; instead, binds a special handler to the root of the DOM tree. In our example, when the new element is clicked, the following steps occur:

Because the test in step 5 is not performed until the event occurs, elements can be added at any time and still respond to events.

See the discussion for for more information on event binding.

Multiple Events

As of jQuery 1.4.1 can accept multiple, space-separated events, similar to the functionality provided in . For example, we can "live bind" the and events at the same time like so:

$('.hoverme').live('mouseover mouseout', function(event) {
  if (event.type == 'mouseover') {
    // do something on mouseover
  } else {
    // do something on mouseout
  }
});

Event Data

As of jQuery 1.4, the optional parameter allows us to pass additional information to the handler. One handy use of this parameter is to work around issues caused by closures. See the method's "" discussion for more information.

Event Context

As of jQuery 1.4, live events can be bound to a DOM element "context" rather than to the default document root. To set this context, we use the , passing in a single DOM element (as opposed to a jQuery collection or a selector).

$('div.clickme', $('#container')[0]).live('click', function() {
  // Live handler called.
});

The live handler in this example is called only when is a descendant of an element with an ID of "container."

Caveats

The technique is useful, but due to its special approach cannot be simply substituted for in all cases. Specific differences include:

Examples:

Example:

Click a paragraph to add another. Note that .live() binds the click event to all paragraphs - even new ones.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { background:yellow; font-weight:bold; cursor:pointer;
      padding:5px; }
  p.over { background: #ccc; }
  span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Click me!</p>

  <span></span>
  <script>
    $("p").live("click", function(){
      $(this).after("<p>Another paragraph!</p>");
    });
</script>
</body>
</html>

Demo:

Example:

To display each paragraph's text in an alert box whenever it is clicked:
<script>$("p").live("click", function(){
  alert( $(this).text() );
});</script>

Example:

To cancel a default action and prevent it from bubbling up, return false:
<script>$("a").live("click", function() { return false; })</script>

Example:

To cancel only the default action by using the preventDefault method.
<script>$("a").live("click", function(event){
  event.preventDefault();
});</script>

Example:

Can bind custom events too.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { color:red; }
  span { color:blue; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Has an attached custom event.</p>
  <button>Trigger custom event</button>
  <span style="display:none;"></span>
  <script>

    $("p").live("myCustomEvent", function(e, myName, myValue){
      $(this).text("Hi there!");
      $("span").stop().css("opacity", 1)
               .text("myName = " + myName)
               .fadeIn(30).fadeOut(1000);
    });
    $("button").click(function () {
      $("p").trigger("myCustomEvent");
    });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


triggerHandler – jQuery API

Returns: ObjectObject .triggerHandler( [String] eventType, [Array] extraParameters )

Categories: Event Handler Attachment, Version 1.2
Description: Execute all handlers attached to an element for an event.
  • version added: 1.2

  • .triggerHandler( [String] eventType, [Array] extraParameters )

  • eventType A string containing a JavaScript event type, such as or .
  • extraParameters An array of additional parameters to pass along to the event handler.

The method behaves similarly to , with the following exceptions:

For more information on this method, see the discussion for .

Examples:

Example:

If you called .triggerHandler() on a focus event - the browser's default focus action would not be triggered, only the event handlers bound to the focus event.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button id="old">.trigger("focus")</button>
<button id="new">.triggerHandler("focus")</button><br/><br/>

<input type="text" value="To Be Focused"/>
  <script>

$("#old").click(function(){
$("input").trigger("focus");
});
$("#new").click(function(){
$("input").triggerHandler("focus");
});
$("input").focus(function(){
$("<span>Focused!</span>").appendTo("body").fadeOut(1000);
});

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


trigger – jQuery API

Returns: jQueryjQuery .trigger( [String] eventType, [Array] extraParameters )

Categories: Event Handler Attachment, Version 1.0
Description: Execute all handlers and behaviors attached to the matched elements for the given event type.
  • version added: 1.0

  • .trigger( [String] eventType, [Array] extraParameters )

  • eventType A string containing a JavaScript event type, such as or .
  • extraParameters An array of additional parameters to pass along to the event handler.

Any event handlers attached with or one of its shortcut methods are triggered when the corresponding event occurs. They can be fired manually, however, with the method. A call to executes the handlers in the same order they would be if the event were triggered naturally by the user:

$('#foo').bind('click', function() {
      alert($(this).text());
    });
    $('#foo').trigger('click');

While simulates an event activation, complete with a synthesized event object, it does not perfectly replicate a naturally-occurring event.

To trigger handlers bound via jQuery without also triggering the native event, use instead.

When we define a custom event type using the method, the second argument to can become useful. For example, suppose we have bound a handler for the event to our element instead of the built-in event as we did above:

$('#foo').bind('custom', function(event, param1, param2) {
  alert(param1 + "\n" + param2);
});
$('#foo').trigger('custom', ['Custom', 'Event']);

The event object is always passed as the first parameter to an event handler, but if additional parameters are specified during a call as they are here, these parameters will be passed along to the handler as well.

Note the difference between the extra parameters we're passing here and the parameter to the method. Both are mechanisms for passing information to an event handler, but the argument to allows information to be determined at the time the event is triggered, while the argument to requires the information to be already computed at the time the handler is bound.

Examples:

Example:

Clicks to button #2 also trigger a click for button #1.
<!DOCTYPE html>
<html>
<head>
  <style>
button { margin:10px; }
div { color:blue; font-weight:bold; }
span { color:red; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button>Button #1</button>
<button>Button #2</button>
<div><span>0</span> button #1 clicks.</div>

<div><span>0</span> button #2 clicks.</div>
  <script>
$("button:first").click(function () {
update($("span:first"));
});
$("button:last").click(function () {
$("button:first").trigger('click');

update($("span:last"));
});

function update(j) {
var n = parseInt(j.text(), 10);
j.text(n + 1);
}
</script>
</body>
</html>

Demo:

Example:

To submit the first form without using the submit() function, try:
<script>$("form:first").trigger("submit")</script>

Example:

To submit the first form without using the submit() function, try:
<script>var event = jQuery.Event("submit");
$("form:first").trigger(event);
if ( event.isDefaultPrevented() ) {
// Perform an action...
}</script>

Example:

To pass arbitrary data to an event:
<script>$("p").click( function (event, a, b) {
// when a normal click fires, a and b are undefined
// for a trigger like below a refers to "foo" and b refers to "bar"

} ).trigger("click", ["foo", "bar"]);</script>

Example:

To pass arbitrary data through an event object:
<script>var event = jQuery.Event("logged");
event.user = "foo";
event.pass = "bar";
$("body").trigger(event);</script>

Example:

Alternate way to pass data through an event object:
<script>$("body").trigger({
type:"logged",
user:"foo",
pass:"bar"

});</script>

Comments

© 2010 The jQuery Project


one – jQuery API

Returns: jQueryjQuery .one( [String] eventType, [Object] eventData, [Function] handler(eventObject) )

Categories: Event Handler Attachment, Version 1.1
Description: Attach a handler to an event for the elements. The handler is executed at most once per element.
  • version added: 1.1

  • .one( [String] eventType, [Object] eventData, [Function] handler(eventObject) )

  • eventType A string containing one or more JavaScript event types, such as "click" or "submit," or custom event names.
  • eventData A map of data that will be passed to the event handler.
  • handler(eventObject) A function to execute at the time the event is triggered.

This method is identical to , except that the handler is unbound after its first invocation. For example:

$('#foo').one('click', function() {
  alert('This will be displayed only once.');
});

After the code is executed, a click on the element with ID will display the alert. Subsequent clicks will do nothing. This code is equivalent to:

$('#foo').bind('click', function(event) {
  alert('This will be displayed only once.');
  $(this).unbind(event);
});

In other words, explicitly calling from within a regularly-bound handler has exactly the same effect.

Examples:

Example:

Tie a one-time click to each div.
<!DOCTYPE html>
<html>
<head>
  <style>
div { width:60px; height:60px; margin:5px; float:left;
background:green; border:10px outset;
cursor:pointer; }
p { color:red; margin:0; clear:left; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div></div>
<div></div>
<div></div>
<div></div>

<div></div>
<p>Click a green square...</p>
  <script>
var n = 0;
$("div").one("click", function(){
var index = $("div").index(this);
$(this).css({ borderStyle:"inset",
    cursor:"auto" });
$("p").text("Div at index #" + index + " clicked." +
  "  That's " + ++n + " total clicks.");
});

</script>
</body>
</html>

Demo:

Example:

To display the text of all paragraphs in an alert box the first time each of them is clicked:
<script>$("p").one("click", function(){
alert( $(this).text() );
});</script>

Comments

© 2010 The jQuery Project


unbind – jQuery API

  • unbind( [String] eventType, [Function] handler(eventObject) )

    • 1.0unbind( [String] eventType, [Function] handler(eventObject) )

  • unbind( [Object] event )

    • 1.0unbind( [Object] event )

Returns: jQueryjQuery .unbind( [Object] event )

Categories: Event Handler Attachment, Version 1.0
Description: Remove a previously-attached event handler from the elements.
  • version added: 1.0

  • .unbind( [String] eventType, [Function] handler(eventObject) )

  • eventType A string containing a JavaScript event type, such as or .
  • handler(eventObject) The function that is to be no longer executed.
  • version added: 1.0

  • .unbind( [Object] event )

  • event A JavaScript event object as passed to an event handler.

Any handler that has been attached with can be removed with . In the simplest case, with no arguments, removes all handlers attached to the elements:

$('#foo').unbind();

This version removes the handlers regardless of type. To be more precise, we can pass an event type:

$('#foo').unbind('click');

By specifying the event type, only handlers for that event type will be unbound. This approach can still have negative ramifications if other scripts might be attaching behaviors to the same element, however. Robust and extensible applications typically demand the two-argument version for this reason:

var handler = function() {
  alert('The quick brown fox jumps over the lazy dog.');
};
$('#foo').bind('click', handler);
$('#foo').unbind('click', handler);

By naming the handler, we can be assured that no other functions are caught in the crossfire. Note that the following will work:

$('#foo').bind('click', function() {
  alert('The quick brown fox jumps over the lazy dog.');
});

$('#foo').unbind('click', function() {
  alert('The quick brown fox jumps over the lazy dog.');
});

Even though the two functions are identical in content, they are created separately and so JavaScript is free to keep them as distinct function objects. To unbind a particular handler, we need a reference to that function and not a different one that happens to do the same thing.

Using Namespaces

Instead of maintaining references to handlers in order to unbind them, we can namespace the events and use this capability to narrow the scope of our unbinding actions. As shown in the discussion for the method, namespaces are defined by using a period () character when binding a handler:

$('#foo').bind('click.myEvents', handler);

When a handler is bound in this fashion, we can still unbind it the normal way:

$('#foo').unbind('click');

However, if we want to avoid affecting other handlers, we can be more specific:

$('#foo').unbind('click.myEvents');

If multiple namespaced handlers are bound, we can unbind them at once:

$('#foo').unbind('click.myEvents.yourEvents');

This syntax is similar to that used for CSS class selectors; they are not hierarchical. This method call is thus the same as:

$('#foo').unbind('click.yourEvents.myEvents');

We can also unbind all of the handlers in a namespace, regardless of event type:

$('#foo').unbind('.myEvents');

It is particularly useful to attach namespaces to event bindings when we are developing plug-ins or otherwise writing code that may interact with other event-handling code in the future.

Using the Event Object

The second form of the method is used when we wish to unbind a handler from within itself. For example, suppose we wish to trigger an event handler only three times:

var timesClicked = 0;
$('#foo').bind('click', function(event) {
  alert('The quick brown fox jumps over the lazy dog.');
  timesClicked++;
  if (timesClicked >= 3) {
    $(this).unbind(event);
  }
});

The handler in this case must take a parameter, so that we can capture the event object and use it to unbind the handler after the third click. The event object contains the context necessary for to know which handler to remove. This example is also an illustration of a closure. Since the handler refers to the variable, which is defined outside the function, incrementing the variable has an effect even between invocations of the handler.

Examples:

Example:

Can bind and unbind events to the colored button.
<!DOCTYPE html>
<html>
<head>
  <style>
button { margin:5px; }
button#theone { color:red; background:yellow; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button id="theone">Does nothing...</button>
<button id="bind">Bind Click</button>
<button id="unbind">Unbind Click</button>

<div style="display:none;">Click!</div>
  <script>

function aClick() {
$("div").show().fadeOut("slow");
}
$("#bind").click(function () {
// could use .bind('click', aClick) instead but for variety...
$("#theone").click(aClick)
  .text("Can Click!");
});
$("#unbind").click(function () {
$("#theone").unbind('click', aClick)
  .text("Does nothing...");
});

</script>
</body>
</html>

Demo:

Example:

To unbind all events from all paragraphs, write:
<script>$("p").unbind()</script>

Example:

To unbind all click events from all paragraphs, write:
<script>$("p").unbind( "click" )</script>

Example:

To unbind just one previously bound handler, pass the function in as the second argument:
<script>var foo = function () {
// code to handle some kind of event
};

$("p").bind("click", foo); // ... now foo will be called when paragraphs are clicked ...

$("p").unbind("click", foo); // ... foo will no longer be called.</script>

Comments

© 2010 The jQuery Project


bind – jQuery API

  • bind( [String] eventType, [Object] eventData, [Function] handler(eventObject) )

    • 1.0bind( [String] eventType, [Object] eventData, [Function] handler(eventObject) )

  • bind( [Object] events )

    • 1.4bind( [Object] events )

Returns: jQueryjQuery .bind( [Object] events )

Categories: Event Handler Attachment, Version 1.0, Version 1.4
Description: Attach a handler to an event for the elements.
  • version added: 1.0

  • .bind( [String] eventType, [Object] eventData, [Function] handler(eventObject) )

  • eventType A string containing one or more JavaScript event types, such as "click" or "submit," or custom event names.
  • eventData A map of data that will be passed to the event handler.
  • handler(eventObject) A function to execute each time the event is triggered.
  • version added: 1.4

  • .bind( [Object] events )

  • events A map of one or more JavaScript event types and functions to execute for them.

The method is the primary means of attaching behavior to a document. All JavaScript event types, such as , , and , are allowed for (The and events on the object use nonstandard conventions and are not supported by jQuery; attach a handler directly to the object instead.)

The jQuery library provides shortcut methods for binding the standard event types, such as for . A description of each can be found in the discussion of its shortcut method: , , , , , , , , , , , , , , , , , , , , , , ,

Any string is legal for ; if the string is not the name of a native JavaScript event, then the handler is bound to a custom event. These events are never called by the browser, but may be triggered manually from other JavaScript code using or .

If the string contains a period () character, then the event is namespaced. The period character separates the event from its namespace. For example, in the call , the string is the event type, and the string is the namespace. Namespacing allows us to unbind or trigger some events of a type without affecting others. See the discussion of for more information.

When an event reaches an element, all handlers bound to that event type for the element are fired. If there are multiple handlers registered, they will always execute in the order in which they were bound. After all handlers have executed, the event continues along the normal event propagation path.

A basic usage of is:

$('#foo').bind('click', function() {
  alert('User clicked on "foo."');
});

This code will cause the element with an ID of to respond to the event. When a user clicks inside this element thereafter, the alert will be shown.

Multiple Events

Multiple event types can be bound at once by including each one separated by a space:

$('#foo').bind('mouseenter mouseleave', function() {
  $(this).toggleClass('entered');
});

The effect of this on (when it does not initially have the "entered" class) is to add the "entered" class when the mouse enters the and remove the class when the mouse leaves.

As of jQuery 1.4 we can bind multiple event handlers simultaneously by passing a map of event type/handler pairs:

$('#foo').bind({
  click: function() {
    // do something on click
  },
  mouseenter: function() {
    // do something on mouseenter
  }
});

Event Handlers

The parameter takes a callback function, as shown above. Within the handler, the keyword refers to the DOM element to which the handler is bound. To make use of the element in jQuery, it can be passed to the normal function. For example:

$('#foo').bind('click', function() {
  alert($(this).text());
});

After this code is executed, when the user clicks inside the element with an ID of , its text contents will be shown as an alert.

As of jQuery 1.4.2 duplicate event handlers can be bound to an element instead of being discarded. For example:

function test(){ alert("Hello"); }
$("button").click( test );
$("button").click( test );

The above will generate two alerts when the button is clicked.

The callback function can also take parameters. When the function is called, the JavaScript event object will be passed to the first parameter.

The event object is often unnecessary and the parameter omitted, as sufficient context is usually available when the handler is bound to know exactly what needs to be done when the handler is triggered. However, at times it becomes necessary to gather more information about the user's environment at the time the event was initiated. .

Returning from a handler is equivalent to calling both and on the event object.

Using the event object in a handler looks like this:

$(document).ready(function() {
  $('#foo').bind('click', function(event) {
    alert('The mouse cursor is at ('
      + event.pageX + ', ' + event.pageY + ')');
  });
});

Note the parameter added to the anonymous function. This code will cause a click on the element with ID to report the page coordinates of the mouse cursor at the time of the click.

Passing Event Data

The optional parameter is not commonly used. When provided, this argument allows us to pass additional information to the handler. One handy use of this parameter is to work around issues caused by closures. For example, suppose we have two event handlers that both refer to the same external variable:

var message = 'Spoon!';
$('#foo').bind('click', function() {
  alert(message);
});
message = 'Not in the face!';
$('#bar').bind('click', function() {
  alert(message);
});

Because the handlers are closures that both have in their environment, both will display the message when triggered. The variable's value has changed. To sidestep this, we can pass the message in using :

var message = 'Spoon!';
$('#foo').bind('click', {msg: message}, function(event) {
  alert(event.data.msg);
});
message = 'Not in the face!';
$('#bar').bind('click', {msg: message}, function(event) {
  alert(event.data.msg);
});

This time the variable is not referred to directly within the handlers; instead, the variable is passed in through , which fixes the value at the time the event is bound. The first handler will now display while the second will alert

If is present, it is the second argument to the method; if no additional data needs to be sent to the handler, then the callback is passed as the second and final argument.

As of jQuery 1.4 we can no longer attach data (and thus, events) to object, embed, or applet elements because critical errors occur when attaching data to Java applets.

Examples:

Example:

Handle click and double-click for the paragraph. Note: the coordinates are window relative, so in this case relative to the demo iframe.
<!DOCTYPE html>
<html>
<head>
  <style>
p { background:yellow; font-weight:bold; cursor:pointer;
padding:5px; }
p.over { background: #ccc; }
span { color:red; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Click or double click here.</p>
<span></span>
  <script>
$("p").bind("click", function(event){
var str = "( " + event.pageX + ", " + event.pageY + " )";
$("span").text("Click happened! " + str);
});
$("p").bind("dblclick", function(){
$("span").text("Double-click happened in " + this.nodeName);
});
$("p").bind("mouseenter mouseleave", function(event){
$(this).toggleClass("over");
});

</script>
</body>
</html>

Demo:

Example:

To display each paragraph's text in an alert box whenever it is clicked:
<script>$("p").bind("click", function(){
alert( $(this).text() );
});</script>

Example:

You can pass some extra data before the event handler:
<script>function handler(event) {
alert(event.data.foo);
}
$("p").bind("click", {foo: "bar"}, handler)</script>

Example:

Cancel a default action and prevent it from bubbling up by returning :
<script>$("form").bind("submit", function() { return false; })</script>

Example:

Cancel only the default action by using the .preventDefault() method.
<script>$("form").bind("submit", function(event) {
event.preventDefault();
});</script>

Example:

Stop an event from bubbling without preventing the default action by using the .stopPropagation() method.
<script>$("form").bind("submit", function(event) {
  event.stopPropagation();
});</script>

Example:

Bind custom events.
<!DOCTYPE html>
<html>
<head>
  <style>
p { color:red; }
span { color:blue; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Has an attached custom event.</p>
<button>Trigger custom event</button>
<span style="display:none;"></span>
  <script>

$("p").bind("myCustomEvent", function(e, myName, myValue){
$(this).text(myName + ", hi there!");
$("span").stop().css("opacity", 1)
.text("myName = " + myName)
.fadeIn(30).fadeOut(1000);
});
$("button").click(function () {
$("p").trigger("myCustomEvent", [ "John" ]);
});

</script>
</body>
</html>

Demo:

Example:

Bind multiple events simultaneously.
<script>$("div.test").bind({
  click: function(){
    $(this).addClass("active");
  },
  mouseenter: function(){
    $(this).addClass("inside");
  },
  mouseleave: function(){
    $(this).removeClass("inside");
  }
});</script>

Comments

© 2010 The jQuery Project


Event Object – jQuery API

Event Object

  • Boolean event.isImmediatePropagationStopped( )

    New in 1.3 !

    Returns whether event.stopImmediatePropagation() was ever called on this event object.

  • event.stopImmediatePropagation( )

    New in 1.3 !

    Keeps the rest of the handlers from being executed and prevents the event from bubbling up the DOM tree

  • Boolean event.isPropagationStopped( )

    New in 1.3 !

    Returns whether was ever called on this event object.

  • event.stopPropagation( )

    New in 1.0 !

    Prevents the event from bubbling up the DOM tree, preventing any parent handlers from being notified of the event.

  • Boolean event.isDefaultPrevented( )

    New in 1.3 !

    Returns whether was ever called on this event object.

  • undefined event.preventDefault( )

    New in 1.0 !

    If this method is called, the default action of the event will not be triggered.

  • Number event.timeStamp

    New in 1.2.6 !

    This attribute returns the number of milliseconds since January 1, 1970, when the event is triggered.

  • Object event.result

    New in 1.3 !

    This attribute contains the last value returned by an event handler that was triggered by this event, unless the value was .

  • String event.which

    New in 1.1.3 !

    For key or button events, this attribute indicates the specific button or key that was pressed.

  • Number event.pageY

    New in 1.0.4 !

    The mouse position relative to the top edge of the document.

  • Number event.pageX

    New in 1.0.4 !

    The mouse position relative to the left edge of the document.

  • Element event.currentTarget

    New in 1.3 !

    The current DOM element within the event bubbling phase.

  • Element event.relatedTarget

    New in 1.1.4 !

    The other DOM element involved in the event, if any.

  • Anything event.data

    New in 1.1 !

    Contains the optional data passed to jQuery.fn.bind when the current executing handler was bound.

  • Element event.target

    New in 1.0 !

    The DOM element that initiated the event.

  • String event.type

    New in 1.0 !

    Describes the nature of the event.


event.isImmediatePropagationStopped – jQuery API

Returns: BooleanBoolean event.isImmediatePropagationStopped( )

Categories: Event Object, Version 1.3
Description: Returns whether event.stopImmediatePropagation() was ever called on this event object.
  • version added: 1.3

  • event.isImmediatePropagationStopped( )

This property was introduced in .

Examples:

Example:

Checks whether event.stopImmediatePropagation() was called.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

  <button>click me</button>
  <div id="stop-log"></div>

  <script>

function immediatePropStopped(e) {
  var msg = "";
  if ( e.isImmediatePropagationStopped() ) {
    msg =  "called"
  } else {
    msg = "not called";
  }
  $("#stop-log").append( "<div>" + msg + "</div>" );
}

$("button").click(function(event) {
  immediatePropStopped(event);
  event.stopImmediatePropagation();
  immediatePropStopped(event);
});
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


event.stopImmediatePropagation – jQuery API

Returns: event.stopImmediatePropagation( )

Categories: Event Object, Version 1.3
Description: Keeps the rest of the handlers from being executed and prevents the event from bubbling up the DOM tree
  • version added: 1.3

  • event.stopImmediatePropagation( )

In addition to keeping any additional handlers on an element from being executed, this method also stops the bubbling by implicitly calling . To simply prevent the event from bubbling to ancestor elements but allow other event handlers to execute on the same element, we can use instead.

Use to know whether this method was ever called (on that event object).

Examples:

Example:

Prevents other event handlers from being called.
<!DOCTYPE html>
<html>
<head>
  <style>
p { height: 30px; width: 150px; background-color: #ccf; }
div {height: 30px; width: 150px; background-color: #cfc; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>paragraph</p>
<div>division</div>
  <script>
$("p").click(function(event){
  event.stopImmediatePropagation();
});
$("p").click(function(event){
  // This function won't be executed
  $(this).css("background-color", "#f00");
});
$("div").click(function(event) {
  // This function will be executed
    $(this).css("background-color", "#f00");
});</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


event.isPropagationStopped – jQuery API

Returns: BooleanBoolean event.isPropagationStopped( )

Categories: Event Object, Version 1.3
Description: Returns whether was ever called on this event object.
  • version added: 1.3

  • event.isPropagationStopped( )

This event method is described in the .

Examples:

Example:

Checks whether event.stopPropagation() was called
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

  <button>click me</button>
  <div id="stop-log"></div>

  <script>

function propStopped(e) {
  var msg = "";
  if ( e.isPropagationStopped() ) {
    msg =  "called"
  } else {
    msg = "not called";
  }
  $("#stop-log").append( "<div>" + msg + "</div>" );
}

$("button").click(function(event) {
  propStopped(event);
  event.stopPropagation();
  propStopped(event);
});
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


event.stopPropagation – jQuery API

Returns: event.stopPropagation( )

Categories: Event Object, Version 1.0
Description: Prevents the event from bubbling up the DOM tree, preventing any parent handlers from being notified of the event.
  • version added: 1.0

  • event.stopPropagation( )

We can use to determine if this method was ever called (on that event object).

This method works for custom events triggered with , as well.

Note that this will not prevent other handlers from running.

Examples:

Example:

Kill the bubbling on the click event.
<script>$("p").click(function(event){
  event.stopPropagation();
  // do something
});  </script>

Comments

© 2010 The jQuery Project


event.isDefaultPrevented – jQuery API

Returns: BooleanBoolean event.isDefaultPrevented( )

Categories: Event Object, Version 1.3
Description: Returns whether was ever called on this event object.
  • version added: 1.3

  • event.isDefaultPrevented( )

Examples:

Example:

Checks whether event.preventDefault() was called.
<script>$("a").click(function(event){
  alert( event.isDefaultPrevented() ); // false
  event.preventDefault();
  alert( event.isDefaultPrevented() ); // true
});  </script>

Comments

© 2010 The jQuery Project


event.preventDefault – jQuery API

Returns: undefinedundefined event.preventDefault( )

Categories: Event Object, Version 1.0
Description: If this method is called, the default action of the event will not be triggered.
  • version added: 1.0

  • event.preventDefault( )

For example, clicked anchors will not take the browser to a new URL. We can use to determine if this method has been called by an event handler that was triggered by this event.

Examples:

Example:

Cancel the default action (navigation) of the click.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<a href="http://jquery.com">default click action is prevented</a>
<div id="log"></div>

  <script>
$("a").click(function(event) {
  event.preventDefault();
  $('<div/>')
    .append('default ' + event.type + ' prevented')
    .appendTo('#log');
});
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


event.timeStamp – jQuery API

Returns: NumberNumber event.timeStamp

Categories: Event Object, Version 1.2.6
Description: This attribute returns the number of milliseconds since January 1, 1970, when the event is triggered.
  • version added: 1.2.6

  • event.timeStamp

Examples:

Example:

Display the time since the click handler last executed.
<!DOCTYPE html>
<html>
<head>
  <style>
div { height: 100px; width: 300px; margin: 10px;
      background-color: #ffd; overflow: auto; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<div></div>
  <script>
var last, diff;
$('div').click(function(event) {
  if ( last ) {
    diff = event.timeStamp - last
    $('div').append('time since last event: ' + diff + '<br/>');
  } else {
    $('div').append('Click again.<br/>');
  }
  last = event.timeStamp;
});  </script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


event.result – jQuery API

Returns: ObjectObject event.result

Categories: Event Object, Version 1.3
Description: This attribute contains the last value returned by an event handler that was triggered by this event, unless the value was .
  • version added: 1.3

  • event.result

Examples:

Example:

Alert previous handler's return value
<script>$("p").click(function(event) {
  return "hey"
});
$("p").click(function(event) {
  alert( event.result );
});  </script>

Comments

© 2010 The jQuery Project


event.which – jQuery API

Returns: StringString event.which

Categories: Event Object, Version 1.1.3
Description: For key or button events, this attribute indicates the specific button or key that was pressed.
  • version added: 1.1.3

  • event.which

normalizes and . It is recommended to watch for keyboard key input. For more detail, read about .

Examples:

Example:

Log what key was depressed.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<input id="whichkey" value="type something">
<div id="log"></div>
  <script>$('#whichkey').bind('keydown',function(e){
  $('#log').html(e.type + ': ' +  e.which );
});  </script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


event.pageY – jQuery API

Returns: NumberNumber event.pageY

Categories: Event Object, Version 1.0.4
Description: The mouse position relative to the top edge of the document.
  • version added: 1.0.4

  • event.pageY

Examples:

Example:

Show the mouse position relative to the left and top edges of the document (within this iframe).
<!DOCTYPE html>
<html>
<head>
  <style>
body {background-color: #eef; }
div { padding: 20px; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div id="log"></div>
  <script>$(document).bind('mousemove',function(e){
            $("#log").text("e.pageX: " + e.pageX + ", e.pageY: " + e.pageY);
}); </script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


event.pageX – jQuery API

Returns: NumberNumber event.pageX

Categories: Event Object, Version 1.0.4
Description: The mouse position relative to the left edge of the document.
  • version added: 1.0.4

  • event.pageX

Examples:

Example:

Show the mouse position relative to the left and top edges of the document (within the iframe).
<!DOCTYPE html>
<html>
<head>
  <style>
body {background-color: #eef; }
div { padding: 20px; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div id="log"></div>
  <script>$(document).bind('mousemove',function(e){
            $("#log").text("e.pageX: " + e.pageX + ", e.pageY: " + e.pageY);
}); </script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


event.currentTarget – jQuery API

Returns: ElementElement event.currentTarget

Categories: Event Object, Version 1.3
Description: The current DOM element within the event bubbling phase.
  • version added: 1.3

  • event.currentTarget

This property will always be equal to the of the function.

Examples:

Example:

Alert that currentTarget matches the `this` keyword.
<script>$("p").click(function(event) {
  alert( event.currentTarget === this ); // true
});  </script>

Comments

© 2010 The jQuery Project


event.relatedTarget – jQuery API

Returns: ElementElement event.relatedTarget

Categories: Event Object, Version 1.1.4
Description: The other DOM element involved in the event, if any.
  • version added: 1.1.4

  • event.relatedTarget

For , indicates the element being entered; for , indicates the element being exited.

Examples:

Example:

On mouseout of anchors, alert the element type being entered.
<script>$("a").mouseout(function(event) {
  alert(event.relatedTarget.nodeName); // "DIV"
});  </script>

Comments

© 2010 The jQuery Project


event.data – jQuery API

Returns: AnythingAnything event.data

Categories: Event Object, Version 1.1
Description: Contains the optional data passed to jQuery.fn.bind when the current executing handler was bound.
  • version added: 1.1

  • event.data

Examples:

Example:

The description of the example.
<script>$("a").each(function(i) {
  $(this).bind('click', {index:i}, function(e){
     alert('my index is ' + e.data.index);
  });
});   </script>

Comments

© 2010 The jQuery Project


event.target – jQuery API

Returns: ElementElement event.target

Categories: Event Object, Version 1.0
Description: The DOM element that initiated the event.
  • version added: 1.0

  • event.target

This can be the element that registered for the event or a child of it. It is often useful to compare to in order to determine if the event is being handled due to event bubbling. This property is very useful in event delegation, when events bubble.

Examples:

Example:

Display the tag's name on click
<!DOCTYPE html>
<html>
<head>
  <style>
span, strong, p {
  padding: 8px; display: block; border: 1px solid #999;  }
    </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<div id="log"></div>
<div>
  <p>
    <strong><span>click</span></strong>
  </p>
</div>
  <script>$("body").click(function(event) {
  $("#log").html("clicked: " + event.target.nodeName);
});  </script>
</body>
</html>

Demo:

Example:

Implements a simple event delegation: The click handler is added to an unordered list, and the children of its li children are hidden. Clicking one of the li children toggles (see toggle()) their children.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<ul>
  <li>item 1
    <ul>
      <li>sub item 1-a</li>
      <li>sub item 1-b</li>
    </ul>
  </li>
  <li>item 2
    <ul>
      <li>sub item 2-a</li>
      <li>sub item 2-b</li>
    </ul>
  </li>
</ul>
  <script>function handler(event) {
  var $target = $(event.target);
  if( $target.is("li") ) {
    $target.children().toggle();
  }
}
$("ul").click(handler).find("ul").hide();</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


event.type – jQuery API

Returns: StringString event.type

Categories: Event Object, Version 1.0
Description: Describes the nature of the event.
  • version added: 1.0

  • event.type

Examples:

Example:

On all anchor clicks, alert the event type.
<script>$("a").click(function(event) {
  alert(event.type); // "click"
}); </script>

Comments

© 2010 The jQuery Project


Form Events – jQuery API

Form Events

  • jQuery .submit( )

    New in 1.0 !

    Bind an event handler to the "submit" JavaScript event, or trigger that event on an element.

  • jQuery .select( )

    New in 1.0 !

    Bind an event handler to the "select" JavaScript event, or trigger that event on an element.

  • jQuery .change( )

    New in 1.0 !

    Bind an event handler to the "change" JavaScript event, or trigger that event on an element.

  • jQuery .blur( )

    New in 1.0 !

    Bind an event handler to the "blur" JavaScript event, or trigger that event on an element.

  • jQuery .focus( )

    New in 1.0 !

    Bind an event handler to the "focus" JavaScript event, or trigger that event on an element.


submit – jQuery API

  • submit( [Function] handler(eventObject) )

    • 1.0submit( [Function] handler(eventObject) )

  • submit( )

    • 1.0submit( )

Returns: JQuery(":submit")

Categories: Form, Version 1.0
Description: Selects all elements of type submit.
  • version added: 1.0

  • JQuery(":submit")

The selector typically applies to button or input elements. Note that some browsers treat element as implicitly while others (such as Internet Explorer) do not.

Examples:

Example:

Finds all submit elements that are descendants of a td element.
<!DOCTYPE html>
<html>
<head>
  <style>
  textarea { height:45px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<table>
<form>
<table id="exampleTable" border="1" cellpadding="10" align="center">

    <tr>
        <th>
            Element Type
        </th>
        <th>
            Element
        </th>

    </tr
    <tr>
        <td>
            <input type="button" value="Input Button"/>
        </td>

    </tr>
    <tr>
        <td>
            <input type="checkbox" />
        </td>

    </tr>
    <tr>
        <td>
            <input type="file" />
        </td>

    </tr>
    <tr>
        <td>
            <input type="hidden" />
        </td>

    </tr>
    <tr>
        <td>
            <input type="image" />
        </td>

    </tr>
    <tr>
        <td>
            <input type="password" />
        </td>

    </tr>
    <tr>
        <td>
            <input type="radio" />
        </td>

    </tr>
    <tr>
        <td>
            <input type="reset" />
        </td>

    </tr>
    <tr>
        <td>
            <input type="submit" />
        </td>

    </tr>
    <tr>
        <td>
            <input type="text" />
        </td>

    </tr>
    <tr>
        <td>
            <select><option>Option</option></select>
        </td>

    </tr>
    <tr>
        <td>
            <textarea></textarea>
        </td>
    </tr>

    <tr>
        <td>
            <button>Button</button>
        </td>
    </tr>
    <tr>
        <td>
            <button type="submit">Button type="submit"</button>
        </td>
    </tr>

</table>
</form>
<div id="result"></div>

  <script>
    var submitEl = $("td :submit")
      .parent('td')
      .css({background:"yellow", border:"3px red solid"})
    .end();

    $('#result').text('jQuery matched ' + submitEl.length + ' elements.');

    // so it won't submit
    $("form").submit(function () { return false; });

    // Extra JS to make the HTML easier to edit (None of this is relevant to the ':submit' selector
    $('#exampleTable').find('td').each(function(i, el) {
        var inputEl = $(el).children(),
            inputType = inputEl.attr('type') ? ' type="' + inputEl.attr('type') + '"' : '';
        $(el).before('<td>' + inputEl[0].nodeName + inputType + '</td>');
    })

</script>
</body>
</html>

Demo:

Returns: jQueryjQuery .submit( )

Categories: Form Events, Forms, Version 1.0
Description: Bind an event handler to the "submit" JavaScript event, or trigger that event on an element.
  • version added: 1.0

  • .submit( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute each time the event is triggered.
  • version added: 1.0

  • .submit( )

This method is a shortcut for in the first variation, and in the second.

The event is sent to an element when the user is attempting to submit a form. It can only be attached to elements. Forms can be submitted either by clicking an explicit , , or , or by pressing when certain form element has focus.

For example, consider the HTML:

<form id="target" action="destination.html">
  <input type="text" value="Hello there" />
  <input type="submit" value="Go" />
</form>
<div id="other">
  Trigger the handler
</div>

The event handler can be bound to the form:

$('#target').submit(function() {
  alert('Handler for .submit() called.');
  return false;
});

Now when the form is submitted, the message is alerted. This happens prior to the actual submission, so we can cancel the submit action by calling on the event object or by returning from our handler. We can trigger the event manually when another element is clicked:

$('#other').click(function() {
  $('#target').submit();
});

After this code executes, clicks on will also display the message. In addition, the default action on the form will be fired, so the form will be submitted.

The JavaScript event does not bubble in Internet Explorer. However, scripts that rely on event delegation with the event will work consistently across browsers as of jQuery 1.4, which has normalized the event's behavior.

Examples:

Example:

If you'd like to prevent forms from being submitted unless a flag variable is set, try:
<!DOCTYPE html>
<html>
<head>
  <style>
  p { margin:0; color:blue; }
  div,p { margin-left:10px; }
  span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Type 'correct' to validate.</p>
  <form action="javascript:alert('success!');">
    <div>
      <input type="text" />

      <input type="submit" />
    </div>
  </form>
  <span></span>
  <script>

    $("form").submit(function() {
      if ($("input:first").val() == "correct") {
        $("span").text("Validated...").show();
        return true;
      }
      $("span").text("Not valid!").show().fadeOut(1000);
      return false;
    });
</script>
</body>
</html>

Demo:

Example:

If you'd like to prevent forms from being submitted unless a flag variable is set, try:
<script>$("form").submit( function () {
  return this.some_flag_variable;
} );</script>

Example:

To trigger the submit event on the first form on the page, try:
<script>$("form:first").submit();</script>

Comments

© 2010 The jQuery Project


select – jQuery API

  • select( [Function] handler(eventObject) )

    • 1.0select( [Function] handler(eventObject) )

  • select( )

    • 1.0select( )

Returns: jQueryjQuery .select( )

Categories: Form Events, Forms, Version 1.0
Description: Bind an event handler to the "select" JavaScript event, or trigger that event on an element.
  • version added: 1.0

  • .select( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute each time the event is triggered.
  • version added: 1.0

  • .select( )

This method is a shortcut for in the first variation, and in the second.

The event is sent to an element when the user makes a text selection inside it. This event is limited to fields and boxes.

For example, consider the HTML:

<form>
  <input id="target" type="text" value="Hello there" />
</form>
<div id="other">
  Trigger the handler
</div>

The event handler can be bound to the text input:

$('#target').select(function() {
  alert('Handler for .select() called.');
});

Now when any portion of the text is selected, the alert is displayed. Merely setting the location of the insertion point will not trigger the event. We can trigger the event manually when another element is clicked:

$('#other').click(function() {
  $('#target').select();
});

After this code executes, clicks on the Trigger button will also alert the message:

In addition, the default action on the field will be fired, so the entire text field will be selected.

Examples:

Example:

To do something when text in input boxes is selected:
<!DOCTYPE html>
<html>
<head>
  <style>
  p { color:blue; }
  div { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>

    Click and drag the mouse to select text in the inputs.
  </p>
  <input type="text" value="Some text" />
  <input type="text" value="to test on" />

  <div></div>
  <script>
    $(":input").select( function () {
      $("div").text("Something was selected").show().fadeOut(1000);
    });
</script>
</body>
</html>

Demo:

Example:

To trigger the select event on all input elements, try:
<script>$("input").select();</script>

Comments

© 2010 The jQuery Project


change – jQuery API

  • change( [Function] handler(eventObject) )

    • 1.0change( [Function] handler(eventObject) )

  • change( )

    • 1.0change( )

Returns: jQueryjQuery .change( )

Categories: Form Events, Forms, Version 1.0
Description: Bind an event handler to the "change" JavaScript event, or trigger that event on an element.
  • version added: 1.0

  • .change( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute each time the event is triggered.
  • version added: 1.0

  • .change( )

This method is a shortcut for in the first variation, and in the second.

The event is sent to an element when its value changes. This event is limited to elements, boxes and elements. For select boxes, checkboxes, and radio buttons, the event is fired immediately when the user makes a selection with the mouse, but for the other element types the event is deferred until the element loses focus.

For example, consider the HTML:

<form>
  <input class="target" type="text" value="Field 1" />
  <select class="target">
    <option value="option1" selected="selected">Option 1</option>
    <option value="option2">Option 2</option>
  </select>
</form>
<div id="other">
  Trigger the handler
</div>

The event handler can be bound to the text input and the select box:

$('.target').change(function() {
  alert('Handler for .change() called.');
});

Now when the second option is selected from the dropdown, the alert is displayed. It is also displayed if we change the text in the field and then click away. If the field loses focus without the contents having changed, though, the event is not triggered. We can trigger the event manually when another element is clicked:

$('#other').click(function() {
  $('.target').change();
});

After this code executes, clicks on will also alert the message. The message will be displayed twice, because the handler has been bound to the event on both of the form elements.

As of jQuery 1.4 the event now bubbles, and works identically to all other browsers, in Internet Explorer.

Examples:

Example:

Attaches a change event to the select that gets the text for each selected option and writes them in the div. It then triggers the event for the initial text draw.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <select name="sweets" multiple="multiple">
    <option>Chocolate</option>
    <option selected="selected">Candy</option>

    <option>Taffy</option>
    <option selected="selected">Caramel</option>
    <option>Fudge</option>
    <option>Cookie</option>

  </select>
  <div></div>
  <script>
    $("select").change(function () {
          var str = "";
          $("select option:selected").each(function () {
                str += $(this).text() + " ";
              });
          $("div").text(str);
        })
        .change();
</script>
</body>
</html>

Demo:

Example:

To add a validity test to all text input elements:
<script>$("input[type='text']").change( function() {
  // check input ($(this).val()) for validity here
});</script>

Comments

© 2010 The jQuery Project


blur – jQuery API

  • blur( [Function] handler(eventObject) )

    • 1.0blur( [Function] handler(eventObject) )

  • blur( )

    • 1.0blur( )

Returns: jQueryjQuery .blur( )

Categories: Form Events, Forms, Version 1.0
Description: Bind an event handler to the "blur" JavaScript event, or trigger that event on an element.
  • version added: 1.0

  • .blur( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute each time the event is triggered.
  • version added: 1.0

  • .blur( )

This method is a shortcut for in the first variation, and in the second.

The event is sent to an element when it loses focus. Originally, this event was only applicable to form elements, such as . In recent browsers, the domain of the event has been extended to include all element types. An element can lose focus via keyboard commands, such as the Tab key, or by mouse clicks elsewhere on the page.

For example, consider the HTML:

<form>
  <input id="target" type="text" value="Field 1" />
  <input type="text" value="Field 2" />
</form>
<div id="other">
  Trigger the handler
</div>
The event handler can be bound to the first input field:
$('#target').blur(function() {
  alert('Handler for .blur() called.');
});

Now if the first field has the focus and we click elsewhere, or tab away from it, the alert is displayed:

We can trigger the event when another element is clicked:

$('#other').click(function() {
  $('#target').blur();
});

After this code executes, clicks on will also alert the message.

The event does not bubble in Internet Explorer. Therefore, scripts that rely on event delegation with the event will not work consistently across browsers.

Examples:

Example:

To trigger the blur event on all paragraphs:
<script>$("p").blur();</script>

Comments

© 2010 The jQuery Project


focus – jQuery API

  • focus( [Function] handler(eventObject) )

    • 1.0focus( [Function] handler(eventObject) )

  • focus( )

    • 1.0focus( )

Returns: jQueryjQuery .focus( )

Categories: Form Events, Forms, Version 1.0
Description: Bind an event handler to the "focus" JavaScript event, or trigger that event on an element.
  • version added: 1.0

  • .focus( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute each time the event is triggered.
  • version added: 1.0

  • .focus( )

For example, consider the HTML:

<form>
  <input id="target" type="text" value="Field 1" />
  <input type="text" value="Field 2" />
</form>
<div id="other">
  Trigger the handler
</div>

The event handler can be bound to the first input field:

$('#target').focus(function() {
  alert('Handler for .focus() called.');
});

Now if we click on the first field, or tab to it from another field, the alert is displayed:

We can trigger the event when another element is clicked:

$('#other').click(function() {
  $('#target').focus();
});

After this code executes, clicks on will also alert the message.

The event does not bubble in Internet Explorer. Therefore, scripts that rely on event delegation with the event will not work consistently across browsers.

Examples:

Example:

Fire focus.
<!DOCTYPE html>
<html>
<head>
  <style>
span {display:none;}</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p><input type="text" /> <span>focus fire</span></p>

<p><input type="password" /> <span>focus fire</span></p>
  <script>
    $("input").focus(function () {
         $(this).next("span").css('display','inline').fadeOut(1000);
    });
</script>
</body>
</html>

Demo:

Example:

To stop people from writing in text input boxes, try:
<script>$("input[type=text]").focus(function(){
  $(this).blur();
});</script>

Example:

To focus on a login input box with id 'login' on page startup, try:
<script>$(document).ready(function(){
  $("#login").focus();
});</script>

Comments

© 2010 The jQuery Project


Keyboard Events – jQuery API

Keyboard Events

  • jQuery .focusout( [Function] handler(eventObject) )

    New in 1.4 !

    Bind an event handler to the "focusout" JavaScript event.

  • jQuery .focusin( [Function] handler(eventObject) )

    New in 1.4 !

    Bind an event handler to the "focusin" JavaScript event.

  • jQuery .keydown( )

    New in 1.0 !

    Bind an event handler to the "keydown" JavaScript event, or trigger that event on an element.

  • jQuery .keyup( )

    New in 1.0 !

    Bind an event handler to the "keyup" JavaScript event, or trigger that event on an element.

  • jQuery .keypress( )

    New in 1.0 !

    Bind an event handler to the "keypress" JavaScript event, or trigger that event on an element.


focusout – jQuery API

Returns: jQueryjQuery .focusout( [Function] handler(eventObject) )

Categories: Keyboard Events, Mouse Events, Version 1.4
Description: Bind an event handler to the "focusout" JavaScript event.
  • version added: 1.4

  • .focusout( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute each time the event is triggered.

This method is a shortcut for .

The event is sent to an element when it, or any element inside of it, loses focus. This is distinct from the event in that it supports detecting the loss of focus from parent elements (in other words, it supports event bubbling).

This event will likely be used together with the event.

Examples:

Example:

Watch for a loss of focus to occur inside paragraphs and note the difference between the count and the count.
<!DOCTYPE html>
<html>
<head>
  <style>
.inputs { float: left; margin-right: 1em; }
.inputs p { margin-top: 0; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<div class="inputs">
  <p>
    <input type="text" /><br />
    <input type="text" />
  </p>
  <p>
    <input type="password" />
  </p>
</div>
<div id="fo">focusout fire</div>
<div id="b">blur fire</div>

  <script>
var fo = 0, b = 0;
$("p").focusout(function() {
  fo++;
  $("#fo")
    .text("focusout fired: " + fo + "x");
}).blur(function() {
  b++;
  $("#b")
    .text("blur fired: " + b + "x");

});
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


focusin – jQuery API

Returns: jQueryjQuery .focusin( [Function] handler(eventObject) )

Categories: Keyboard Events, Mouse Events, Version 1.4
Description: Bind an event handler to the "focusin" JavaScript event.
  • version added: 1.4

  • .focusin( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute each time the event is triggered.

This method is a shortcut for .

The event is sent to an element when it, or any element inside of it, gains focus. This is distinct from the event in that it supports detecting the focus event on parent elements.

This event will likely be used together with the event.

Examples:

Example:

Watch for a focus to occur within the paragraphs on the page.
<!DOCTYPE html>
<html>
<head>
  <style>
span {display:none;}</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p><input type="text" /> <span>focusin fire</span></p>
<p><input type="password" /> <span>focusin fire</span></p>
  <script>
    $("p").focusin(function() {
         $(this).find("span").css('display','inline').fadeOut(1000);
    });
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


keydown – jQuery API

  • keydown( [Function] handler(eventObject) )

    • 1.0keydown( [Function] handler(eventObject) )

  • keydown( )

    • 1.0keydown( )

Returns: jQueryjQuery .keydown( )

Categories: Keyboard Events, Version 1.0
Description: Bind an event handler to the "keydown" JavaScript event, or trigger that event on an element.
  • version added: 1.0

  • .keydown( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute each time the event is triggered.
  • version added: 1.0

  • .keydown( )

This method is a shortcut for in the first variation, and in the second.

The event is sent to an element when the user first presses a key on the keyboard. It can be attached to any element, but the event is only sent to the element that has the focus. Focusable elements can vary between browsers, but form elements can always get focus so are reasonable candidates for this event type.

For example, consider the HTML:

<form>
  <input id="target" type="text" value="Hello there" />
</form>
<div id="other">
  Trigger the handler
</div>

The event handler can be bound to the input field:

$('#target').keydown(function() {
  alert('Handler for .keydown() called.');
});

Now when the insertion point is inside the field and a key is pressed, the alert is displayed:

We can trigger the event manually when another element is clicked:

$('#other').click(function() {
  $('#target').keydown();
});

After this code executes, clicks on will also alert the message.

If key presses anywhere need to be caught (for example, to implement global shortcut keys on a page), it is useful to attach this behavior to the object. Because of event bubbling, all key presses will make their way up the DOM to the object unless explicitly stopped.

To determine which key was pressed, we can examine the that is passed to the handler function. While browsers use differing properties to store this information, jQuery normalizes the property so we can reliably use it to retrieve the key code. This code corresponds to a key on the keyboard, including codes for special keys such as arrows. For catching actual text entry, may be a better choice.

Examples:

Example:

Show the event object for the keydown handler when a key is pressed in the input.
<!DOCTYPE html>
<html>
<head>
  <style>
fieldset { margin-bottom: 1em; }
input { display: block; margin-bottom: .25em; }
#print-output {
  width: 100%;
}
.print-output-line {
  white-space: pre;
  padding: 5px;
  font-family: monaco, monospace;
  font-size: .7em;
}
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <form>
  <fieldset>
    <label for="target">Type Something:</label>
    <input id="target" type="text" />
  </fieldset>
</form>
<button id="other">
  Trigger the handler
</button>
<script type="text/javascript" src="/scripts/events.js"></script>
  <script>
var xTriggered = 0;
$('#target').keydown(function(event) {
  if (event.keyCode == '13') {
     event.preventDefault();
   }
   xTriggered++;
   var msg = 'Handler for .keydown() called ' + xTriggered + ' time(s).';
  $.print(msg, 'html');
  $.print(event);
});

$('#other').click(function() {
  $('#target').keydown();
});</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


keyup – jQuery API

  • keyup( [Function] handler(eventObject) )

    • 1.0keyup( [Function] handler(eventObject) )

  • keyup( )

    • 1.0keyup( )

Returns: jQueryjQuery .keyup( )

Categories: Keyboard Events, Version 1.0
Description: Bind an event handler to the "keyup" JavaScript event, or trigger that event on an element.
  • version added: 1.0

  • .keyup( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute each time the event is triggered.
  • version added: 1.0

  • .keyup( )

This method is a shortcut for in the first variation, and in the second.

The event is sent to an element when the user releases a key on the keyboard. It can be attached to any element, but the event is only sent to the element that has the focus. Focusable elements can vary between browsers, but form elements can always get focus so are reasonable candidates for this event type.

For example, consider the HTML:

<form>
  <input id="target" type="text" value="Hello there" />
</form>
<div id="other">
  Trigger the handler
</div>

The event handler can be bound to the input field:

$('#target').keyup(function() {
  alert('Handler for .keyup() called.');
});

Now when the insertion point is inside the field and a key is pressed and released, the alert is displayed:

We can trigger the event manually when another element is clicked:

$('#other').click(function() {
  $('#target').keyup();
});

After this code executes, clicks on will also alert the message.

If key presses anywhere need to be caught (for example, to implement global shortcut keys on a page), it is useful to attach this behavior to the object. Because of event bubbling, all key presses will make their way up the DOM to the object unless explicitly stopped.

To determine which key was pressed, we can examine the event object that is passed to the handler function. While browsers use differing attributes to store this information, jQuery normalizes the attribute so we can reliably use it to retrieve the key code. This code corresponds to a key on the keyboard, including codes for special keys such as arrows. For catching actual text entry, may be a better choice.

Examples:

Example:

Show the event object for the keyup handler when a key is released in the input.
<!DOCTYPE html>
<html>
<head>
  <style>
fieldset { margin-bottom: 1em; }
input { display: block; margin-bottom: .25em; }
#print-output {
  width: 100%;
}
.print-output-line {
  white-space: pre;
  padding: 5px;
  font-family: monaco, monospace;
  font-size: .7em;
}
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <form>
  <fieldset>
    <label for="target">Type Something:</label>
    <input id="target" type="text" />
  </fieldset>
</form>
<button id="other">
  Trigger the handler
</button>
<script type="text/javascript" src="/scripts/events.js"></script>
  <script>
var xTriggered = 0;
$('#target').keyup(function(event) {
  if (event.keyCode == '13') {
     event.preventDefault();
   }
   xTriggered++;
   var msg = 'Handler for .keyup() called ' + xTriggered + ' time(s).';
  $.print(msg, 'html');
  $.print(event);
});

$('#other').click(function() {
  $('#target').keyup();
});</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


keypress – jQuery API

  • keypress( [Function] handler(eventObject) )

    • 1.0keypress( [Function] handler(eventObject) )

  • keypress( )

    • 1.0keypress( )

Returns: jQueryjQuery .keypress( )

Categories: Keyboard Events, Version 1.0
Description: Bind an event handler to the "keypress" JavaScript event, or trigger that event on an element.
  • version added: 1.0

  • .keypress( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute each time the event is triggered.
  • version added: 1.0

  • .keypress( )

This method is a shortcut for in the first variation, and in the second.

The event is sent to an element when the browser registers keyboard input. This is similar to the event, except in the case of key repeats. If the user presses and holds a key, a event is triggered once, but separate events are triggered for each inserted character. In addition, modifier keys (such as Shift) cause events but not events.

A event handler can be attached to any element, but the event is only sent to the element that has the focus. Focusable elements can vary between browsers, but form elements can always get focus so are reasonable candidates for this event type.

For example, consider the HTML:

<form>
    <fieldset>
      <input id="target" type="text" value="Hello there" />
    </fieldset>
</form>
<div id="other">
  Trigger the handler
</div>

The event handler can be bound to the input field:

$('#target').keypress(function() {
  alert('Handler for .keypress() called.');
});

Now when the insertion point is inside the field and a key is pressed, the alert is displayed:

The message repeats if the key is held down. We can trigger the event manually when another element is clicked:

$('#other').click(function() {
  $('#target').keypress();
});

After this code executes, clicks on will also alert the message.

If key presses anywhere need to be caught (for example, to implement global shortcut keys on a page), it is useful to attach this behavior to the object. Because of event bubbling, all key presses will make their way up the DOM to the object unless explicitly stopped.

To determine which character was entered, we can examine the event object that is passed to the handler function. While browsers use differing attributes to store this information, jQuery normalizes the attribute so we can reliably use it to retrieve the character code.

Note that and provide a code indicating which key is pressed, while indicates which character was entered. For example, a lowercase "a" will be reported as 65 by and , but as 97 by . An uppercase "A" is reported as 65 by all events. Because of this distinction, when catching special keystrokes such as arrow keys, or is a better choice.

Examples:

Example:

Show the event object for the keypress handler when a key is pressed in the input.
<!DOCTYPE html>
<html>
<head>
  <style>
fieldset { margin-bottom: 1em; }
input { display: block; margin-bottom: .25em; }
#print-output {
  width: 100%;
}
.print-output-line {
  white-space: pre;
  padding: 5px;
  font-family: monaco, monospace;
  font-size: .7em;
}
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <form>
  <fieldset>
    <label for="target">Type Something:</label>
    <input id="target" type="text" />
  </fieldset>
</form>
<button id="other">
  Trigger the handler
</button>
<script type="text/javascript" src="/scripts/events.js"></script>
  <script>
var xTriggered = 0;
$('#target').keypress(function(event) {
  if (event.keyCode == '13') {
     event.preventDefault();
   }
   xTriggered++;
   var msg = 'Handler for .keypress() called ' + xTriggered + ' time(s).';
  $.print(msg, 'html');
  $.print(event);
});

$('#other').click(function() {
  $('#target').keypress();
});</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Mouse Events – jQuery API

Mouse Events

  • jQuery .focusout( [Function] handler(eventObject) )

    New in 1.4 !

    Bind an event handler to the "focusout" JavaScript event.

  • jQuery .focusin( [Function] handler(eventObject) )

    New in 1.4 !

    Bind an event handler to the "focusin" JavaScript event.

  • jQuery .mousemove( )

    New in 1.0 !

    Bind an event handler to the "mousemove" JavaScript event, or trigger that event on an element.

  • jQuery .hover( [Function] handlerInOut(eventObject) )

    New in 1.4 !

    Bind a single handler to the matched elements, to be executed when the mouse pointer enters or leaves the elements.

  • jQuery .mouseleave( )

    New in 1.0 !

    Bind an event handler to be fired when the mouse leaves an element, or trigger that handler on an element.

  • jQuery .mouseenter( )

    New in 1.0 !

    Bind an event handler to be fired when the mouse enters an element, or trigger that handler on an element.

  • jQuery .mouseout( )

    New in 1.0 !

    Bind an event handler to the "mouseout" JavaScript event, or trigger that event on an element.

  • jQuery .mouseover( )

    New in 1.0 !

    Bind an event handler to the "mouseover" JavaScript event, or trigger that event on an element.

  • jQuery .dblclick( )

    New in 1.0 !

    Bind an event handler to the "dblclick" JavaScript event, or trigger that event on an element.

  • jQuery .click( )

    New in 1.0 !

    Bind an event handler to the "click" JavaScript event, or trigger that event on an element.

  • jQuery .mouseup( )

    New in 1.0 !

    Bind an event handler to the "mouseup" JavaScript event, or trigger that event on an element.

  • jQuery .mousedown( )

    New in 1.0 !

    Bind an event handler to the "mousedown" JavaScript event, or trigger that event on an element.

  • jQuery .toggle( [Boolean] showOrHide )

    New in 1.3 !

    Display or hide the matched elements.


mousemove – jQuery API

  • mousemove( [Function] handler(eventObject) )

    • 1.0mousemove( [Function] handler(eventObject) )

  • mousemove( )

    • 1.0mousemove( )

Returns: jQueryjQuery .mousemove( )

Categories: Mouse Events, Version 1.0
Description: Bind an event handler to the "mousemove" JavaScript event, or trigger that event on an element.
  • version added: 1.0

  • .mousemove( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute each time the event is triggered.
  • version added: 1.0

  • .mousemove( )

This method is a shortcut for in the first variation, and in the second.

The event is sent to an element when the mouse pointer moves inside the element. Any HTML element can receive this event.

For example, consider the HTML:

<div id="target">
  Move here
</div>
<div id="other">
  Trigger the handler
</div>
<div id="log"></div>

The event handler can be bound to the target:

$('#target').mousemove(function(event) {
  var msg = 'Handler for .mousemove() called at ' + event.pageX + ', ' + event.pageY;
  $('#log').append('<div> + msg + '</div>');
});

Now when the mouse pointer moves within the target button, the messages are appended to <div id="log">:

We can also trigger the event when the second button is clicked:

$('#other').click(function() {
  $('#target').mousemove();
});

After this code executes, clicks on the Trigger button will also append the message:

When tracking mouse movement, we usually need to know the actual position of the mouse pointer. The event object that is passed to the handler contains some information about the mouse coordinates. Properties such as , , and are available, but support for them differs between browsers. Fortunately, jQuery normalizes the and attributes so that they can be used in all browsers. These attributes provide the X and Y coordinates of the mouse pointer relative to the top-left corner of the page, as illustrated in the example output above.

We need to remember that the event is triggered whenever the mouse pointer moves, even for a pixel. This means that hundreds of events can be generated over a very small amount of time. If the handler has to do any significant processing, or if multiple handlers for the event exist, this can be a serious performance drain on the browser. It is important, therefore, to optimize handlers as much as possible, and to unbind them as soon as they are no longer needed.

A common pattern is to bind the handler from within a hander, and to unbind it from a corresponding handler. If implementing this sequence of events, remember that the event might be sent to a different HTML element than the event was. To account for this, the handler should typically be bound to an element high up in the DOM tree, such as .

Examples:

Example:

Show the mouse coordinates when the mouse is moved over the yellow div. Coordinates are relative to the window, which in this case is the iframe.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { width:220px; height:170px; margin;10px; margin-right:50px;
        background:yellow; border:2px groove; float:right; }
  p { margin:0; margin-left:10px; color:red; width:220px;
      height:120px; padding-top:70px;
      float:left; font-size:14px; }
  span { display:block; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>
    Try scrolling too.
    <span>Move the mouse over the div.</span>
    <span>&nbsp;</span>
  </p>

  <div></div>
  <script>
    $("div").mousemove(function(e){
      var pageCoords = "( " + e.pageX + ", " + e.pageY + " )";
      var clientCoords = "( " + e.clientX + ", " + e.clientY + " )";
      $("span:first").text("( e.pageX, e.pageY ) - " + pageCoords);
      $("span:last").text("( e.clientX, e.clientY ) - " + clientCoords);
    });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


hover – jQuery API

  • hover( [Function] handlerIn(eventObject), [Function] handlerOut(eventObject) )

    • 1.0hover( [Function] handlerIn(eventObject), [Function] handlerOut(eventObject) )

  • hover( [Function] handlerInOut(eventObject) )

    • 1.4hover( [Function] handlerInOut(eventObject) )

Returns: jQueryjQuery .hover( [Function] handlerIn(eventObject), [Function] handlerOut(eventObject) )

Categories: Mouse Events, Version 1.0
Description: Bind two handlers to the matched elements, to be executed when the mouse pointer enters and leaves the elements.
  • version added: 1.0

  • .hover( [Function] handlerIn(eventObject), [Function] handlerOut(eventObject) )

  • handlerIn(eventObject) A function to execute when the mouse pointer enters the element.
  • handlerOut(eventObject) A function to execute when the mouse pointer leaves the element.

The method binds handlers for both and events. We can use it to simply apply behavior to an element during the time the mouse is within the element.

Calling is shorthand for:

$(selector).mouseenter(handlerIn).mouseleave(handlerOut);

See the discussions for and for more details.

Examples:

Example:

To add a special style to list items that are being hovered over, try:
<!DOCTYPE html>
<html>
<head>
  <style>
  ul { margin-left:20px; color:blue; }
  li { cursor:default; }
  span { color:red; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <ul>
    <li>Milk</li>
    <li>Bread</li>
    <li class='fade'>Chips</li>

    <li class='fade'>Socks</li>
  </ul>
  <script>
$("li").hover(
  function () {
    $(this).append($("<span> ***</span>"));
  },
  function () {
    $(this).find("span:last").remove();
  }
);

//li with fade class
$("li.fade").hover(function(){$(this).fadeOut(100);$(this).fadeIn(500);});

</script>
</body>
</html>

Demo:

Example:

To add a special style to table cells that are being hovered over, try:
<script>$("td").hover(
  function () {
    $(this).addClass("hover");
  },
  function () {
    $(this).removeClass("hover");
  }
);</script>

Example:

To unbind the above example use:
<script>$("td").unbind('mouseenter mouseleave');</script>

Returns: jQueryjQuery .hover( [Function] handlerInOut(eventObject) )

Categories: Mouse Events, Version 1.0
Description: Bind a single handler to the matched elements, to be executed when the mouse pointer enters or leaves the elements.
  • version added: 1.4

  • .hover( [Function] handlerInOut(eventObject) )

  • handlerInOut(eventObject) A function to execute when the mouse pointer enters or leaves the element.

The method, when passed a single function, will execute that handler for both and events. This allows the user to use jQuery's various toggle methods within the handler.

Calling is shorthand for:

$(selector).bind("mouseenter mouseleave",handlerInOut);

See the discussions for and for more details.

Examples:

Example:

Slide the next sibling LI up or down on hover, and toggle a class.
<!DOCTYPE html>
<html>
<head>
  <style>
  ul { margin-left:20px; color:blue; }
  li { cursor:default; }
  li.active { background:black;color:white; }
  span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <ul>
    <li>Milk</li>
    <li>White</li>
    <li>Carrots</li>
    <li>Orange</li>
    <li>Broccoli</li>
    <li>Green</li>
  </ul>
  <script>
$("li")
.filter(":odd")
.hide()
 .end()
.filter(":even")
.hover(
  function () {
    $(this).toggleClass("active")
      .next().stop(true, true).slideToggle();
  }
);

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


mouseleave – jQuery API

  • mouseleave( [Function] handler(eventObject) )

    • 1.0mouseleave( [Function] handler(eventObject) )

  • mouseleave( )

    • 1.0mouseleave( )

Returns: jQueryjQuery .mouseleave( )

Categories: Mouse Events, Version 1.0
Description: Bind an event handler to be fired when the mouse leaves an element, or trigger that handler on an element.
  • version added: 1.0

  • .mouseleave( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute each time the event is triggered.
  • version added: 1.0

  • .mouseleave( )

This method is a shortcut for in the first variation, and in the second.

The JavaScript event is proprietary to Internet Explorer. Because of the event's general utility, jQuery simulates this event so that it can be used regardless of browser. This event is sent to an element when the mouse pointer leaves the element. Any HTML element can receive this event.

For example, consider the HTML:

<div id="outer">
  Outer
  <div id="inner">
    Inner
  </div>
</div>
<div id="other">
  Trigger the handler
</div>
<div id="log"></div>

The event handler can be bound to any element:

$('#outer').mouseleave(function() {
  $('#log').append('<div>Handler for .mouseleave() called.</div>');
});

Now when the mouse pointer moves out of the , the message is appended to . We can also trigger the event when another element is clicked:

$('#other').click(function() {
  $('#outer').mouseleave();
});

After this code executes, clicks on will also append the message.

The event differs from in the way it handles event bubbling. If were used in this example, then when the mouse pointer moved out of the element, the handler would be triggered. This is usually undesirable behavior. The event, on the other hand, only triggers its handler when the mouse leaves the element it is bound to, not a descendant. So in this example, the handler is triggered when the mouse leaves the element, but not the element.

Examples:

Example:

Show number of times mouseout and mouseleave events are triggered. fires when the pointer moves out of child element as well, while fires only when the pointer moves out of the bound element.
<!DOCTYPE html>
<html>
<head>
  <style>
div.out {
width:40%;
height:120px;
margin:0 15px;
background-color:#D6EDFC;
float:left;
}
div.in {
width:60%;
height:60%;
background-color:#FFCC00;
margin:10px auto;
}
p {
line-height:1em;
margin:0;
padding:0;
}
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<div class="out overout"><p>move your mouse</p><div class="in overout"><p>move your mouse</p><p>0</p></div><p>0</p></div>

<div class="out enterleave"><p>move your mouse</p><div class="in enterleave"><p>move your mouse</p><p>0</p></div><p>0</p></div>

  <script>
    var i = 0;
    $("div.overout").mouseover(function(){
      $("p:first",this).text("mouse over");
    }).mouseout(function(){
      $("p:first",this).text("mouse out");
      $("p:last",this).text(++i);
    });

    var n = 0;
    $("div.enterleave").mouseenter(function(){
      $("p:first",this).text("mouse enter");
    }).mouseleave(function(){
      $("p:first",this).text("mouse leave");
      $("p:last",this).text(++n);
    });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


mouseenter – jQuery API

  • mouseenter( [Function] handler(eventObject) )

    • 1.0mouseenter( [Function] handler(eventObject) )

  • mouseenter( )

    • 1.0mouseenter( )

Returns: jQueryjQuery .mouseenter( )

Categories: Mouse Events, Version 1.0
Description: Bind an event handler to be fired when the mouse enters an element, or trigger that handler on an element.
  • version added: 1.0

  • .mouseenter( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute each time the event is triggered.
  • version added: 1.0

  • .mouseenter( )

This method is a shortcut for in the first variation, and in the second.

The JavaScript event is proprietary to Internet Explorer. Because of the event's general utility, jQuery simulates this event so that it can be used regardless of browser. This event sent to an element when the mouse pointer enters the element. Any HTML element can receive this event.

For example, consider the HTML:

<div id="outer">
  Outer
  <div id="inner">
    Inner
  </div>
</div>
<div id="other">
  Trigger the handler
</div>
<div id="log"></div>

The event handler can be bound to any element:

$('#outer').mouseenter(function() {
  $('#log').append('<div>Handler for .mouseenter() called.</div>');
});

Now when the mouse pointer moves over the , the message is appended to . We can also trigger the event when another element is clicked:

$('#other').click(function() {
  $('#outer').mouseenter();
});

After this code executes, clicks on will also append the message.

The event differs from in the way it handles event bubbling. If were used in this example, then when the mouse pointer moved over the element, the handler would be triggered. This is usually undesirable behavior. The event, on the other hand, only triggers its handler when the mouse enters the element it is bound to, not a descendant. So in this example, the handler is triggered when the mouse enters the element, but not the element.

Examples:

Example:

Show texts when mouseenter and mouseout event triggering. fires when the pointer moves into the child element as well, while fires only when the pointer moves into the bound element.
<!DOCTYPE html>
<html>
<head>
  <style>
div.out {
width:40%;
height:120px;
margin:0 15px;
background-color:#D6EDFC;
float:left;
}
div.in {
width:60%;
height:60%;
background-color:#FFCC00;
margin:10px auto;
}
p {
line-height:1em;
margin:0;
padding:0;
}
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<div class="out overout"><p>move your mouse</p><div class="in overout"><p>move your mouse</p><p>0</p></div><p>0</p></div>

<div class="out enterleave"><p>move your mouse</p><div class="in enterleave"><p>move your mouse</p><p>0</p></div><p>0</p></div>

  <script>
    var i = 0;
    $("div.overout").mouseover(function(){
      $("p:first",this).text("mouse over");
      $("p:last",this).text(++i);
    }).mouseout(function(){
      $("p:first",this).text("mouse out");
    });

    var n = 0;
    $("div.enterleave").mouseenter(function(){
      $("p:first",this).text("mouse enter");
      $("p:last",this).text(++n);
    }).mouseleave(function(){
      $("p:first",this).text("mouse leave");
    });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


mouseout – jQuery API

  • mouseout( [Function] handler(eventObject) )

    • 1.0mouseout( [Function] handler(eventObject) )

  • mouseout( )

    • 1.0mouseout( )

Returns: jQueryjQuery .mouseout( )

Categories: Mouse Events, Version 1.0
Description: Bind an event handler to the "mouseout" JavaScript event, or trigger that event on an element.
  • version added: 1.0

  • .mouseout( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute each time the event is triggered.
  • version added: 1.0

  • .mouseout( )

This method is a shortcut for in the first variation, and in the second.

The event is sent to an element when the mouse pointer leaves the element. Any HTML element can receive this event.

For example, consider the HTML:

<div id="outer">
  Outer
  <div id="inner">
    Inner
  </div>
</div>
<div id="other">
  Trigger the handler
</div>
<div id="log"></div>

The event handler can be bound to any element:

$('#outer').mouseout(function() {
  $('#log').append('Handler for .mouseout() called.');
});

Now when the mouse pointer moves out of the , the message is appended to . We can also trigger the event when another element is clicked:

$('#other').click(function() {
  $('#outer').mouseout();
});

After this code executes, clicks on will also append the message.

This event type can cause many headaches due to event bubbling. For instance, when the mouse pointer moves out of the element in this example, a event will be sent to that, then trickle up to . This can trigger the bound handler at inopportune times. See the discussion for for a useful alternative.

Examples:

Example:

Show the number of times mouseout and mouseleave events are triggered. fires when the pointer moves out of the child element as well, while fires only when the pointer moves out of the bound element.
<!DOCTYPE html>
<html>
<head>
  <style>
div.out {
width:40%;
height:120px;
margin:0 15px;
background-color:#D6EDFC;
float:left;
}
div.in {
width:60%;
height:60%;
background-color:#FFCC00;
margin:10px auto;
}
p {
line-height:1em;
margin:0;
padding:0;
}
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<div class="out overout"><p>move your mouse</p><div class="in overout"><p>move your mouse</p><p>0</p></div><p>0</p></div>

<div class="out enterleave"><p>move your mouse</p><div class="in enterleave"><p>move your mouse</p><p>0</p></div><p>0</p></div>

  <script>
    var i = 0;
    $("div.overout").mouseout(function(){
      $("p:first",this).text("mouse out");
      $("p:last",this).text(++i);
    }).mouseover(function(){
      $("p:first",this).text("mouse over");
    });

    var n = 0;
    $("div.enterleave").bind("mouseenter",function(){
      $("p:first",this).text("mouse enter");
    }).bind("mouseleave",function(){
      $("p:first",this).text("mouse leave");
      $("p:last",this).text(++n);
    });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


mouseover – jQuery API

  • mouseover( [Function] handler(eventObject) )

    • 1.0mouseover( [Function] handler(eventObject) )

  • mouseover( )

    • 1.0mouseover( )

Returns: jQueryjQuery .mouseover( )

Categories: Mouse Events, Version 1.0
Description: Bind an event handler to the "mouseover" JavaScript event, or trigger that event on an element.
  • version added: 1.0

  • .mouseover( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute each time the event is triggered.
  • version added: 1.0

  • .mouseover( )

This method is a shortcut for in the first variation, and in the second.

The event is sent to an element when the mouse pointer enters the element. Any HTML element can receive this event.

For example, consider the HTML:

<div id="outer">
  Outer
  <div id="inner">
    Inner
  </div>
</div>
<div id="other">
  Trigger the handler
</div>
<div id="log"></div>

The event handler can be bound to any element:

$('#outer').mouseover(function() {
  $('#log').append('<div>Handler for .mouseover() called.</div>');
});

Now when the mouse pointer moves over the , the message is appended to . We can also trigger the event when another element is clicked:

$('#other').click(function() {
  $('#outer').mouseover();
});

After this code executes, clicks on will also append the message.

This event type can cause many headaches due to event bubbling. For instance, when the mouse pointer moves over the element in this example, a event will be sent to that, then trickle up to . This can trigger our bound handler at inopportune times. See the discussion for for a useful alternative.

Examples:

Example:

Show the number of times mouseover and mouseenter events are triggered. fires when the pointer moves into the child element as well, while fires only when the pointer moves into the bound element.
<!DOCTYPE html>
<html>
<head>
  <style>
div.out { width:40%; height:120px; margin:0 15px;
          background-color:#D6EDFC; float:left; }
div.in {  width:60%; height:60%;
          background-color:#FFCC00; margin:10px auto; }
p { line-height:1em; margin:0; padding:0; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<div class="out overout">
  <span>move your mouse</span>
  <div class="in">
  </div>
</div>

<div class="out enterleave">
  <span>move your mouse</span>
  <div class="in">
  </div>
</div>

  <script>
  var i = 0;
  $("div.overout").mouseover(function() {
    i += 1;
    $(this).find("span").text( "mouse over x " + i );
  }).mouseout(function(){
    $(this).find("span").text("mouse out ");
  });

  var n = 0;
  $("div.enterleave").mouseenter(function() {
    n += 1;
    $(this).find("span").text( "mouse enter x " + n );
  }).mouseleave(function() {
    $(this).find("span").text("mouse leave");
  });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


dblclick – jQuery API

  • dblclick( [Function] handler(eventObject) )

    • 1.0dblclick( [Function] handler(eventObject) )

  • dblclick( )

    • 1.0dblclick( )

Returns: jQueryjQuery .dblclick( )

Categories: Mouse Events, Version 1.0
Description: Bind an event handler to the "dblclick" JavaScript event, or trigger that event on an element.
  • version added: 1.0

  • .dblclick( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute each time the event is triggered.
  • version added: 1.0

  • .dblclick( )

This method is a shortcut for in the first variation, and in the second. The event is sent to an element when the element is double-clicked. Any HTML element can receive this event. For example, consider the HTML:

<div id="target">
  Double-click here
</div>
<div id="other">
  Trigger the handler
</div>

The event handler can be bound to any :

$('#target').dblclick(function() {
  alert('Handler for .dblclick() called.');
});

Now if we double-click on this element, the alert is displayed:

We can also trigger the event when a different element is clicked:

$('#other').click(function() {
  $('#target').dblclick();
});

After this code executes, (single) clicks on will also alert the message.

The event is only triggered after this exact series of events:

It is inadvisable to bind handlers to both the and events for the same element. The sequence of events triggered varies from browser to browser, with some receiving two events and others only one. If an interface that reacts differently to single- and double-clicks cannot be avoided, then the event should be simulated within the handler. We can achieve this by saving a timestamp in the handler, and then comparing the current time to the saved timestamp on subsequent clicks. If the difference is small enough, we can treat the click as a double-click.

Examples:

Example:

To bind a "Hello World!" alert box the dblclick event on every paragraph on the page:
<script>$("p").dblclick( function () { alert("Hello World!"); });</script>

Example:

Double click to toggle background color.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { background:blue;
        color:white;
        height:100px;
        width:150px;
 }
  div.dbl { background:yellow;color:black; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div></div><span>Double click the block</span>
  <script>
    var divdbl = $("div:first");
    divdbl.dblclick(function () {
      divdbl.toggleClass('dbl');
    });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


click – jQuery API

  • click( [Function] handler(eventObject) )

    • 1.0click( [Function] handler(eventObject) )

  • click( )

    • 1.0click( )

Returns: jQueryjQuery .click( )

Categories: Mouse Events, Version 1.0
Description: Bind an event handler to the "click" JavaScript event, or trigger that event on an element.
  • version added: 1.0

  • .click( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute each time the event is triggered.
  • version added: 1.0

  • .click( )

This method is a shortcut for in the first variation, and in the second.

The event is sent to an element when the mouse pointer is over the element, and the mouse button is pressed and released. Any HTML element can receive this event.

For example, consider the HTML:
<div id="target">
  Click here
</div>
<div id="other">
  Trigger the handler
</div>

The event handler can be bound to any :

$('#target').click(function() {
  alert('Handler for .click() called.');
});

Now if we click on this element, the alert is displayed:

We can also trigger the event when a different element is clicked:

$('#other').click(function() {
  $('#target').click();
});

After this code executes, clicks on will also alert the message.

The event is only triggered after this exact series of events:

This is usually the desired sequence before taking an action. If this is not required, the or event may be more suitable.

Examples:

Example:

To hide paragraphs on a page when they are clicked:
<!DOCTYPE html>
<html>
<head>
  <style>
  p { color:red; margin:5px; cursor:pointer; }
  p.hilite { background:yellow; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>First Paragraph</p>

  <p>Second Paragraph</p>
  <p>Yet one more Paragraph</p>
  <script>
    $("p").click(function () {
      $(this).slideUp();
    });
    $("p").hover(function () {
      $(this).addClass("hilite");
    }, function () {
      $(this).removeClass("hilite");
    });
</script>
</body>
</html>

Demo:

Example:

To trigger the click event on all of the paragraphs on the page:
<script>$("p").click();</script>

Comments

© 2010 The jQuery Project


mouseup – jQuery API

  • mouseup( [Function] handler(eventObject) )

    • 1.0mouseup( [Function] handler(eventObject) )

  • mouseup( )

    • 1.0mouseup( )

Returns: jQueryjQuery .mouseup( )

Categories: Mouse Events, Version 1.0
Description: Bind an event handler to the "mouseup" JavaScript event, or trigger that event on an element.
  • version added: 1.0

  • .mouseup( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute each time the event is triggered.
  • version added: 1.0

  • .mouseup( )

This method is a shortcut for in the first variation, and in the second.

The event is sent to an element when the mouse pointer is over the element, and the mouse button is released. Any HTML element can receive this event.

For example, consider the HTML:

<div id="target">
  Click here
</div>
<div id="other">
  Trigger the handler
</div>

The event handler can be bound to any :

$('#target').mouseup(function() {
  alert('Handler for .mouseup() called.');
});

Now if we click on this element, the alert is displayed:

We can also trigger the event when a different element is clicked:

$('#other').click(function() {
  $('#target').mouseup();
});

After this code executes, clicks on will also alert the message.

If the user clicks outside an element, drags onto it, and releases the button, this is still counted as a event. This sequence of actions is not treated as a button press in most user interfaces, so it is usually better to use the event unless we know that the event is preferable for a particular situation.

Examples:

Example:

Show texts when mouseup and mousedown event triggering.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Press mouse and release here.</p>

  <script>
    $("p").mouseup(function(){
      $(this).append('<span style="color:#F00;">Mouse up.</span>');
    }).mousedown(function(){
      $(this).append('<span style="color:#00F;">Mouse down.</span>');
    });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


mousedown – jQuery API

  • mousedown( [Function] handler(eventObject) )

    • 1.0mousedown( [Function] handler(eventObject) )

  • mousedown( )

    • 1.0mousedown( )

Returns: jQueryjQuery .mousedown( )

Categories: Mouse Events, Version 1.0
Description: Bind an event handler to the "mousedown" JavaScript event, or trigger that event on an element.
  • version added: 1.0

  • .mousedown( [Function] handler(eventObject) )

  • handler(eventObject) A function to execute each time the event is triggered.
  • version added: 1.0

  • .mousedown( )

This method is a shortcut for in the first variation, and in the second.

The event is sent to an element when the mouse pointer is over the element, and the mouse button is pressed. Any HTML element can receive this event.

For example, consider the HTML:

<div id="target">
  Click here
</div>
<div id="other">
  Trigger the handler
</div>

The event handler can be bound to any :

$('#target').mousedown(function() {
  alert('Handler for .mousedown() called.');
});

Now if we click on this element, the alert is displayed:

We can also trigger the event when a different element is clicked:

$('#other').click(function() {
  $('#target').mousedown();
});

After this code executes, clicks on will also alert the message.

The event is sent when any mouse button is clicked. To act only on specific buttons, we can use the event object's property. Not all browsers support this property (Internet Explorer uses button instead), but jQuery normalizes the property so that it is safe to use in any browser. The value of will be 1 for the left button, 2 for the middle button, or 3 for the right button.

This event is primarily useful for ensuring that the primary button was used to begin a drag operation; if ignored, strange results can occur when the user attempts to use a context menu. While the middle and right buttons can be detected with these properties, this is not reliable. In Opera and Safari, for example, right mouse button clicks are not detectable by default.

If the user clicks on an element, drags away from it, and releases the button, this is still counted as a event. This sequence of actions is treated as a "canceling" of the button press in most user interfaces, so it is usually better to use the event unless we know that the event is preferable for a particular situation.

Examples:

Example:

Show texts when mouseup and mousedown event triggering.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Press mouse and release here.</p>

  <script>
    $("p").mouseup(function(){
      $(this).append('<span style="color:#F00;">Mouse up.</span>');
    }).mousedown(function(){
      $(this).append('<span style="color:#00F;">Mouse down.</span>');
    });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Forms – jQuery API

Forms

  • jQuery .submit( )

    New in 1.0 !

    Bind an event handler to the "submit" JavaScript event, or trigger that event on an element.

  • jQuery .select( )

    New in 1.0 !

    Bind an event handler to the "select" JavaScript event, or trigger that event on an element.

  • jQuery .change( )

    New in 1.0 !

    Bind an event handler to the "change" JavaScript event, or trigger that event on an element.

  • jQuery .blur( )

    New in 1.0 !

    Bind an event handler to the "blur" JavaScript event, or trigger that event on an element.

  • jQuery .focus( )

    New in 1.0 !

    Bind an event handler to the "focus" JavaScript event, or trigger that event on an element.

  • Array .serializeArray( )

    New in 1.2 !

    Encode a set of form elements as an array of names and values.

  • String .serialize( )

    New in 1.0 !

    Encode a set of form elements as a string for submission.

  • String jQuery.param( [Array|Object] obj, [Boolean] traditional )

    New in 1.4 !

    Create a serialized representation of an array or object, suitable for use in a URL query string or Ajax request.

  • jQuery .val( [Function] function(index, value) )

    New in 1.4 !

    Set the value of each element in the set of matched elements.


Manipulation – jQuery API

Manipulation

  • jQuery .toggleClass( [Function] function(index, class), [Boolean] switch )

    New in 1.4 !

    Add or remove one or more classes from each element in the set of matched elements, depending on either the class's presence or the value of the switch argument.

  • jQuery .removeClass( [Function] function(index, class) )

    New in 1.4 !

    Remove a single class, multiple classes, or all classes from each element in the set of matched elements.

  • Boolean .hasClass( [String] className )

    New in 1.2 !

    Determine whether any of the matched elements are assigned the given class.

  • jQuery .addClass( [Function] function(index, class) )

    New in 1.4 !

    Adds the specified class(es) to each of the set of matched elements.

  • jQuery .clone( [Boolean] withDataAndEvents )

    New in 1.0 !

    Create a copy of the set of matched elements.

  • jQuery .unwrap( )

    New in 1.4 !

    Remove the parents of the set of matched elements from the DOM, leaving the matched elements in their place.

  • jQuery .wrapInner( [Function] wrappingFunction )

    New in 1.4 !

    Wrap an HTML structure around the content of each element in the set of matched elements.

  • jQuery .wrapAll( [String|Selector|Element|jQuery] wrappingElement )

    New in 1.2 !

    Wrap an HTML structure around all elements in the set of matched elements.

  • jQuery .wrap( [Function] wrappingFunction )

    New in 1.4 !

    Wrap an HTML structure around each element in the set of matched elements.

  • jQuery .prependTo( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements to the beginning of the target.

  • jQuery .prepend( [Function] function(index, html) )

    New in 1.4 !

    Insert content, specified by the parameter, to the beginning of each element in the set of matched elements.

  • jQuery .appendTo( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements to the end of the target.

  • jQuery .append( [Function] function(index, html) )

    New in 1.4 !

    Insert content, specified by the parameter, to the end of each element in the set of matched elements.

  • jQuery .text( [Function] function(index, text) )

    New in 1.4 !

    Set the content of each element in the set of matched elements to the specified text.

  • jQuery .html( [Function] function(index, oldhtml) )

    New in 1.4 !

    Set the HTML contents of each element in the set of matched elements.

  • jQuery .insertBefore( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements before the target.

  • jQuery .before( [Function] function )

    New in 1.4 !

    Insert content, specified by the parameter, before each element in the set of matched elements.

  • jQuery .insertAfter( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements after the target.

  • jQuery .after( [Function] function(index) )

    New in 1.4 !

    Insert content, specified by the parameter, after each element in the set of matched elements.

  • jQuery .unwrap( )

    New in 1.4 !

    Remove the parents of the set of matched elements from the DOM, leaving the matched elements in their place.

  • jQuery .detach( [Selector] selector )

    New in 1.4 !

    Remove the set of matched elements from the DOM.

  • jQuery .remove( [String] selector )

    New in 1.0 !

    Remove the set of matched elements from the DOM.

  • jQuery .empty( )

    New in 1.0 !

    Remove all child nodes of the set of matched elements from the DOM.

  • jQuery .replaceAll( )

    New in 1.2 !

    Replace each target element with the set of matched elements.

  • jQuery .replaceWith( [Function] function )

    New in 1.4 !

    Replace each element in the set of matched elements with the provided new content.

  • jQuery .val( [Function] function(index, value) )

    New in 1.4 !

    Set the value of each element in the set of matched elements.

  • jQuery .removeAttr( [String] attributeName )

    New in 1.0 !

    Remove an attribute from each element in the set of matched elements.

  • jQuery .attr( [String] attributeName, [Function] function(index, attr) )

    New in 1.1 !

    Set one or more attributes for the set of matched elements.

  • Integer .outerWidth( [Boolean] includeMargin )

    New in 1.2.6 !

    Get the current computed width for the first element in the set of matched elements, including padding and border.

  • Integer .outerHeight( [Boolean] includeMargin )

    New in 1.2.6 !

    Get the current computed height for the first element in the set of matched elements, including padding, border, and optionally margin.

  • Integer .innerWidth( )

    New in 1.2.6 !

    Get the current computed width for the first element in the set of matched elements, including padding but not border.

  • Integer .innerHeight( )

    New in 1.2.6 !

    Get the current computed height for the first element in the set of matched elements, including padding but not border.

  • jQuery .width( [Function] function(index, width) )

    New in 1.4.1 !

    Set the CSS width of each element in the set of matched elements.

  • jQuery .height( [Function] function(index, height) )

    New in 1.4.1 !

    Set the CSS height of every matched element.

  • jQuery .scrollLeft( [Number] value )

    New in 1.2.6 !

    Set the current horizontal position of the scroll bar for each of the set of matched elements.

  • jQuery .scrollTop( [Number] value )

    New in 1.2.6 !

    Set the current vertical position of the scroll bar for each of the set of matched elements.

  • Object .position( )

    New in 1.2 !

    Get the current coordinates of the first element in the set of matched elements, relative to the offset parent.

  • jQuery .offset( [Function] function(index, coords) )

    New in 1.4 !

    Set the current coordinates of every element in the set of matched elements, relative to the document.

  • jQuery .css( [Map] map )

    New in 1.0 !

    Set one or more CSS properties for the set of matched elements.


Class Attribute – jQuery API

Class Attribute

  • jQuery .toggleClass( [Function] function(index, class), [Boolean] switch )

    New in 1.4 !

    Add or remove one or more classes from each element in the set of matched elements, depending on either the class's presence or the value of the switch argument.

  • jQuery .removeClass( [Function] function(index, class) )

    New in 1.4 !

    Remove a single class, multiple classes, or all classes from each element in the set of matched elements.

  • Boolean .hasClass( [String] className )

    New in 1.2 !

    Determine whether any of the matched elements are assigned the given class.

  • jQuery .addClass( [Function] function(index, class) )

    New in 1.4 !

    Adds the specified class(es) to each of the set of matched elements.


Copying – jQuery API

Copying

  • jQuery .clone( [Boolean] withDataAndEvents )

    New in 1.0 !

    Create a copy of the set of matched elements.


clone – jQuery API

Returns: jQueryjQuery .clone( [Boolean] withDataAndEvents )

Categories: Copying, Version 1.0
Description: Create a copy of the set of matched elements.
  • version added: 1.0

  • .clone( [Boolean] withDataAndEvents )

  • withDataAndEvents A Boolean indicating whether event handlers should be copied along with the elements. As of jQuery 1.4 element data will be copied as well.

The method, when used in conjunction with one of the insertion methods, is a convenient way to duplicate elements on a page. Consider the following HTML:

<div class="container">
  <div class="hello">Hello</div>
  <div class="goodbye">Goodbye</div>
</div>

As shown in the discussion for , normally when we insert an element somewhere in the DOM, it is moved from its old location. So, given the code:

$('.hello').appendTo('.goodbye');

The resulting DOM structure would be:

<div class="container">
  <div class="goodbye">
    Goodbye
    <div class="hello">Hello</div>
  </div>
</div>

To prevent this and instead create a copy of the element, we could write the following:

$('.hello').clone().appendTo('.goodbye');

This would produce:

<div class="container">
  <div class="hello">Hello</div>
  <div class="goodbye">
    Goodbye
    <div class="hello">Hello</div>
  </div>
</div>

Normally, any event handlers bound to the original element are copied to the clone. The optional parameter allows us to change this behavior, and to instead make copies of all of the event handlers as well, bound to the new copy of the element. As of jQuery 1.4, all element data (attached by the method) is also copied to the new copy.

Examples:

Example:

Clones all b elements (and selects the clones) and prepends them to all paragraphs.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <b>Hello</b><p>, how are you?</p>
  <script>$("b").clone().prependTo("p");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


DOM Insertion – jQuery API

DOM Insertion

    © 2010 The jQuery Project


DOM Insertion, Around – jQuery API

DOM Insertion, Around

  • jQuery .unwrap( )

    New in 1.4 !

    Remove the parents of the set of matched elements from the DOM, leaving the matched elements in their place.

  • jQuery .wrapInner( [Function] wrappingFunction )

    New in 1.4 !

    Wrap an HTML structure around the content of each element in the set of matched elements.

  • jQuery .wrapAll( [String|Selector|Element|jQuery] wrappingElement )

    New in 1.2 !

    Wrap an HTML structure around all elements in the set of matched elements.

  • jQuery .wrap( [Function] wrappingFunction )

    New in 1.4 !

    Wrap an HTML structure around each element in the set of matched elements.


unwrap – jQuery API

Returns: jQueryjQuery .unwrap( )

Categories: DOM Insertion, Around, DOM Removal, Version 1.4
Description: Remove the parents of the set of matched elements from the DOM, leaving the matched elements in their place.
  • version added: 1.4

  • .unwrap( )

The method removes the element's parent. This is effectively the inverse of the method. The matched elements (and their siblings, if any) replace their parents within the DOM structure.

Examples:

Example:

Wrap/unwrap a div around each of the paragraphs.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { border: 2px solid blue; }
  p { background:yellow; margin:4px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button>wrap/unwrap</button>
<p>Hello</p>
<p>cruel</p>
<p>World</p>
  <script>
$("button").toggle(function(){
  $("p").wrap("<div></div>");
}, function(){
  $("p").unwrap();
});</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


wrapInner – jQuery API

Returns: jQueryjQuery .wrapInner( [Function] wrappingFunction )

Categories: DOM Insertion, Around, Version 1.2, Version 1.4
Description: Wrap an HTML structure around the content of each element in the set of matched elements.
  • version added: 1.2

  • .wrapInner( [String] wrappingElement )

  • wrappingElement An HTML snippet, selector expression, jQuery object, or DOM element specifying the structure to wrap around the content of the matched elements.
  • version added: 1.4

  • .wrapInner( [Function] wrappingFunction )

  • wrappingFunction A callback function which generates a structure to wrap around the content of the matched elements.

The function can take any string or object that could be passed to the factory function to specify a DOM structure. This structure may be nested several levels deep, but should contain only one inmost element. The structure will be wrapped around the content of each of the elements in the set of matched elements.

Consider the following HTML:

<div class="container">
  <div class="inner">Hello</div>
  <div class="inner">Goodbye</div>
</div>

Using , we can insert an HTML structure around the content of each inner elements like so:

$('.inner').wrapInner('<div class="new" />');

The new element is created on the fly and added to the DOM. The result is a new wrapped around the content of each matched element:

<div class="container">
  <div class="inner">
    <div class="new">Hello</div>
  </div>
  <div class="inner">
    <div class="new">Goodbye</div>
  </div>
</div>

The second version of this method allows us to instead specify a callback function. This callback function will be called once for every matched element; it should return a DOM element, jQuery object, or HTML snippet in which to wrap the content of the corresponding element. For example:

$('.inner').wrapInner(function() {
  return '<div class="' + this.nodeValue + '" />';
});

This will cause each to have a class corresponding to the text it wraps:

<div class="container">
  <div class="inner">
    <div class="Hello">Hello</div>
  </div>
  <div class="inner">
    <div class="Goodbye">Goodbye</div>
  </div>
</div>

Examples:

Example:

Selects all paragraphs and wraps a bold tag around each of its contents.
<!DOCTYPE html>
<html>
<head>
  <style>
p { background:#bbf; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p>

  <p>cruel</p>
  <p>World</p>
  <script>$("p").wrapInner("<b></b>");</script>
</body>
</html>

Demo:

Example:

Wraps a newly created tree of objects around the inside of the body.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { border:2px green solid; margin:2px; padding:2px; }
  p { background:yellow; margin:2px; padding:2px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  Plain old text, or is it?
  <script>$("body").wrapInner("<div><div><p><em><b></b></em></p></div></div>");</script>
</body>
</html>

Demo:

Example:

Selects all paragraphs and wraps a bold tag around each of its contents.
<!DOCTYPE html>
<html>
<head>
  <style>
p { background:#9f9; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p>

  <p>cruel</p>
  <p>World</p>
  <script>$("p").wrapInner(document.createElement("b"));</script>
</body>
</html>

Demo:

Example:

Selects all paragraphs and wraps a jQuery object around each of its contents.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { background:#9f9; }
  .red { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p>
  <p>cruel</p>
  <p>World</p>
  <script>$("p").wrapInner($("<span class='red'></span>"));</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


wrapAll – jQuery API

Returns: jQueryjQuery .wrapAll( [String|Selector|Element|jQuery] wrappingElement )

Categories: DOM Insertion, Around, Version 1.2, Version 1.4
Description: Wrap an HTML structure around all elements in the set of matched elements.
  • version added: 1.2

  • .wrapAll( [String|Selector|Element|jQuery] wrappingElement )

  • wrappingElement An HTML snippet, selector expression, jQuery object, or DOM element specifying the structure to wrap around the matched elements.

The function can take any string or object that could be passed to the function to specify a DOM structure. This structure may be nested several levels deep, but should contain only one inmost element. The structure will be wrapped around all of the elements in the set of matched elements, as a single group.

Consider the following HTML:

<div class="container">
  <div class="inner">Hello</div>
  <div class="inner">Goodbye</div>
</div>

Using , we can insert an HTML structure around the inner elements like so:

$('.inner').wrapAll('<div class="new" />');

The new element is created on the fly and added to the DOM. The result is a new wrapped around all matched elements:

<div class="container">
  <div class="new">
    <div class="inner">Hello</div>
    <div class="inner">Goodbye</div>
  </div>
</div>

Examples:

Example:

Wrap a new div around all of the paragraphs.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { border: 2px solid blue; }
  p { background:yellow; margin:4px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p>
  <p>cruel</p>
  <p>World</p>
  <script>$("p").wrapAll("<div></div>");</script>
</body>
</html>

Demo:

Example:

Wraps a newly created tree of objects around the spans. Notice anything in between the spans gets left out like the (red text) in this example. Even the white space between spans is left out. Click View Source to see the original html.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { border:2px blue solid; margin:2px; padding:2px; }
  p { background:yellow; margin:2px; padding:2px; }
  strong { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <span>Span Text</span>
  <strong>What about me?</strong>
  <span>Another One</span>
  <script>$("span").wrapAll("<div><div><p><em><b></b></em></p></div></div>");</script>
</body>
</html>

Demo:

Example:

Wrap a new div around all of the paragraphs.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { border: 2px solid blue; }
  p { background:yellow; margin:4px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p>
  <p>cruel</p>
  <p>World</p>
  <script>$("p").wrapAll(document.createElement("div"));</script>
</body>
</html>

Demo:

Example:

Wrap a jQuery object double depth div around all of the paragraphs. Notice it doesn't move the object but just clones it to wrap around its target.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { border: 2px solid blue; margin:2px; padding:2px; }
  .doublediv { border-color:red; }
  p { background:yellow; margin:4px; font-size:14px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p>
  <p>cruel</p>
  <p>World</p>
  <div class="doublediv"><div></div></div>
  <script>$("p").wrapAll($(".doublediv"));</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


wrap – jQuery API

Returns: jQueryjQuery .wrap( [Function] wrappingFunction )

Categories: DOM Insertion, Around, Version 1.0, Version 1.4
Description: Wrap an HTML structure around each element in the set of matched elements.
  • version added: 1.0

  • .wrap( [String|Selector|Element|jQuery] wrappingElement )

  • wrappingElement An HTML snippet, selector expression, jQuery object, or DOM element specifying the structure to wrap around the matched elements.
  • version added: 1.4

  • .wrap( [Function] wrappingFunction )

  • wrappingFunction A callback function which generates a structure to wrap around the matched elements.

The function can take any string or object that could be passed to the factory function to specify a DOM structure. This structure may be nested several levels deep, but should contain only one inmost element. The structure will be wrapped around each of the elements in the set of matched elements. This method returns the original set of elements for chaining purposes.

Consider the following HTML:

<div class="container">
  <div class="inner">Hello</div>
  <div class="inner">Goodbye</div>
</div>

Using , we can insert an HTML structure around the inner elements like so:

$('.inner').wrap('<div class="new" />');

The new element is created on the fly and added to the DOM. The result is a new wrapped around each matched element:

<div class="container">
  <div class="new">
    <div class="inner">Hello</div>
  </div>
  <div class="new">
    <div class="inner">Goodbye</div>
  </div>
</div>

The second version of this method allows us to instead specify a callback function. This callback function will be called once for every matched element; it should return a DOM element, jQuery object, or HTML snippet in which to wrap the corresponding element. For example:

$('.inner').wrap(function() {
  return '<div class="' + $(this).text() + '" />';
});

This will cause each to have a class corresponding to the text it wraps:

<div class="container">
  <div class="Hello">
    <div class="inner">Hello</div>
  </div>
  <div class="Goodbye">
    <div class="inner">Goodbye</div>
  </div>
</div>

Examples:

Example:

Wrap a new div around all of the paragraphs.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { border: 2px solid blue; }
  p { background:yellow; margin:4px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p>
  <p>cruel</p>
  <p>World</p>
  <script>$("p").wrap("<div></div>");</script>
</body>
</html>

Demo:

Example:

Wraps a newly created tree of objects around the spans. Notice anything in between the spans gets left out like the (red text) in this example. Even the white space between spans is left out. Click View Source to see the original html.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { border:2px blue solid; margin:2px; padding:2px; }
  p { background:yellow; margin:2px; padding:2px; }
  strong { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <span>Span Text</span>
  <strong>What about me?</strong>
  <span>Another One</span>
  <script>$("span").wrap("<div><div><p><em><b></b></em></p></div></div>");</script>
</body>
</html>

Demo:

Example:

Wrap a new div around all of the paragraphs.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { border: 2px solid blue; }
  p { background:yellow; margin:4px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p>
  <p>cruel</p>
  <p>World</p>
  <script>$("p").wrap(document.createElement("div"));</script>
</body>
</html>

Demo:

Example:

Wrap a jQuery object double depth div around all of the paragraphs. Notice it doesn't move the object but just clones it to wrap around its target.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { border: 2px solid blue; margin:2px; padding:2px; }
  .doublediv { border-color:red; }
  p { background:yellow; margin:4px; font-size:14px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p>
  <p>cruel</p>
  <p>World</p>
  <div class="doublediv"><div></div></div>
  <script>$("p").wrap($(".doublediv"));</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


DOM Insertion, Inside – jQuery API

DOM Insertion, Inside

  • jQuery .prependTo( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements to the beginning of the target.

  • jQuery .prepend( [Function] function(index, html) )

    New in 1.4 !

    Insert content, specified by the parameter, to the beginning of each element in the set of matched elements.

  • jQuery .appendTo( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements to the end of the target.

  • jQuery .append( [Function] function(index, html) )

    New in 1.4 !

    Insert content, specified by the parameter, to the end of each element in the set of matched elements.

  • jQuery .text( [Function] function(index, text) )

    New in 1.4 !

    Set the content of each element in the set of matched elements to the specified text.

  • jQuery .html( [Function] function(index, oldhtml) )

    New in 1.4 !

    Set the HTML contents of each element in the set of matched elements.


prependTo – jQuery API

Returns: jQueryjQuery .prependTo( [Selector|Element|jQuery] target )

Categories: DOM Insertion, Inside, Version 1.0
Description: Insert every element in the set of matched elements to the beginning of the target.
  • version added: 1.0

  • .prependTo( [Selector|Element|jQuery] target )

  • target A selector, element, HTML string, or jQuery object; the matched set of elements will be inserted at the beginning of the element(s) specified by this parameter.

The and methods perform the same task. The major difference is in the syntax-specifically, in the placement of the content and target. With, the selector expression preceding the method is the container into which the content is inserted. With , on the other hand, the content precedes the method, either as a selector expression or as markup created on the fly, and it is inserted into the target container.

Consider the following HTML:

<h2>Greetings</h2>
<div class="container">
  <div class="inner">Hello</div>
  <div class="inner">Goodbye</div>
</div>

We can create content and insert it into several elements at once:

$('<p>Test</p>').prependTo('.inner');

Each inner element gets this new content:

<h2>Greetings</h2>
<div class="container">
  <div class="inner">
    <p>Test</p>
    Hello
  </div>
  <div class="inner">
    <p>Test</p>
    Goodbye
  </div>
</div>

We can also select an element on the page and insert it into another:

$('h2').prependTo($('.container'));

If an element selected this way is inserted elsewhere, it will be moved into the target (not cloned):

<div class="container">
  <h2>Greetings</h2>
  <div class="inner">Hello</div>
  <div class="inner">Goodbye</div>
</div>

If there is more than one target element, however, cloned copies of the inserted element will be created for each target after the first.

Examples:

Example:

Prepends all spans to the element with the ID "foo"
<!DOCTYPE html>
<html>
<head>
  <style>
div { background:yellow; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div id="foo">FOO!</div>

  <span>I have something to say... </span>
  <script>$("span").prependTo("#foo"); // check prepend() examples</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


prepend – jQuery API

Returns: jQueryjQuery .prepend( [Function] function(index, html) )

Categories: DOM Insertion, Inside, Version 1.0, Version 1.4
Description: Insert content, specified by the parameter, to the beginning of each element in the set of matched elements.
  • version added: 1.0

  • .prepend( [String|Element|jQuery] content )

  • content An element, HTML string, or jQuery object to insert at the beginning of each element in the set of matched elements.
  • version added: 1.4

  • .prepend( [Function] function(index, html) )

  • function(index, html) A function that returns an HTML string to insert at the beginning of each element in the set of matched elements. Receives the index position of the element in the set and the old HTML value of the element as arguments.

The method inserts the specified content as the first child of each element in the jQuery collection (To insert it as the child, use ).

The and methods perform the same task. The major difference is in the syntax-specifically, in the placement of the content and target. With, the selector expression preceding the method is the container into which the content is inserted. With , on the other hand, the content precedes the method, either as a selector expression or as markup created on the fly, and it is inserted into the target container.

Consider the following HTML:

<h2>Greetings</h2>
<div class="container">
  <div class="inner">Hello</div>
  <div class="inner">Goodbye</div>
</div>

We can create content and insert it into several elements at once:

$('.inner').prepend('<p>Test</p>');

Each element gets this new content:

<h2>Greetings</h2>
<div class="container">
  <div class="inner">
    <p>Test</p>
    Hello
  </div>
  <div class="inner">
    <p>Test</p>
    Goodbye
  </div>
</div>

We can also select an element on the page and insert it into another:

$('.container').prepend($('h2'));

If an element selected this way is inserted elsewhere, it will be moved into the target (not cloned):

<div class="container">
  <h2>Greetings</h2>
  <div class="inner">Hello</div>
  <div class="inner">Goodbye</div>
</div>

If there is more than one target element, however, cloned copies of the inserted element will be created for each target after the first.

Examples:

Example:

Prepends some HTML to all paragraphs.
<!DOCTYPE html>
<html>
<head>
  <style>
p { background:yellow; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>there friend!</p>

  <p>amigo!</p>
  <script>$("p").prepend("<b>Hello </b>");</script>
</body>
</html>

Demo:

Example:

Prepends a DOM Element to all paragraphs.
<!DOCTYPE html>
<html>
<head>
  <style>
p { background:yellow; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>is what I'd say</p>
  <p>is what I said</p>
  <script>$("p").prepend(document.createTextNode("Hello "));</script>
</body>
</html>

Demo:

Example:

Prepends a jQuery object (similar to an Array of DOM Elements) to all paragraphs.
<!DOCTYPE html>
<html>
<head>
  <style>
p { background:yellow; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p> is what was said.</p><b>Hello</b>
  <script>$("p").prepend( $("b") );</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


appendTo – jQuery API

Returns: jQueryjQuery .appendTo( [Selector|Element|jQuery] target )

Categories: DOM Insertion, Inside, Version 1.0
Description: Insert every element in the set of matched elements to the end of the target.
  • version added: 1.0

  • .appendTo( [Selector|Element|jQuery] target )

  • target A selector, element, HTML string, or jQuery object; the matched set of elements will be inserted at the end of the element(s) specified by this parameter.

The and methods perform the same task. The major difference is in the syntax-specifically, in the placement of the content and target. With, the selector expression preceding the method is the container into which the content is inserted. With , on the other hand, the content precedes the method, either as a selector expression or as markup created on the fly, and it is inserted into the target container.

Consider the following HTML:

<h2>Greetings</h2>
<div class="container">
  <div class="inner">Hello</div>
  <div class="inner">Goodbye</div>
</div>

We can create content and insert it into several elements at once:

$('<p>Test</p>').appendTo('.inner');

Each inner element gets this new content:

<h2>Greetings</h2>
<div class="container">
  <div class="inner">
    Hello
    <p>Test</p>
  </div>
  <div class="inner">
    Goodbye
    <p>Test</p>
  </div>
</div>

We can also select an element on the page and insert it into another:

$('h2').appendTo($('.container'));

If an element selected this way is inserted elsewhere, it will be moved into the target (not cloned):

<div class="container">
  <div class="inner">Hello</div>
  <div class="inner">Goodbye</div>
  <h2>Greetings</h2>
</div>

If there is more than one target element, however, cloned copies of the inserted element will be created for each target after the first.

Examples:

Example:

Appends all spans to the element with the ID "foo"
<!DOCTYPE html>
<html>
<head>
  <style>
#foo { background:yellow; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <span>I have nothing more to say... </span>

  <div id="foo">FOO! </div>
  <script>$("span").appendTo("#foo"); // check append() examples</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


append – jQuery API

Returns: jQueryjQuery .append( [Function] function(index, html) )

Categories: DOM Insertion, Inside, Version 1.0, Version 1.4
Description: Insert content, specified by the parameter, to the end of each element in the set of matched elements.
  • version added: 1.0

  • .append( [String|Element|jQuery] content )

  • content An element, HTML string, or jQuery object to insert at the end of each element in the set of matched elements.
  • version added: 1.4

  • .append( [Function] function(index, html) )

  • function(index, html) A function that returns an HTML string to insert at the end of each element in the set of matched elements. Receives the index position of the element in the set and the old HTML value of the element as arguments.

The method inserts the specified content as the last child of each element in the jQuery collection (To insert it as the child, use ).

The and methods perform the same task. The major difference is in the syntax-specifically, in the placement of the content and target. With, the selector expression preceding the method is the container into which the content is inserted. With , on the other hand, the content precedes the method, either as a selector expression or as markup created on the fly, and it is inserted into the target container.

Consider the following HTML:

<h2>Greetings</h2>
<div class="container">
  <div class="inner">Hello</div>
  <div class="inner">Goodbye</div>
</div>

We can create content and insert it into several elements at once:

$('.inner').append('<p>Test</p>');

Each inner element gets this new content:

<h2>Greetings</h2>
<div class="container">
  <div class="inner">
    Hello
    <p>Test</p>
  </div>
  <div class="inner">
    Goodbye
    <p>Test</p>
  </div>
</div>

We can also select an element on the page and insert it into another:

$('.container').append($('h2'));

If an element selected this way is inserted elsewhere, it will be moved into the target (not cloned):

<div class="container">
  <div class="inner">Hello</div>
  <div class="inner">Goodbye</div>
  <h2>Greetings</h2>
</div>

If there is more than one target element, however, cloned copies of the inserted element will be created for each target after the first.

Examples:

Example:

Appends some HTML to all paragraphs.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { background:yellow; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>I would like to say: </p>
  <script>
  $("p").append("<strong>Hello</strong>");
</script>
</body>
</html>

Demo:

Example:

Appends an Element to all paragraphs.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { background:yellow; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>I would like to say: </p>

  <script>
  $("p").append(document.createTextNode("Hello"));
</script>
</body>
</html>

Demo:

Example:

Appends a jQuery object (similar to an Array of DOM Elements) to all paragraphs.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { background:yellow; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <strong>Hello world!!!</strong><p>I would like to say: </p>
  <script>
  $("p").append( $("strong") );
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


text – jQuery API

  • text( )

    • 1.0text( )

  • text( [String] textString )

    • 1.0text( [String] textString )
    • 1.4text( [Function] function(index, text) )

Returns: JQuery(":text")

Categories: Form, Version 1.0
Description: Selects all elements of type text.
  • version added: 1.0

  • JQuery(":text")

is equivalent to and thus selects all elements. As with other pseudo-class selectors (those that begin with a ":") it is recommended to precede it with a tag name or some other selector; otherwise, the universal selector ("*") is implied. In other words, the bare is equivalent to , so should be used instead.

Examples:

Example:

Finds all text inputs.
<!DOCTYPE html>
<html>
<head>
  <style>
  textarea { height:25px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <form>
    <input type="button" value="Input Button"/>
    <input type="checkbox" />

    <input type="file" />
    <input type="hidden" />
    <input type="image" />

    <input type="password" />
    <input type="radio" />
    <input type="reset" />

    <input type="submit" />
    <input type="text" />
    <select><option>Option</option></select>

    <textarea></textarea>
    <button>Button</button>
  </form>
  <div>
  </div>
  <script>

    var input = $("form input:text").css({background:"yellow", border:"3px red solid"});
    $("div").text("For this type jQuery found " + input.length + ".")
            .css("color", "red");
    $("form").submit(function () { return false; }); // so it won't submit

</script>
</body>
</html>

Demo:

Returns: StringString .text( )

Categories: DOM Insertion, Inside, Version 1.0, Version 1.4
Description: Get the combined text contents of each element in the set of matched elements, including their descendants.
  • version added: 1.0

  • .text( )

Unlike the method, can be used in both XML and HTML documents. The result of the method is a string containing the combined text of all matched elements. (Due to variations in the HTML parsers in different browsers, the text returned may vary in newlines and other white space.) Consider the following HTML:

<div class="demo-container">
  <div class="demo-box">Demonstration Box</div>
  <ul>
  <li>list item 1</li>
  <li>list <strong>item</strong> 2</li>
  </ul>
  </div>

The code would produce the following result:

The method cannot be used on input elements. For input field text, use the method.

As of jQuery 1.4, the method returns the value of text and CDATA nodes as well as element nodes.

Examples:

Example:

Find the text in the first paragraph (stripping out the html), then set the html of the last paragraph to show it is just text (the red bold is gone).
<!DOCTYPE html>
<html>
<head>
  <style>
  p { color:blue; margin:8px; }
  b { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p><b>Test</b> Paragraph.</p>

  <p></p>
  <script>
    var str = $("p:first").text();
    $("p:last").html(str);
</script>
</body>
</html>

Demo:

Returns: jQueryjQuery .text( [Function] function(index, text) )

Categories: DOM Insertion, Inside, Version 1.0, Version 1.4
Description: Set the content of each element in the set of matched elements to the specified text.
  • version added: 1.0

  • .text( [String] textString )

  • textString A string of text to set as the content of each matched element.
  • version added: 1.4

  • .text( [Function] function(index, text) )

  • function(index, text) A function returning the text content to set. Receives the index position of the element in the set and the old text value as arguments.

Unlike the method, can be used in both XML and HTML documents.

We need to be aware that this method escapes the string provided as necessary so that it will render correctly in HTML. To do so, it calls the DOM method , which replaces special characters with their HTML entity equivalents (such as for ). Consider the following HTML:

<div class="demo-container">
  <div class="demo-box">Demonstration Box</div>
  <ul>
    <li>list item 1</li>
    <li>list <strong>item</strong> 2</li>
  </ul>
</div>

The code will produce the following DOM output:

<div class="demo-container">
&lt;p&gt;This is a test.&lt;/p&gt;
</div>

It will appear on a rendered page as though the tags were exposed, like this:

<p>This is a test</p>

The method cannot be used on input elements. For input field text, use the method.

As of jQuery 1.4, the method allows us to set the text content by passing in a function.

$('ul li').text(function(index) {
  return 'item number ' + (index + 1);
});

Given an unordered list with three elements, this example will produce the following DOM output:

<ul>
  <li>item number 1</li>
  <li>item number 2</li>
  <li>item number 3</li>
</ul>

Examples:

Example:

Add text to the paragraph (notice the bold tag is escaped).
<!DOCTYPE html>
<html>
<head>
  <style>
  p { color:blue; margin:8px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Test Paragraph.</p>
  <script>$("p").text("<b>Some</b> new text.");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


DOM Insertion, Outside – jQuery API

DOM Insertion, Outside

  • jQuery .insertBefore( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements before the target.

  • jQuery .before( [Function] function )

    New in 1.4 !

    Insert content, specified by the parameter, before each element in the set of matched elements.

  • jQuery .insertAfter( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements after the target.

  • jQuery .after( [Function] function(index) )

    New in 1.4 !

    Insert content, specified by the parameter, after each element in the set of matched elements.


insertBefore – jQuery API

Returns: jQueryjQuery .insertBefore( [Selector|Element|jQuery] target )

Categories: DOM Insertion, Outside, Version 1.0
Description: Insert every element in the set of matched elements before the target.
  • version added: 1.0

  • .insertBefore( [Selector|Element|jQuery] target )

  • target A selector, element, HTML string, or jQuery object; the matched set of elements will be inserted before the element(s) specified by this parameter.

The and methods perform the same task. The major difference is in the syntax-specifically, in the placement of the content and target. With, the selector expression preceding the method is the container before which the content is inserted. With , on the other hand, the content precedes the method, either as a selector expression or as markup created on the fly, and it is inserted before the target container.

Consider the following HTML:

<div class="container">
  <h2>Greetings</h2>
  <div class="inner">Hello</div>
  <div class="inner">Goodbye</div>
</div>

We can create content and insert it before several elements at once:

$('<p>Test</p>').insertBefore('.inner');

Each inner element gets this new content:

<div class="container">
  <h2>Greetings</h2>
  <p>Test</p>
  <div class="inner">Hello</div>
  <p>Test</p>
  <div class="inner">Goodbye</div>
</div>

We can also select an element on the page and insert it before another:

$('h2').insertBefore($('.container'));

If an element selected this way is inserted elsewhere, it will be moved before the target (not cloned):

<h2>Greetings</h2>
<div class="container">
  <div class="inner">Hello</div>
  <div class="inner">Goodbye</div>
</div>

If there is more than one target element, however, cloned copies of the inserted element will be created for each target after the first.

Examples:

Example:

Inserts all paragraphs before an element with id of "foo". Same as $("#foo").before("p")
<!DOCTYPE html>
<html>
<head>
  <style>
#foo { background:yellow; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div id="foo">FOO!</div><p>I would like to say: </p>
  <script>$("p").insertBefore("#foo"); // check before() examples</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


before – jQuery API

Returns: jQueryjQuery .before( [Function] function )

Categories: DOM Insertion, Outside, Version 1.0, Version 1.4
Description: Insert content, specified by the parameter, before each element in the set of matched elements.
  • version added: 1.0

  • .before( [String|Element|jQuery] content )

  • content An element, HTML string, or jQuery object to insert before each element in the set of matched elements.
  • version added: 1.4

  • .before( [Function] function )

  • function A function that returns an HTML string to insert before each element in the set of matched elements.

The and methods perform the same task. The major difference is in the syntax-specifically, in the placement of the content and target. With, the selector expression preceding the method is the container before which the content is inserted. With , on the other hand, the content precedes the method, either as a selector expression or as markup created on the fly, and it is inserted before the target container.

Consider the following HTML:

<div class="container">
  <h2>Greetings</h2>
  <div class="inner">Hello</div>
  <div class="inner">Goodbye</div>
</div>

We can create content and insert it before several elements at once:

$('.inner').before('<p>Test</p>');

Each inner element gets this new content:

<div class="container">
  <h2>Greetings</h2>
  <p>Test</p>
  <div class="inner">Hello</div>
  <p>Test</p>
  <div class="inner">Goodbye</div>
</div>

We can also select an element on the page and insert it before another:

$('.container').before($('h2'));

If an element selected this way is inserted elsewhere, it will be moved before the target (not cloned):

<h2>Greetings</h2>
<div class="container">
  <div class="inner">Hello</div>
  <div class="inner">Goodbye</div>
</div>

If there is more than one target element, however, cloned copies of the inserted element will be created for each target after the first.

In jQuery 1.4, and will also work on disconnected DOM nodes:

$("<div/>").before("<p></p>");

The result is a jQuery set that contains a paragraph and a div (in that order).

Examples:

Example:

Inserts some HTML before all paragraphs.
<!DOCTYPE html>
<html>
<head>
  <style>
p { background:yellow; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p> is what I said...</p>
  <script>$("p").before("<b>Hello</b>");</script>
</body>
</html>

Demo:

Example:

Inserts a DOM element before all paragraphs.
<!DOCTYPE html>
<html>
<head>
  <style>
p { background:yellow; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p> is what I said...</p>
  <script>$("p").before( document.createTextNode("Hello") );</script>
</body>
</html>

Demo:

Example:

Inserts a jQuery object (similar to an Array of DOM Elements) before all paragraphs.
<!DOCTYPE html>
<html>
<head>
  <style>
p { background:yellow; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p> is what I said...</p><b>Hello</b>
  <script>$("p").before( $("b") );</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


insertAfter – jQuery API

Returns: jQueryjQuery .insertAfter( [Selector|Element|jQuery] target )

Categories: DOM Insertion, Outside, Version 1.0
Description: Insert every element in the set of matched elements after the target.
  • version added: 1.0

  • .insertAfter( [Selector|Element|jQuery] target )

  • target A selector, element, HTML string, or jQuery object; the matched set of elements will be inserted after the element(s) specified by this parameter.

The and methods perform the same task. The major difference is in the syntax-specifically, in the placement of the content and target. With, the selector expression preceding the method is the container after which the content is inserted. With , on the other hand, the content precedes the method, either as a selector expression or as markup created on the fly, and it is inserted after the target container.

Consider the following HTML:

<div class="container">
  <h2>Greetings</h2>
  <div class="inner">Hello</div>
  <div class="inner">Goodbye</div>
</div>

We can create content and insert it after several elements at once:

$('<p>Test</p>').insertAfter('.inner');

Each inner element gets this new content:

<div class="container">
  <h2>Greetings</h2>
  <div class="inner">Hello</div>
  <p>Test</p>
  <div class="inner">Goodbye</div>
  <p>Test</p>
</div>

We can also select an element on the page and insert it after another:

$('h2').insertAfter($('.container'));

If an element selected this way is inserted elsewhere, it will be moved after the target (not cloned):

<div class="container">
  <div class="inner">Hello</div>
  <div class="inner">Goodbye</div>
</div>
<h2>Greetings</h2>

If there is more than one target element, however, cloned copies of the inserted element will be created for each target after the first.

Examples:

Example:

Inserts all paragraphs after an element with id of "foo". Same as $("#foo").after("p")
<!DOCTYPE html>
<html>
<head>
  <style>
#foo { background:yellow; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p> is what I said... </p><div id="foo">FOO!</div>
  <script>$("p").insertAfter("#foo"); // check after() examples</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


after – jQuery API

Returns: jQueryjQuery .after( [Function] function(index) )

Categories: DOM Insertion, Outside, Version 1.0, Version 1.4
Description: Insert content, specified by the parameter, after each element in the set of matched elements.
  • version added: 1.0

  • .after( [String|Element|jQuery] content )

  • content An element, HTML string, or jQuery object to insert after each element in the set of matched elements.
  • version added: 1.4

  • .after( [Function] function(index) )

  • function(index) A function that returns an HTML string to insert after each element in the set of matched elements.

The and methods perform the same task. The major difference is in the syntax—specifically, in the placement of the content and target. With, the selector expression preceding the method is the container after which the content is inserted. With , on the other hand, the content precedes the method, either as a selector expression or as markup created on the fly, and it is inserted after the target container.

Consider the following HTML:

<div class="container">
  <h2>Greetings</h2>
  <div class="inner">Hello</div>
  <div class="inner">Goodbye</div>
</div>

We can create content and insert it after several elements at once:

$('.inner').after('<p>Test</p>');

Each inner element gets this new content:

<div class="container">
  <h2>Greetings</h2>
  <div class="inner">Hello</div>
  <p>Test</p>
  <div class="inner">Goodbye</div>
  <p>Test</p>
</div>

We can also select an element on the page and insert it after another:

$('.container').after($('h2'));

If an element selected this way is inserted elsewhere, it will be moved after the target (not cloned):

<div class="container">
  <div class="inner">Hello</div>
  <div class="inner">Goodbye</div>
</div>
<h2>Greetings</h2>

If there is more than one target element, however, cloned copies of the inserted element will be created for each target after the first.

Inserting Disconnected DOM nodes

As of jQuery 1.4, and will also work on disconnected DOM nodes. For example, given the following code:

$('<div/>').after('<p></p>');

The result is a jQuery set containing a div and a paragraph, in that order. We can further manipulate that set, even before inserting it in the document.

$('<div/>').after('<p></p>').addClass('foo')
  .filter('p').attr('id', 'bar').html('hello')
.end()
.appendTo('body');

This results in the following elements inserted just before the closing tag:

<div class="foo"></div>
<p class="foo" id="bar">hello</p>

As of jQuery 1.4, allows us to pass a function that returns the elements to insert.

$('p').after(function() {
  return '<div>' + this.className + '</div>';
});

This inserts a after each paragraph, containing the class name(s) of each paragraph in turn.

Examples:

Example:

Inserts some HTML after all paragraphs.
<!DOCTYPE html>
<html>
<head>
  <style>
p { background:yellow; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>I would like to say: </p>
  <script>$("p").after("<b>Hello</b>");</script>
</body>
</html>

Demo:

Example:

Inserts a DOM element after all paragraphs.
<!DOCTYPE html>
<html>
<head>
  <style>
p { background:yellow; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>I would like to say: </p>
  <script>$("p").after( document.createTextNode("Hello") );</script>
</body>
</html>

Demo:

Example:

Inserts a jQuery object (similar to an Array of DOM Elements) after all paragraphs.
<!DOCTYPE html>
<html>
<head>
  <style>
p { background:yellow; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <b>Hello</b><p>I would like to say: </p>
  <script>$("p").after( $("b") );</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


DOM Removal – jQuery API

DOM Removal

  • jQuery .unwrap( )

    New in 1.4 !

    Remove the parents of the set of matched elements from the DOM, leaving the matched elements in their place.

  • jQuery .detach( [Selector] selector )

    New in 1.4 !

    Remove the set of matched elements from the DOM.

  • jQuery .remove( [String] selector )

    New in 1.0 !

    Remove the set of matched elements from the DOM.

  • jQuery .empty( )

    New in 1.0 !

    Remove all child nodes of the set of matched elements from the DOM.


detach – jQuery API

Returns: jQueryjQuery .detach( [Selector] selector )

Categories: DOM Removal, Version 1.4
Description: Remove the set of matched elements from the DOM.
  • version added: 1.4

  • .detach( [Selector] selector )

  • selector A selector expression that filters the set of matched elements to be removed.

The method is the same as , except that keeps all jQuery data associated with the removed elements. This method is useful when removed elements are to be reinserted into the DOM at a later time.

Examples:

Example:

Detach all paragraphs from the DOM
<!DOCTYPE html>
<html>
<head>
  <style>
p { background:yellow; margin:6px 0; } p.off { background: black; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p>
  how are
  <p>you?</p>
  <button>Attach/detach paragraphs</button>
  <script>
    $("p").click(function(){
      $(this).toggleClass("off");
    });
    var p;
    $("button").click(function(){
      if ( p ) {
        p.appendTo("body");
        p = null;
      } else {
        p = $("p").detach();
      }
    });</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


remove – jQuery API

Returns: jQueryjQuery .remove( [String] selector )

Categories: DOM Removal, Version 1.0
Description: Remove the set of matched elements from the DOM.
  • version added: 1.0

  • .remove( [String] selector )

  • selector A selector expression that filters the set of matched elements to be removed.

Similar to , the method takes elements out of the DOM. We use when we want to remove the element itself, as well as everything inside it. In addition to the elements themselves, all bound events and jQuery data associated with the elements are removed.

Consider the following HTML:

<div class="container">
  <div class="hello">Hello</div>
  <div class="goodbye">Goodbye</div>
</div>

We can target any element for removal:

$('.hello').remove();

This will result in a DOM structure with the element deleted:

<div class="container">
  <div class="goodbye">Goodbye</div>
</div>

If we had any number of nested elements inside , they would be removed, too. Other jQuery constructs such as data or event handlers are erased as well.

We can also include a selector as an optional parameter. For example, we could rewrite the previous DOM removal code as follows:

$('div').remove('.hello');

This would result in the same DOM structure:

<div class="container">
  <div class="goodbye">Goodbye</div>
</div>

Examples:

Example:

Removes all paragraphs from the DOM
<!DOCTYPE html>
<html>
<head>
  <style>
p { background:yellow; margin:6px 0; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p>
  how are
  <p>you?</p>
  <button>Call remove() on paragraphs</button>
  <script>
    $("button").click(function () {
      $("p").remove();
    });

</script>
</body>
</html>

Demo:

Example:

Removes all paragraphs that contain "Hello" from the DOM
<!DOCTYPE html>
<html>
<head>
  <style>
p { background:yellow; margin:6px 0; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p class="hello">Hello</p>
  how are
  <p>you?</p>

  <button>Call remove(":contains('Hello')") on paragraphs</button>
  <script>

    $("button").click(function () {
      $("p").remove(":contains('Hello')");
    });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


empty – jQuery API

Returns: JQuery(":empty")

Categories: Content Filter, Version 1.0
Description: Select all elements that have no children (including text nodes).
  • version added: 1.0

  • JQuery(":empty")

This is the inverse of .

One important thing to note with :empty (and :parent) is that child elements include text nodes.

The W3C recommends that the element have at least one child node, even if that child is merely text (see http://www.w3.org/TR/html401/struct/text.html#edef-P). Some other elements, on the other hand, are empty (i.e. have no children) by definition: <input>, <img>, <br>, and <hr>, for example.

Examples:

Example:

Finds all elements that are empty - they don't have child elements or text.
<!DOCTYPE html>
<html>
<head>
  <style>
  td { text-align:center; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <table border="1">
    <tr><td>TD #0</td><td></td></tr>
    <tr><td>TD #2</td><td></td></tr>

    <tr><td></td><td>TD#5</td></tr>
  </table>
  <script>$("td:empty").text("Was empty!").css('background', 'rgb(255,220,200)');</script>
</body>
</html>

Demo:

Returns: jQueryjQuery .empty( )

Categories: DOM Removal, Version 1.0
Description: Remove all child nodes of the set of matched elements from the DOM.
  • version added: 1.0

  • .empty( )

This method removes not only child (and other descendant) elements, but also any text within the set of matched elements. This is because, according to the DOM specification, any string of text within an element is considered a child node of that element. Consider the following HTML:

<div class="container">
  <div class="hello">Hello</div>
  <div class="goodbye">Goodbye</div>
</div>

We can target any element for removal:

$('.hello').empty();

This will result in a DOM structure with the text deleted:

<div class="container">
  <div class="hello"></div>
  <div class="goodbye">Goodbye</div>
</div>

If we had any number of nested elements inside , they would be removed, too.

To avoid memory leaks, jQuery removes other constructs such as data and event handlers from the child elements before removing the elements themselves.

Examples:

Example:

Removes all child nodes (including text nodes) from all paragraphs
<!DOCTYPE html>
<html>
<head>
  <style>
  p { background:yellow; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>
  Hello, <span>Person</span> <a href="javascript:;">and person</a>
</p>

<button>Call empty() on above paragraph</button>
  <script>
  $("button").click(function () {
    $("p").empty();
  });
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


DOM Replacement – jQuery API

DOM Replacement

  • jQuery .replaceAll( )

    New in 1.2 !

    Replace each target element with the set of matched elements.

  • jQuery .replaceWith( [Function] function )

    New in 1.4 !

    Replace each element in the set of matched elements with the provided new content.


replaceAll – jQuery API

Returns: jQueryjQuery .replaceAll( )

Categories: DOM Replacement, Version 1.2
Description: Replace each target element with the set of matched elements.
  • version added: 1.2

  • .replaceAll( )

The method is corollary to , but with the source and target reversed. Consider this DOM structure:

<div class="container">
  <div class="inner first">Hello</div>
  <div class="inner second">And</div>
  <div class="inner third">Goodbye</div>
</div>

We can create an element, then replace other elements with it:

$('<h2>New heading</h2>').replaceAll('.inner');

This causes all of them to be replaced:

<div class="container">
  <h2>New heading</h2>
  <h2>New heading</h2>
  <h2>New heading</h2>
</div>

Or, we could select an element to use as the replacement:

$('.first').replaceAll('.third');

This results in the DOM structure:

<div class="container">
  <div class="inner second">And</div>
  <div class="inner first">Hello</div>
</div>

From this example, we can see that the selected element replaces the target by being moved from its old location, not by being cloned.

Examples:

Example:

Replace all the paragraphs with bold words.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p>
  <p>cruel</p>
  <p>World</p>
  <script>$("<b>Paragraph. </b>").replaceAll("p"); // check replaceWith() examples</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


replaceWith – jQuery API

Returns: jQueryjQuery .replaceWith( [Function] function )

Categories: DOM Replacement, Version 1.2, Version 1.4
Description: Replace each element in the set of matched elements with the provided new content.
  • version added: 1.2

  • .replaceWith( [String|Element|jQuery] newContent )

  • newContent The content to insert. May be an HTML string, DOM element, or jQuery object.
  • version added: 1.4

  • .replaceWith( [Function] function )

  • function A function that returns an HTML string to replace the set of matched elements with.

The method allows us to remove content from the DOM and insert new content in its place with a single call. Consider this DOM structure:

<div class="container">
  <div class="inner first">Hello</div>
  <div class="inner second">And</div>
  <div class="inner third">Goodbye</div>
</div>

We can replace the second inner with specified HTML:

$('.second').replaceWith('<h2>New heading</h2>');

This results in the structure:

<div class="container">
  <div class="inner first">Hello</div>
  <h2>New heading</h2>
  <div class="inner third">Goodbye</div>
</div>

We could equally target all inner elements at once:

$('.inner').replaceWith('<h2>New heading</h2>');

This causes all of them to be replaced:

<div class="container">
  <h2>New heading</h2>
  <h2>New heading</h2>
  <h2>New heading</h2>
</div>

Or, we could select an element to use as the replacement:

$('.third').replaceWith($('.first'));

This results in the DOM structure:

<div class="container">
  <div class="inner second">And</div>
  <div class="inner first">Hello</div>
</div>

From this example, we can see that the selected element replaces the target by being moved from its old location, not by being cloned.

The method, like most jQuery methods, returns the jQuery object so that other methods can be chained onto it. However, it must be noted that the jQuery object is returned. This object refers to the element that has been removed from the DOM, not the new element that has replaced it.

In jQuery 1.4 , , and can also work on disconnected DOM nodes. For example, with the following code:

$("<div/>").replaceWith("<p></p>");

The method returns a jQuery set containing only a paragraph.

Examples:

Example:

On click, replace the button with a div containing the same word.
<!DOCTYPE html>
<html>
<head>
  <style>
  button { display:block; margin:3px; color:red; width:200px; }
  div { color:red; border:2px solid blue; width:200px;
        margin:3px; text-align:center; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button>First</button>
  <button>Second</button>

  <button>Third</button>
  <script>

    $("button").click(function () {
      $(this).replaceWith("<div>" + $(this).text() + "</div>");
    });
</script>
</body>
</html>

Demo:

Example:

Replace all the paragraphs with bold words.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p>
  <p>cruel</p>

  <p>World</p>
  <script>$("p").replaceWith("<b>Paragraph. </b>");</script>
</body>
</html>

Demo:

Example:

Replace all the paragraphs with empty div elements.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { border:2px solid blue; margin:3px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p>

  <p>cruel</p>
  <p>World</p>
  <script>$("p").replaceWith(document.createElement("div"));</script>
</body>
</html>

Demo:

Example:

On click, replace each paragraph with a jQuery div object that is already in the DOM. Notice it doesn't clone the object but rather moves it to replace the paragraph.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { border:2px solid blue; color:red; margin:3px; }
  p { border:2px solid red; color:blue; margin:3px; cursor:pointer; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p>
  <p>cruel</p>
  <p>World</p>

  <div>Replaced!</div>
  <script>
    $("p").click(function () {
      $(this).replaceWith($("div"));
    });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


General Attributes – jQuery API

General Attributes

  • jQuery .val( [Function] function(index, value) )

    New in 1.4 !

    Set the value of each element in the set of matched elements.

  • jQuery .removeAttr( [String] attributeName )

    New in 1.0 !

    Remove an attribute from each element in the set of matched elements.

  • jQuery .attr( [String] attributeName, [Function] function(index, attr) )

    New in 1.1 !

    Set one or more attributes for the set of matched elements.


Style Properties – jQuery API

Style Properties

  • Integer .outerWidth( [Boolean] includeMargin )

    New in 1.2.6 !

    Get the current computed width for the first element in the set of matched elements, including padding and border.

  • Integer .outerHeight( [Boolean] includeMargin )

    New in 1.2.6 !

    Get the current computed height for the first element in the set of matched elements, including padding, border, and optionally margin.

  • Integer .innerWidth( )

    New in 1.2.6 !

    Get the current computed width for the first element in the set of matched elements, including padding but not border.

  • Integer .innerHeight( )

    New in 1.2.6 !

    Get the current computed height for the first element in the set of matched elements, including padding but not border.

  • jQuery .width( [Function] function(index, width) )

    New in 1.4.1 !

    Set the CSS width of each element in the set of matched elements.

  • jQuery .height( [Function] function(index, height) )

    New in 1.4.1 !

    Set the CSS height of every matched element.

  • jQuery .scrollLeft( [Number] value )

    New in 1.2.6 !

    Set the current horizontal position of the scroll bar for each of the set of matched elements.

  • jQuery .scrollTop( [Number] value )

    New in 1.2.6 !

    Set the current vertical position of the scroll bar for each of the set of matched elements.

  • Object .position( )

    New in 1.2 !

    Get the current coordinates of the first element in the set of matched elements, relative to the offset parent.

  • jQuery .offset( [Function] function(index, coords) )

    New in 1.4 !

    Set the current coordinates of every element in the set of matched elements, relative to the document.

  • jQuery .css( [Map] map )

    New in 1.0 !

    Set one or more CSS properties for the set of matched elements.


Miscellaneous – jQuery API

Miscellaneous

  • jQuery .each( [Function] function(index, Element) )

    New in 1.0 !

    Iterate over a jQuery object, executing a function for each matched element.

  • String jQuery.param( [Array|Object] obj, [Boolean] traditional )

    New in 1.4 !

    Create a serialized representation of an array or object, suitable for use in a URL query string or Ajax request.

  • jQuery .removeData( [String] name )

    New in 1.2.3 !

    Remove a previously-stored piece of data.

  • Object .data( )

    New in 1.4 !

    Returns value at named data store for the element, as set by data(name, value).

  • Array .toArray( )

    New in 1.4 !

    Retrieve all the DOM elements contained in the jQuery set, as an array.

  • Number .index( [Element|jQuery] element )

    New in 1.0 !

    Search for a given element from among the matched elements.

  • Element, Array .get( [Number] index )

    New in 1.0 !

    Retrieve the DOM elements matched by the jQuery object.

  • Number .size( )

    New in 1.0 !

    Return the number of DOM elements matched by the jQuery object.

  • Object jQuery.noConflict( [Boolean] removeAll )

    New in 1.0 !

    Relinquish jQuery's control of the variable.


Collection Manipulation – jQuery API

Collection Manipulation

  • jQuery .each( [Function] function(index, Element) )

    New in 1.0 !

    Iterate over a jQuery object, executing a function for each matched element.

  • String jQuery.param( [Array|Object] obj, [Boolean] traditional )

    New in 1.4 !

    Create a serialized representation of an array or object, suitable for use in a URL query string or Ajax request.


each – jQuery API

Returns: jQueryjQuery .each( [Function] function(index, Element) )

Categories: Collection Manipulation, Traversing, Version 1.0
Description: Iterate over a jQuery object, executing a function for each matched element.
  • version added: 1.0

  • .each( [Function] function(index, Element) )

  • function(index, Element) A function to execute for each matched element.

The method is designed to make DOM looping constructs concise and less error-prone. When called it iterates over the DOM elements that are part of the jQuery object. Each time the callback runs, it is passed the current loop iteration, beginning from 0. More importantly, the callback is fired in the context of the current DOM element, so the keyword refers to the element.

Suppose we had a simple unordered list on the page:

<ul>
    <li>foo</li>
    <li>bar</li>
  </ul>

We can select the list items and iterate across them:

$('li').each(function(index) {
    alert(index + ': ' + $(this).text());
  });

A message is thus alerted for each item in the list:

We can stop the loop from within the callback function by returning .

Examples:

Example:

Iterates over three divs and sets their color property.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { color:red; text-align:center; cursor:pointer;
        font-weight:bolder; width:300px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>Click here</div>

  <div>to iterate through</div>
  <div>these divs.</div>
  <script>
    $(document.body).click(function () {
      $("div").each(function (i) {
        if (this.style.color != "blue") {
          this.style.color = "blue";
        } else {
          this.style.color = "";
        }
      });
    });</script>
</body>
</html>

Demo:

Example:

If you want to have the jQuery object instead of the regular DOM element, use the $(this) function, for example:
<!DOCTYPE html>
<html>
<head>
  <style>
  ul { font-size:18px; margin:0; }
  span { color:blue; text-decoration:underline; cursor:pointer; }
  .example { font-style:italic; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  To do list: <span>(click here to change)</span>
  <ul>
    <li>Eat</li>
    <li>Sleep</li>

    <li>Be merry</li>
  </ul>
  <script>
    $("span").click(function () {
      $("li").each(function(){
        $(this).toggleClass("example");
      });
    });

</script>
</body>
</html>

Demo:

Example:

You can use 'return' to break out of each() loops early.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { width:40px; height:40px; margin:5px; float:left;
        border:2px blue solid; text-align:center; }
  span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button>Change colors</button>
  <span></span>
  <div></div>
  <div></div>

  <div></div>
  <div></div>
  <div id="stop">Stop here</div>
  <div></div>

  <div></div>
  <div></div>
  <script>
    $("button").click(function () {
      $("div").each(function (index, domEle) {
        // domEle == this
        $(domEle).css("backgroundColor", "yellow");
        if ($(this).is("#stop")) {
          $("span").text("Stopped at div index #" + index);
          return false;
        }
      });
    });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Data Storage – jQuery API

Data Storage

  • jQuery .removeData( [String] name )

    New in 1.2.3 !

    Remove a previously-stored piece of data.

  • Object .data( )

    New in 1.4 !

    Returns value at named data store for the element, as set by data(name, value).


DOM Element Methods – jQuery API

DOM Element Methods

  • Array .toArray( )

    New in 1.4 !

    Retrieve all the DOM elements contained in the jQuery set, as an array.

  • Number .index( [Element|jQuery] element )

    New in 1.0 !

    Search for a given element from among the matched elements.

  • Element, Array .get( [Number] index )

    New in 1.0 !

    Retrieve the DOM elements matched by the jQuery object.

  • Number .size( )

    New in 1.0 !

    Return the number of DOM elements matched by the jQuery object.


toArray – jQuery API

Returns: ArrayArray .toArray( )

Categories: DOM Element Methods, Version 1.4
Description: Retrieve all the DOM elements contained in the jQuery set, as an array.
  • version added: 1.4

  • .toArray( )

returns all of the elements in the jQuery set:

alert($('li').toArray());

All of the matched DOM nodes are returned by this call, contained in a standard array:

Examples:

Example:

Selects all divs in the document and returns the DOM Elements as an Array, then uses the built-in reverse-method to reverse that array.
<!DOCTYPE html>
<html>
<head>
  <style>
  span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  Reversed - <span></span>

  <div>One</div>
  <div>Two</div>
  <div>Three</div>
  <script>

    function disp(divs) {
      var a = [];
      for (var i = 0; i < divs.length; i++) {
        a.push(divs[i].innerHTML);
      }
      $("span").text(a.join(" "));
    }

    disp( $("div").toArray().reverse() );
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


index – jQuery API

  • index( )

    • 1.4index( )

  • index( [Selector] selector )

    • 1.4index( [Selector] selector )
    • 1.0index( [Element|jQuery] element )

Returns: NumberNumber .index( [Element|jQuery] element )

Categories: DOM Element Methods, Version 1.0, Version 1.4
Description: Search for a given element from among the matched elements.
  • version added: 1.4

  • .index( )

  • version added: 1.4

  • .index( [Selector] selector )

  • selector A selector representing a jQuery collection in which to look for an element.
  • version added: 1.0

  • .index( [Element|jQuery] element )

  • element The DOM element or first element within the jQuery object to look for.

Return Values

If no argument is passed to the method, the return value is an integer indicating the position of the first element within the jQuery object relative to its sibling elements.

If is called on a collection of elements and a DOM element or jQuery object is passed in, returns an integer indicating the position of the passed element relative to the original collection.

If a selector string is passed as an argument, returns an integer indicating the position of the original element relative to the elements matched by the selector. If the element is not found, will return -1.

Detail

The complementary operation to , which accepts an index and returns a DOM node, can take a DOM node and returns an index. Suppose we have a simple unordered list on the page:

<ul>
  <li id="foo">foo</li>
  <li id="bar">bar</li>
  <li id="baz">baz</li>
</ul>

If we retrieve one of the three list items (for example, through a DOM function or as the context to an event handler), can search for this list item within the set of matched elements:

var listItem = document.getElementById('bar');
alert('Index: ' + $('li').index(listItem));
We get back the zero-based position of the list item:

Similarly, if we retrieve a jQuery object consisting of one of the three list items, will search for that list item:

var listItem = $('#bar');
alert('Index: ' + $('li').index(listItem));

We get back the zero-based position of the list item:

Note that if the jQuery collection used as the method's argument contains more than one element, the first element within the matched set of elements will be used.

var listItems = $('li:gt(0)');
alert('Index: ' + $('li').index(listItems));

We get back the zero-based position of the first list item within the matched set:

If we use a string as the method's argument, it is interpreted as a jQuery selector string. The first element among the object's matched elements which also matches this selector is located.

var listItem = $('#bar');
alert('Index: ' + listItem.index('li'));

We get back the zero-based position of the list item:

If we omit the argument, will return the position of the first element within the set of matched elements in relation to its siblings:

alert('Index: ' + $('#bar').index();

Again, we get back the zero-based position of the list item:

Examples:

Example:

On click, returns the index (based zero) of that div in the page.
<!DOCTYPE html>
<html>
<head>
  <style>
div { background:yellow; margin:5px; }
span { color:red; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <span>Click a div!</span>
<div>First div</div>
<div>Second div</div>
<div>Third div</div>
  <script>
$("div").click(function () {
  // this is the dom element clicked
  var index = $("div").index(this);
  $("span").text("That was div index #" + index);
});
</script>
</body>
</html>

Demo:

Example:

Returns the index for the element with ID bar.
<!DOCTYPE html>
<html>
<head>
  <style>
div { font-weight: bold; color: #090; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <ul>
  <li id="foo">foo</li>
  <li id="bar">bar</li>
  <li id="baz">baz</li>
</ul>
<div></div>
  <script>var listItem = $('#bar');
    $('div').html( 'Index: ' + $('li').index(listItem) );</script>
</body>
</html>

Demo:

Example:

Returns the index for the first item in the jQuery collection.
<!DOCTYPE html>
<html>
<head>
  <style>
div { font-weight: bold; color: #090; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <ul>
  <li id="foo">foo</li>
  <li id="bar">bar</li>
  <li id="baz">baz</li>
</ul>
<div></div>
  <script>var listItems = $('li:gt(0)');
$('div').html( 'Index: ' + $('li').index(listItems) );
</script>
</body>
</html>

Demo:

Example:

Returns the index for the element with ID bar in relation to all
  • elements.
    • <!DOCTYPE html>
<html>
<head>
  <style>
div { font-weight: bold; color: #090; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <ul>
  <li id="foo">foo</li>
  <li id="bar">bar</li>
  <li id="baz">baz</li>
</ul>
<div></div>
  <script>$('div').html('Index: ' +  $('#bar').index('li') );</script>
</body>
</html>

    Demo:

    Example:

    Returns the index for the element with ID bar in relation to its siblings.
    <!DOCTYPE html>
<html>
<head>
  <style>
div { font-weight: bold; color: #090; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <ul>
  <li id="foo">foo</li>
  <li id="bar">bar</li>
  <li id="baz">baz</li>
</ul>
<div></div>
  <script>var barIndex = $('#bar').index();
$('div').html( 'Index: ' +  barIndex );</script>
</body>
</html>

    Demo:

    Example:

    Returns -1, as there is no element with ID foobar.
    <!DOCTYPE html>
<html>
<head>
  <style>
div { font-weight: bold; color: #090; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <ul>
  <li id="foo">foo</li>
  <li id="bar">bar</li>
  <li id="baz">baz</li>
</ul>
<div></div>
  <script>var foobar = $("li").index( $('#foobar') );
$('div').html('Index: ' + foobar);</script>
</body>
</html>

    Demo:

    Comments

    © 2010 The jQuery Project


get – jQuery API

Returns: Element, ArrayElement, Array .get( [Number] index )

Categories: DOM Element Methods, Version 1.0
Description: Retrieve the DOM elements matched by the jQuery object.
  • version added: 1.0

  • .get( [Number] index )

  • index A zero-based integer indicating which element to retrieve.

The method grants us access to the DOM nodes underlying each jQuery object. Suppose we had a simple unordered list on the page:

<ul>
  <li id="foo">foo</li>
  <li id="bar">bar</li>
</ul>

Without a parameter, returns all of the elements:

alert($('li').get());

All of the matched DOM nodes are returned by this call, contained in a standard array:

With an index specified, .get() will retrieve a single element:

($('li').get(0));

Since the index is zero-based, the first list item is returned:

Each jQuery object also masquerades as an array, so we can use the array dereferencing operator to get at the list item instead:

alert($('li')[0]);

However, this syntax lacks some of the additional capabilities of .get(), such as specifying a negative index:

alert($('li').get(-1));

A negative index is counted from the end of the matched set, so this example will return the last item in the list:

Examples:

Example:

Selects all divs in the document and returns the DOM Elements as an Array, then uses the built-in reverse-method to reverse that array.
<!DOCTYPE html>
<html>
<head>
  <style>
  span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  Reversed - <span></span>

  <div>One</div>
  <div>Two</div>
  <div>Three</div>
  <script>

    function disp(divs) {
      var a = [];
      for (var i = 0; i < divs.length; i++) {
        a.push(divs[i].innerHTML);
      }
      $("span").text(a.join(" "));
    }

    disp( $("div").get().reverse() );
</script>
</body>
</html>

Demo:

Example:

Gives the tag name of the element clicked on.
<!DOCTYPE html>
<html>
<head>
  <style>
  span { color:red; }
  div { background:yellow; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <span>&nbsp;</span>
  <p>In this paragraph is an <span>important</span> section</p>

  <div><input type="text" /></div>
  <script>

    $("*", document.body).click(function (e) {
      e.stopPropagation();
      var domEl = $(this).get(0);
      $("span:first").text("Clicked on - " + domEl.tagName);
    });
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


size – jQuery API

Returns: NumberNumber .size( )

Categories: DOM Element Methods, Version 1.0
Description: Return the number of DOM elements matched by the jQuery object.
  • version added: 1.0

  • .size( )

<ul>
  <li>foo</li>
  <li>bar</li>
</ul>

We can determine the number of list items by calling :

alert('Size: ' + $('li').size());

This will alert the count of items:

The property is a slightly faster way to get this information.

Examples:

Example:

Count the divs. Click to add more.
<!DOCTYPE html>
<html>
<head>
  <style>
body { cursor:pointer; }
 div { width:50px; height:30px; margin:5px; float:left; background:blue; }
 span { color:red; }
 </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <span></span>

 <div></div>
  <script>$(document.body).click(function () { $(document.body).append($("<div>"));
var n = $("div").size();
$("span").text("There are " + n + " divs." + "Click to add more.");}).click(); // trigger the click to start</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Setup Methods – jQuery API

Setup Methods

  • Object jQuery.noConflict( [Boolean] removeAll )

    New in 1.0 !

    Relinquish jQuery's control of the variable.


Offset – jQuery API

Offset

  • jQuery .offsetParent( )

    New in 1.26 !

    Get the closest ancestor element that is positioned.

  • jQuery .scrollLeft( [Number] value )

    New in 1.2.6 !

    Set the current horizontal position of the scroll bar for each of the set of matched elements.

  • jQuery .scrollTop( [Number] value )

    New in 1.2.6 !

    Set the current vertical position of the scroll bar for each of the set of matched elements.

  • Object .position( )

    New in 1.2 !

    Get the current coordinates of the first element in the set of matched elements, relative to the offset parent.

  • jQuery .offset( [Function] function(index, coords) )

    New in 1.4 !

    Set the current coordinates of every element in the set of matched elements, relative to the document.


offsetParent – jQuery API

Returns: jQueryjQuery .offsetParent( )

Categories: Offset, Tree Traversal
Description: Get the closest ancestor element that is positioned.
  • version added: 1.26

  • .offsetParent( )

Given a jQuery object that represents a set of DOM elements, the method allows us to search through the ancestors of these elements in the DOM tree and construct a new jQuery object wrapped around the closest positioned ancestor. An element is said to be positioned if it has a CSS position attribute of , , or . This information is useful for calculating offsets for performing animations and placing objects on the page.

Consider a page with a basic nested list on it, with a positioned element:

<ul class="level-1">
  <li class="item-i">I</li>
  <li class="item-ii" style="position: relative;">II
    <ul class="level-2">
      <li class="item-a">A</li>
      <li class="item-b">B
        <ul class="level-3">
          <li class="item-1">1</li>
          <li class="item-2">2</li>
          <li class="item-3">3</li>
        </ul>
      </li>
      <li class="item-c">C</li>
    </ul>
  </li>
  <li class="item-iii">III</li>
</ul>

If we begin at item A, we can find its positioned ancestor:

$('li.item-a').offsetParent().css('background-color', 'red');

This will change the color of list item II, which is positioned.

Examples:

Example:

Find the offsetParent of item "A."
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

    <ul class="level-1">
      <li class="item-i">I</li>
      <li class="item-ii" style="position: relative;">II
        <ul class="level-2">
          <li class="item-a">A</li>
          <li class="item-b">B
            <ul class="level-3">
              <li class="item-1">1</li>
              <li class="item-2">2</li>
              <li class="item-3">3</li>
            </ul>
          </li>
          <li class="item-c">C</li>
        </ul>
      </li>
      <li class="item-iii">III</li>
    </ul>

  <script>$('li.item-a').offsetParent().css('background-color', 'red');</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Plugin Authoring – jQuery API

Plugin Authoring

  • jQuery.error( [String] message )

    New in 1.4.1 !

    Takes a string and throws an exception containing it.

  • jQuery jQuery.pushStack( [Array] elements, [String] name, [Array] arguments )

    New in 1.3 !

    Add a collection of DOM elements onto the jQuery stack.

  • String selector

    New in 1.3 !

    A selector representing selector originally passed to jQuery().

  • Element context

    New in 1.3 !

    The DOM node context originally passed to jQuery(); if none was passed then context will likely be the document.


jQuery.error – jQuery API

Returns: jQuery.error( [String] message )

Categories: Plugin Authoring, Version 1.4.1
Description: Takes a string and throws an exception containing it.
  • version added: 1.4.1

  • jQuery.error( [String] message )

  • message The message to send out.

This method exists primarily for plugin developers who wish to override it and provide a better display (or more information) for the error messages.

Examples:

Example:

Override jQuery.error for display in Firebug.
<script>jQuery.error = console.error;</script>

Comments

© 2010 The jQuery Project


jQuery.pushStack – jQuery API

  • jQuery.pushStack( [Array] elements )

    • 1.0jQuery.pushStack( [Array] elements )

  • jQuery.pushStack( [Array] elements, [String] name, [Array] arguments )

    • 1.3jQuery.pushStack( [Array] elements, [String] name, [Array] arguments )

Returns: jQueryjQuery jQuery.pushStack( [Array] elements, [String] name, [Array] arguments )

Categories: Plugin Authoring, Version 1.0, Version 1.3
Description: Add a collection of DOM elements onto the jQuery stack.
  • version added: 1.0

  • jQuery.pushStack( [Array] elements )

  • elements An array of elements to push onto the stack and make into a new jQuery object.
  • version added: 1.3

  • jQuery.pushStack( [Array] elements, [String] name, [Array] arguments )

  • elements An array of elements to push onto the stack and make into a new jQuery object.
  • name The name of a jQuery method that generated the array of elements.
  • arguments The arguments that were passed in to the jQuery method (for serialization).

Examples:

Example:

Add some elements onto the jQuery stack, then pop back off again.
<script>jQuery([])
    .pushStack( document.getElementsByTagName("div") )
        .remove()
    .end();</script>

Comments

© 2010 The jQuery Project


selector – jQuery API

Returns: StringString selector

Categories: Plugin Authoring, Properties of jQuery Object Instances, Version 1.3
Description: A selector representing selector originally passed to jQuery().
  • version added: 1.3

  • selector

Should be used in conjunction with context to determine the exact query used.

The method for binding event handlers uses this property to determine how to perform its searches. Plug-ins which perform similar tasks may also find the property useful. This property contains a string representing the matched set of elements, but if DOM traversal methods have been called on the object, the string may not be a valid jQuery selector expression. For this reason, the value of is generally most useful immediately following the original creation of the object. Consequently, the method should only be used in this scenario.

Examples:

Example:

Determine the selector used.
<!DOCTYPE html>
<html>
<head>
  <style>
  body { cursor:pointer; }
  div { width:50px; height:30px; margin:5px; float:left;
        background:green; }
  span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  Some selectors:<ul></ul>
  <script>$("ul")
  .append("<li>" + $("ul").selector + "</li>")
  .append("<li>" + $("ul li").selector + "</li>")
  .append("<li>" + $("div#foo ul:not([class])").selector + "</li>");

</script>
</body>
</html>

Demo:

Example:

Collecting elements differently
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  Some selectors:<ul></ul>

  <script>
   $('<div>' + $('ul li.foo').selector + '</div>').appendTo('body');  // "ul li.foo"
   $('<div>' + $('ul').find('li').filter('.foo').selector + '</div>').appendTo('body'); // "ul li.filter(.foo)"
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


context – jQuery API

Returns: ElementElement context

Categories: Plugin Authoring, Properties of jQuery Object Instances, Version 1.3
Description: The DOM node context originally passed to jQuery(); if none was passed then context will likely be the document.
  • version added: 1.3

  • context

The method for binding event handlers uses this property to determine the root element to use for its event delegation needs. Plug-ins which perform similar tasks may also find the property useful.

The value of this property is typically equal to document, as this is the default context for jQuery objects if none is supplied. The context may differ if, for example, the object was created by searching within an or XML document.

Examples:

Example:

Determine the exact context used.
<!DOCTYPE html>
<html>
<head>
  <style>
  body { cursor:pointer; }
  div { width:50px; height:30px; margin:5px; float:left;
        background:green; }
  span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  Context:<ul></ul>
  <script>$("ul")
  .append("<li>" + $("ul").context + "</li>")
  .append("<li>" + $("ul", document.body).context.nodeName + "</li>");

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Properties – jQuery API

Properties

  • Number length

    New in 1.0 !

    The number of elements in the jQuery object.

  • String selector

    New in 1.3 !

    A selector representing selector originally passed to jQuery().

  • Element context

    New in 1.3 !

    The DOM node context originally passed to jQuery(); if none was passed then context will likely be the document.

  • Boolean jQuery.fx.off

    New in 1.3 !

    Globally disable all animations.

  • Map jQuery.browser

    New in 1.0 !

    Contains flags for the useragent, read from navigator.userAgent. While jQuery.browser will not be removed from future versions of jQuery, every effort to use jQuery.support and proper feature detection should be made.

  • String jQuery.browser.version

    New in 1.1.3 !

    The version number of the rendering engine for the user's browser.

  • Object jQuery.support

    New in 1.3 !

    A collection of properties that represent the presence of different browser features or bugs.


Properties of jQuery Object Instances – jQuery API

Properties of jQuery Object Instances

  • Number length

    New in 1.0 !

    The number of elements in the jQuery object.

  • String selector

    New in 1.3 !

    A selector representing selector originally passed to jQuery().

  • Element context

    New in 1.3 !

    The DOM node context originally passed to jQuery(); if none was passed then context will likely be the document.


length – jQuery API

Returns: NumberNumber length

Categories: Properties of jQuery Object Instances, Version 1.0
Description: The number of elements in the jQuery object.
  • version added: 1.0

  • length

The number of elements currently matched. The . method will return the same value.

Examples:

Example:

Count the divs. Click to add more.
<!DOCTYPE html>
<html>
<head>
  <style>
  body { cursor:pointer; }
  div { width:50px; height:30px; margin:5px; float:left;
        background:green; }
  span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <span></span>
  <div></div>
  <script>$(document.body).click(function () {
      $(document.body).append($("<div>"));
      var n = $("div").length;
      $("span").text("There are " + n + " divs." +
                     "Click to add more.");
    }).trigger('click'); // trigger the click to start</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Properties of the Global jQuery Object – jQuery API

Properties of the Global jQuery Object

  • Boolean jQuery.fx.off

    New in 1.3 !

    Globally disable all animations.

  • Map jQuery.browser

    New in 1.0 !

    Contains flags for the useragent, read from navigator.userAgent. While jQuery.browser will not be removed from future versions of jQuery, every effort to use jQuery.support and proper feature detection should be made.

  • String jQuery.browser.version

    New in 1.1.3 !

    The version number of the rendering engine for the user's browser.

  • Object jQuery.support

    New in 1.3 !

    A collection of properties that represent the presence of different browser features or bugs.


jQuery.browser – jQuery API

Returns: MapMap jQuery.browser

Categories: Properties of the Global jQuery Object, Utilities, Version 1.0, Version 1.1.3
Description: Contains flags for the useragent, read from navigator.userAgent. While jQuery.browser will not be removed from future versions of jQuery, every effort to use jQuery.support and proper feature detection should be made.
  • version added: 1.0

  • jQuery.browser

The property allows us to detect which web browser is accessing the page, as reported by the browser itself. It contains flags for each of the four most prevalent browser classes (Internet Explorer, Mozilla, Webkit, and Opera) as well as version information.

Available flags are:

This property is available immediately. It is therefore safe to use it to determine whether or not to call . The property is deprecated in jQuery 1.3, but there are no immediate plans to remove it.

Because uses to determine the platform, it is vulnerable to spoofing by the user or misrepresentation by the browser itself. It is always best to avoid browser-specific code entirely where possible. The property is available for detection of support for particular features rather than relying on .

Examples:

Example:

Show the browser info.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { color:green; font-weight:bolder; margin:3px 0 0 10px; }
  div { color:blue; margin-left:20px; font-size:14px; }
  span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Browser info:</p>
  <script>
    jQuery.each(jQuery.browser, function(i, val) {
      $("<div>" + i + " : <span>" + val + "</span>")
                .appendTo(document.body);
    });</script>
</body>
</html>

Demo:

Example:

Returns true if the current useragent is some version of Microsoft's Internet Explorer.
<script>$.browser.msie</script>

Example:

Alerts "this is webkit!" only for webkit browsers
<script>if ($.browser.webkit) {
    alert("this is webkit!");
 }</script>

Example:

Alerts "Do stuff for firefox 3" only for firefox 3 browsers.
<script>jQuery.each(jQuery.browser, function(i, val) {
   if(i=="mozilla" && jQuery.browser.version.substr(0,3)=="1.9")
      alert("Do stuff for firefox 3")
 });</script>

Example:

Set a CSS property to specific browser.
<script>jQuery.each(jQuery.browser, function(i) {
   if($.browser.msie){
      $("#div ul li").css("display","inline");
   }else{
      $("#div ul li").css("display","inline-table");
   }
 });</script>

Comments

© 2010 The jQuery Project


jQuery.browser.version – jQuery API

Returns: StringString jQuery.browser.version

Categories: Properties of the Global jQuery Object, Utilities, Version 1.0, Version 1.1.3
Description: The version number of the rendering engine for the user's browser.
  • version added: 1.1.3

  • jQuery.browser.version

Here are some typical results:

Note that IE8 claims to be 7 in Compatibility View.

Examples:

Example:

Returns the browser version.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { color:blue; margin:20px; }
  span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>
  </p>
  <script>

    $("p").html("The browser version is: <span>" +
                jQuery.browser.version + "</span>");
</script>
</body>
</html>

Demo:

Example:

Alerts the version of IE that is being used
<script>if ( $.browser.msie ) {
  alert( $.browser.version );
}</script>

Example:

Often you only care about the "major number," the whole number. This can be accomplished with JavaScript's built-in parseInt() function:
<script>
if (jQuery.browser.msie) {
  alert(parseInt(jQuery.browser.version));
}
</script>

Comments

© 2010 The jQuery Project


jQuery.support – jQuery API

Returns: ObjectObject jQuery.support

Categories: Properties of the Global jQuery Object, Utilities, Version 1.3
Description: A collection of properties that represent the presence of different browser features or bugs.
  • version added: 1.3

  • jQuery.support

Rather than using to detect the current user agent and alter the page presentation based on which browser is running, it is a good practice to perform . This means that prior to executing code which relies on a browser feature, we test to ensure that the feature works properly. To make this process simpler, jQuery performs many such tests and makes the results available to us as properties of the object.

The values of all the support properties are determined using feature detection (and do not use any form of browser sniffing).

While jQuery includes a number of properties, developers should feel free to add their own as their needs dictate. Many of the properties are rather low-level, so they are most useful for plugin and jQuery core development, rather than general day-to-day development.

The tests included in are as follows:

Examples:

Example:

Returns the box model for the iframe.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { color:blue; margin:20px; }
  span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>
  </p>
  <script>

    $("p").html("This frame uses the W3C box model: <span>" +
                jQuery.support.boxModel + "</span>");

</script>
</body>
</html>

Demo:

Example:

Returns false if the page is in QuirksMode in Internet Explorer
<script>jQuery.support.boxModel</script>

Comments

© 2010 The jQuery Project


Selectors – jQuery API

Selectors

  • JQuery("[attribute|=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value either equal to a given string or starting with that string followed by a hyphen (-).

  • JQuery("[attribute~=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value containing a given word, delimited by spaces.

  • JQuery("[attributeFilter1][attributeFilter2][attributeFilterN]")

    New in 1.0 !

    Matches elements that match all of the specified attribute filters.

  • JQuery("[attribute*=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value containing the a given substring.

  • JQuery("[attribute$=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value ending exactly with a given string.

  • JQuery("[attribute^=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value beginning exactly with a given string.

  • JQuery("[attribute!=value]")

    New in 1.0 !

    Select elements that either don't have the specified attribute, or do have the specified attribute but not with a certain value.

  • JQuery("[attribute=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value exactly equal to a certain value.

  • JQuery("[attribute]")

    New in 1.0 !

    Selects elements that have the specified attribute, with any value.

  • JQuery("selector1, selector2, selectorN")

    New in 1.0 !

    Selects the combined results of all the specified selectors.

  • JQuery("*")

    New in 1.0 !

    Selects all elements.

  • JQuery(".class")

    New in 1.0 !

    Selects all elements with the given class.

  • JQuery("element")

    New in 1.0 !

    Selects all elements with the given tag name.

  • JQuery("#id")

    New in 1.0 !

    Selects a single element with the given id attribute.

  • JQuery(":animated")

    New in 1.2 !

    Select all elements that are in the progress of an animation at the time the selector is run.

  • JQuery(":header")

    New in 1.2 !

    Selects all elements that are headers, like h1, h2, h3 and so on.

  • JQuery(":lt(index)")

    New in 1.0 !

    Select all elements at an index less than within the matched set.

  • JQuery(":gt(index)")

    New in 1.0 !

    Select all elements at an index greater than within the matched set.

  • JQuery(":eq(index)")

    New in 1.0 !

    Select the element at index within the matched set.

  • JQuery(":odd")

    New in 1.0 !

    Selects odd elements, zero-indexed. See also .

  • JQuery(":even")

    New in 1.0 !

    Selects even elements, zero-indexed. See also .

  • JQuery(":not(selector)")

    New in 1.0 !

    Selects all elements that do not match the given selector.

  • JQuery(":last")

    New in 1.0 !

    Selects the last matched element.

  • JQuery(":first")

    New in 1.0 !

    Selects the first matched element.

  • JQuery(":only-child")

    New in 1.1.4 !

    Selects all elements that are the only child of their parent.

  • JQuery(":last-child")

    New in 1.1.4 !

    Selects all elements that are the last child of their parent.

  • JQuery(":first-child")

    New in 1.1.4 !

    Selects all elements that are the first child of their parent.

  • JQuery(":nth-child(index/even/odd/equation)")

    New in 1.1.4 !

    Selects all elements that are the nth-child of their parent.

  • JQuery(":parent")

    New in 1.0 !

    Select all elements that are the parent of another element, including text nodes.

  • JQuery(":has(selector)")

    New in 1.1.4 !

    Selects elements which contain at least one element that matches the specified selector.

  • JQuery(":empty")

    New in 1.0 !

    Select all elements that have no children (including text nodes).

  • JQuery(":contains(text)")

    New in 1.1.4 !

    Select all elements that contain the specified text.

  • JQuery(":selected")

    New in 1.0 !

    Selects all elements that are selected.

  • JQuery(":checked")

    New in 1.0 !

    Matches all elements that are checked.

  • JQuery(":disabled")

    New in 1.0 !

    Selects all elements that are disabled.

  • JQuery(":enabled")

    New in 1.0 !

    Selects all elements that are enabled.

  • JQuery(":file")

    New in 1.0 !

    Selects all elements of type file.

  • JQuery(":button")

    New in 1.0 !

    Selects all button elements and elements of type button.

  • JQuery(":reset")

    New in 1.0 !

    Selects all elements of type reset.

  • JQuery(":image")

    New in 1.0 !

    Selects all elements of type image.

  • JQuery(":submit")

    New in 1.0 !

    Selects all elements of type submit.

  • JQuery(":checkbox")

    New in 1.0 !

    Selects all elements of type checkbox.

  • JQuery(":radio")

    New in 1.0 !

    Selects all elements of type radio.

  • JQuery(":password")

    New in 1.0 !

    Selects all elements of type password.

  • JQuery(":text")

    New in 1.0 !

    Selects all elements of type text.

  • JQuery(":input")

    New in 1.0 !

    Selects all input, textarea, select and button elements.

  • JQuery("prev ~ siblings")

    New in 1.0 !

    Selects all sibling elements that follow after the "prev" element, have the same parent, and match the filtering "siblings" selector.

  • JQuery("prev + next")

    New in 1.0 !

    Selects all next elements matching "next" that are immediately preceded by a sibling "prev".

  • child")" rel="bookmark">JQuery("parent > child")

    New in 1.0 !

    Selects all direct child elements specified by "child" of elements specified by "parent".

  • JQuery("ancestor descendant")

    New in 1.0 !

    Selects all elements that are descendants of a given ancestor.

  • JQuery(":visible")

    New in 1.0 !

    Selects all elements that are visible.

  • JQuery(":hidden")

    New in 1.0 !

    Selects all elements that are hidden.


Attribute – jQuery API

Attribute

  • JQuery("[attribute|=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value either equal to a given string or starting with that string followed by a hyphen (-).

  • JQuery("[attribute~=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value containing a given word, delimited by spaces.

  • JQuery("[attributeFilter1][attributeFilter2][attributeFilterN]")

    New in 1.0 !

    Matches elements that match all of the specified attribute filters.

  • JQuery("[attribute*=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value containing the a given substring.

  • JQuery("[attribute$=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value ending exactly with a given string.

  • JQuery("[attribute^=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value beginning exactly with a given string.

  • JQuery("[attribute!=value]")

    New in 1.0 !

    Select elements that either don't have the specified attribute, or do have the specified attribute but not with a certain value.

  • JQuery("[attribute=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value exactly equal to a certain value.

  • JQuery("[attribute]")

    New in 1.0 !

    Selects elements that have the specified attribute, with any value.


attributeContainsPrefix – jQuery API

Returns: JQuery("[attribute|=value]")

Categories: Attribute, Version 1.0
Description: Selects elements that have the specified attribute with a value either equal to a given string or starting with that string followed by a hyphen (-).
  • version added: 1.0

  • JQuery("[attribute|=value]")

  • attribute An attribute name.
  • value An attribute value. Quotes are optional.

This selector was introduced into the CSS specification to handle language attributes.

Examples:

Example:

Finds all links with an hreflang attribute that is english.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

                         <a href="example.html" hreflang="en">Some text</a>

                          <a href="example.html" hreflang="en-UK">Some other text</a>

  <script>$('a[hreflang|=en]').css('border','3px dotted green');</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


attributeContainsWord – jQuery API

Returns: JQuery("[attribute~=value]")

Categories: Attribute, Version 1.0
Description: Selects elements that have the specified attribute with a value containing a given word, delimited by spaces.
  • version added: 1.0

  • JQuery("[attribute~=value]")

  • attribute An attribute name.
  • value An attribute value. Quotes are optional.

This selector matches the test string against each word in the attribute value, where a "word" is defined as a string delimited by whitespace. The selector matches if the test string is exactly equal to any of the words.

Examples:

Example:

Finds all inputs with a name attribute that contains the word 'man' and sets the value with some text.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <input name="man-news" />

  <input name="milk man" />
  <input name="letterman2" />
  <input name="newmilk" />
  <script>$("input[name~=man]").val("mr. man is in it!");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


attributeMultiple – jQuery API

Returns: JQuery("[attributeFilter1][attributeFilter2][attributeFilterN]")

Categories: Attribute, Version 1.0
Description: Matches elements that match all of the specified attribute filters.
  • version added: 1.0

  • JQuery("[attributeFilter1][attributeFilter2][attributeFilterN]")

  • attributeFilter1 An attribute filter.
  • attributeFilter2 Another attribute filter, reducing the selection even more
  • attributeFilterN As many more attribute filters as necessary

Examples:

Example:

Finds all inputs that have an id attribute and whose name attribute ends with man and sets the value.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <input id="man-news" name="man-news" />

  <input name="milkman" />
  <input id="letterman" name="new-letterman" />
  <input name="newmilk" />
  <script>$("input[id][name$='man']").val("only this one");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


attributeContains – jQuery API

Returns: JQuery("[attribute*=value]")

Categories: Attribute, Version 1.0
Description: Selects elements that have the specified attribute with a value containing the a given substring.
  • version added: 1.0

  • JQuery("[attribute*=value]")

  • attribute An attribute name.
  • value An attribute value. Quotes are optional.

This is the most generous of the jQuery attribute selectors that match against a value. It will select an element if the selector's string appears anywhere within the element's attribute value. Compare this selector with the Attribute Contains Word selector (e.g. [attr~=word]), which is more appropriate in many cases.

Examples:

Example:

Finds all inputs with a name attribute that contains 'man' and sets the value with some text.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <input name="man-news" />

  <input name="milkman" />
  <input name="letterman2" />
  <input name="newmilk" />
  <script>$("input[name*='man']").val("has man in it!");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


attributeEndsWith – jQuery API

Returns: JQuery("[attribute$=value]")

Categories: Attribute, Version 1.0
Description: Selects elements that have the specified attribute with a value ending exactly with a given string.
  • version added: 1.0

  • JQuery("[attribute$=value]")

  • attribute An attribute name.
  • value An attribute value. Quotes are optional.

Examples:

Example:

Finds all inputs with an attribute name that ends with 'letter' and puts text in them.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <input name="newsletter" />

  <input name="milkman" />
  <input name="jobletter" />
  <script>$("input[name$='letter']").val("a letter");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


attributeStartsWith – jQuery API

Returns: JQuery("[attribute^=value]")

Categories: Attribute, Version 1.0
Description: Selects elements that have the specified attribute with a value beginning exactly with a given string.
  • version added: 1.0

  • JQuery("[attribute^=value]")

  • attribute An attribute name.
  • value An attribute value. Quotes are optional.

This selector can be useful for identifying elements in pages produced by server-side frameworks that produce HTML with systematic element IDs. However it will be slower than using a class selector so leverage classes, if you can, to group like elements.

Examples:

Example:

Finds all inputs with an attribute name that starts with 'news' and puts text in them.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <input name="newsletter" />

  <input name="milkman" />
  <input name="newsboy" />
  <script>$("input[name^='news']").val("news here!");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


attributeNotEqual – jQuery API

Returns: JQuery("[attribute!=value]")

Categories: Attribute, Version 1.0
Description: Select elements that either don't have the specified attribute, or do have the specified attribute but not with a certain value.
  • version added: 1.0

  • JQuery("[attribute!=value]")

  • attribute An attribute name.
  • value An attribute value. Quotes are optional.

This selector is equivalent to .

Examples:

Example:

Finds all inputs that don't have the name 'newsletter' and appends text to the span next to it.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>

    <input type="radio" name="newsletter" value="Hot Fuzz" />
    <span>name is newsletter</span>

  </div>
  <div>
    <input type="radio" value="Cold Fusion" />
    <span>no name</span>

  </div>
  <div>
    <input type="radio" name="accept" value="Evil Plans" />

    <span>name is accept</span>
  </div>
  <script>$("input[name!=newsletter]").next().append("<b>; not newsletter</b>");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


attributeEquals – jQuery API

Returns: JQuery("[attribute=value]")

Categories: Attribute, Version 1.0
Description: Selects elements that have the specified attribute with a value exactly equal to a certain value.
  • version added: 1.0

  • JQuery("[attribute=value]")

  • attribute An attribute name.
  • value An attribute value. Quotes are optional.

Examples:

Example:

Finds all inputs with name 'newsletter' and changes the text of the span next to it.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>

    <input type="radio" name="newsletter" value="Hot Fuzz" />
    <span>name?</span>

  </div>
  <div>
    <input type="radio" name="newsletters" value="Cold Fusion" />

    <span>name?</span>
  </div>
  <div>
    <input type="radio" name="accept" value="Evil Plans" />

    <span>name?</span>
  </div>
  <script>$("input[name='newsletter']").next().text(" is newsletter");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


attributeHas – jQuery API

Returns: JQuery("[attribute]")

Categories: Attribute, Version 1.0
Description: Selects elements that have the specified attribute, with any value.
  • version added: 1.0

  • JQuery("[attribute]")

  • attribute An attribute name.

Examples:

Example:

Bind a single click that adds the div id to its text.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>no id</div>
  <div id="hey">with id</div>

  <div id="there">has an id</div>
  <div>nope</div>
  <script>

    $("div[id]").one("click", function(){
      var idString = $(this).text() + " = " + $(this).attr("id");
      $(this).text(idString);
    });
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Basic – jQuery API

Basic

  • JQuery("selector1, selector2, selectorN")

    New in 1.0 !

    Selects the combined results of all the specified selectors.

  • JQuery("*")

    New in 1.0 !

    Selects all elements.

  • JQuery(".class")

    New in 1.0 !

    Selects all elements with the given class.

  • JQuery("element")

    New in 1.0 !

    Selects all elements with the given tag name.

  • JQuery("#id")

    New in 1.0 !

    Selects a single element with the given id attribute.


multiple – jQuery API

Returns: JQuery("selector1, selector2, selectorN")

Categories: Basic, Version 1.0
Description: Selects the combined results of all the specified selectors.
  • version added: 1.0

  • JQuery("selector1, selector2, selectorN")

  • selector1 Any valid selector.
  • selector2 Another valid selector.
  • selectorN As many more valid selectors as you like.

You can specify any number of selectors to combine into a single result. This multiple expression combinator is an efficient way to select disparate elements. The order of the DOM elements in the returned jQuery object may not be identical, as they will be in document order. An alternative to this combinator is the . method.

Examples:

Example:

Finds the elements that match any of these three selectors.
<!DOCTYPE html>
<html>
<head>
  <style>
  div,span,p {
    width: 126px;
    height: 60px;
    float:left;
    padding: 3px;
    margin: 2px;
    background-color: #EEEEEE;
    font-size:14px;
  }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>div</div>

  <p class="myClass">p class="myClass"</p>
  <p class="notMyClass">p class="notMyClass"</p>
  <span>span</span>
  <script>$("div,span,p.myClass").css("border","3px solid red");</script>
</body>
</html>

Demo:

Example:

Show the order in the jQuery object.
<!DOCTYPE html>
<html>
<head>
  <style>
  b { color:red; font-size:16px; display:block; clear:left; }
  div,span,p { width: 40px; height: 40px; float:left;
               margin: 10px; background-color: blue;
               padding:3px; color:white;
             }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <span>span</span>

  <p>p</p>
  <p>p</p>
  <div>div</div>
  <span>span</span>

  <p>p</p>
  <div>div</div>
  <b></b>
  <script>
    var list = $("div,p,span").map(function () {
      return this.tagName;
    }).get().join(", ");
    $("b").append(document.createTextNode(list));
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


all – jQuery API

Returns: JQuery("*")

Categories: Basic, Version 1.0
Description: Selects all elements.
  • version added: 1.0

  • JQuery("*")

Caution: The all, or universal, selector is extremely slow, except when used by itself.

Examples:

Example:

Finds every element (including head, body, etc) in the document.
<!DOCTYPE html>
<html>
<head>
  <style>
  h3 { margin: 0; }
  div,span,p {
    width: 80px;
    height: 40px;
    float:left;
    padding: 10px;
    margin: 10px;
    background-color: #EEEEEE;
  }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>DIV</div>

  <span>SPAN</span>
  <p>P <button>Button</button></p>
  <script>var elementCount = $("*").css("border","3px solid red").length;
$("body").prepend("<h3>" + elementCount + " elements found</h3>");</script>
</body>
</html>

Demo:

Example:

A common way to select all elements is to find within document.body so elements like head, script, etc are left out.
<!DOCTYPE html>
<html>
<head>
  <style>
  h3 { margin: 0; }
  div,span,p {
    width: 80px;
    height: 40px;
    float:left;
    padding: 10px;
    margin: 10px;
    background-color: #EEEEEE;
  }
  #test {
    width: auto; height: auto; background-color: transparent;
  }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div id="test">
  <div>DIV</div>
  <span>SPAN</span>
  <p>P <button>Button</button></p>
</div>
  <script>
var elementCount = $("#test").find("*").css("border","3px solid red").length;
$("body").prepend("<h3>" + elementCount + " elements found</h3>");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


class – jQuery API

Returns: JQuery(".class")

Categories: Basic, Version 1.0
Description: Selects all elements with the given class.
  • version added: 1.0

  • JQuery(".class")

  • class A class to search for. An element can have multiple classes; only one of them must match.

For class selectors, jQuery uses JavaScript's native function if the browser supports it.

Examples:

Example:

Finds the element with the class "myClass".
<!DOCTYPE html>
<html>
<head>
  <style>
  div,span {
    width: 100px;
    height: 40px;
    float:left;
    padding: 10px;
    margin: 10px;
    background-color: #EEEEEE;
  }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div class="notMe">div class="notMe"</div>

  <div class="myClass">div class="myClass"</div>
  <span class="myClass">span class="myClass"</span>
  <script>$(".myClass").css("border","3px solid red");</script>
</body>
</html>

Demo:

Example:

Finds the element with both "myclass" and "otherclass" classes.
<!DOCTYPE html>
<html>
<head>
  <style>
  div,span {
    width: 100px;
    height: 40px;
    float:left;
    padding: 10px;
    margin: 10px;
    background-color: #EEEEEE;
  }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div class="myclass">div class="notMe"</div>

  <div class="myclass otherclass">div class="myClass"</div>
  <span class="myclass otherclass">span class="myClass"</span>
  <script>$(".myclass.otherclass").css("border","13px solid red");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


element – jQuery API

Returns: JQuery("element")

Categories: Basic, Version 1.0
Description: Selects all elements with the given tag name.
  • version added: 1.0

  • JQuery("element")

  • element An element to search for. Refers to the tagName of DOM nodes.

JavaScript's function is called to return the appropriate elements when this expression is used.

Examples:

Example:

Finds every DIV element.
<!DOCTYPE html>
<html>
<head>
  <style>
  div,span {
    width: 60px;
    height: 60px;
    float:left;
    padding: 10px;
    margin: 10px;
    background-color: #EEEEEE;
  }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>DIV1</div>

  <div>DIV2</div>
  <span>SPAN</span>
  <script>$("div").css("border","9px solid red");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


id – jQuery API

Returns: JQuery("#id")

Categories: Basic, Version 1.0
Description: Selects a single element with the given id attribute.
  • version added: 1.0

  • JQuery("#id")

  • id An ID to search for, specified via the id attribute of an element.

For id selectors, jQuery uses the JavaScript function , which is extremely efficient. When another selector is attached to the id selector, such as , jQuery performs an additional check before identifying the element as a match.

Each value must be used only once within a document. If more than one element has been assigned the same ID, queries that use that ID will only select the first matched element in the DOM. This behavior should not be relied on, however; a document with more than one element using the same ID is invalid.

If the id contains characters like periods or colons you have to .

Examples:

Example:

Finds the element with the id "myDiv".
<!DOCTYPE html>
<html>
<head>
  <style>
  div {
    width: 90px;
    height: 90px;
    float:left;
    padding: 5px;
    margin: 5px;
    background-color: #EEEEEE;
  }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div id="notMe"><p>id="notMe"</p></div>

  <div id="myDiv">id="myDiv"</div>
  <script>$("#myDiv").css("border","3px solid red");</script>
</body>
</html>

Demo:

Example:

Finds the element with the id "myID.entry[1]". See how certain characters must be escaped with backslashes.
<!DOCTYPE html>
<html>
<head>
  <style>
  div {
    width: 300px;
    float:left;
    padding: 2px;
    margin: 3px;
    background-color: #EEEEEE;
  }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div id="myID.entry[0]">id="myID.entry[0]"</div>

  <div id="myID.entry[1]">id="myID.entry[1]"</div>
  <div id="myID.entry[2]">id="myID.entry[2]"</div>
  <script>$("#myID\\.entry\\[1\\]").css("border","3px solid red");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Basic Filter – jQuery API

Basic Filter

  • JQuery(":animated")

    New in 1.2 !

    Select all elements that are in the progress of an animation at the time the selector is run.

  • JQuery(":header")

    New in 1.2 !

    Selects all elements that are headers, like h1, h2, h3 and so on.

  • JQuery(":lt(index)")

    New in 1.0 !

    Select all elements at an index less than within the matched set.

  • JQuery(":gt(index)")

    New in 1.0 !

    Select all elements at an index greater than within the matched set.

  • JQuery(":eq(index)")

    New in 1.0 !

    Select the element at index within the matched set.

  • JQuery(":odd")

    New in 1.0 !

    Selects odd elements, zero-indexed. See also .

  • JQuery(":even")

    New in 1.0 !

    Selects even elements, zero-indexed. See also .

  • JQuery(":not(selector)")

    New in 1.0 !

    Selects all elements that do not match the given selector.

  • JQuery(":last")

    New in 1.0 !

    Selects the last matched element.

  • JQuery(":first")

    New in 1.0 !

    Selects the first matched element.


animated – jQuery API

Returns: JQuery(":animated")

Categories: Basic Filter, Version 1.2
Description: Select all elements that are in the progress of an animation at the time the selector is run.
  • version added: 1.2

  • JQuery(":animated")

Examples:

Example:

Change the color of any div that is animated.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { background:yellow; border:1px solid #AAA; width:80px; height:80px; margin:0 5px; float:left; }
  div.colored { background:green; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button id="run">Run</button>

  <div></div>
  <div id="mover"></div>
  <div></div>
  <script>

    $("#run").click(function(){
      $("div:animated").toggleClass("colored");
    });
    function animateIt() {
      $("#mover").slideToggle("slow", animateIt);
    }
    animateIt();
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


header – jQuery API

Returns: JQuery(":header")

Categories: Basic Filter, Version 1.2
Description: Selects all elements that are headers, like h1, h2, h3 and so on.
  • version added: 1.2

  • JQuery(":header")

Examples:

Example:

Adds a background and text color to all the headers on the page.
<!DOCTYPE html>
<html>
<head>
  <style>
  body { font-size: 10px; font-family: Arial; }
  h1, h2 { margin: 3px 0; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <h1>Header 1</h1>

  <p>Contents 1</p>
  <h2>Header 2</h2>
  <p>Contents 2</p>
  <script>$(":header").css({ background:'#CCC', color:'blue' });</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


lt – jQuery API

Returns: JQuery(":lt(index)")

Categories: Basic Filter, Version 1.0
Description: Select all elements at an index less than within the matched set.
  • version added: 1.0

  • JQuery(":lt(index)")

  • index Zero-based index.

The index-related selectors (including this "less than" selector) filter the set of elements that have matched the expressions that precede them. They narrow the set down based on the order of the elements within this matched set. For example, if elements are first selected with a class selector () and four elements are returned, these elements are given indices 0 through 3 for the purposes of these selectors.

Note that since JavaScript arrays use , these selectors reflect that fact. This is why selects the first element in the document with the class , rather than selecting no elements. In contrast, uses to conform to the CSS specification.

Examples:

Example:

Finds TDs less than the one with the 4th index (TD#4).
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <table border="1">

  <tr><td>TD #0</td><td>TD #1</td><td>TD #2</td></tr>
  <tr><td>TD #3</td><td>TD #4</td><td>TD #5</td></tr>

  <tr><td>TD #6</td><td>TD #7</td><td>TD #8</td></tr>
</table>
  <script>$("td:lt(4)").css("color", "red");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


gt – jQuery API

Returns: JQuery(":gt(index)")

Categories: Basic Filter, Version 1.0
Description: Select all elements at an index greater than within the matched set.
  • version added: 1.0

  • JQuery(":gt(index)")

The index-related selector expressions (including this "greater than" selector) filter the set of elements that have matched the expressions that precede them. They narrow the set down based on the order of the elements within this matched set. For example, if elements are first selected with a class selector () and four elements are returned, these elements are given indices 0 through 3 for the purposes of these selectors.

Note that since JavaScript arrays use , these selectors reflect that fact. This is why selects elements after the second element in the document with the class , rather than after the first. In contrast, uses to conform to the CSS specification.

Examples:

Example:

Finds TD #5 and higher. Reminder: the indexing starts at 0.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <table border="1">

    <tr><td>TD #0</td><td>TD #1</td><td>TD #2</td></tr>
    <tr><td>TD #3</td><td>TD #4</td><td>TD #5</td></tr>

    <tr><td>TD #6</td><td>TD #7</td><td>TD #8</td></tr>
  </table>
  <script>$("td:gt(4)").css("text-decoration", "line-through");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


eq – jQuery API

Returns: JQuery(":eq(index)")

Categories: Basic Filter, Version 1.0
Description: Select the element at index within the matched set.
  • version added: 1.0

  • JQuery(":eq(index)")

  • index Zero-based index of the element to match.

The index-related selectors (, , , , ) filter the set of elements that have matched the expressions that precede them. They narrow the set down based on the order of the elements within this matched set. For example, if elements are first selected with a class selector () and four elements are returned, these elements are given indices through for the purposes of these selectors.

Note that since JavaScript arrays use , these selectors reflect that fact. This is why selects the second element in the document with the class myclass, rather than the first. In contrast, uses to conform to the CSS specification.

Examples:

Example:

Finds the third td.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <table border="1">
  <tr><td>TD #0</td><td>TD #1</td><td>TD #2</td></tr>
  <tr><td>TD #3</td><td>TD #4</td><td>TD #5</td></tr>
  <tr><td>TD #6</td><td>TD #7</td><td>TD #8</td></tr>
</table>
  <script>$("td:eq(2)").css("color", "red");</script>
</body>
</html>

Demo:

Returns: jQueryjQuery .eq( [Integer] -index )

Categories: Filtering, Version 1.1.2
Description: Reduce the set of matched elements to the one at the specified index.
  • version added: 1.1.2

  • .eq( [Integer] index )

  • index An integer indicating the 0-based position of the element.
  • version added: 1.4

  • .eq( [Integer] -index )

  • -index An integer indicating the position of the element, counting backwards from the last element in the set.

Given a jQuery object that represents a set of DOM elements, the method constructs a new jQuery object from one of the matching elements. The supplied index identifies the position of this element in the set.

Consider a page with a simple list on it:

  <ul>
    <li>list item 1</li>
    <li>list item 2</li>
    <li>list item 3</li>
    <li>list item 4</li>
    <li>list item 5</li>
  </ul>

We can apply this method to the set of list items:

  $('li').eq(2).css('background-color', 'red');

The result of this call is a red background for item 3. Note that the supplied index is zero-based, and refers to the position of the element within the jQuery object, not within the DOM tree.

If a negative number is provided, this indicates a position starting from the end of the set, rather than the beginning. For example:

  $('li').eq(-2).css('background-color', 'red');

This time list item 4 is turned red, since it is two from the end of the set.

Examples:

Example:

Turn the div with index 2 blue by adding an appropriate class.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { width:60px; height:60px; margin:10px; float:left;
        border:2px solid blue; }
  .blue { background:blue; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div></div>
  <div></div>
  <div></div>

  <div></div>
  <div></div>
  <div></div>
  <script>

    $("div").eq(2).addClass("blue");
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


odd – jQuery API

Returns: JQuery(":odd")

Categories: Basic Filter, Version 1.0
Description: Selects odd elements, zero-indexed. See also .
  • version added: 1.0

  • JQuery(":odd")

In particular, note that the means that, counter-intuitively, selects the second element, fourth element, and so on within the matched set.

Examples:

Example:

Finds odd table rows, matching the second, fourth and so on (index 1, 3, 5 etc.).
<!DOCTYPE html>
<html>
<head>
  <style>
  table {
    background:#f3f7f5;
  }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <table border="1">
    <tr><td>Row with Index #0</td></tr>
    <tr><td>Row with Index #1</td></tr>

    <tr><td>Row with Index #2</td></tr>
    <tr><td>Row with Index #3</td></tr>
  </table>
  <script>$("tr:odd").css("background-color", "#bbbbff");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


even – jQuery API

Returns: JQuery(":even")

Categories: Basic Filter, Version 1.0
Description: Selects even elements, zero-indexed. See also .
  • version added: 1.0

  • JQuery(":even")

In particular, note that the means that, counter-intuitively, selects the first element, third element, and so on within the matched set.

Examples:

Example:

Finds even table rows, matching the first, third and so on (index 0, 2, 4 etc.).
<!DOCTYPE html>
<html>
<head>
  <style>
  table {
    background:#eeeeee;
  }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <table border="1">
    <tr><td>Row with Index #0</td></tr>
    <tr><td>Row with Index #1</td></tr>

    <tr><td>Row with Index #2</td></tr>
    <tr><td>Row with Index #3</td></tr>
  </table>
  <script>$("tr:even").css("background-color", "#bbbbff");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


not – jQuery API

Returns: JQuery(":not(selector)")

Categories: Basic Filter, Version 1.0
Description: Selects all elements that do not match the given selector.
  • version added: 1.0

  • JQuery(":not(selector)")

  • selector A selector with which to filter by.

All selectors are accepted inside , for example: and .

Examples:

Example:

Finds all inputs that are not checked and highlights the next sibling span. Notice there is no change when clicking the checkboxes since no click events have been linked.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>
  <input type="checkbox" name="a" />
  <span>Mary</span>
</div>

<div>
  <input type="checkbox" name="b" />
  <span>lcm</span>

</div>
<div>
  <input type="checkbox" name="c" checked="checked" />

  <span>Peter</span>
</div>
  <script>
  $("input:not(:checked) + span").css("background-color", "yellow");
  $("input").attr("disabled", "disabled");

</script>
</body>
</html>

Demo:

Returns: jQueryjQuery .not( [Function] function(index) )

Categories: Filtering, Version 1.0, Version 1.4
Description: Remove elements from the set of matched elements.
  • version added: 1.0

  • .not( [Selector] selector )

  • selector A string containing a selector expression to match elements against.
  • version added: 1.0

  • .not( [Elements] elements )

  • elements One or more DOM elements to remove from the matched set.
  • version added: 1.4

  • .not( [Function] function(index) )

  • function(index) A function used as a test for each element in the set. is the current DOM element.

Given a jQuery object that represents a set of DOM elements, the method constructs a new jQuery object from a subset of the matching elements. The supplied selector is tested against each element; the elements that don't match the selector will be included in the result.

Consider a page with a simple list on it:

<ul>
  <li>list item 1</li>
  <li>list item 2</li>
  <li>list item 3</li>
  <li>list item 4</li>
  <li>list item 5</li>
</ul>

We can apply this method to the set of list items:

$('li').not(':even').css('background-color', 'red');

The result of this call is a red background for items 2 and 4, as they do not match the selector (recall that :even and :odd use 0-based indexing).

Removing Specific Elements

The second version of the method allows us to remove elements from the matched set, assuming we have found those elements previously by some other means. For example, suppose our list had an id applied to one of its items:

<ul>
  <li>list item 1</li>
  <li>list item 2</li>
  <li id="notli">list item 3</li>
  <li>list item 4</li>
  <li>list item 5</li>
</ul>

We can fetch the third list item using the native JavaScript function, then remove it from a jQuery object:

$('li').not(document.getElementById('notli'))
  .css('background-color', 'red');

This statement changes the color of items 1, 2, 4, and 5. We could have accomplished the same thing with a simpler jQuery expression, but this technique can be useful when, for example, other libraries provide references to plain DOM nodes.

As of jQuery 1.4, the method can take a function as its argument in the same way that does. Elements for which the function returns are excluded from the filtered set; all other elements are included.

Examples:

Example:

Adds a border to divs that are not green or blue.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { width:50px; height:50px; margin:10px; float:left;
        background:yellow; border:2px solid white; }
  .green { background:#8f8; }
  .gray { background:#ccc; }
  #blueone { background:#99f; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div></div>
  <div id="blueone"></div>
  <div></div>
  <div class="green"></div>

  <div class="green"></div>
  <div class="gray"></div>
  <div></div>
  <script>
    $("div").not(".green, #blueone")
            .css("border-color", "red");

</script>
</body>
</html>

Demo:

Example:

Removes the element with the ID "selected" from the set of all paragraphs.
<script>$("p").not( $("#selected")[0] )</script>

Example:

Removes the element with the ID "selected" from the set of all paragraphs.
<script>$("p").not("#selected")</script>

Example:

Removes all elements that match "div p.selected" from the total set of all paragraphs.
<script>$("p").not($("div p.selected"))</script>

Comments

© 2010 The jQuery Project


last – jQuery API

Returns: JQuery(":last")

Categories: Basic Filter, Version 1.0
Description: Selects the last matched element.
  • version added: 1.0

  • JQuery(":last")

Note that selects a single element by filtering the current jQuery collection and matching the last element within it.

Examples:

Example:

Finds the last table row.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <table>

    <tr><td>First Row</td></tr>
    <tr><td>Middle Row</td></tr>
    <tr><td>Last Row</td></tr>

  </table>
  <script>$("tr:last").css({backgroundColor: 'yellow', fontWeight: 'bolder'});</script>
</body>
</html>

Demo:

Returns: jQueryjQuery .last( )

Categories: Filtering, Version 1.4
Description: Reduce the set of matched elements to the final one in the set.
  • version added: 1.4

  • .last( )

Given a jQuery object that represents a set of DOM elements, the method constructs a new jQuery object from the last matching element.

Consider a page with a simple list on it:

<ul>
  <li>list item 1</li>
  <li>list item 2</li>
  <li>list item 3</li>
  <li>list item 4</li>
  <li>list item 5</li>
</ul>

We can apply this method to the set of list items:

$('li').last().css('background-color', 'red');

The result of this call is a red background for the final item.

Examples:

Example:

Highlight the last span in a paragraph.
<!DOCTYPE html>
<html>
<head>
  <style>
.highlight{background-color: yellow}</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p><span>Look:</span> <span>This is some text in a paragraph.</span> <span>This is a note about it.</span></p>
  <script>$("p span").last().addClass('highlight');</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


first – jQuery API

Returns: JQuery(":first")

Categories: Basic Filter, Version 1.0
Description: Selects the first matched element.
  • version added: 1.0

  • JQuery(":first")

The pseudo-class is equivalent to . It could also be written as . While this matches only a single element, can match more than one: One for each parent.

Examples:

Example:

Finds the first table row.
<!DOCTYPE html>
<html>
<head>
  <style>
  td { color:blue; font-weight:bold; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <table>
    <tr><td>Row 1</td></tr>
    <tr><td>Row 2</td></tr>

    <tr><td>Row 3</td></tr>
  </table>
  <script>$("tr:first").css("font-style", "italic");</script>
</body>
</html>

Demo:

Returns: jQueryjQuery .first( )

Categories: Filtering, Version 1.4
Description: Reduce the set of matched elements to the first in the set.
  • version added: 1.4

  • .first( )

Given a jQuery object that represents a set of DOM elements, the method constructs a new jQuery object from the first matching element.

Consider a page with a simple list on it:

<ul>
  <li>list item 1</li>
  <li>list item 2</li>
  <li>list item 3</li>
  <li>list item 4</li>
  <li>list item 5</li>
</ul>

We can apply this method to the set of list items:

$('li').first().css('background-color', 'red');

The result of this call is a red background for the first item.

Examples:

Example:

Highlight the first span in a paragraph.
<!DOCTYPE html>
<html>
<head>
  <style>
.highlight{background-color: yellow}</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p><span>Look:</span> <span>This is some text in a paragraph.</span> <span>This is a note about it.</span></p>
  <script>$("p span").first().addClass('highlight');</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Child Filter – jQuery API

Child Filter

  • JQuery(":only-child")

    New in 1.1.4 !

    Selects all elements that are the only child of their parent.

  • JQuery(":last-child")

    New in 1.1.4 !

    Selects all elements that are the last child of their parent.

  • JQuery(":first-child")

    New in 1.1.4 !

    Selects all elements that are the first child of their parent.

  • JQuery(":nth-child(index/even/odd/equation)")

    New in 1.1.4 !

    Selects all elements that are the nth-child of their parent.


only-child – jQuery API

Returns: JQuery(":only-child")

Categories: Child Filter, Version 1.1.4
Description: Selects all elements that are the only child of their parent.
  • version added: 1.1.4

  • JQuery(":only-child")

If the parent has other child elements, nothing is matched.

Examples:

Example:

Finds the button with no siblings in each matched div and modifies look.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { width:100px; height:80px; margin:5px; float:left; background:#b9e }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>
    <button>Sibling!</button>
    <button>Sibling!</button>
  </div>

  <div>
    <button>Sibling!</button>
  </div>
  <div>
    None
  </div>

  <div>
    <button>Sibling!</button>
    <button>Sibling!</button>
    <button>Sibling!</button>

  </div>
  <div>
    <button>Sibling!</button>
  </div>
  <script>$("div button:only-child").text("Alone").css("border", "2px blue solid");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


last-child – jQuery API

Returns: JQuery(":last-child")

Categories: Child Filter, Version 1.1.4
Description: Selects all elements that are the last child of their parent.
  • version added: 1.1.4

  • JQuery(":last-child")

While matches only a single element, can match more than one: one for each parent.

Examples:

Example:

Finds the last span in each matched div and adds some css plus a hover state.
<!DOCTYPE html>
<html>
<head>
  <style>
  span.solast { text-decoration:line-through; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>
    <span>John,</span>
    <span>Karl,</span>
    <span>Brandon,</span>

    <span>Sam</span>
  </div>
  <div>
    <span>Glen,</span>
    <span>Tane,</span>

    <span>Ralph,</span>
    <span>David</span>
  </div>
  <script>
    $("div span:last-child")
        .css({color:"red", fontSize:"80%"})
        .hover(function () {
              $(this).addClass("solast");
            }, function () {
              $(this).removeClass("solast");
            });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


first-child – jQuery API

Returns: JQuery(":first-child")

Categories: Child Filter, Version 1.1.4
Description: Selects all elements that are the first child of their parent.
  • version added: 1.1.4

  • JQuery(":first-child")

While matches only a single element, the selector can match more than one: one for each parent. This is equivalent to .

Examples:

Example:

Finds the first span in each matched div to underline and add a hover state.
<!DOCTYPE html>
<html>
<head>
  <style>
  span { color:#008; }
  span.sogreen { color:green; font-weight: bolder; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>
    <span>John,</span>
    <span>Karl,</span>
    <span>Brandon</span>

  </div>
  <div>
    <span>Glen,</span>
    <span>Tane,</span>
    <span>Ralph</span>

  </div>
  <script>
    $("div span:first-child")
        .css("text-decoration", "underline")
        .hover(function () {
              $(this).addClass("sogreen");
            }, function () {
              $(this).removeClass("sogreen");
            });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


nth-child – jQuery API

Returns: JQuery(":nth-child(index/even/odd/equation)")

Categories: Child Filter, Version 1.1.4
Description: Selects all elements that are the nth-child of their parent.
  • version added: 1.1.4

  • JQuery(":nth-child(index/even/odd/equation)")

  • index The index of each child to match, starting with , the string or , or an equation ( eg. , )

Because jQuery's implementation of is strictly derived from the CSS specification, the value of is "1-indexed", meaning that the counting starts at 1. For all other selector expressions, however, jQuery follows JavaScript's "0-indexed" counting. Therefore, given a single containing two s, selects the first while selects the second.

The pseudo-class is easily confused with , even though the two can result in dramatically different matched elements. With , all children are counted, regardless of what they are, and the specified element is selected only if it matches the selector attached to the pseudo-class. With only the selector attached to the pseudo-class is counted, not limited to children of any other element, and the (n+1)th one (n is 0-based) is selected.

Further discussion of this unusual usage can be found in the .

Examples:

Example:

Finds the second li in each matched ul and notes it.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { float:left; }
  span { color:blue; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div><ul>
    <li>John</li>
    <li>Karl</li>
    <li>Brandon</li>

  </ul></div>
  <div><ul>
    <li>Sam</li>
  </ul></div>

  <div><ul>
    <li>Glen</li>
    <li>Tane</li>
    <li>Ralph</li>

    <li>David</li>
  </ul></div>
  <script>$("ul li:nth-child(2)").append("<span> - 2nd!</span>");</script>
</body>
</html>

Demo:

Example:

This is a playground to see how the selector works with different strings. Notice that this is different from the :even and :odd which have no regard for parent and just filter the list of elements to every other one. The :nth-child, however, counts the index of the child to its particular parent. In any case, it's easier to see than explain so...
<!DOCTYPE html>
<html>
<head>
  <style>
  button { display:block; font-size:12px; width:100px; }
  div { float:left; margin:10px; font-size:10px;
        border:1px solid black; }
  span { color:blue; font-size:18px; }
  #inner { color:red; }
  td { width:50px; text-align:center; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>
    <button>:nth-child(even)</button>
    <button>:nth-child(odd)</button>
    <button>:nth-child(3n)</button>

    <button>:nth-child(2)</button>
  </div>
  <div>
    <button>:nth-child(3n+1)</button>
    <button>:nth-child(3n+2)</button>

    <button>:even</button>
    <button>:odd</button>
  </div>
  <div><table>

    <tr><td>John</td></tr>
    <tr><td>Karl</td></tr>
    <tr><td>Brandon</td></tr>

    <tr><td>Benjamin</td></tr>
  </table></div>
  <div><table>
    <tr><td>Sam</td></tr>

  </table></div>
  <div><table>
    <tr><td>Glen</td></tr>
    <tr><td>Tane</td></tr>

    <tr><td>Ralph</td></tr>
    <tr><td>David</td></tr>
    <tr><td>Mike</td></tr>

    <tr><td>Dan</td></tr>
  </table></div>
  <span>
    tr<span id="inner"></span>

  </span>
  <script>
    $("button").click(function () {
      var str = $(this).text();
      $("tr").css("background", "white");
      $("tr" + str).css("background", "#ff0000");
      $("#inner").text(str);
    });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Content Filter – jQuery API

Content Filter

  • JQuery(":parent")

    New in 1.0 !

    Select all elements that are the parent of another element, including text nodes.

  • JQuery(":has(selector)")

    New in 1.1.4 !

    Selects elements which contain at least one element that matches the specified selector.

  • JQuery(":empty")

    New in 1.0 !

    Select all elements that have no children (including text nodes).

  • JQuery(":contains(text)")

    New in 1.1.4 !

    Select all elements that contain the specified text.


parent – jQuery API

Returns: JQuery(":parent")

Categories: Content Filter, Version 1.0
Description: Select all elements that are the parent of another element, including text nodes.
  • version added: 1.0

  • JQuery(":parent")

This is the inverse of .

One important thing to note regarding the use of (and ) is that child elements include text nodes.

The W3C recommends that the element have at least one child node, even if that child is merely text (see ). Some other elements, on the other hand, are empty (i.e. have no children) by definition:, , , and , for example.

Examples:

Example:

Finds all tds with children, including text.
<!DOCTYPE html>
<html>
<head>
  <style>
  td { width:40px; background:green; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <table border="1">

  <tr><td>Value 1</td><td></td></tr>
  <tr><td>Value 2</td><td></td></tr>

</table>
  <script>$("td:parent").fadeTo(1500, 0.3);</script>
</body>
</html>

Demo:

Returns: jQueryjQuery .parent( [Selector] selector )

Categories: Tree Traversal, Version 1.0
Description: Get the parent of each element in the current set of matched elements, optionally filtered by a selector.
  • version added: 1.0

  • .parent( [Selector] selector )

  • selector A string containing a selector expression to match elements against.

Given a jQuery object that represents a set of DOM elements, the method allows us to search through the parents of these elements in the DOM tree and construct a new jQuery object from the matching elements. The and methods are similar, except that the latter only travels a single level up the DOM tree.

The method optionally accepts a selector expression of the same type that we can pass to the function. If the selector is supplied, the elements will be filtered by testing whether they match it.

Consider a page with a basic nested list on it:

<ul class="level-1">
  <li class="item-i">I</li>
  <li class="item-ii">II
    <ul class="level-2">
      <li class="item-a">A</li>
      <li class="item-b">B
        <ul class="level-3">
          <li class="item-1">1</li>
          <li class="item-2">2</li>
          <li class="item-3">3</li>
        </ul>
      </li>
      <li class="item-c">C</li>
    </ul>
  </li>
  <li class="item-iii">III</li>
</ul>

If we begin at item A, we can find its parents:

$('li.item-a').parent().css('background-color', 'red');

The result of this call is a red background for the level-2 list. Since we do not supply a selector expression, the parent element is unequivocally included as part of the object. If we had supplied one, the element would be tested for a match before it was included.

Examples:

Example:

Shows the parent of each element as (parent > child). Check the View Source to see the raw html.
<!DOCTYPE html>
<html>
<head>
  <style>
  div,p { margin:10px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>div,
    <span>span, </span>
    <b>b </b>

  </div>
  <p>p,
    <span>span,
      <em>em </em>
    </span>
  </p>

  <div>div,
    <strong>strong,
      <span>span, </span>
      <em>em,
        <b>b, </b>
      </em>

    </strong>
    <b>b </b>
  </div>
  <script>

    $("*", document.body).each(function () {
      var parentTag = $(this).parent().get(0).tagName;
      $(this).prepend(document.createTextNode(parentTag + " > "));
    });
</script>
</body>
</html>

Demo:

Example:

Find the parent element of each paragraph with a class "selected".
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div><p>Hello</p></div>

  <div class="selected"><p>Hello Again</p></div>

  <script>$("p").parent(".selected").css("background", "yellow");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


has – jQuery API

Returns: jQueryjQuery .has( [Element] contained )

Categories: Filtering, Version 1.4
Description: Reduce the set of matched elements to those that have a descendant that matches the selector or DOM element.
  • version added: 1.4

  • .has( [String] selector )

  • selector A string containing a selector expression to match elements against.
  • version added: 1.4

  • .has( [Element] contained )

  • contained A DOM element to match elements against.

Given a jQuery object that represents a set of DOM elements, the method constructs a new jQuery object from a subset of the matching elements. The supplied selector is tested against the descendants of the matching elements; the element will be included in the result if any of its descendant elements matches the selector.

Consider a page with a nested list as follows:

 <ul>
  <li>list item 1</li>
  <li>list item 2
    <ul>
      <li>list item 2-a</li>
      <li>list item 2-b</li>
    </ul>
  </li>
  <li>list item 3</li>
  <li>list item 4</li>
</ul>

We can apply this method to the set of list items as follows:

$('li').has('ul').css('background-color', 'red');

The result of this call is a red background for item 2, as it is the only that has a among its descendants.

Examples:

Example:

Check if an element is inside another.
<!DOCTYPE html>
<html>
<head>
  <style>
  .full { border: 1px solid red; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<ul><li>Does the UL contain an LI?</li></ul>

  <script>
  $("ul").append("<li>" + ($("ul").has("li").length ? "Yes" : "No") + "</li>");
  $("ul").has("li").addClass("full");
</script>
</body>
</html>

Demo:

Returns: JQuery(":has(selector)")

Categories: Content Filter, Version 1.1.4
Description: Selects elements which contain at least one element that matches the specified selector.
  • version added: 1.1.4

  • JQuery(":has(selector)")

The expression matches a if a exists anywhere among its descendants, not just as a direct child.

Examples:

Example:

Adds the class "test" to all divs that have a paragraph inside of them.
<!DOCTYPE html>
<html>
<head>
  <style>
  .test{ border: 3px inset red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div><p>Hello in a paragraph</p></div>

  <div>Hello again! (with no paragraph)</div>
  <script>$("div:has(p)").addClass("test");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


contains – jQuery API

Returns: JQuery(":contains(text)")

Categories: Content Filter, Version 1.1.4
Description: Select all elements that contain the specified text.
  • version added: 1.1.4

  • JQuery(":contains(text)")

The matching text can appear directly within the selected element, in any of that element's descendants, or a combination thereof. As with attribute value selectors, text inside the parentheses of can be written as bare words or surrounded by quotation marks. The text must have matching case to be selected.

Examples:

Example:

Finds all divs containing "John" and underlines them.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<div>John Resig</div>

<div>George Martin</div>
<div>Malcom John Sinclair</div>
<div>J. Ohn</div>

  <script>
$("div:contains('John')").css("text-decoration", "underline");
    </script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Form – jQuery API

Form

  • JQuery(":selected")

    New in 1.0 !

    Selects all elements that are selected.

  • JQuery(":checked")

    New in 1.0 !

    Matches all elements that are checked.

  • JQuery(":disabled")

    New in 1.0 !

    Selects all elements that are disabled.

  • JQuery(":enabled")

    New in 1.0 !

    Selects all elements that are enabled.

  • JQuery(":file")

    New in 1.0 !

    Selects all elements of type file.

  • JQuery(":button")

    New in 1.0 !

    Selects all button elements and elements of type button.

  • JQuery(":reset")

    New in 1.0 !

    Selects all elements of type reset.

  • JQuery(":image")

    New in 1.0 !

    Selects all elements of type image.

  • JQuery(":submit")

    New in 1.0 !

    Selects all elements of type submit.

  • JQuery(":checkbox")

    New in 1.0 !

    Selects all elements of type checkbox.

  • JQuery(":radio")

    New in 1.0 !

    Selects all elements of type radio.

  • JQuery(":password")

    New in 1.0 !

    Selects all elements of type password.

  • JQuery(":text")

    New in 1.0 !

    Selects all elements of type text.

  • JQuery(":input")

    New in 1.0 !

    Selects all input, textarea, select and button elements.


selected – jQuery API

Returns: JQuery(":selected")

Categories: Form, Version 1.0
Description: Selects all elements that are selected.
  • version added: 1.0

  • JQuery(":selected")

The selector works for elements. It does not work for checkboxes or radio inputs; use for them.

Examples:

Example:

Attaches a change event to the select that gets the text for each selected option and writes them in the div. It then triggers the event for the initial text draw.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <select name="garden" multiple="multiple">

    <option>Flowers</option>
    <option selected="selected">Shrubs</option>
    <option>Trees</option>
    <option selected="selected">Bushes</option>

    <option>Grass</option>
    <option>Dirt</option>
  </select>
  <div></div>
  <script>

    $("select").change(function () {
          var str = "";
          $("select option:selected").each(function () {
                str += $(this).text() + " ";
              });
          $("div").text(str);
        })
        .trigger('change');
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


checked – jQuery API

Returns: JQuery(":checked")

Categories: Form, Version 1.0
Description: Matches all elements that are checked.
  • version added: 1.0

  • JQuery(":checked")

The selector works for checkboxes and radio buttons. For select elements, use the selector.

Examples:

Example:

Finds all input elements that are checked.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <form>
    <input type="checkbox" name="newsletter" checked="checked" value="Hourly" />

    <input type="checkbox" name="newsletter" value="Daily" />
    <input type="checkbox" name="newsletter" value="Weekly" />

    <input type="checkbox" name="newsletter" checked="checked" value="Monthly" />
    <input type="checkbox" name="newsletter" value="Yearly" />

  </form>
  <div></div>
  <script>

    function countChecked() {
      var n = $("input:checked").length;
      $("div").text(n + (n <= 1 ? " is" : " are") + " checked!");
    }
    countChecked();
    $(":checkbox").click(countChecked);

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


disabled – jQuery API

Returns: JQuery(":disabled")

Categories: Form, Version 1.0
Description: Selects all elements that are disabled.
  • version added: 1.0

  • JQuery(":disabled")

As with other pseudo-class selectors (those that begin with a ":") it is recommended to precede it with a tag name or some other selector; otherwise, the universal selector ("*") is implied. In other words, the bare is equivalent to , so should be used instead.

Examples:

Example:

Finds all input elements that are disabled.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <form>

    <input name="email" disabled="disabled" />
    <input name="id" />
  </form>
  <script>$("input:disabled").val("this is it");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


enabled – jQuery API

Returns: JQuery(":enabled")

Categories: Form, Version 1.0
Description: Selects all elements that are enabled.
  • version added: 1.0

  • JQuery(":enabled")

As with other pseudo-class selectors (those that begin with a ":") it is recommended to precede it with a tag name or some other selector; otherwise, the universal selector ("*") is implied. In other words, the bare is equivalent to , so should be used instead.

Examples:

Example:

Finds all input elements that are enabled.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <form>

    <input name="email" disabled="disabled" />
    <input name="id" />
  </form>
  <script>$("input:enabled").val("this is it");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


file – jQuery API

Returns: JQuery(":file")

Categories: Form, Version 1.0
Description: Selects all elements of type file.
  • version added: 1.0

  • JQuery(":file")

As with other pseudo-class selectors (those that begin with a ":") it is recommended to precede it with a tag name or some other selector; otherwise, the universal selector ("*") is implied. In other words, the bare is equivalent to , so should be used instead.

Examples:

Example:

Finds all file inputs.
<!DOCTYPE html>
<html>
<head>
  <style>
  textarea { height:45px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <form>
    <input type="button" value="Input Button"/>
    <input type="checkbox" />

    <input type="file" />
    <input type="hidden" />
    <input type="image" />

    <input type="password" />
    <input type="radio" />
    <input type="reset" />

    <input type="submit" />
    <input type="text" />
    <select><option>Option<option/></select>

    <textarea></textarea>
    <button>Button</button>
  </form>
  <div>
  </div>
  <script>

    var input = $("input:file").css({background:"yellow", border:"3px red solid"});
    $("div").text("For this type jQuery found " + input.length + ".")
            .css("color", "red");
    $("form").submit(function () { return false; }); // so it won't submit

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


button – jQuery API

Returns: JQuery(":button")

Categories: Form, Version 1.0
Description: Selects all button elements and elements of type button.
  • version added: 1.0

  • JQuery(":button")

Examples:

Example:

Finds all button inputs.
<!DOCTYPE html>
<html>
<head>
  <style>
  textarea { height:45px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <form>
    <input type="button" value="Input Button"/>
    <input type="checkbox" />

    <input type="file" />
    <input type="hidden" />
    <input type="image" />

    <input type="password" />
    <input type="radio" />
    <input type="reset" />

    <input type="submit" />
    <input type="text" />
    <select><option>Option<option/></select>

    <textarea></textarea>
    <button>Button</button>
  </form>
  <div>
  </div>
  <script>

    var input = $(":button").css({background:"yellow", border:"3px red solid"});
    $("div").text("For this type jQuery found " + input.length + ".")
            .css("color", "red");
    $("form").submit(function () { return false; }); // so it won't submit

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


reset – jQuery API

Returns: JQuery(":reset")

Categories: Form, Version 1.0
Description: Selects all elements of type reset.
  • version added: 1.0

  • JQuery(":reset")

Examples:

Example:

Finds all reset inputs.
<!DOCTYPE html>
<html>
<head>
  <style>
  textarea { height:45px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <form>
    <input type="button" value="Input Button"/>
    <input type="checkbox" />

    <input type="file" />
    <input type="hidden" />
    <input type="image" />

    <input type="password" />
    <input type="radio" />
    <input type="reset" />

    <input type="submit" />
    <input type="text" />
    <select><option>Option<option/></select>

    <textarea></textarea>
    <button>Button</button>
  </form>
  <div>
  </div>
  <script>

    var input = $("input:reset").css({background:"yellow", border:"3px red solid"});
    $("div").text("For this type jQuery found " + input.length + ".")
            .css("color", "red");
    $("form").submit(function () { return false; }); // so it won't submit

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


image – jQuery API

Returns: JQuery(":image")

Categories: Form, Version 1.0
Description: Selects all elements of type image.
  • version added: 1.0

  • JQuery(":image")

Examples:

Example:

Finds all image inputs.
<!DOCTYPE html>
<html>
<head>
  <style>
  textarea { height:45px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <form>
    <input type="button" value="Input Button"/>
    <input type="checkbox" />

    <input type="file" />
    <input type="hidden" />
    <input type="image" />

    <input type="password" />
    <input type="radio" />
    <input type="reset" />

    <input type="submit" />
    <input type="text" />
    <select><option>Option<option/></select>

    <textarea></textarea>
    <button>Button</button>
  </form>
  <div>
  </div>
  <script>
    var input = $("input:image").css({background:"yellow", border:"3px red solid"});
    $("div").text("For this type jQuery found " + input.length + ".")
            .css("color", "red");
    $("form").submit(function () { return false; }); // so it won't submit

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


checkbox – jQuery API

Returns: JQuery(":checkbox")

Categories: Form, Version 1.0
Description: Selects all elements of type checkbox.
  • version added: 1.0

  • JQuery(":checkbox")

is equivalent to . As with other pseudo-class selectors (those that begin with a ":") it is recommended to precede it with a tag name or some other selector; otherwise, the universal selector ("*") is implied. In other words, the bare is equivalent to , so should be used instead.

Examples:

Example:

Finds all checkbox inputs.
<!DOCTYPE html>
<html>
<head>
  <style>
  textarea { height:25px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <form>
    <input type="button" value="Input Button"/>
    <input type="checkbox" />

    <input type="checkbox" />
    <input type="file" />
    <input type="hidden" />

    <input type="image" />
    <input type="password" />
    <input type="radio" />

    <input type="reset" />
    <input type="submit" />
    <input type="text" />

    <select><option>Option<option/></select>
    <textarea></textarea>
    <button>Button</button>
  </form>

  <div>
  </div>
  <script>

    var input = $("form input:checkbox").wrap('<span></span>').parent().css({background:"yellow", border:"3px red solid"});
    $("div").text("For this type jQuery found " + input.length + ".")
            .css("color", "red");
    $("form").submit(function () { return false; }); // so it won't submit

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


radio – jQuery API

Returns: JQuery(":radio")

Categories: Form, Version 1.0
Description: Selects all elements of type radio.
  • version added: 1.0

  • JQuery(":radio")

is equivalent to . As with other pseudo-class selectors (those that begin with a ":") it is recommended to precede it with a tag name or some other selector; otherwise, the universal selector ("*") is implied. In other words, the bare is equivalent to , so should be used instead.

To select a set of associated radio buttons, you might use:

Examples:

Example:

Finds all radio inputs.
<!DOCTYPE html>
<html>
<head>
  <style>
  textarea { height:25px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <form>
    <input type="button" value="Input Button"/>
    <input type="checkbox" />

    <input type="file" />
    <input type="hidden" />
    <input type="image" />

    <input type="password" />
    <input type="radio" name="asdf" />
    <input type="radio" name="asdf" />

    <input type="reset" />
    <input type="submit" />
    <input type="text" />

    <select><option>Option<option/></select>
    <textarea></textarea>
    <button>Button</button>
  </form>

  <div>
  </div>
  <script>

    var input = $("form input:radio").wrap('<span></span>').parent().css({background:"yellow", border:"3px red solid"});
    $("div").text("For this type jQuery found " + input.length + ".")
            .css("color", "red");
    $("form").submit(function () { return false; }); // so it won't submit

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


password – jQuery API

Returns: JQuery(":password")

Categories: Form, Version 1.0
Description: Selects all elements of type password.
  • version added: 1.0

  • JQuery(":password")

is equivalent to . As with other pseudo-class selectors (those that begin with a ":") it is recommended to precede it with a tag name or some other selector; otherwise, the universal selector ("*") is implied. In other words, the bare is equivalent to , so should be used instead.

Examples:

Example:

Finds all password inputs.
<!DOCTYPE html>
<html>
<head>
  <style>
  textarea { height:45px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <form>
    <input type="button" value="Input Button"/>
    <input type="checkbox" />

    <input type="file" />
    <input type="hidden" />
    <input type="image" />

    <input type="password" />
    <input type="radio" />
    <input type="reset" />

    <input type="submit" />
    <input type="text" />
    <select><option>Option<option/></select>

    <textarea></textarea>
    <button>Button</button>
  </form>
  <div>
  </div>
  <script>

    var input = $("input:password").css({background:"yellow", border:"3px red solid"});
    $("div").text("For this type jQuery found " + input.length + ".")
            .css("color", "red");
    $("form").submit(function () { return false; }); // so it won't submit

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


input – jQuery API

Returns: JQuery(":input")

Categories: Form, Version 1.0
Description: Selects all input, textarea, select and button elements.
  • version added: 1.0

  • JQuery(":input")

The selector basically selects all form controls.

Examples:

Example:

Finds all input elements.
<!DOCTYPE html>
<html>
<head>
  <style>
  textarea { height:25px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <form>
    <input type="button" value="Input Button"/>
    <input type="checkbox" />

    <input type="file" />
    <input type="hidden" />
    <input type="image" />

    <input type="password" />
    <input type="radio" />
    <input type="reset" />

    <input type="submit" />
    <input type="text" />
    <select><option>Option</option></select>

    <textarea></textarea>
    <button>Button</button>
  </form>
  <div id="messages">
  </div>
  <script>

    var allInputs = $(":input");
    var formChildren = $("form > *");
    $("#messages").text("Found " + allInputs.length + " inputs and the form has " +
                             formChildren.length + " children.");

    // so it won't submit
    $("form").submit(function () { return false; });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Hierarchy – jQuery API

Hierarchy

  • JQuery("prev ~ siblings")

    New in 1.0 !

    Selects all sibling elements that follow after the "prev" element, have the same parent, and match the filtering "siblings" selector.

  • JQuery("prev + next")

    New in 1.0 !

    Selects all next elements matching "next" that are immediately preceded by a sibling "prev".

  • child")" rel="bookmark">JQuery("parent > child")

    New in 1.0 !

    Selects all direct child elements specified by "child" of elements specified by "parent".

  • JQuery("ancestor descendant")

    New in 1.0 !

    Selects all elements that are descendants of a given ancestor.


next siblings – jQuery API

Returns: JQuery("prev ~ siblings")

Categories: Hierarchy, Version 1.0
Description: Selects all sibling elements that follow after the "prev" element, have the same parent, and match the filtering "siblings" selector.
  • version added: 1.0

  • JQuery("prev ~ siblings")

  • prev Any valid selector.
  • siblings A selector to filter elements that are the following siblings of the first selector.

The notable difference between () and () is their respective reach. While the former reaches only to the immediately following sibling element, the latter extends that reach to all following sibling elements.

Examples:

Example:

Finds all divs that are siblings after the element with #prev as its id. Notice the span isn't selected since it is not a div and the "niece" isn't selected since it is a child of a sibling, not an actual sibling.
<!DOCTYPE html>
<html>
<head>
  <style>
  div,span {
    display:block;
    width:80px;
    height:80px;
    margin:5px;
    background:#bbffaa;
    float:left;
    font-size:14px;
  }
  div#small {
    width:60px;
    height:25px;
    font-size:12px;
    background:#fab;
  }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>div (doesn't match since before #prev)</div>
  <span id="prev">span#prev</span>
  <div>div sibling</div>

  <div>div sibling <div id="small">div niece</div></div>
  <span>span sibling (not div)</span>
  <div>div sibling</div>
  <script>$("#prev ~ div").css("border", "3px groove blue");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


next adjacent – jQuery API

Returns: JQuery("prev + next")

Categories: Hierarchy, Version 1.0
Description: Selects all next elements matching "next" that are immediately preceded by a sibling "prev".
  • version added: 1.0

  • JQuery("prev + next")

  • prev Any valid selector.
  • next A selector to match the element that is next to the first selector.

One important point to consider with both the next adjacent sibling selector () and the general sibling selector () is that the elements on either side of the combinator must share the same parent.

Examples:

Example:

Finds all inputs that are next to a label.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <form>

    <label>Name:</label>
    <input name="name" />
    <fieldset>
      <label>Newsletter:</label>

      <input name="newsletter" />
    </fieldset>
  </form>
  <input name="none" />
  <script>$("label + input").css("color", "blue").val("Labeled!")</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


child – jQuery API

Returns: JQuery("parent > child")

Categories: Hierarchy, Version 1.0
Description: Selects all direct child elements specified by "child" of elements specified by "parent".
  • version added: 1.0

  • JQuery("parent > child")

  • parent Any valid selector.
  • child A selector to filter the child elements.

As a CSS selector, the child combinator is supported by all modern web browsers including Safari, Firefox, Opera, Chrome, and Internet Explorer 7 and above, but notably not by Internet Explorer versions 6 and below. However, in jQuery, this selector (along with all others) works across all supported browsers, including IE6.

The child combinator (E F) can be thought of as a more specific form of the descendant combinator (E F) in that it selects only first-level descendants.

Examples:

Example:

Places a border around all list items that are children of
    .
<!DOCTYPE html>
<html>
<head>
  <style>
body { font-size:14px; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<ul class="topnav">
    <li>Item 1</li>
    <li>Item 2
        <ul><li>Nested item 1</li><li>Nested item 2</li><li>Nested item 3</li></ul>
       </li>
    <li>Item 3</li>
</ul>

  <script>$("ul.topnav > li").css("border", "3px double red");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


descendant – jQuery API

Returns: JQuery("ancestor descendant")

Categories: Hierarchy, Version 1.0
Description: Selects all elements that are descendants of a given ancestor.
  • version added: 1.0

  • JQuery("ancestor descendant")

  • ancestor Any valid selector.
  • descendant A selector to filter the descendant elements.

A descendant of an element could be a child, grandchild, great-grandchild, and so on, of that element.

Examples:

Example:

Finds all input descendants of forms.
<!DOCTYPE html>
<html>
<head>
  <style>
  body { font-size:14px; }
  form { border:2px green solid; padding:2px; margin:0;
         background:#efe; }
  div { color:red; }
  fieldset { margin:1px; padding:3px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <form>
    <div>Form is surrounded by the green outline</div>
    <label>Child:</label>
    <input name="name" />

    <fieldset>
      <label>Grandchild:</label>
      <input name="newsletter" />
    </fieldset>

  </form>
  Sibling to form: <input name="none" />
  <script>$("form input").css("border", "2px dotted blue");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Visibility Filter – jQuery API

Visibility Filter

  • JQuery(":visible")

    New in 1.0 !

    Selects all elements that are visible.

  • JQuery(":hidden")

    New in 1.0 !

    Selects all elements that are hidden.


visible – jQuery API

Returns: JQuery(":visible")

Categories: Version 1.0, Visibility Filter
Description: Selects all elements that are visible.
  • version added: 1.0

  • JQuery(":visible")

Elements can be considered hidden for several reasons:

Elements with or are considered to be visible, since they still consume space in the layout. During animations that hide an element, the element is considered to be visible until the end of the animation. During animations to show an element, the element is considered to be visible at the start at the animation.

How is calculated was changed in jQuery 1.3.2. The outline the changes in more detail.

Examples:

Example:

Make all visible divs turn yellow on click.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { width:50px; height:40px; margin:5px; border:3px outset green; float:left; }
  .starthidden { display:none; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button>Show hidden to see they don't change</button>
  <div></div>
  <div class="starthidden"></div>
  <div></div>

  <div></div>
  <div style="display:none;"></div>
  <script>
    $("div:visible").click(function () {
      $(this).css("background", "yellow");
    });
    $("button").click(function () {
      $("div:hidden").show("fast");
    });

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


hidden – jQuery API

Returns: JQuery(":hidden")

Categories: Version 1.0, Visibility Filter
Description: Selects all elements that are hidden.
  • version added: 1.0

  • JQuery(":hidden")

Elements can be considered hidden for several reasons:

Elements with or are considered to be visible, since they still consume space in the layout. During animations that hide an element, the element is considered to be visible until the end of the animation. During animations to show an element, the element is considered to be visible at the start at the animation.

How is determined was changed in jQuery 1.3.2. An element is assumed to be hidden if it or any of its parents consumes no space in the document. CSS visibility isn't taken into account (therefore ). The outline the changes in more detail.

Examples:

Example:

Shows all hidden divs and counts hidden inputs.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { width:70px; height:40px; background:#ee77ff; margin:5px; float:left; }
  span { display:block; clear:left; color:red; }
  .starthidden { display:none; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <span></span>
  <div></div>
  <div style="display:none;">Hider!</div>
  <div></div>

  <div class="starthidden">Hider!</div>
  <div></div>
  <form>
    <input type="hidden" />

    <input type="hidden" />
    <input type="hidden" />
  </form>
  <span>

  </span>
  <script>
    // in some browsers :hidden includes head, title, script, etc... so limit to body
    $("span:first").text("Found " + $(":hidden", document.body).length +
                         " hidden elements total.");
    $("div:hidden").show(3000);
    $("span:last").text("Found " + $("input:hidden").length + " hidden inputs.");

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Traversing – jQuery API

Traversing

  • jQuery .has( [Element] contained )

    New in 1.4 !

    Reduce the set of matched elements to those that have a descendant that matches the selector or DOM element.

  • jQuery .first( )

    New in 1.4 !

    Reduce the set of matched elements to the first in the set.

  • jQuery .last( )

    New in 1.4 !

    Reduce the set of matched elements to the final one in the set.

  • jQuery .slice( [Integer] start, [Integer] end )

    New in 1.1.4 !

    Reduce the set of matched elements to a subset specified by a range of indices.

  • jQuery .not( [Function] function(index) )

    New in 1.4 !

    Remove elements from the set of matched elements.

  • jQuery .map( [Function] callback(index, domElement) )

    New in 1.2 !

    Pass each element in the current matched set through a function, producing a new jQuery object containing the return values.

  • Boolean .is( [Selector] selector )

    New in 1.0 !

    Check the current matched set of elements against a selector and return true if at least one of these elements matches the selector.

  • jQuery .eq( [Integer] -index )

    New in 1.4 !

    Reduce the set of matched elements to the one at the specified index.

  • jQuery .filter( [Function] function(index) )

    New in 1.0 !

    Reduce the set of matched elements to those that match the selector or pass the function's test.

  • jQuery .end( )

    New in 1.0 !

    End the most recent filtering operation in the current chain and return the set of matched elements to its previous state.

  • jQuery .andSelf( )

    New in 1.2 !

    Add the previous set of elements on the stack to the current set.

  • jQuery .contents( )

    New in 1.2 !

    Get the children of each element in the set of matched elements, including text nodes.

  • jQuery .add( [Selector] selector, [Element] context )

    New in 1.4 !

    Add elements to the set of matched elements.

  • jQuery .parentsUntil( [Selector] selector )

    New in 1.4 !

    Get the ancestors of each element in the current set of matched elements, up to but not including the element matched by the selector.

  • jQuery .prevUntil( [Selector] selector )

    New in 1.4 !

    Get all preceding siblings of each element up to but not including the element matched by the selector.

  • jQuery .nextUntil( [Selector] selector )

    New in 1.4 !

    Get all following siblings of each element up to but not including the element matched by the selector.

  • jQuery .siblings( [Selector] selector )

    New in 1.0 !

    Get the siblings of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .prevAll( [Selector] selector )

    New in 1.2 !

    Get all preceding siblings of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .prev( [Selector] selector )

    New in 1.0 !

    Get the immediately preceding sibling of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .parents( [Selector] selector )

    New in 1.0 !

    Get the ancestors of each element in the current set of matched elements, optionally filtered by a selector.

  • jQuery .parent( [Selector] selector )

    New in 1.0 !

    Get the parent of each element in the current set of matched elements, optionally filtered by a selector.

  • jQuery .offsetParent( )

    New in 1.26 !

    Get the closest ancestor element that is positioned.

  • jQuery .nextAll( [String] selector )

    New in 1.2 !

    Get all following siblings of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .next( [Selector] selector )

    New in 1.0 !

    Get the immediately following sibling of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .find( [Selector] selector )

    New in 1.0 !

    Get the descendants of each element in the current set of matched elements, filtered by a selector.

  • Array .closest( [Array] selectors, [Element] context )

    New in 1.4 !

    Gets an array of all the elements and selectors matched against the current element up through the DOM tree.

  • jQuery .children( [Selector] selector )

    New in 1.0 !

    Get the children of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .each( [Function] function(index, Element) )

    New in 1.0 !

    Iterate over a jQuery object, executing a function for each matched element.


Filtering – jQuery API

Filtering

  • jQuery .has( [Element] contained )

    New in 1.4 !

    Reduce the set of matched elements to those that have a descendant that matches the selector or DOM element.

  • jQuery .first( )

    New in 1.4 !

    Reduce the set of matched elements to the first in the set.

  • jQuery .last( )

    New in 1.4 !

    Reduce the set of matched elements to the final one in the set.

  • jQuery .slice( [Integer] start, [Integer] end )

    New in 1.1.4 !

    Reduce the set of matched elements to a subset specified by a range of indices.

  • jQuery .not( [Function] function(index) )

    New in 1.4 !

    Remove elements from the set of matched elements.

  • jQuery .map( [Function] callback(index, domElement) )

    New in 1.2 !

    Pass each element in the current matched set through a function, producing a new jQuery object containing the return values.

  • Boolean .is( [Selector] selector )

    New in 1.0 !

    Check the current matched set of elements against a selector and return true if at least one of these elements matches the selector.

  • jQuery .eq( [Integer] -index )

    New in 1.4 !

    Reduce the set of matched elements to the one at the specified index.

  • jQuery .filter( [Function] function(index) )

    New in 1.0 !

    Reduce the set of matched elements to those that match the selector or pass the function's test.


slice – jQuery API

Returns: jQueryjQuery .slice( [Integer] start, [Integer] end )

Categories: Filtering, Version 1.1.4
Description: Reduce the set of matched elements to a subset specified by a range of indices.
  • version added: 1.1.4

  • .slice( [Integer] start, [Integer] end )

  • start An integer indicating the 0-based position after which the elements are selected. If negative, it indicates an offset from the end of the set.
  • end An integer indicating the 0-based position before which the elements stop being selected. If negative, it indicates an offset from the end of the set. If omitted, the range continues until the end of the set.

Given a jQuery object that represents a set of DOM elements, the method constructs a new jQuery object from a subset of the matching elements. The supplied index identifies the position of one of the elements in the set; if is omitted, all elements after this one will be included in the result.

Consider a page with a simple list on it:

<ul>
  <li>list item 1</li>
  <li>list item 2</li>
  <li>list item 3</li>
  <li>list item 4</li>
  <li>list item 5</li>
</ul>

We can apply this method to the set of list items:

$('li').slice(2).css('background-color', 'red');

The result of this call is a red background for items 3, 4, and 5. Note that the supplied index is zero-based, and refers to the position of elements within the jQuery object, not within the DOM tree.

The end parameter allows us to limit the selected range even further. For example:

$('li').slice(2, 4).css('background-color', 'red');

Now only items 3 and 4 are selected. The index is once again zero-based; the range extends up to but not including the specified index.

Negative Indices

The jQuery method is patterned after the JavaScript .slice() method for arrays. One of the features that it mimics is the ability for negative numbers to be passed as either the or parameter. If a negative number is provided, this indicates a position starting from the end of the set, rather than the beginning. For example:

$('li').slice(-2, -1).css('background-color', 'red');

This time only list item 4 is turned red, since it is the only item in the range between two from the end () and one from the end ().

Examples:

Example:

Turns divs yellow based on a random slice.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { width:40px; height:40px; margin:10px; float:left;
        border:2px solid blue; }
  span { color:red; font-weight:bold; }
  button { margin:5px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p><button>Turn slice yellow</button>
  <span>Click the button!</span></p>
  <div></div>
  <div></div>

  <div></div>
  <div></div>
  <div></div>
  <div></div>
  <div></div>

  <div></div>
  <div></div>
  <script>

    function colorEm() {
      var $div = $("div");
      var start = Math.floor(Math.random() *
                             $div.length);
      var end = Math.floor(Math.random() *
                           ($div.length - start)) +
                           start + 1;
      if (end == $div.length) end = undefined;
      $div.css("background", "");
      if (end)
        $div.slice(start, end).css("background", "yellow");
       else
        $div.slice(start).css("background", "yellow");

      $("span").text('$("div").slice(' + start +
                     (end ? ', ' + end : '') +
                     ').css("background", "yellow");');
    }

    $("button").click(colorEm);

</script>
</body>
</html>

Demo:

Example:

Selects all paragraphs, then slices the selection to include only the first element.
<script>$("p").slice(0, 1).wrapInner("<b></b>");</script>

Example:

Selects all paragraphs, then slices the selection to include only the first and second element.
<script>$("p").slice(0, 2).wrapInner("<b></b>");</script>

Example:

Selects all paragraphs, then slices the selection to include only the second element.
<script>$("p").slice(1, 2).wrapInner("<b></b>");</script>

Example:

Selects all paragraphs, then slices the selection to include only the second and third element.
<script>$("p").slice(1).wrapInner("<b></b>");</script>

Example:

Selects all paragraphs, then slices the selection to include only the third element.
<script>$("p").slice(-1).wrapInner("<b></b>");</script>

Comments

© 2010 The jQuery Project


map – jQuery API

Returns: jQueryjQuery .map( [Function] callback(index, domElement) )

Categories: Filtering, Version 1.2
Description: Pass each element in the current matched set through a function, producing a new jQuery object containing the return values.
  • version added: 1.2

  • .map( [Function] callback(index, domElement) )

  • callback(index, domElement) A function object that will be invoked for each element in the current set.

As the return value is a jQuery-wrapped array, it's very common to the returned object to work with a basic array.

The method is particularly useful for getting or setting the value of a collection of elements. Consider a form with a set of checkboxes in it:

<form method="post" action="">
  <fieldset>
    <div>
      <label for="two">2</label>
      <input type="checkbox" value="2" id="two" name="number[]">
    </div>
    <div>
      <label for="four">4</label>
      <input type="checkbox" value="4" id="four" name="number[]">
    </div>
    <div>
      <label for="six">6</label>
      <input type="checkbox" value="6" id="six" name="number[]">
    </div>
    <div>
      <label for="eight">8</label>
      <input type="checkbox" value="8" id="eight" name="number[]">
    </div>
  </fieldset>
</form>

We can get a comma-separated list of checkbox s:

$(':checkbox').map(function() {
  return this.id;
}).get().join(',');

The result of this call is the string, .

Within the callback function, refers to the current DOM element for each iteration. The function can return an individual data item or an array of data items to be inserted into the resulting set. If an array is returned, the elements inside the array are inserted into the set. If the function returns or , no element will be inserted.

Examples:

Example:

Build a list of all the values within a form.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p><b>Values: </b></p>
  <form>
    <input type="text" name="name" value="John"/>

    <input type="text" name="password" value="password"/>
    <input type="text" name="url" value="http://ejohn.org/"/>

  </form>
  <script>
    $("p").append( $("input").map(function(){
      return $(this).val();
    }).get().join(", ") );

</script>
</body>
</html>

Demo:

Example:

A contrived example to show some functionality.
<!DOCTYPE html>
<html>
<head>
  <style>
  body { font-size:16px; }
  ul { float:left; margin:0 30px; color:blue; }
  #results { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <ul>
    <li>First</li>
    <li>Second</li>
    <li>Third</li>

    <li>Fourth</li>
    <li>Fifth</li>
  </ul>
  <ul id="results">

  </ul>
  <script>
    var mappedItems = $("li").map(function (index) {
      var replacement = $("<li>").text($(this).text()).get(0);
      if (index == 0) {
        // make the first item all caps
        $(replacement).text($(replacement).text().toUpperCase());
      } else if (index == 1 || index == 3) {
        // delete the second and fourth items
        replacement = null;
      } else if (index == 2) {
        // make two of the third item and add some text
        replacement = [replacement,$("<li>").get(0)];
        $(replacement[0]).append("<b> - A</b>");
        $(replacement[1]).append("Extra <b> - B</b>");
      }

      // replacement will be an dom element, null,
      // or an array of dom elements
      return replacement;
    });
    $("#results").append(mappedItems);

</script>
</body>
</html>

Demo:

Example:

Equalize the heights of the divs.
<!DOCTYPE html>
<html>
<head>
  <style>
div { width: 40px; float:left; }
input { clear:left}
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<input type="button" value="equalize div heights">

<div style="background:red; height: 40px; "></div>
<div style="background:green; height: 70px;"></div>
<div style="background:blue; height: 50px; "></div>

  <script>
$.fn.equalizeHeights = function(){
  return this.height( Math.max.apply(this, $(this).map(function(i,e){ return $(e).height() }).get() ) )
}
$('input').click(function(){
  $('div').equalizeHeights();
});

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


is – jQuery API

Returns: BooleanBoolean .is( [Selector] selector )

Categories: Filtering, Version 1.0
Description: Check the current matched set of elements against a selector and return true if at least one of these elements matches the selector.
  • version added: 1.0

  • .is( [Selector] selector )

  • selector A string containing a selector expression to match elements against.

Unlike the other filtering and traversal methods, does not create a new jQuery object. Instead, it allows us to test the contents of a jQuery object without modification. This is often useful inside callbacks, such as event handlers.

Suppose we have a list, with two of its items containing a child element:

<ul>
  <li>list <strong>item 1</strong></li>
  <li><span>list item 2</span></li>
  <li>list item 3</li>
</ul>

We can attach a click handler to the <ul> element, and then limit the code to be triggered only when a list item itself, not one of its children, is clicked:

$('ul').click(function(event) {
  if ($(event.target).is('li') ) {
    $(event.target).css('background-color', 'red');
  }
});

Now, when the user clicks on the word list in the first item or anywhere in the third item, the clicked list item will be given a red background. However, when the user clicks on item 1 in the first item or anywhere in the second item, nothing will occur, because in those cases the target of the event would be or , respectively.

Examples:

Example:

Shows a few ways is() can be used inside an event handler.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { width:60px; height:60px; margin:5px; float:left;
        border:4px outset; background:green; text-align:center;
        font-weight:bolder; cursor:pointer; }
  .blue { background:blue; }
  .red { background:red; }
  span { color:white; font-size:16px; }
  p { color:red; font-weight:bolder; background:yellow;
      margin:3px; clear:left; display:none; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div></div>
  <div class="blue"></div>
  <div></div>
  <div class="red"></div>

  <div><br/><span>Peter</span></div>
  <div class="blue"></div>
  <p>&nbsp;</p>
  <script>
    $("div").one('click', function () {
      if ($(this).is(":first-child")) {
        $("p").text("It's the first div.");
      } else if ($(this).is(".blue,.red")) {
        $("p").text("It's a blue or red div.");
      } else if ($(this).is(":contains('Peter')")) {
        $("p").text("It's Peter!");
      } else {
        $("p").html("It's nothing <em>special</em>.");
      }
      $("p").hide().slideDown("slow");
      $(this).css({"border-style": "inset", cursor:"default"});
    });

</script>
</body>
</html>

Demo:

Example:

Returns true, because the parent of the input is a form element
<!DOCTYPE html>
<html>
<head>
  <style>
div { color:red; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <form><input type="checkbox" /></form>

  <div></div>
  <script>

    var isFormParent = $("input[type='checkbox']").parent().is("form")
    $("div").text("isFormParent = " + isFormParent);
</script>
</body>
</html>

Demo:

Example:

Returns false, because the parent of the input is a p element
<!DOCTYPE html>
<html>
<head>
  <style>
div { color:red; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <form><p><input type="checkbox" /></p></form>

  <div></div>
  <script>
    var isFormParent = $("input[type='checkbox']").parent().is("form")
    $("div").text("isFormParent = " + isFormParent);
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


filter – jQuery API

Returns: jQueryjQuery .filter( [Function] function(index) )

Categories: Filtering, Version 1.0
Description: Reduce the set of matched elements to those that match the selector or pass the function's test.
  • version added: 1.0

  • .filter( [Selector] selector )

  • selector A string containing a selector expression to match elements against.
  • version added: 1.0

  • .filter( [Function] function(index) )

  • function(index) A function used as a test for each element in the set. is the current DOM element.

Given a jQuery object that represents a set of DOM elements, the method constructs a new jQuery object from a subset of the matching elements. The supplied selector is tested against each element; all elements matching the selector will be included in the result.

Consider a page with a simple list on it:

We can apply this method to the set of list items:

  $('li').filter(':even').css('background-color', 'red');

The result of this call is a red background for items 1, 3, and 5, as they match the selector (recall that and use 0-based indexing).

Using a Filter Function

The second form of this method allows us to filter elements against a function rather than a selector. For each element, if the function returns , the element will be included in the filtered set; otherwise, it will be excluded. Suppose we have a somewhat more involved HTML snippet:

<ul>
  <li><strong>list</strong> item 1 -
    one strong tag</li>
  <li><strong>list</strong> item <strong>2</strong> -
    two <span>strong tags</span></li>
  <li>list item 3</li>
  <li>list item 4</li>
  <li>list item 5</li>
  <li>list item 6</li>
</ul>

We can select the list items, then filter them based on their contents:

$('li').filter(function(index) {
  return $('strong', this).length == 1;
}).css('background-color', 'red');

This code will alter the first list item only, as it contains exactly one tag. Within the filter function, refers to each DOM element in turn. The parameter passed to the function tells us the index of that DOM element within the set matched by the jQuery object.

We can also take advantage of the passed through the function, which indicates the 0-based position of the element within the unfiltered set of matched elements:

$('li').filter(function(index) {
  return index % 3 == 2;
}).css('background-color', 'red');

This alteration to the code will cause the third and sixth list items to be highlighted, as it uses the modulus operator () to select every item with an value that, when divided by 3, has a remainder of .

Examples:

Example:

Change the color of all divs then put a border around only some of them.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { width:60px; height:60px; margin:5px; float:left;
        border:2px white solid;}
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div></div>

  <div class="middle"></div>
  <div class="middle"></div>
  <div class="middle"></div>
  <div class="middle"></div>

  <div></div>
  <script>

    $("div").css("background", "#c8ebcc")
            .filter(".middle")
            .css("border-color", "red");
</script>
</body>
</html>

Demo:

Example:

Selects all paragraphs and removes those without a class "selected".
<script>$("p").filter(".selected")</script>

Example:

Selects all paragraphs and removes those that aren't of class "selected" or the first one.
<script>$("p").filter(".selected, :first")</script>

Example:

Change the color of all divs then put a border to specific ones.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { width:60px; height:60px; margin:5px; float:left;
        border:3px white solid; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div id="first"></div>
  <div id="second"></div>
  <div id="third"></div>

  <div id="fourth"></div>
  <div id="fifth"></div>
  <div id="sixth"></div>
  <script>
    $("div").css("background", "#b4b0da")
            .filter(function (index) {
                  return index == 1 || $(this).attr("id") == "fourth";
                })
            .css("border", "3px double red");

</script>
</body>
</html>

Demo:

Example:

Remove all elements that have a descendant ol element
<script>$("div").filter(function(index) {
   return $("ol", this).length == 0;
 });</script>

Comments

© 2010 The jQuery Project


Miscellaneous Traversing – jQuery API

Miscellaneous Traversing

  • jQuery .end( )

    New in 1.0 !

    End the most recent filtering operation in the current chain and return the set of matched elements to its previous state.

  • jQuery .andSelf( )

    New in 1.2 !

    Add the previous set of elements on the stack to the current set.

  • jQuery .contents( )

    New in 1.2 !

    Get the children of each element in the set of matched elements, including text nodes.

  • jQuery .add( [Selector] selector, [Element] context )

    New in 1.4 !

    Add elements to the set of matched elements.


end – jQuery API

Returns: jQueryjQuery .end( )

Categories: Miscellaneous Traversing, Version 1.0
Description: End the most recent filtering operation in the current chain and return the set of matched elements to its previous state.
  • version added: 1.0

  • .end( )

Most of jQuery's methods operate on a jQuery object instance and produce a new one, matching a different set of DOM elements. When this happens, it is as if the new set of elements is pushed onto a stack that is maintained inside the object. Each successive filtering method pushes a new element set onto the stack. If we need an older element set, we can use to pop the sets back off of the stack.

Suppose we have a couple short lists on a page:

<ul class="first">
   <li class="foo">list item 1</li>
   <li>list item 2</li>
   <li class="bar">list item 3</li>
</ul>
<ul class="second">
   <li class="foo">list item 1</li>
   <li>list item 2</li>
   <li class="bar">list item 3</li>
</ul>

The method is useful primarily when exploiting jQuery's chaining properties. When not using chaining, we can usually just call up a previous object by variable name, so we don't need to manipulate the stack. With , though, we can string all the method calls together:

$('ul.first').find('.foo').css('background-color', 'red')
  .find('.bar').css('background-color', 'green');

This chain searches for items with the class within the first list only and turns their backgrounds red. Then returns the object to its state before the call to , so the second looks for '.bar' inside , not just inside that list's , and turns the matching elements' backgrounds green. The net result is that items 1 and 3 of the first list have a colored background, and none of the items from the second list do.

A long jQuery chain can be visualized as a structured code block, with filtering methods providing the openings of nested blocks and methods closing them:

$('ul.first').find('.foo')
  .css('background-color', 'red')
.end().find('.bar')
  .css('background-color', 'green')
.end();

The last is unnecessary, as we are discarding the jQuery object immediately thereafter. However, when the code is written in this form, the provides visual symmetry and closure—making the program, at least to the eyes of some developers, more readable.

Examples:

Example:

Selects all paragraphs, finds span elements inside these, and reverts the selection back to the paragraphs.
<!DOCTYPE html>
<html>
<head>
  <style>
  p, div { margin:1px; padding:1px; font-weight:bold;
           font-size:16px; }
  div { color:blue; }
  b { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>
    Hi there <span>how</span> are you <span>doing</span>?
  </p>

  <p>
    This <span>span</span> is one of
    several <span>spans</span> in this
    <span>sentence</span>.
  </p>

  <div>
    Tags in jQuery object initially: <b></b>
  </div>
  <div>
    Tags in jQuery object after find: <b></b>

  </div>
  <div>
    Tags in jQuery object after end: <b></b>
  </div>
  <script>

    jQuery.fn.showTags = function (n) {
      var tags = this.map(function () {
                              return this.tagName;
                            })
                        .get().join(", ");
      $("b:eq(" + n + ")").text(tags);
      return this;
    };

    $("p").showTags(0)
          .find("span")
          .showTags(1)
          .css("background", "yellow")
          .end()
          .showTags(2)
          .css("font-style", "italic");

</script>
</body>
</html>

Demo:

Example:

Selects all paragraphs, finds span elements inside these, and reverts the selection back to the paragraphs.
<!DOCTYPE html>
<html>
<head>
  <style>
p { margin:10px; padding:10px; }</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p><span>Hello</span>, how are you?</p>
  <script>$("p").find("span").end().css("border", "2px red solid");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


andSelf – jQuery API

Returns: jQueryjQuery .andSelf( )

Categories: Miscellaneous Traversing, Version 1.2
Description: Add the previous set of elements on the stack to the current set.
  • version added: 1.2

  • .andSelf( )

As described in the discussion for above, jQuery objects maintain an internal stack that keeps track of changes to the matched set of elements. When one of the DOM traversal methods is called, the new set of elements is pushed onto the stack. If the previous set of elements is desired as well, can help.

Consider a page with a simple list on it:

<ul>
   <li>list item 1</li>
   <li>list item 2</li>
   <li class="third-item">list item 3</li>
   <li>list item 4</li>
   <li>list item 5</li>
</ul>

If we begin at the third item, we can find the elements which come after it:

$('li.third-item').nextAll().andSelf()
  .css('background-color', 'red');

The result of this call is a red background behind items 3, 4 and 5. First, the initial selector locates item 3, initializing the stack with the set containing just this item. The call to then pushes the set of items 4 and 5 onto the stack. Finally, the invocation merges these two sets together, creating a jQuery object that points to all three items.

Examples:

Example:

Find all divs, and all the paragraphs inside of them, and give them both classnames. Notice the div doesn't have the yellow background color since it didn't use andSelf.
<!DOCTYPE html>
<html>
<head>
  <style>
  p, div { margin:5px; padding:5px; }
  .border { border: 2px solid red; }
  .background { background:yellow; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>
    <p>First Paragraph</p>
    <p>Second Paragraph</p>
  </div>
  <script>
    $("div").find("p").andSelf().addClass("border");
    $("div").find("p").addClass("background");

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


contents – jQuery API

Returns: jQueryjQuery .contents( )

Categories: Miscellaneous Traversing, Version 1.2
Description: Get the children of each element in the set of matched elements, including text nodes.
  • version added: 1.2

  • .contents( )

Given a jQuery object that represents a set of DOM elements, the method allows us to search through the immediate children of these elements in the DOM tree and construct a new jQuery object from the matching elements. The and methods are similar, except that the former includes text nodes as well as HTML elements in the resulting jQuery object.

The method can also be used to get the content document of an iframe, if the iframe is on the same domain as the main page.

Consider a simple with a number of text nodes, each of which is separated by two line break elements ():

<div class="container">
  Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed
  do eiusmod tempor incididunt ut labore et dolore magna aliqua.
  <br /><br />
  Ut enim ad minim veniam, quis nostrud exercitation ullamco
  laboris nisi ut aliquip ex ea commodo consequat.
  <br /> <br />
  Duis aute irure dolor in reprehenderit in voluptate velit
  esse cillum dolore eu fugiat nulla pariatur.
</div>

We can employ the method to help convert this blob of text into three well-formed paragraphs:

$('.container').contents().filter(function() {
  return this.nodeType == 3;
})
  .wrap('<p></p>')
.end()
.filter('br')
  .remove();

This code first retrieves the contents of and then filters it for text nodes, which are wrapped in paragraph tags. This is accomplished by testing the of the element. This DOM property holds a numeric code indicating the node's type; text nodes use the code 3. The contents are again filtered, this time for elements, and these elements are removed.

Examples:

Example:

Find all the text nodes inside a paragraph and wrap them with a bold tag.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello <a href="http://ejohn.org/">John</a>, how are you doing?</p>
  <script>$("p").contents().filter(function(){ return this.nodeType != 1; }).wrap("<b/>");</script>
</body>
</html>

Demo:

Example:

Change the background colour of links inside of an iframe.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <iframe src="http://api.jquery.com/" width="80%" height="600" id='frameDemo'></iframe>
  <script>$("#frameDemo").contents().find("a").css("background-color","#BADA55");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


add – jQuery API

  • add( [HTML] html )

    • 1.0add( [HTML] html )

  • add( [Selector] selector, [Element] context )

    • 1.4add( [Selector] selector, [Element] context )

Returns: jQueryjQuery .add( [Selector] selector, [Element] context )

Categories: Miscellaneous Traversing, Version 1.0, Version 1.4
Description: Add elements to the set of matched elements.
  • version added: 1.0

  • .add( [Selector] selector )

  • selector A string containing a selector expression to match additional elements against.
  • version added: 1.0

  • .add( [Elements] elements )

  • elements one or more elements to add to the set of matched elements.
  • version added: 1.0

  • .add( [HTML] html )

  • html An HTML fragment to add to the set of matched elements.
  • version added: 1.4

  • .add( [Selector] selector, [Element] context )

  • selector A string containing a selector expression to match additional elements against.
  • context Add some elements rooted against the specified context.

Given a jQuery object that represents a set of DOM elements, the method constructs a new jQuery object from the union of those elements and the ones passed into the method. The argument to can be pretty much anything that accepts, including a jQuery selector expression, references to DOM elements, or an HTML snippet.

Consider a page with a simple list and a paragraph following it:

<ul>
  <li>list item 1</li>
  <li>list item 2</li>
  <li>list item 3</li>
</ul>
<p>a paragraph</p>

We can select the list items and then the paragraph by using either a selector or a reference to the DOM element itself as the method's argument:

$('li').add('p').css('background-color', 'red');

Or:

$('li').add(document.getElementsByTagName('p')[0])
  .css('background-color', 'red');

The result of this call is a red background behind all four elements. Using an HTML snippet as the method's argument (as in the third version), we can create additional elements on the fly and add those elements to the matched set of elements. Let's say, for example, that we want to alter the background of the list items along with a newly created paragraph:

$('li').add('<p id="new">new paragraph</p>')
  .css('background-color', 'red');

Although the new paragraph has been created and its background color changed, it still does not appear on the page. To place it on the page, we could add one of the insertion methods to the chain.

As of jQuery 1.4 the results from .add() will always be returned in document order (rather than a simple concatenation).

Examples:

Example:

Finds all divs and makes a border. Then adds all paragraphs to the jQuery object to set their backgrounds yellow.
<!DOCTYPE html>
<html>
<head>
  <style>
 div { width:60px; height:60px; margin:10px; float:left; }
 p { clear:left; font-weight:bold; font-size:16px;
     color:blue; margin:0 10px; padding:2px; }
 </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div></div>

  <div></div>
  <div></div>
  <div></div>
  <div></div>
  <div></div>

  <p>Added this... (notice no border)</p>
  <script>

$("div").css("border", "2px solid red")
        .add("p")
        .css("background", "yellow");
</script>
</body>
</html>

Demo:

Example:

Adds more elements, matched by the given expression, to the set of matched elements.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p><span>Hello Again</span>
  <script>$("p").add("span").css("background", "yellow");</script>
</body>
</html>

Demo:

Example:

Adds more elements, created on the fly, to the set of matched elements.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p>
  <script>$("p").clone().add("<span>Again</span>").appendTo(document.body);</script>
</body>
</html>

Demo:

Example:

Adds one or more Elements to the set of matched elements.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p><span id="a">Hello Again</span>
  <script>$("p").add(document.getElementById("a")).css("background", "yellow");</script>
</body>
</html>

Demo:

Example:

Demonstrates how to add (or push) elements to an existing collection
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p><span id="a">Hello Again</span>
  <script>var collection = $("p");
// capture the new collection
collection = collection.add(document.getElementById("a"));
collection.css("background", "yellow");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Tree Traversal – jQuery API

Tree Traversal

  • jQuery .parentsUntil( [Selector] selector )

    New in 1.4 !

    Get the ancestors of each element in the current set of matched elements, up to but not including the element matched by the selector.

  • jQuery .prevUntil( [Selector] selector )

    New in 1.4 !

    Get all preceding siblings of each element up to but not including the element matched by the selector.

  • jQuery .nextUntil( [Selector] selector )

    New in 1.4 !

    Get all following siblings of each element up to but not including the element matched by the selector.

  • jQuery .siblings( [Selector] selector )

    New in 1.0 !

    Get the siblings of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .prevAll( [Selector] selector )

    New in 1.2 !

    Get all preceding siblings of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .prev( [Selector] selector )

    New in 1.0 !

    Get the immediately preceding sibling of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .parents( [Selector] selector )

    New in 1.0 !

    Get the ancestors of each element in the current set of matched elements, optionally filtered by a selector.

  • jQuery .parent( [Selector] selector )

    New in 1.0 !

    Get the parent of each element in the current set of matched elements, optionally filtered by a selector.

  • jQuery .offsetParent( )

    New in 1.26 !

    Get the closest ancestor element that is positioned.

  • jQuery .nextAll( [String] selector )

    New in 1.2 !

    Get all following siblings of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .next( [Selector] selector )

    New in 1.0 !

    Get the immediately following sibling of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .find( [Selector] selector )

    New in 1.0 !

    Get the descendants of each element in the current set of matched elements, filtered by a selector.

  • Array .closest( [Array] selectors, [Element] context )

    New in 1.4 !

    Gets an array of all the elements and selectors matched against the current element up through the DOM tree.

  • jQuery .children( [Selector] selector )

    New in 1.0 !

    Get the children of each element in the set of matched elements, optionally filtered by a selector.


parentsUntil – jQuery API

Returns: jQueryjQuery .parentsUntil( [Selector] selector )

Categories: Tree Traversal, Version 1.4
Description: Get the ancestors of each element in the current set of matched elements, up to but not including the element matched by the selector.
  • version added: 1.4

  • .parentsUntil( [Selector] selector )

  • selector A string containing a selector expression to indicate where to stop matching ancestor elements.

Given a jQuery object that represents a set of DOM elements, the method traverses through the ancestors of these elements until it reaches an element matched by the selector passed in the method's argument. The resulting jQuery object contains all of the ancestors up to but not including the one matched by the selector. Consider a page with a basic nested list as follows:

<ul class="level-1">
  <li class="item-i">I</li>
  <li class="item-ii">II
    <ul class="level-2">
      <li class="item-a">A</li>
      <li class="item-b">B
        <ul class="level-3">
          <li class="item-1">1</li>
          <li class="item-2">2</li>
          <li class="item-3">3</li>
        </ul>
      </li>
      <li class="item-c">C</li>
    </ul>
  </li>
  <li class="item-iii">III</li>
</ul>

If we begin at item A, we can find its ancestors up to but not including as follows:

$('li.item-a').parentsUntil('.level-1')
    .css('background-color', 'red');

The result of this call is a red background for the level-2 list and the item II.

If the .parentsUntil() selector is not matched, or if no selector is supplied, the returned jQuery object contains all of the previous jQuery object's ancestors. For example, let's say we begin at item A again, but this time we use a selector that is not matched by any of its ancestors:

$('li.item-a').parentsUntil('.not-here')
    .css('background-color', 'red');

The result of this call is a red background-color style applied to the level-2 list, the item II, the level-1 list, the element, and the element.

Examples:

Example:

Find the ancestors of
  • up to
      and give them a red background color.
    • <!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<ul class="level-1">
  <li class="item-i">I</li>
  <li class="item-ii">II
    <ul class="level-2">
      <li class="item-a">A</li>
      <li class="item-b">B
        <ul class="level-3">
          <li class="item-1">1</li>
          <li class="item-2">2</li>
          <li class="item-3">3</li>
        </ul>
      </li>
      <li class="item-c">C</li>
    </ul>
  </li>
  <li class="item-iii">III</li>
</ul>
  <script>
    $('li.item-a').parentsUntil('.level-1')
      .css('background-color', 'red');
</script>
</body>
</html>

    Demo:

    Comments

    © 2010 The jQuery Project


prevUntil – jQuery API

Returns: jQueryjQuery .prevUntil( [Selector] selector )

Categories: Tree Traversal, Version 1.4
Description: Get all preceding siblings of each element up to but not including the element matched by the selector.
  • version added: 1.4

  • .prevUntil( [Selector] selector )

  • selector A string containing a selector expression to indicate where to stop matching preceding sibling elements.

Given a jQuery object that represents a set of DOM elements, the method allows us to search through the predecessors of these elements in the DOM tree, stopping when it reaches an element matched by the method's argument. The new jQuery object that is returned contains all previous siblings up to but not including the one matched by the selector.

If the selector is not matched or is not supplied, all previous siblings will be selected; in these cases it selects the same elements as the method does when no filter selector is provided.

Consider a page with a simple definition list as follows:

<dl>
  <dt>term 1</dt>
  <dd>definition 1-a</dd>
  <dd>definition 1-b</dd>
  <dd>definition 1-c</dd>
  <dd>definition 1-d</dd>

  <dt id="term-2">term 2</dt>
  <dd>definition 2-a</dd>
  <dd>definition 2-b</dd>
  <dd>definition 2-c</dd>

  <dt>term 3</dt>
  <dd>definition 3-a</dd>
  <dd>definition 3-b</dd>
</dl>

If we begin at the second term, we can find the elements which come after it until a preceding .

$('#term-2').prevUntil('dt').css('background-color', 'red');

The result of this call is a red background behind definitions , , , and .

Examples:

Example:

Find the siblings that precede
up to the preceding
and give them a red background color.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <dl>
  <dt>term 1</dt>
  <dd>definition 1-a</dd>
  <dd>definition 1-b</dd>
  <dd>definition 1-c</dd>
  <dd>definition 1-d</dd>

  <dt id="term-2">term 2</dt>
  <dd>definition 2-a</dd>
  <dd>definition 2-b</dd>
  <dd>definition 2-c</dd>

  <dt>term 3</dt>
  <dd>definition 3-a</dd>
  <dd>definition 3-b</dd>
</dl>
  <script>
    $("#term-2").prevUntil("dt")
      .css("background-color", "red")
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


nextUntil – jQuery API

Returns: jQueryjQuery .nextUntil( [Selector] selector )

Categories: Tree Traversal, Version 1.4
Description: Get all following siblings of each element up to but not including the element matched by the selector.
  • version added: 1.4

  • .nextUntil( [Selector] selector )

  • selector A string containing a selector expression to indicate where to stop matching following sibling elements.

Given a jQuery object that represents a set of DOM elements, the method allows us to search through the successors of these elements in the DOM tree, stopping when it reaches an element matched by the method's argument. The new jQuery object that is returned contains all following siblings up to but not including the one matched by the selector.

If the selector is not matched or is not supplied, all following siblings will be selected; in these cases it selects the same elements as the method does when no filter selector is provided.

Consider a page with a simple definition list as follows:

<dl>
  <dt>term 1</dt>
  <dd>definition 1-a</dd>
  <dd>definition 1-b</dd>
  <dd>definition 1-c</dd>
  <dd>definition 1-d</dd>

  <dt id="term-2">term 2</dt>
  <dd>definition 2-a</dd>
  <dd>definition 2-b</dd>
  <dd>definition 2-c</dd>

  <dt>term 3</dt>
  <dd>definition 3-a</dd>
  <dd>definition 3-b</dd>
</dl>

If we begin at the second term, we can find the elements which come after it until a following .

$('#term-2').nextUntil('dt').css('background-color', 'red');

The result of this call is a red background behind definitions , , and .

Examples:

Example:

Find the siblings that follow
up to the next
and give them a red background color.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <dl>
  <dt>term 1</dt>
  <dd>definition 1-a</dd>
  <dd>definition 1-b</dd>
  <dd>definition 1-c</dd>
  <dd>definition 1-d</dd>

  <dt id="term-2">term 2</dt>
  <dd>definition 2-a</dd>
  <dd>definition 2-b</dd>
  <dd>definition 2-c</dd>

  <dt>term 3</dt>
  <dd>definition 3-a</dd>
  <dd>definition 3-b</dd>
</dl>
  <script>
    $("#term-2").nextUntil("dt")
      .css("background-color", "red")
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


siblings – jQuery API

Returns: jQueryjQuery .siblings( [Selector] selector )

Categories: Tree Traversal, Version 1.0
Description: Get the siblings of each element in the set of matched elements, optionally filtered by a selector.
  • version added: 1.0

  • .siblings( [Selector] selector )

  • selector A string containing a selector expression to match elements against.

Given a jQuery object that represents a set of DOM elements, the method allows us to search through the siblings of these elements in the DOM tree and construct a new jQuery object from the matching elements.

The method optionally accepts a selector expression of the same type that we can pass to the function. If the selector is supplied, the elements will be filtered by testing whether they match it.

Consider a page with a simple list on it:

<ul>
   <li>list item 1</li>
   <li>list item 2</li>
   <li class="third-item">list item 3</li>
   <li>list item 4</li>
   <li>list item 5</li>
</ul>

If we begin at the third item, we can find its siblings:

$('li.third-item').siblings().css('background-color', 'red');

The result of this call is a red background behind items 1, 2, 4, and 5. Since we do not supply a selector expression, all of the siblings are part of the object. If we had supplied one, only the matching items among these four would be included.

The original element is not included among the siblings, which is important to remember when we wish to find all elements at a particular level of the DOM tree.

Examples:

Example:

Find the unique siblings of all yellow li elements in the 3 lists (including other yellow li elements if appropriate).
<!DOCTYPE html>
<html>
<head>
  <style>
  ul { float:left; margin:5px; font-size:16px; font-weight:bold; }
  p { color:blue; margin:10px 20px; font-size:16px; padding:5px;
      font-weight:bolder; }
  .hilite { background:yellow; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <ul>
    <li>One</li>

    <li>Two</li>
    <li class="hilite">Three</li>
    <li>Four</li>
  </ul>

  <ul>
    <li>Five</li>
    <li>Six</li>
    <li>Seven</li>

  </ul>
  <ul>
    <li>Eight</li>
    <li class="hilite">Nine</li>

    <li>Ten</li>
    <li class="hilite">Eleven</li>
  </ul>
  <p>Unique siblings: <b></b></p>
  <script>

    var len = $(".hilite").siblings()
                          .css("color", "red")
                          .length;
    $("b").text(len);
</script>
</body>
</html>

Demo:

Example:

Find all siblings with a class "selected" of each div.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div><span>Hello</span></div>

  <p class="selected">Hello Again</p>
  <p>And Again</p>
  <script>$("p").siblings(".selected").css("background", "yellow");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


prevAll – jQuery API

Returns: jQueryjQuery .prevAll( [Selector] selector )

Categories: Tree Traversal, Version 1.2
Description: Get all preceding siblings of each element in the set of matched elements, optionally filtered by a selector.
  • version added: 1.2

  • .prevAll( [Selector] selector )

  • selector A string containing a selector expression to match elements against.

Given a jQuery object that represents a set of DOM elements, the method allows us to search through the predecessors of these elements in the DOM tree and construct a new jQuery object from the matching elements.

The method optionally accepts a selector expression of the same type that we can pass to the function. If the selector is supplied, the elements will be filtered by testing whether they match it.

Consider a page with a simple list on it:

<ul>
   <li>list item 1</li>
   <li>list item 2</li>
   <li class="third-item">list item 3</li>
   <li>list item 4</li>
   <li>list item 5</li>
</ul>

If we begin at the third item, we can find the elements which come before it:

$('li.third-item').prevAll().css('background-color', 'red');

The result of this call is a red background behind items 1 and 2. Since we do not supply a selector expression, these preceding elements are unequivocally included as part of the object. If we had supplied one, the elements would be tested for a match before they were included.

Examples:

Example:

Locate all the divs preceding the last div and give them a class.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { width:70px; height:70px; background:#abc;
        border:2px solid black; margin:10px; float:left; }
  div.before { border-color: red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div></div>
  <div></div>
  <div></div>
  <div></div>
  <script>$("div:last").prevAll().addClass("before");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


prev – jQuery API

Returns: jQueryjQuery .prev( [Selector] selector )

Categories: Tree Traversal, Version 1.0
Description: Get the immediately preceding sibling of each element in the set of matched elements, optionally filtered by a selector.
  • version added: 1.0

  • .prev( [Selector] selector )

  • selector A string containing a selector expression to match elements against.

Given a jQuery object that represents a set of DOM elements, the method allows us to search through the predecessors of these elements in the DOM tree and construct a new jQuery object from the matching elements.

The method optionally accepts a selector expression of the same type that we can pass to the function. If the selector is supplied, the elements will be filtered by testing whether they match it.

Consider a page with a simple list on it:

<ul>
   <li>list item 1</li>
   <li>list item 2</li>
   <li class="third-item">list item 3</li>
   <li>list item 4</li>
   <li>list item 5</li>
</ul>

If we begin at the third item, we can find the element which comes just before it:

$('li.third-item').prev().css('background-color', 'red');

The result of this call is a red background behind item 2. Since we do not supply a selector expression, this preceding element is unequivocally included as part of the object. If we had supplied one, the element would be tested for a match before it was included.

Examples:

Example:

Find the very previous sibling of each div.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { width:40px; height:40px; margin:10px;
        float:left; border:2px blue solid;
        padding:2px; }
  span { font-size:14px; }
  p { clear:left; margin:10px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div></div>
  <div></div>
  <div><span>has child</span></div>

  <div></div>
  <div></div>
  <div></div>
  <div id="start"></div>

  <div></div>
  <p><button>Go to Prev</button></p>
  <script>
    var $curr = $("#start");
    $curr.css("background", "#f99");
    $("button").click(function () {
      $curr = $curr.prev();
      $("div").css("background", "");
      $curr.css("background", "#f99");
    });

</script>
</body>
</html>

Demo:

Example:

For each paragraph, find the very previous sibling that has a class "selected".
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div><span>Hello</span></div>

  <p class="selected">Hello Again</p>
  <p>And Again</p>
  <script>$("p").prev(".selected").css("background", "yellow");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


parents – jQuery API

Returns: jQueryjQuery .parents( [Selector] selector )

Categories: Tree Traversal, Version 1.0
Description: Get the ancestors of each element in the current set of matched elements, optionally filtered by a selector.
  • version added: 1.0

  • .parents( [Selector] selector )

  • selector A string containing a selector expression to match elements against.

Given a jQuery object that represents a set of DOM elements, the method allows us to search through the ancestors of these elements in the DOM tree and construct a new jQuery object from the matching elements ordered from immediate parent on up. The and methods are similar, except that the latter only travels a single level up the DOM tree.

The method optionally accepts a selector expression of the same type that we can pass to the function. If the selector is supplied, the elements will be filtered by testing whether they match it.

Consider a page with a basic nested list on it:

<ul class="level-1">
  <li class="item-i">I</li>
  <li class="item-ii">II
    <ul class="level-2">
      <li class="item-a">A</li>
      <li class="item-b">B
        <ul class="level-3">
          <li class="item-1">1</li>
          <li class="item-2">2</li>
          <li class="item-3">3</li>
        </ul>
      </li>
      <li class="item-c">C</li>
    </ul>
  </li>
  <li class="item-iii">III</li>
</ul>

If we begin at item A, we can find its ancestors:

$('li.item-a').parents().css('background-color', 'red');

The result of this call is a red background for the level-2 list, item II, and the level-1 list (and on up the DOM tree all the way to the element). Since we do not supply a selector expression, all of the ancestors are part of the returned jQuery object. If we had supplied one, only the matching items among these would be included.

Examples:

Example:

Find all parent elements of each b.
<!DOCTYPE html>
<html>
<head>
  <style>
  b, span, p, html body {
    padding: .5em;
    border: 1px solid;
  }
  b { color:blue; }
  strong { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>
    <p>
      <span>
        <b>My parents are: </b>
      </span>

    </p>
  </div>
  <script>
var parentEls = $("b").parents()
            .map(function () {
                  return this.tagName;
                })
            .get().join(", ");
$("b").append("<strong>" + parentEls + "</strong>");

</script>
</body>
</html>

Demo:

Example:

Click to find all unique div parent elements of each span.
<!DOCTYPE html>
<html>
<head>
  <style>
  p, div, span {margin:2px; padding:1px; }
  div { border:2px white solid; }
  span { cursor:pointer; font-size:12px; }
  .selected { color:blue; }
  b { color:red; display:block; font-size:14px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>
    <div>
      <div><span>Hello</span></div>
      <span>Hello Again</span>

    </div>
    <div>
      <span>And Hello Again</span>
    </div>
  </p>

  <b>Click Hellos to toggle their parents.</b>
  <script>
function showParents() {
  $("div").css("border-color", "white");
  var len = $("span.selected")
                   .parents("div")
                   .css("border", "2px red solid")
                   .length;
  $("b").text("Unique div parents: " + len);
}
$("span").click(function () {
  $(this).toggleClass("selected");
  showParents();
});</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


nextAll – jQuery API

Returns: jQueryjQuery .nextAll( [String] selector )

Categories: Tree Traversal, Version 1.2
Description: Get all following siblings of each element in the set of matched elements, optionally filtered by a selector.
  • version added: 1.2

  • .nextAll( [String] selector )

  • selector A string containing a selector expression to match elements against.

Given a jQuery object that represents a set of DOM elements, the method allows us to search through the successors of these elements in the DOM tree and construct a new jQuery object from the matching elements.

The method optionally accepts a selector expression of the same type that we can pass to the function. If the selector is supplied, the elements will be filtered by testing whether they match it.

Consider a page with a simple list on it:

<ul>
   <li>list item 1</li>
   <li>list item 2</li>
   <li class="third-item">list item 3</li>
   <li>list item 4</li>
   <li>list item 5</li>
</ul>

If we begin at the third item, we can find the elements which come after it:

$('li.third-item').nextAll().css('background-color', 'red');

The result of this call is a red background behind items 4 and 5. Since we do not supply a selector expression, these following elements are unequivocally included as part of the object. If we had supplied one, the elements would be tested for a match before they were included.

Examples:

Example:

Locate all the divs after the first and give them a class.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { width: 80px; height: 80px; background: #abc;
        border: 2px solid black; margin: 10px; float: left; }
  div.after { border-color: red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>first</div>
  <div>sibling<div>child</div></div>
  <div>sibling</div>

  <div>sibling</div>
  <script>$("div:first").nextAll().addClass("after");</script>
</body>
</html>

Demo:

Example:

Locate all the paragraphs after the second child in the body and give them a class.
<!DOCTYPE html>
<html>
<head>
  <style>
  div, p { width: 60px; height: 60px; background: #abc;
           border: 2px solid black; margin: 10px; float: left; }
  .after { border-color: red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>p</p>

  <div>div</div>
  <p>p</p>
  <p>p</p>
  <div>div</div>

  <p>p</p>
  <div>div</div>
  <script>
    $(":nth-child(1)").nextAll("p").addClass("after");
</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


next – jQuery API

Returns: jQueryjQuery .next( [Selector] selector )

Categories: Tree Traversal, Version 1.0
Description: Get the immediately following sibling of each element in the set of matched elements, optionally filtered by a selector.
  • version added: 1.0

  • .next( [Selector] selector )

  • selector A string containing a selector expression to match elements against.

Given a jQuery object that represents a set of DOM elements, the method allows us to search through the immediately following sibling of these elements in the DOM tree and construct a new jQuery object from the matching elements.

The method optionally accepts a selector expression of the same type that we can pass to the function. If the the immediately following sibling matches the selector, it remains in the newly constructed jQuery object; otherwise, it is excluded.

Consider a page with a simple list on it:

<ul>
   <li>list item 1</li>
   <li>list item 2</li>
   <li class="third-item">list item 3</li>
   <li>list item 4</li>
   <li>list item 5</li>
</ul>

If we begin at the third item, we can find the element which comes just after it:

$('li.third-item').next().css('background-color', 'red');

The result of this call is a red background behind item 4. Since we do not supply a selector expression, this following element is unequivocally included as part of the object. If we had supplied one, the element would be tested for a match before it was included.

Examples:

Example:

Find the very next sibling of each disabled button and change its text "this button is disabled".
<!DOCTYPE html>
<html>
<head>
  <style>
  span { color:blue; font-weight:bold; }
  button { width:100px; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div><button disabled="disabled">First</button> - <span></span></div>
  <div><button>Second</button> - <span></span></div>

  <div><button disabled="disabled">Third</button> - <span></span></div>
  <script>$("button[disabled]").next().text("this button is disabled");</script>
</body>
</html>

Demo:

Example:

Find the very next sibling of each paragraph. Keep only the ones with a class "selected".
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello</p>

  <p class="selected">Hello Again</p>
  <div><span>And Again</span></div>
  <script>$("p").next(".selected").css("background", "yellow");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


find – jQuery API

Returns: jQueryjQuery .find( [Selector] selector )

Categories: Tree Traversal, Version 1.0
Description: Get the descendants of each element in the current set of matched elements, filtered by a selector.
  • version added: 1.0

  • .find( [Selector] selector )

  • selector A string containing a selector expression to match elements against.

Given a jQuery object that represents a set of DOM elements, the method allows us to search through the descendants of these elements in the DOM tree and construct a new jQuery object from the matching elements. The and methods are similar, except that the latter only travels a single level down the DOM tree.

The method accepts a selector expression of the same type that we can pass to the function. The elements will be filtered by testing whether they match this selector.

Consider a page with a basic nested list on it:

<ul class="level-1">
  <li class="item-i">I</li>
  <li class="item-ii">II
    <ul class="level-2">
      <li class="item-a">A</li>
      <li class="item-b">B
        <ul class="level-3">
          <li class="item-1">1</li>
          <li class="item-2">2</li>
          <li class="item-3">3</li>
        </ul>
      </li>
      <li class="item-c">C</li>
    </ul>
  </li>
  <li class="item-iii">III</li>
</ul>

If we begin at item II, we can find list items within it:

$('li.item-ii').find('li').css('background-color', 'red');

The result of this call is a red background on items A, B, 1, 2, 3, and C. Even though item II matches the selector expression, it is not included in the results; only descendants are considered candidates for the match.

is implemented with the therefore, is equivalent to .

Examples:

Example:

Starts with all paragraphs and searches for descendant span elements, same as $("p span")
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p><span>Hello</span>, how are you?</p>
<p>Me? I'm <span>good</span>.</p>
  <script>
  $("p").find("span").css('color','red');
</script>
</body>
</html>

Demo:

Example:

Add spans around each word then add a hover and italicize words with the letter .
<!DOCTYPE html>
<html>
<head>
  <style>
  p { font-size:20px; width:200px; cursor:default;
      color:blue; font-weight:bold; margin:0 10px; }
  .hilite { background:yellow; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>
  When the day is short
  find that which matters to you
  or stop believing
  </p>
  <script>
  var newText = $("p").text().split(" ").join("</span> <span>");
  newText = "<span>" + newText + "</span>";

  $("p").html(newText)
    .find('span')
    .hover(function() {
      $(this).addClass("hilite");
    },
      function() { $(this).removeClass("hilite");
    })
  .end()
    .find(":contains('t')")
    .css({"font-style":"italic", "font-weight":"bolder"});

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


closest – jQuery API

  • closest( [Selector] selector )

    • 1.3closest( [Selector] selector )

  • closest( [Array] selectors, [Element] context )

    • 1.4closest( [Array] selectors, [Element] context )

Returns: jQueryjQuery .closest( [Selector] selector, [Element] context )

Categories: Tree Traversal, Version 1.3, Version 1.4
Description: Get the first ancestor element that matches the selector, beginning at the current element and progressing up through the DOM tree.
  • version added: 1.3

  • .closest( [Selector] selector )

  • selector A string containing a selector expression to match elements against.
  • version added: 1.4

  • .closest( [Selector] selector, [Element] context )

  • selector A string containing a selector expression to match elements against.
  • context A DOM element within which a matching element may be found. If no context is passed in then the context of the jQuery set will be used instead.

Given a jQuery object that represents a set of DOM elements, the method allows us to search through these elements and their ancestors in the DOM tree and construct a new jQuery object from the matching elements. The and methods are similar in that they both traverse up the DOM tree. The differences between the two, though subtle, are significant:

  <ul id="one" class="level-1">
    <li class="item-i">I</li>
    <li id="ii" class="item-ii">II
    <ul class="level-2">
      <li class="item-a">A</li>
      <li class="item-b">B
        <ul class="level-3">
          <li class="item-1">1</li>
          <li class="item-2">2</li>
          <li class="item-3">3</li>
        </ul>
      </li>
      <li class="item-c">C</li>
    </ul>
  </li>
  <li class="item-iii">III</li>
</ul>

Suppose we perform a search for elements starting at item A:

$('li.item-a').closest('ul')
  .css('background-color', 'red');

This will change the color of the level-2 , since it is the first encountered when traveling up the DOM tree.

Suppose we search for an element instead:

$('li.item-a').closest('li')
  .css('background-color', 'red');

This will change the color of list item A. The method begins its search with the element itself before progressing up the DOM tree, and stops when item A matches the selector.

We can pass in a DOM element as the context within which to search for the closest element.

var listItemII = document.getElementById('ii');
$('li.item-a').closest('ul', listItemII)
  .css('background-color', 'red');
$('li.item-a').closest('#one', listItemII)
  .css('background-color', 'green');

This will change the color of the level-2 , because it is both the first ancestor of list item A and a descendant of list item II. It will not change the color of the level-1 , however, because it is not a descendant of list item II.

Examples:

Example:

Show how event delegation can be done with closest.
<!DOCTYPE html>
<html>
<head>
  <style>
  li { margin: 3px; padding: 3px; background: #EEEEEE; }
  li.hilight { background: yellow; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <ul>
<li><b>Click me!</b></li>
<li>You can also <b>Click me!</b></li>
</ul>
  <script>

    $(document).bind("click", function (e) {
      $(e.target).closest("li").toggleClass("hilight");
    });
</script>
</body>
</html>

Demo:

Returns: ArrayArray .closest( [Array] selectors, [Element] context )

Categories: Tree Traversal, Version 1.3, Version 1.4
Description: Gets an array of all the elements and selectors matched against the current element up through the DOM tree.
  • version added: 1.4

  • .closest( [Array] selectors, [Element] context )

  • selectors An array or string containing a selector expression to match elements against (can also be a jQuery object).
  • context A DOM element within which a matching element may be found. If no context is passed in then the context of the jQuery set will be used instead.

This method is primarily meant to be used internally or by plugin authors.

Examples:

Example:

Show how event delegation can be done with closest.
<!DOCTYPE html>
<html>
<head>
  <style>
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <ul><li></li><li></li></ul>
  <script>var close = $("li:first").closest(["ul", "body"]);
        $.each(close, function(i){
  $("li").eq(i).html( this.selector + ": " + this.elem.nodeName );
});</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


children – jQuery API

Returns: jQueryjQuery .children( [Selector] selector )

Categories: Tree Traversal, Version 1.0
Description: Get the children of each element in the set of matched elements, optionally filtered by a selector.
  • version added: 1.0

  • .children( [Selector] selector )

  • selector A string containing a selector expression to match elements against.

Given a jQuery object that represents a set of DOM elements, the method allows us to search through the immediate children of these elements in the DOM tree and construct a new jQuery object from the matching elements. The and methods are similar, except that the latter only travels a single level down the DOM tree.

The method optionally accepts a selector expression of the same type that we can pass to the function. If the selector is supplied, the elements will be filtered by testing whether they match it.

Consider a page with a basic nested list on it:

<ul class="level-1">
  <li class="item-i">I</li>
  <li class="item-ii">II
    <ul class="level-2">
      <li class="item-a">A</li>
      <li class="item-b">B
        <ul class="level-3">
          <li class="item-1">1</li>
          <li class="item-2">2</li>
          <li class="item-3">3</li>
        </ul>
      </li>
      <li class="item-c">C</li>
    </ul>
  </li>
  <li class="item-iii">III</li>
</ul>

If we begin at the level-2 list, we can find its children:

$('ul.level-2').children().css('background-color', 'red');

The result of this call is a red background behind items A, B, and C. Since we do not supply a selector expression, all of the children are part of the returned jQuery object. If we had supplied one, only the matching items among these three would be included.

Examples:

Example:

Find all children of the clicked element.
<!DOCTYPE html>
<html>
<head>
  <style>
  body { font-size:16px; font-weight:bolder; }
  div { width:130px; height:82px; margin:10px; float:left;
        border:1px solid blue; padding:4px; }
  #container { width:auto; height:105px; margin:0; float:none;
        border:none; }
  .hilite { border-color:red; }
  #results { display:block; color:red; }
  p { margin:10px; border:1px solid transparent; }
  span { color:blue; border:1px solid transparent; }
  input { width:100px; }
  em { border:1px solid transparent; }
  a { border:1px solid transparent; }
  b { border:1px solid transparent; }
  button { border:1px solid transparent; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div id="container">

    <div>
      <p>This <span>is the <em>way</em> we</span>
      write <em>the</em> demo,</p>

    </div>
    <div>
      <a href="#"><b>w</b>rit<b>e</b></a> the <span>demo,</span> <button>write
      the</button> demo,
    </div>

    <div>
      This <span>the way we <em>write</em> the <em>demo</em> so</span>

      <input type="text" value="early" /> in
    </div>
    <p>
      <span>t</span>he <span>m</span>orning.
      <span id="results">Found <span>0</span> children in <span>TAG</span>.</span>

    </p>
  </div>
  <script>

    $("#container").click(function (e) {
      $("*").removeClass("hilite");
      var $kids = $(e.target).children();
      var len = $kids.addClass("hilite").length;

      $("#results span:first").text(len);
      $("#results span:last").text(e.target.tagName);

      e.preventDefault();
      return false;
    });
</script>
</body>
</html>

Demo:

Example:

Find all children of each div.
<!DOCTYPE html>
<html>
<head>
  <style>
  body { font-size:16px; font-weight:bolder; }
  span { color:blue; }
  p { margin:5px 0; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>Hello (this is a paragraph)</p>

  <div><span>Hello Again (this span is a child of the a div)</span></div>
  <p>And <span>Again</span> (in another paragraph)</p>

  <div>And One Last <span>Time</span> (most text directly in a div)</div>
  <script>$("div").children().css("border-bottom", "3px double red");</script>
</body>
</html>

Demo:

Example:

Find all children with a class "selected" of each div.
<!DOCTYPE html>
<html>
<head>
  <style>
  body { font-size:16px; font-weight:bolder; }
  p { margin:5px 0; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>
    <span>Hello</span>
    <p class="selected">Hello Again</p>
    <div class="selected">And Again</div>

    <p>And One Last Time</p>
  </div>
  <script>$("div").children(".selected").css("color", "blue");</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


Utilities – jQuery API

Utilities

  • Object jQuery.parseJSON( [String] json )

    New in 1.4.1 !

    Takes a well-formed JSON string and returns the resulting JavaScript object.

  • Function jQuery.proxy( [Object] context, [String] name )

    New in 1.4 !

    Takes a function and returns a new one that will always have a particular context.

  • Boolean jQuery.contains( [Element] container, [Element] contained )

    New in 1.4 !

    Check to see if a DOM node is within another DOM node.

  • Function jQuery.noop( )

    New in 1.4 !

    An empty function.

  • jQuery.globalEval( [String] code )

    New in 1.0.4 !

    Execute some JavaScript code globally.

  • Boolean jQuery.isXMLDoc( [Element] node )

    New in 1.1.4 !

    Check to see if a DOM node is within an XML document (or is an XML document).

  • jQuery jQuery.removeData( [Element] element, [String] name )

    New in 1.2.3 !

    Remove a previously-stored piece of data.

  • Object jQuery.data( [Element] element )

    New in 1.4 !

    Returns value at named data store for the element, as set by , or the full data store for the element.

  • jQuery jQuery.dequeue( [Element] element, [String] queueName )

    New in 1.3 !

    Execute the next function on the queue for the matched element.

  • jQuery jQuery.queue( [Element] element, [String] queueName, [Function] callback() )

    New in 1.3 !

    Manipulate the queue of functions to be executed on the matched element.

  • jQuery .clearQueue( [String] queueName )

    New in 1.4 !

    Remove from the queue all items that have not yet been run.

  • Boolean jQuery.isEmptyObject( [Object] object )

    New in 1.4 !

    Check to see if an object is empty (contains no properties).

  • Boolean jQuery.isPlainObject( [Object] object )

    New in 1.4 !

    Check to see if an object is a plain object (created using "{}" or "new Object").

  • jQuery .dequeue( [String] queueName )

    New in 1.2 !

    Execute the next function on the queue for the matched elements.

  • jQuery .queue( [String] queueName, [Function] callback( next ) )

    New in 1.2 !

    Manipulate the queue of functions to be executed on the matched elements.

  • Map jQuery.browser

    New in 1.0 !

    Contains flags for the useragent, read from navigator.userAgent. While jQuery.browser will not be removed from future versions of jQuery, every effort to use jQuery.support and proper feature detection should be made.

  • String jQuery.browser.version

    New in 1.1.3 !

    The version number of the rendering engine for the user's browser.

  • String jQuery.trim( [String] str )

    New in 1.0 !

    Remove the whitespace from the beginning and end of a string.

  • boolean jQuery.isFunction( [Object] obj )

    New in 1.2 !

    Determine if the argument passed is a Javascript function object.

  • boolean jQuery.isArray( [Object] obj )

    New in 1.3 !

    Determine whether the argument is an array.

  • Array jQuery.unique( [Array] array )

    New in 1.1.3 !

    Sorts an array of DOM elements, in place, with the duplicates removed. Note that this only works on arrays of DOM elements, not strings or numbers.

  • Array jQuery.merge( [Array] first, [Array] second )

    New in 1.0 !

    Merge the contents of two arrays together into the first array.

  • Number jQuery.inArray( [Any] value, [Array] array )

    New in 1.2 !

    Search for a specified value within an array and return its index (or -1 if not found).

  • Array jQuery.map( [Array] array, [Function] callback(elementOfArray, indexInArray) )

    New in 1.0 !

    Translate all items in an array or array-like object to another array of items.

  • Array jQuery.makeArray( [Object] obj )

    New in 1.2 !

    Convert an array-like object into a true JavaScript array.

  • Array jQuery.grep( [Array] array, [Function] function(elementOfArray, indexInArray), [Boolean] invert )

    New in 1.0 !

    Finds the elements of an array which satisfy a filter function. The original array is not affected.

  • Object jQuery.extend( [Boolean] deep, [Object] target, [Object] object1, [Object] objectN )

    New in 1.1.4 !

    Merge the contents of two or more objects together into the first object.

  • Object jQuery.each( [Object] collection, [Function] callback(indexInArray, valueOfElement) )

    New in 1.0 !

    A generic iterator function, which can be used to seamlessly iterate over both objects and arrays. Arrays and array-like objects with a length property (such as a function's arguments object) are iterated by numeric index, from 0 to length-1. Other objects are iterated via their named properties.

  • Boolean jQuery.boxModel

    New in 1.0 !

    . States if the current page, in the user's browser, is being rendered using the .

  • Object jQuery.support

    New in 1.3 !

    A collection of properties that represent the presence of different browser features or bugs.


jQuery.parseJSON – jQuery API

Returns: ObjectObject jQuery.parseJSON( [String] json )

Categories: Utilities, Version 1.4.1
Description: Takes a well-formed JSON string and returns the resulting JavaScript object.
  • version added: 1.4.1

  • jQuery.parseJSON( [String] json )

  • json The JSON string to parse.

Passing in a malformed JSON string will result in an exception being thrown. For example, the following are all malformed JSON strings:

Additionally if you pass in nothing, an empty string, null, or undefined, 'null' will be returned from parseJSON. Where the browser provides a native implementation of , jQuery uses it to parse the string. For details on the JSON format, see .

Examples:

Example:

Parse a JSON string.
<script>var obj = jQuery.parseJSON('{"name":"John"}');
alert( obj.name === "John" );</script>

Comments

© 2010 The jQuery Project


jQuery.contains – jQuery API

Returns: BooleanBoolean jQuery.contains( [Element] container, [Element] contained )

Categories: Utilities, Version 1.4
Description: Check to see if a DOM node is within another DOM node.
  • version added: 1.4

  • jQuery.contains( [Element] container, [Element] contained )

  • container The DOM element that may contain the other element.
  • contained The DOM node that may be contained by the other element.

Examples:

Example:

Check if an element is inside another.
<script>jQuery.contains(document.documentElement, document.body); // true
jQuery.contains(document.body, document.documentElement); // false</script>

Comments

© 2010 The jQuery Project


jQuery.noop – jQuery API

Returns: FunctionFunction jQuery.noop( )

Categories: Utilities, Version 1.4
Description: An empty function.
  • version added: 1.4

  • jQuery.noop( )

You can use this empty function when you wish to pass around a function that will do nothing.

This is useful for plugin authors who offer optional callbacks; in the case that no callback is given, something like could execute.

Examples:

Comments

© 2010 The jQuery Project


jQuery.globalEval – jQuery API

Returns: jQuery.globalEval( [String] code )

Categories: Utilities, Version 1.0.4
Description: Execute some JavaScript code globally.
  • version added: 1.0.4

  • jQuery.globalEval( [String] code )

  • code The JavaScript code to execute.

This method behaves differently from using a normal JavaScript in that it's executed within the global context (which is important for loading external scripts dynamically).

Examples:

Example:

Execute a script in the global context.
<script>function test(){
    jQuery.globalEval("var newVar = true;")
}
test();
// newVar === true</script>

Comments

© 2010 The jQuery Project


jQuery.isXMLDoc – jQuery API

Returns: BooleanBoolean jQuery.isXMLDoc( [Element] node )

Categories: Utilities, Version 1.1.4
Description: Check to see if a DOM node is within an XML document (or is an XML document).
  • version added: 1.1.4

  • jQuery.isXMLDoc( [Element] node )

  • node The DOM node that will be checked to see if it's in an XML document.

Examples:

Example:

Check an object to see if it's in an XML document.
<script>jQuery.isXMLDoc(document) // false
jQuery.isXMLDoc(document.body) // false</script>

Comments

© 2010 The jQuery Project


jQuery.isEmptyObject – jQuery API

Returns: BooleanBoolean jQuery.isEmptyObject( [Object] object )

Categories: Utilities, Version 1.4
Description: Check to see if an object is empty (contains no properties).
  • version added: 1.4

  • jQuery.isEmptyObject( [Object] object )

  • object The object that will be checked to see if it's empty.

As of jQuery 1.4 this method checks both properties on the object itself and properties inherited from prototypes (in that it doesn't use hasOwnProperty).

Examples:

Example:

Check an object to see if it's empty.
<script>jQuery.isEmptyObject({}) // true
jQuery.isEmptyObject({ foo: "bar" }) // false</script>

Comments

© 2010 The jQuery Project


jQuery.isPlainObject – jQuery API

Returns: BooleanBoolean jQuery.isPlainObject( [Object] object )

Categories: Utilities, Version 1.4
Description: Check to see if an object is a plain object (created using "{}" or "new Object").
  • version added: 1.4

  • jQuery.isPlainObject( [Object] object )

  • object The object that will be checked to see if it's a plain object.

Examples:

Example:

Check an object to see if it's a plain object.
<script>jQuery.isPlainObject({}) // true
jQuery.isPlainObject("test") // false</script>

Comments

© 2010 The jQuery Project


jQuery.trim – jQuery API

Returns: StringString jQuery.trim( [String] str )

Categories: Utilities, Version 1.0
Description: Remove the whitespace from the beginning and end of a string.
  • version added: 1.0

  • jQuery.trim( [String] str )

  • str The string to trim.

The function removes all newlines, spaces (including non-breaking spaces), and tabs from the beginning and end of the supplied string. If these whitespace characters occur in the middle of the string, they are preserved.

Examples:

Example:

Remove the two white spaces at the start and at the end of the string.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <button>Show Trim Example</button>
  <script>

$("button").click(function () {
var str = "     lots of spaces before and after     ";
alert("'" + str + "'");

str = jQuery.trim(str);
alert("'" + str + "' - no longer");
});

</script>
</body>
</html>

Demo:

Example:

Remove the two white spaces at the start and at the end of the string.
<script>$.trim("  hello, how are you?  ");</script>

Comments

© 2010 The jQuery Project


jQuery.isFunction – jQuery API

Returns: booleanboolean jQuery.isFunction( [Object] obj )

Categories: Utilities, Version 1.2
Description: Determine if the argument passed is a Javascript function object.
  • version added: 1.2

  • jQuery.isFunction( [Object] obj )

  • obj Object to test whether or not it is a function.

As of jQuery 1.3, functions provided by the browser like and DOM element methods like are not guaranteed to be detected as functions in browsers such as Internet Explorer.

Examples:

Example:

Test a few parameter examples.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { color:blue; margin:2px; font-size:14px; }
  span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

  <div>jQuery.isFunction(objs[0]) = <span></span></div>

  <div>jQuery.isFunction(objs[1]) = <span></span></div>
  <div>jQuery.isFunction(objs[2]) = <span></span></div>
  <div>jQuery.isFunction(objs[3]) = <span></span></div>

  <div>jQuery.isFunction(objs[4]) = <span></span></div>

  <script>
    function stub() {
    }
    var objs = [
          function () {},
          { x:15, y:20 },
          null,
          stub,
          "function"
        ];

    jQuery.each(objs, function (i) {
      var isFunc = jQuery.isFunction(objs[i]);
      $("span").eq(i).text(isFunc);
    });
</script>
</body>
</html>

Demo:

Example:

Finds out if the parameter is a funcion.
<script>$.isFunction(function(){});</script>

Comments

© 2010 The jQuery Project


jQuery.isArray – jQuery API

Returns: booleanboolean jQuery.isArray( [Object] obj )

Categories: Utilities, Version 1.3
Description: Determine whether the argument is an array.
  • version added: 1.3

  • jQuery.isArray( [Object] obj )

  • obj Object to test whether or not it is an array.

returns a Boolean indicating whether the object is a JavaScript array (not an array-like object, such as a jQuery object).

Examples:

Example:

Finds out if the parameter is an array.
<!DOCTYPE html>
<html>
<head>

  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  Is [] an Array? <b></b>
  <script>$("b").append( "" + $.isArray([]) );</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


jQuery.unique – jQuery API

Returns: ArrayArray jQuery.unique( [Array] array )

Categories: Utilities, Version 1.1.3
Description: Sorts an array of DOM elements, in place, with the duplicates removed. Note that this only works on arrays of DOM elements, not strings or numbers.
  • version added: 1.1.3

  • jQuery.unique( [Array] array )

  • array The Array of DOM elements.

The function searches through an array of objects, sorting the array, and removing any duplicate nodes. This function only works on plain JavaScript arrays of DOM elements, and is chiefly used internally by jQuery.

As of jQuery 1.4 the results will always be returned in document order.

Examples:

Example:

Removes any duplicate elements from the array of divs.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { color:blue; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>There are 6 divs in this document.</div>
  <div></div>
  <div class="dup"></div>
  <div class="dup"></div>

  <div class="dup"></div>
  <div></div>
  <script>

    var divs = $("div").get(); // unique() must take a native array

    // add 3 elements of class dup too (they are divs)
    divs = divs.concat($(".dup").get());
    $("div:eq(1)").text("Pre-unique there are " + divs.length + " elements.");

    divs = jQuery.unique(divs);
    $("div:eq(2)").text("Post-unique there are " + divs.length + " elements.")
                  .css("color", "red");

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


jQuery.merge – jQuery API

Returns: ArrayArray jQuery.merge( [Array] first, [Array] second )

Categories: Utilities, Version 1.0
Description: Merge the contents of two arrays together into the first array.
  • version added: 1.0

  • jQuery.merge( [Array] first, [Array] second )

  • first The first array to merge, the elements of second added.
  • second The second array to merge into the first, unaltered.

The operation forms an array that contains all elements from the two arrays. The orders of items in the arrays are preserved, with items from the second array appended. The function is destructive. It alters the first parameter to add the items from the second.

If you need the original first array, make a copy of it before calling . Fortunately, itself can be used for this duplication:

var newArray = $.merge([], oldArray);

This shortcut creates a new, empty array and merges the contents of oldArray into it, effectively cloning the array.

Prior to jQuery 1.4, the arguments should be true Javascript Array objects; use if they are not.

Examples:

Example:

Merges two arrays, altering the first argument.
<script>$.merge( [0,1,2], [2,3,4] )</script>

Example:

Merges two arrays, altering the first argument.
<script>$.merge( [3,2,1], [4,3,2] )  </script>

Example:

Merges two arrays, but uses a copy, so the original isn't altered.
<script>var first = ['a','b','c'];
var second = ['d','e','f'];
$.merge( $.merge([],first), second);
      </script>

Comments

© 2010 The jQuery Project


jQuery.inArray – jQuery API

Returns: NumberNumber jQuery.inArray( [Any] value, [Array] array )

Categories: Utilities, Version 1.2
Description: Search for a specified value within an array and return its index (or -1 if not found).
  • version added: 1.2

  • jQuery.inArray( [Any] value, [Array] array )

  • value The value to search for.
  • array An array through which to search.

The method is similar to JavaScript's native method in that it returns -1 when it doesn't find a match. If the first element within the array matches , returns 0.

Because JavaScript treats 0 as loosely equal to false (i.e. 0 == false, but 0 !== false), if we're checking for the presence of within , we need to check if it's not equal to (or greater than) -1.

Examples:

Example:

Report the index of some elements in the array.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { color:blue; }
  span { color:red; }
</style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

<div>"John" found at <span></span></div>
<div>4 found at <span></span></div>
<div>"Karl" not found, so <span></span></div>
  <script>var arr = [ 4, "Pete", 8, "John" ];

$("span:eq(0)").text(jQuery.inArray("John", arr));
$("span:eq(1)").text(jQuery.inArray(4, arr));
$("span:eq(2)").text(jQuery.inArray("Karl", arr));

</script>
</body>
</html>

Demo:

Comments

© 2010 The jQuery Project


jQuery.map – jQuery API

Returns: ArrayArray jQuery.map( [Array] array, [Function] callback(elementOfArray, indexInArray) )

Categories: Utilities, Version 1.0
Description: Translate all items in an array or array-like object to another array of items.
  • version added: 1.0

  • jQuery.map( [Array] array, [Function] callback(elementOfArray, indexInArray) )

  • array The Array to translate.
  • callback(elementOfArray, indexInArray) The function to process each item against. The first argument to the function is the list item, the second argument is the index in array The function can return any value. will be the global window object.

The $.map() method applies a function to each item in an array, collecting the results into a new array.

The translation function that is provided to this method is called for each item in the array and is passed two arguments: The item to be translated, and the index within the array.

The function can return:

Map can iterate through Array-like objects, like a jQuery object, that have a length property.

Examples:

Example:

A couple examples of using .map()
<!DOCTYPE html>
<html>
<head>
  <style>
  div { color:blue; }
  p { color:green; margin:0; }
  span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div></div>
  <p></p>
  <span></span>

  <script>

    var arr = [ "a", "b", "c", "d", "e" ];
    $("div").text(arr.join(", "));

    arr = jQuery.map(arr, function(n, i){
      return (n.toUpperCase() + i);
    });
    $("p").text(arr.join(", "));

    arr = jQuery.map(arr, function (a) { return a + a; });
    $("span").text(arr.join(", "));

</script>
</body>
</html>

Demo:

Example:

Maps the original array to a new one and adds 4 to each value.
<script>$.map( [0,1,2], function(n){
   return n + 4;
 });</script>

Example:

Maps the original array to a new one and adds 1 to each value if it is bigger then zero, otherwise it's removed.
<script>$.map( [0,1,2], function(n){
   return n > 0 ? n + 1 : null;
 });</script>

Example:

Maps the original array to a new one, each element is added with it's original value and the value plus one.
<script>$.map( [0,1,2], function(n){
   return [ n, n + 1 ];
 });</script>

Example:

Maps the original array to a new one, each element is squared.
<script>$.map( [0,1,2,3], function (a) { return a * a; } );</script>

Example:

Remove items by returning from the function. This removes any numbers less than 50, and the rest are decreased by 45.
<script>$.map( [0, 1, 52, 97], function (a) { return (a > 50 ? a - 45 : null); } );</script>

Example:

Augmenting the resulting array by returning an array inside the function.
<script>var array = [0, 1, 52, 97];
array = $.map(array, function(a, index) {
  return [a - 45, index];
}); </script>

Comments

© 2010 The jQuery Project


jQuery.makeArray – jQuery API

Returns: ArrayArray jQuery.makeArray( [Object] obj )

Categories: Utilities, Version 1.2
Description: Convert an array-like object into a true JavaScript array.
  • version added: 1.2

  • jQuery.makeArray( [Object] obj )

  • obj Any object to turn into a native Array.

Many methods, both in jQuery and in JavaScript in general, return objects that are array-like. For example, the jQuery factory function returns a jQuery object that has many of the properties of an array (a length, the array access operator, etc.), but is not exactly the same as an array and lacks some of an array's built-in methods (such as and ).

Note that after the conversion, any special features the object had (such as the jQuery methods in our example) will no longer be present. The object is now a plain array.

Examples:

Example:

Turn a collection of HTMLElements into an Array of them.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div>First</div>
  <div>Second</div>
  <div>Third</div>

  <div>Fourth</div>
  <script>
    var elems = document.getElementsByTagName("div"); // returns a nodeList
    var arr = jQuery.makeArray(elems);
    arr.reverse(); // use an Array method on list of dom elements
    $(arr).appendTo(document.body);
</script>
</body>
</html>

Demo:

Example:

Turn a jQuery object into an array
<script>
    var obj = $('li');
    var arr = $.makeArray(obj);
</script>

Comments

© 2010 The jQuery Project


jQuery.grep – jQuery API

Returns: ArrayArray jQuery.grep( [Array] array, [Function] function(elementOfArray, indexInArray), [Boolean] invert )

Categories: Utilities, Version 1.0
Description: Finds the elements of an array which satisfy a filter function. The original array is not affected.
  • version added: 1.0

  • jQuery.grep( [Array] array, [Function] function(elementOfArray, indexInArray), [Boolean] invert )

  • array The array to search through.
  • function(elementOfArray, indexInArray) The function to process each item against. The first argument to the function is the item, and the second argument is the index. The function should return a Boolean value. will be the global window object.
  • invert If "invert" is false, or not provided, then the function returns an array consisting of all elements for which "callback" returns true. If "invert" is true, then the function returns an array consisting of all elements for which "callback" returns false.

The method removes items from an array as necessary so that all remaining items pass a provided test. The test is a function that is passed an array item and the index of the item within the array. Only if the test returns true will the item be in the result array.

The filter function will be passed two arguments: the current array item and its index. The filter function must return 'true' to include the item in the result array.

Examples:

Example:

Filters the original array of numbers leaving that are not 5 and have an index greater than 4. Then it removes all 9s.
<!DOCTYPE html>
<html>
<head>
  <style>
  div { color:blue; }
  p { color:green; margin:0; }
  span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <div></div>
  <p></p>
  <span></span>

  <script>
var arr = [ 1, 9, 3, 8, 6, 1, 5, 9, 4, 7, 3, 8, 6, 9, 1 ];
$("div").text(arr.join(", "));

arr = jQuery.grep(arr, function(n, i){
  return (n != 5 && i > 4);
});
$("p").text(arr.join(", "));

arr = jQuery.grep(arr, function (a) { return a != 9; });
$("span").text(arr.join(", "));

</script>
</body>
</html>

Demo:

Example:

Filter an array of numbers to include only numbers bigger then zero.
<script>$.grep( [0,1,2], function(n,i){
   return n > 0;
 });</script>

Example:

Filter an array of numbers to include numbers that are not bigger than zero.
<script>$.grep( [0,1,2], function(n,i){
    return n > 0;
},true);</script>

Comments

© 2010 The jQuery Project


jQuery.extend – jQuery API

  • jQuery.extend( [Object] target, [Object] object1, [Object] objectN )

    • 1.0jQuery.extend( [Object] target, [Object] object1, [Object] objectN )

  • jQuery.extend( [Boolean] deep, [Object] target, [Object] object1, [Object] objectN )

    • 1.1.4jQuery.extend( [Boolean] deep, [Object] target, [Object] object1, [Object] objectN )

Returns: ObjectObject jQuery.extend( [Boolean] deep, [Object] target, [Object] object1, [Object] objectN )

Categories: Utilities, Version 1.0
Description: Merge the contents of two or more objects together into the first object.
  • version added: 1.0

  • jQuery.extend( [Object] target, [Object] object1, [Object] objectN )

  • target An object that will receive the new properties if additional objects are passed in or that will extend the jQuery namespace if it is the sole argument.
  • object1 An object containing additional properties to merge in.
  • objectN Additional objects containing properties to merge in.
  • version added: 1.1.4

  • jQuery.extend( [Boolean] deep, [Object] target, [Object] object1, [Object] objectN )

  • deep If true, the merge becomes recursive (aka. deep copy).
  • target The object to extend. It will receive the new properties.
  • object1 An object containing additional properties to merge in.
  • objectN Additional objects containing properties to merge in.

When we supply two or more objects to , properties from all of the objects are added to the target object.

If only one argument is supplied to , this means the target argument was omitted. In this case, the jQuery object itself is assumed to be the target. By doing this, we can add new functions to the jQuery namespace. This can be useful for plugin authors wishing to add new methods to JQuery.

Keep in mind that the target object (first argument) will be modified, and will also be returned from . If, however, we want to preserve both of the original objects, we can do so by passing an empty object as the target:

var object = $.extend({}, object1, object2);

The merge performed by is not recursive by default; if a property of the first object is itself an object or array, it will be completely overwritten by a property with the same key in the second object. The values are not merged. This can be seen in the example below by examining the value of banana. However, by passing for the first function argument, objects will be recursively merged.

Undefined properties are not copied. However, properties inherited from the object's prototype be copied over.

Examples:

Example:

Merge two objects, modifying the first.
<script>
var object1 = {
  apple: 0,
  banana: {weight: 52, price: 100},
  cherry: 97
};
var object2 = {
  banana: {price: 200},
  durian: 100
};

$.extend(object1, object2);
</script>

Example:

Merge two objects recursively, modifying the first.
<script>
var object1 = {
  apple: 0,
  banana: {weight: 52, price: 100},
  cherry: 97
};
var object2 = {
  banana: {price: 200},
  durian: 100
};

$.extend(true, object1, object2);
</script>

Example:

Merge settings and options, modifying settings.
<script>var settings = { validate: false, limit: 5, name: "foo" };
var options = { validate: true, name: "bar" };
jQuery.extend(settings, options);</script>

Example:

Merge defaults and options, without modifying the defaults. This is a common plugin development pattern.
<script>var empty = {}
var defaults = { validate: false, limit: 5, name: "foo" };
var options = { validate: true, name: "bar" };
var settings = $.extend(empty, defaults, options);</script>

Comments

© 2010 The jQuery Project


jQuery.each – jQuery API

Returns: ObjectObject jQuery.each( [Object] collection, [Function] callback(indexInArray, valueOfElement) )

Categories: Utilities, Version 1.0
Description: A generic iterator function, which can be used to seamlessly iterate over both objects and arrays. Arrays and array-like objects with a length property (such as a function's arguments object) are iterated by numeric index, from 0 to length-1. Other objects are iterated via their named properties.
  • version added: 1.0

  • jQuery.each( [Object] collection, [Function] callback(indexInArray, valueOfElement) )

  • collection The object or array to iterate over.
  • callback(indexInArray, valueOfElement) The function that will be executed on every object.

The function is not the same as , which is used to iterate, exclusively, over a jQuery object. The function can be used to iterate over any collection, whether it is a map (JavaScript object) or an array. In the case of an array, the callback is passed an array index and a corresponding array value each time. (The value can also be accessed through the keyword.)

$.each([52, 97], function(index, value) {
  alert(index + ': ' + value);
});

This produces two messages:

If a map is used as the collection, the callback is passed a key-value pair each time:

var map = {
  'flammable': 'inflammable',
  'duh': 'no duh'
};
$.each(map, function(key, value) {
  alert(key + ': ' + value);
});

Once again, this produces two messages:

We can break the loop at a particular iteration by making the callback function return . Returning is the same as a statement in a for loop; it will skip immediately to the next iteration.

Examples:

Example:

Iterates through the array displaying each number as both a word and numeral
<!DOCTYPE html>
<html>
<head>
  <style>
  div { color:blue; }
  div#five { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>

  <div id="one"></div>
  <div id="two"></div>
  <div id="three"></div>
  <div id="four"></div>
  <div id="five"></div>
  <script>
    var arr = [ "one", "two", "three", "four", "five" ];
    var obj = { one:1, two:2, three:3, four:4, five:5 };

    jQuery.each(arr, function() {
      $("#" + this).text("Mine is " + this + ".");
       return (this != "three"); // will stop running after "three"
   });

    jQuery.each(obj, function(i, val) {
      $("#" + i).append(document.createTextNode(" - " + val));
    });
</script>
</body>
</html>

Demo:

Example:

Iterates over items in an array, accessing both the current item and its index.
<script>$.each( ['a','b','c'], function(i, l){
   alert( "Index #" + i + ": " + l );
 });</script>

Example:

Iterates over the properties in an object, accessing both the current item and its key.
<script>$.each( { name: "John", lang: "JS" }, function(k, v){
   alert( "Key: " + k + ", Value: " + v );
 });</script>

Comments

© 2010 The jQuery Project


jQuery.boxModel – jQuery API

Returns: BooleanBoolean jQuery.boxModel

Categories: Utilities, Version 1.0
Description: . States if the current page, in the user's browser, is being rendered using the .
  • version added: 1.0

  • jQuery.boxModel

Examples:

Example:

Returns the box model for the iframe.
<!DOCTYPE html>
<html>
<head>
  <style>
  p { color:blue; margin:20px; }
  span { color:red; }
  </style>
  <script src="http://code.jquery.com/jquery-latest.min.js"></script>
</head>
<body>
  <p>
  </p>
  <script>

    $("p").html("The box model for this iframe is: <span>" +
                jQuery.boxModel + "</span>");
</script>
</body>
</html>

Demo:

Example:

Returns false if the page is in Quirks Mode in Internet Explorer
<script>$.boxModel</script>

Comments

© 2010 The jQuery Project


Version – jQuery API

Version

  • event.stopPropagation( )

    New in 1.0 !

    Prevents the event from bubbling up the DOM tree, preventing any parent handlers from being notified of the event.

  • undefined event.preventDefault( )

    New in 1.0 !

    If this method is called, the default action of the event will not be triggered.

  • Element event.target

    New in 1.0 !

    The DOM element that initiated the event.

  • String event.type

    New in 1.0 !

    Describes the nature of the event.

  • jQuery .each( [Function] function(index, Element) )

    New in 1.0 !

    Iterate over a jQuery object, executing a function for each matched element.

  • jQuery jQuery.pushStack( [Array] elements, [String] name, [Array] arguments )

    New in 1.3 !

    Add a collection of DOM elements onto the jQuery stack.

  • jQuery .keydown( )

    New in 1.0 !

    Bind an event handler to the "keydown" JavaScript event, or trigger that event on an element.

  • Number .index( [Element|jQuery] element )

    New in 1.0 !

    Search for a given element from among the matched elements.

  • Element, Array .get( [Number] index )

    New in 1.0 !

    Retrieve the DOM elements matched by the jQuery object.

  • Number .size( )

    New in 1.0 !

    Return the number of DOM elements matched by the jQuery object.

  • Object jQuery.noConflict( [Boolean] removeAll )

    New in 1.0 !

    Relinquish jQuery's control of the variable.

  • JQuery(":selected")

    New in 1.0 !

    Selects all elements that are selected.

  • JQuery(":checked")

    New in 1.0 !

    Matches all elements that are checked.

  • JQuery(":disabled")

    New in 1.0 !

    Selects all elements that are disabled.

  • JQuery(":enabled")

    New in 1.0 !

    Selects all elements that are enabled.

  • JQuery(":file")

    New in 1.0 !

    Selects all elements of type file.

  • JQuery(":button")

    New in 1.0 !

    Selects all button elements and elements of type button.

  • JQuery(":reset")

    New in 1.0 !

    Selects all elements of type reset.

  • JQuery(":image")

    New in 1.0 !

    Selects all elements of type image.

  • jQuery .submit( )

    New in 1.0 !

    Bind an event handler to the "submit" JavaScript event, or trigger that event on an element.

  • JQuery(":checkbox")

    New in 1.0 !

    Selects all elements of type checkbox.

  • JQuery(":radio")

    New in 1.0 !

    Selects all elements of type radio.

  • JQuery(":password")

    New in 1.0 !

    Selects all elements of type password.

  • jQuery .text( [Function] function(index, text) )

    New in 1.4 !

    Set the content of each element in the set of matched elements to the specified text.

  • JQuery(":input")

    New in 1.0 !

    Selects all input, textarea, select and button elements.

  • JQuery("[attribute|=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value either equal to a given string or starting with that string followed by a hyphen (-).

  • JQuery("[attribute~=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value containing a given word, delimited by spaces.

  • JQuery("[attributeFilter1][attributeFilter2][attributeFilterN]")

    New in 1.0 !

    Matches elements that match all of the specified attribute filters.

  • JQuery("[attribute*=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value containing the a given substring.

  • JQuery("[attribute$=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value ending exactly with a given string.

  • JQuery("[attribute^=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value beginning exactly with a given string.

  • JQuery("[attribute!=value]")

    New in 1.0 !

    Select elements that either don't have the specified attribute, or do have the specified attribute but not with a certain value.

  • JQuery("[attribute=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value exactly equal to a certain value.

  • JQuery("[attribute]")

    New in 1.0 !

    Selects elements that have the specified attribute, with any value.

  • JQuery(":visible")

    New in 1.0 !

    Selects all elements that are visible.

  • JQuery(":hidden")

    New in 1.0 !

    Selects all elements that are hidden.

  • jQuery .parent( [Selector] selector )

    New in 1.0 !

    Get the parent of each element in the current set of matched elements, optionally filtered by a selector.

  • jQuery .empty( )

    New in 1.0 !

    Remove all child nodes of the set of matched elements from the DOM.

  • JQuery(":lt(index)")

    New in 1.0 !

    Select all elements at an index less than within the matched set.

  • JQuery(":gt(index)")

    New in 1.0 !

    Select all elements at an index greater than within the matched set.

  • JQuery(":eq(index)")

    New in 1.0 !

    Select the element at index within the matched set.

  • JQuery(":odd")

    New in 1.0 !

    Selects odd elements, zero-indexed. See also .

  • JQuery(":even")

    New in 1.0 !

    Selects even elements, zero-indexed. See also .

  • jQuery .not( [Function] function(index) )

    New in 1.4 !

    Remove elements from the set of matched elements.

  • JQuery(":last")

    New in 1.0 !

    Selects the last matched element.

  • JQuery(":first")

    New in 1.0 !

    Selects the first matched element.

  • JQuery("prev ~ siblings")

    New in 1.0 !

    Selects all sibling elements that follow after the "prev" element, have the same parent, and match the filtering "siblings" selector.

  • JQuery("prev + next")

    New in 1.0 !

    Selects all next elements matching "next" that are immediately preceded by a sibling "prev".

  • child")" rel="bookmark">JQuery("parent > child")

    New in 1.0 !

    Selects all direct child elements specified by "child" of elements specified by "parent".

  • JQuery("ancestor descendant")

    New in 1.0 !

    Selects all elements that are descendants of a given ancestor.

  • JQuery("selector1, selector2, selectorN")

    New in 1.0 !

    Selects the combined results of all the specified selectors.

  • JQuery("*")

    New in 1.0 !

    Selects all elements.

  • JQuery(".class")

    New in 1.0 !

    Selects all elements with the given class.

  • JQuery("element")

    New in 1.0 !

    Selects all elements with the given tag name.

  • JQuery("#id")

    New in 1.0 !

    Selects a single element with the given id attribute.

  • jQuery .scroll( )

    New in 1.0 !

    Bind an event handler to the "scroll" JavaScript event, or trigger that event on an element.

  • jQuery .resize( )

    New in 1.0 !

    Bind an event handler to the "resize" JavaScript event, or trigger that event on an element.

  • jQuery .keyup( )

    New in 1.0 !

    Bind an event handler to the "keyup" JavaScript event, or trigger that event on an element.

  • jQuery .keypress( )

    New in 1.0 !

    Bind an event handler to the "keypress" JavaScript event, or trigger that event on an element.

  • jQuery .select( )

    New in 1.0 !

    Bind an event handler to the "select" JavaScript event, or trigger that event on an element.

  • jQuery .change( )

    New in 1.0 !

    Bind an event handler to the "change" JavaScript event, or trigger that event on an element.

  • jQuery .blur( )

    New in 1.0 !

    Bind an event handler to the "blur" JavaScript event, or trigger that event on an element.

  • jQuery .focus( )

    New in 1.0 !

    Bind an event handler to the "focus" JavaScript event, or trigger that event on an element.

  • jQuery .mousemove( )

    New in 1.0 !

    Bind an event handler to the "mousemove" JavaScript event, or trigger that event on an element.

  • jQuery .hover( [Function] handlerInOut(eventObject) )

    New in 1.4 !

    Bind a single handler to the matched elements, to be executed when the mouse pointer enters or leaves the elements.

  • jQuery .mouseleave( )

    New in 1.0 !

    Bind an event handler to be fired when the mouse leaves an element, or trigger that handler on an element.

  • jQuery .mouseenter( )

    New in 1.0 !

    Bind an event handler to be fired when the mouse enters an element, or trigger that handler on an element.

  • jQuery .mouseout( )

    New in 1.0 !

    Bind an event handler to the "mouseout" JavaScript event, or trigger that event on an element.

  • jQuery .mouseover( )

    New in 1.0 !

    Bind an event handler to the "mouseover" JavaScript event, or trigger that event on an element.

  • jQuery .dblclick( )

    New in 1.0 !

    Bind an event handler to the "dblclick" JavaScript event, or trigger that event on an element.

  • jQuery .click( )

    New in 1.0 !

    Bind an event handler to the "click" JavaScript event, or trigger that event on an element.

  • jQuery .mouseup( )

    New in 1.0 !

    Bind an event handler to the "mouseup" JavaScript event, or trigger that event on an element.

  • jQuery .mousedown( )

    New in 1.0 !

    Bind an event handler to the "mousedown" JavaScript event, or trigger that event on an element.

  • jQuery .error( [Function] handler(eventObject) )

    New in 1.0 !

    Bind an event handler to the "error" JavaScript event.

  • jQuery .unload( [Function] handler(eventObject) )

    New in 1.0 !

    Bind an event handler to the "unload" JavaScript event.

  • jQuery .load( [String] url, [Map|String] data, [Function] complete(responseText, textStatus, XMLHttpRequest) )

    New in 1.0 !

    Load data from the server and place the returned HTML into the matched element.

  • jQuery .ready( [Function] handler )

    New in 1.0 !

    Specify a function to execute when the DOM is fully loaded.

  • Map jQuery.browser

    New in 1.0 !

    Contains flags for the useragent, read from navigator.userAgent. While jQuery.browser will not be removed from future versions of jQuery, every effort to use jQuery.support and proper feature detection should be made.

  • String jQuery.browser.version

    New in 1.1.3 !

    The version number of the rendering engine for the user's browser.

  • jQuery .trigger( [String] eventType, [Array] extraParameters )

    New in 1.0 !

    Execute all handlers and behaviors attached to the matched elements for the given event type.

  • jQuery .ajaxComplete( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

    New in 1.0 !

    Register a handler to be called when Ajax requests complete. This is an .

  • String .serialize( )

    New in 1.0 !

    Encode a set of form elements as a string for submission.

  • jQuery .ajaxSuccess( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

    New in 1.0 !

  • jQuery .ajaxStop( [Function] handler() )

    New in 1.0 !

    Register a handler to be called when all Ajax requests have completed. This is an .

  • jQuery .ajaxStart( [Function] handler() )

    New in 1.0 !

    Register a handler to be called when the first Ajax request begins. This is an .

  • jQuery .ajaxSend( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

    New in 1.0 !

  • jQuery .ajaxError( [Function] handler(event, XMLHttpRequest, ajaxOptions, thrownError) )

    New in 1.0 !

    Register a handler to be called when Ajax requests complete with an error. This is an .

  • jQuery .unbind( [Object] event )

    New in 1.0 !

    Remove a previously-attached event handler from the elements.

  • jQuery .bind( [Object] events )

    New in 1.4 !

    Attach a handler to an event for the elements.

  • jQuery jQuery( [Function] callback )

    New in 1.0 !

    Binds a function to be executed when the DOM has finished loading.

  • jQuery .end( )

    New in 1.0 !

    End the most recent filtering operation in the current chain and return the set of matched elements to its previous state.

  • jQuery .siblings( [Selector] selector )

    New in 1.0 !

    Get the siblings of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .animate( [Options] properties, [Options] options )

    New in 1.0 !

    Perform a custom animation of a set of CSS properties.

  • jQuery .prev( [Selector] selector )

    New in 1.0 !

    Get the immediately preceding sibling of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .fadeTo( [String,Number] duration, [Number] opacity, [Callback] callback )

    New in 1.0 !

    Adjust the opacity of the matched elements.

  • jQuery .fadeOut( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Hide the matched elements by fading them to transparent.

  • jQuery .parents( [Selector] selector )

    New in 1.0 !

    Get the ancestors of each element in the current set of matched elements, optionally filtered by a selector.

  • jQuery .fadeIn( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display the matched elements by fading them to opaque.

  • jQuery .slideToggle( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display or hide the matched elements with a sliding motion.

  • XMLHttpRequest jQuery.post( [String] url, [Map|String] data, [Function] success(data, textStatus, XMLHttpRequest), [String] dataType )

    New in 1.0 !

    Load data from the server using a HTTP POST request.

  • jQuery .slideUp( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Hide the matched elements with a sliding motion.

  • jQuery .next( [Selector] selector )

    New in 1.0 !

    Get the immediately following sibling of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .slideDown( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display the matched elements with a sliding motion.

  • jQuery .find( [Selector] selector )

    New in 1.0 !

    Get the descendants of each element in the current set of matched elements, filtered by a selector.

  • XMLHttpRequest jQuery.getScript( [String] url, [Function] success(data, textStatus) )

    New in 1.0 !

    Load a JavaScript file from the server using a GET HTTP request, then execute it.

  • XMLHttpRequest jQuery.getJSON( [String] url, [Map] data, [Function] callback(data, textStatus) )

    New in 1.0 !

    Load JSON-encoded data from the server using a GET HTTP request.

  • XMLHttpRequest jQuery.get( [String] url, [Map|String] data, [Function] callback(data, textStatus, XMLHttpRequest), [String] dataType )

    New in 1.0 !

    Load data from the server using a HTTP GET request.

  • XMLHttpRequest jQuery.ajax( [Map] settings )

    New in 1.0 !

    Perform an asynchronous HTTP (Ajax) request.

  • Number length

    New in 1.0 !

    The number of elements in the jQuery object.

  • jQuery .children( [Selector] selector )

    New in 1.0 !

    Get the children of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .add( [Selector] selector, [Element] context )

    New in 1.4 !

    Add elements to the set of matched elements.

  • jQuery .toggle( [Boolean] showOrHide )

    New in 1.3 !

    Display or hide the matched elements.

  • jQuery .hide( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Hide the matched elements.

  • jQuery .width( [Function] function(index, width) )

    New in 1.4.1 !

    Set the CSS width of each element in the set of matched elements.

  • jQuery .height( [Function] function(index, height) )

    New in 1.4.1 !

    Set the CSS height of every matched element.

  • jQuery .show( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display the matched elements.

  • String jQuery.trim( [String] str )

    New in 1.0 !

    Remove the whitespace from the beginning and end of a string.

  • Array jQuery.merge( [Array] first, [Array] second )

    New in 1.0 !

    Merge the contents of two arrays together into the first array.

  • Array jQuery.map( [Array] array, [Function] callback(elementOfArray, indexInArray) )

    New in 1.0 !

    Translate all items in an array or array-like object to another array of items.

  • Array jQuery.grep( [Array] array, [Function] function(elementOfArray, indexInArray), [Boolean] invert )

    New in 1.0 !

    Finds the elements of an array which satisfy a filter function. The original array is not affected.

  • Object jQuery.extend( [Boolean] deep, [Object] target, [Object] object1, [Object] objectN )

    New in 1.1.4 !

    Merge the contents of two or more objects together into the first object.

  • Object jQuery.each( [Object] collection, [Function] callback(indexInArray, valueOfElement) )

    New in 1.0 !

    A generic iterator function, which can be used to seamlessly iterate over both objects and arrays. Arrays and array-like objects with a length property (such as a function's arguments object) are iterated by numeric index, from 0 to length-1. Other objects are iterated via their named properties.

  • Boolean jQuery.boxModel

    New in 1.0 !

    . States if the current page, in the user's browser, is being rendered using the .

  • jQuery .css( [Map] map )

    New in 1.0 !

    Set one or more CSS properties for the set of matched elements.

  • jQuery .clone( [Boolean] withDataAndEvents )

    New in 1.0 !

    Create a copy of the set of matched elements.

  • jQuery .remove( [String] selector )

    New in 1.0 !

    Remove the set of matched elements from the DOM.

  • jQuery .wrap( [Function] wrappingFunction )

    New in 1.4 !

    Wrap an HTML structure around each element in the set of matched elements.

  • jQuery .insertBefore( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements before the target.

  • jQuery .before( [Function] function )

    New in 1.4 !

    Insert content, specified by the parameter, before each element in the set of matched elements.

  • jQuery .insertAfter( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements after the target.

  • jQuery .after( [Function] function(index) )

    New in 1.4 !

    Insert content, specified by the parameter, after each element in the set of matched elements.

  • jQuery .prependTo( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements to the beginning of the target.

  • jQuery .prepend( [Function] function(index, html) )

    New in 1.4 !

    Insert content, specified by the parameter, to the beginning of each element in the set of matched elements.

  • jQuery .appendTo( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements to the end of the target.

  • jQuery .append( [Function] function(index, html) )

    New in 1.4 !

    Insert content, specified by the parameter, to the end of each element in the set of matched elements.

  • jQuery .val( [Function] function(index, value) )

    New in 1.4 !

    Set the value of each element in the set of matched elements.

  • jQuery .html( [Function] function(index, oldhtml) )

    New in 1.4 !

    Set the HTML contents of each element in the set of matched elements.

  • Boolean .is( [Selector] selector )

    New in 1.0 !

    Check the current matched set of elements against a selector and return true if at least one of these elements matches the selector.

  • jQuery .filter( [Function] function(index) )

    New in 1.0 !

    Reduce the set of matched elements to those that match the selector or pass the function's test.

  • jQuery .toggleClass( [Function] function(index, class), [Boolean] switch )

    New in 1.4 !

    Add or remove one or more classes from each element in the set of matched elements, depending on either the class's presence or the value of the switch argument.

  • jQuery .removeClass( [Function] function(index, class) )

    New in 1.4 !

    Remove a single class, multiple classes, or all classes from each element in the set of matched elements.

  • jQuery .removeAttr( [String] attributeName )

    New in 1.0 !

    Remove an attribute from each element in the set of matched elements.

  • jQuery .attr( [String] attributeName, [Function] function(index, attr) )

    New in 1.1 !

    Set one or more attributes for the set of matched elements.

  • jQuery .addClass( [Function] function(index, class) )

    New in 1.4 !

    Adds the specified class(es) to each of the set of matched elements.

  • Number event.pageY

    New in 1.0.4 !

    The mouse position relative to the top edge of the document.

  • Number event.pageX

    New in 1.0.4 !

    The mouse position relative to the left edge of the document.

  • jQuery.globalEval( [String] code )

    New in 1.0.4 !

    Execute some JavaScript code globally.

  • Anything event.data

    New in 1.1 !

    Contains the optional data passed to jQuery.fn.bind when the current executing handler was bound.

  • jQuery .one( [String] eventType, [Object] eventData, [Function] handler(eventObject) )

    New in 1.1 !

    Attach a handler to an event for the elements. The handler is executed at most once per element.

  • jQuery.ajaxSetup( [Options] options )

    New in 1.1 !

    Set default values for future Ajax requests.

  • jQuery .attr( [String] attributeName, [Function] function(index, attr) )

    New in 1.1 !

    Set one or more attributes for the set of matched elements.

  • jQuery .eq( [Integer] -index )

    New in 1.4 !

    Reduce the set of matched elements to the one at the specified index.

  • String event.which

    New in 1.1.3 !

    For key or button events, this attribute indicates the specific button or key that was pressed.

  • Map jQuery.browser

    New in 1.0 !

    Contains flags for the useragent, read from navigator.userAgent. While jQuery.browser will not be removed from future versions of jQuery, every effort to use jQuery.support and proper feature detection should be made.

  • String jQuery.browser.version

    New in 1.1.3 !

    The version number of the rendering engine for the user's browser.

  • Array jQuery.unique( [Array] array )

    New in 1.1.3 !

    Sorts an array of DOM elements, in place, with the duplicates removed. Note that this only works on arrays of DOM elements, not strings or numbers.

  • Element event.relatedTarget

    New in 1.1.4 !

    The other DOM element involved in the event, if any.

  • Boolean jQuery.isXMLDoc( [Element] node )

    New in 1.1.4 !

    Check to see if a DOM node is within an XML document (or is an XML document).

  • JQuery(":only-child")

    New in 1.1.4 !

    Selects all elements that are the only child of their parent.

  • JQuery(":last-child")

    New in 1.1.4 !

    Selects all elements that are the last child of their parent.

  • JQuery(":first-child")

    New in 1.1.4 !

    Selects all elements that are the first child of their parent.

  • JQuery(":nth-child(index/even/odd/equation)")

    New in 1.1.4 !

    Selects all elements that are the nth-child of their parent.

  • JQuery(":has(selector)")

    New in 1.1.4 !

    Selects elements which contain at least one element that matches the specified selector.

  • JQuery(":contains(text)")

    New in 1.1.4 !

    Select all elements that contain the specified text.

  • jQuery .slice( [Integer] start, [Integer] end )

    New in 1.1.4 !

    Reduce the set of matched elements to a subset specified by a range of indices.

  • JQuery(":animated")

    New in 1.2 !

    Select all elements that are in the progress of an animation at the time the selector is run.

  • JQuery(":header")

    New in 1.2 !

    Selects all elements that are headers, like h1, h2, h3 and so on.

  • jQuery .dequeue( [String] queueName )

    New in 1.2 !

    Execute the next function on the queue for the matched elements.

  • jQuery .queue( [String] queueName, [Function] callback( next ) )

    New in 1.2 !

    Manipulate the queue of functions to be executed on the matched elements.

  • Object .triggerHandler( [String] eventType, [Array] extraParameters )

    New in 1.2 !

    Execute all handlers attached to an element for an event.

  • Array .serializeArray( )

    New in 1.2 !

    Encode a set of form elements as an array of names and values.

  • jQuery .stop( [Boolean] clearQueue, [Boolean] jumpToEnd )

    New in 1.2 !

    Stop the currently-running animation on the matched elements.

  • jQuery .andSelf( )

    New in 1.2 !

    Add the previous set of elements on the stack to the current set.

  • jQuery .prevAll( [Selector] selector )

    New in 1.2 !

    Get all preceding siblings of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .nextAll( [String] selector )

    New in 1.2 !

    Get all following siblings of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .contents( )

    New in 1.2 !

    Get the children of each element in the set of matched elements, including text nodes.

  • String jQuery.param( [Array|Object] obj, [Boolean] traditional )

    New in 1.4 !

    Create a serialized representation of an array or object, suitable for use in a URL query string or Ajax request.

  • boolean jQuery.isFunction( [Object] obj )

    New in 1.2 !

    Determine if the argument passed is a Javascript function object.

  • Number jQuery.inArray( [Any] value, [Array] array )

    New in 1.2 !

    Search for a specified value within an array and return its index (or -1 if not found).

  • Array jQuery.makeArray( [Object] obj )

    New in 1.2 !

    Convert an array-like object into a true JavaScript array.

  • Object .position( )

    New in 1.2 !

    Get the current coordinates of the first element in the set of matched elements, relative to the offset parent.

  • jQuery .offset( [Function] function(index, coords) )

    New in 1.4 !

    Set the current coordinates of every element in the set of matched elements, relative to the document.

  • jQuery .replaceAll( )

    New in 1.2 !

    Replace each target element with the set of matched elements.

  • jQuery .replaceWith( [Function] function )

    New in 1.4 !

    Replace each element in the set of matched elements with the provided new content.

  • jQuery .wrapInner( [Function] wrappingFunction )

    New in 1.4 !

    Wrap an HTML structure around the content of each element in the set of matched elements.

  • jQuery .wrapAll( [String|Selector|Element|jQuery] wrappingElement )

    New in 1.2 !

    Wrap an HTML structure around all elements in the set of matched elements.

  • jQuery .map( [Function] callback(index, domElement) )

    New in 1.2 !

    Pass each element in the current matched set through a function, producing a new jQuery object containing the return values.

  • Boolean .hasClass( [String] className )

    New in 1.2 !

    Determine whether any of the matched elements are assigned the given class.

  • jQuery jQuery.removeData( [Element] element, [String] name )

    New in 1.2.3 !

    Remove a previously-stored piece of data.

  • Object jQuery.data( [Element] element )

    New in 1.4 !

    Returns value at named data store for the element, as set by , or the full data store for the element.

  • jQuery .removeData( [String] name )

    New in 1.2.3 !

    Remove a previously-stored piece of data.

  • Object .data( )

    New in 1.4 !

    Returns value at named data store for the element, as set by data(name, value).

  • Number event.timeStamp

    New in 1.2.6 !

    This attribute returns the number of milliseconds since January 1, 1970, when the event is triggered.

  • Integer .outerWidth( [Boolean] includeMargin )

    New in 1.2.6 !

    Get the current computed width for the first element in the set of matched elements, including padding and border.

  • Integer .outerHeight( [Boolean] includeMargin )

    New in 1.2.6 !

    Get the current computed height for the first element in the set of matched elements, including padding, border, and optionally margin.

  • Integer .innerWidth( )

    New in 1.2.6 !

    Get the current computed width for the first element in the set of matched elements, including padding but not border.

  • Integer .innerHeight( )

    New in 1.2.6 !

    Get the current computed height for the first element in the set of matched elements, including padding but not border.

  • jQuery .scrollLeft( [Number] value )

    New in 1.2.6 !

    Set the current horizontal position of the scroll bar for each of the set of matched elements.

  • jQuery .scrollTop( [Number] value )

    New in 1.2.6 !

    Set the current vertical position of the scroll bar for each of the set of matched elements.

  • Boolean event.isImmediatePropagationStopped( )

    New in 1.3 !

    Returns whether event.stopImmediatePropagation() was ever called on this event object.

  • event.stopImmediatePropagation( )

    New in 1.3 !

    Keeps the rest of the handlers from being executed and prevents the event from bubbling up the DOM tree

  • Boolean event.isPropagationStopped( )

    New in 1.3 !

    Returns whether was ever called on this event object.

  • Boolean event.isDefaultPrevented( )

    New in 1.3 !

    Returns whether was ever called on this event object.

  • Object event.result

    New in 1.3 !

    This attribute contains the last value returned by an event handler that was triggered by this event, unless the value was .

  • Element event.currentTarget

    New in 1.3 !

    The current DOM element within the event bubbling phase.

  • Boolean jQuery.fx.off

    New in 1.3 !

    Globally disable all animations.

  • jQuery jQuery.pushStack( [Array] elements, [String] name, [Array] arguments )

    New in 1.3 !

    Add a collection of DOM elements onto the jQuery stack.

  • jQuery jQuery.dequeue( [Element] element, [String] queueName )

    New in 1.3 !

    Execute the next function on the queue for the matched element.

  • jQuery jQuery.queue( [Element] element, [String] queueName, [Function] callback() )

    New in 1.3 !

    Manipulate the queue of functions to be executed on the matched element.

  • jQuery .die( [String] eventType, [String] handler )

    New in 1.3 !

    Remove an event handler previously attached using from the elements.

  • jQuery .live( [String] eventType, [Object] eventData, [Function] handler )

    New in 1.4 !

    Attach a handler to the event for all elements which match the current selector, now or in the future.

  • Array .closest( [Array] selectors, [Element] context )

    New in 1.4 !

    Gets an array of all the elements and selectors matched against the current element up through the DOM tree.

  • String selector

    New in 1.3 !

    A selector representing selector originally passed to jQuery().

  • Element context

    New in 1.3 !

    The DOM node context originally passed to jQuery(); if none was passed then context will likely be the document.

  • jQuery .toggle( [Boolean] showOrHide )

    New in 1.3 !

    Display or hide the matched elements.

  • boolean jQuery.isArray( [Object] obj )

    New in 1.3 !

    Determine whether the argument is an array.

  • Object jQuery.support

    New in 1.3 !

    A collection of properties that represent the presence of different browser features or bugs.

  • jQuery .toggleClass( [Function] function(index, class), [Boolean] switch )

    New in 1.4 !

    Add or remove one or more classes from each element in the set of matched elements, depending on either the class's presence or the value of the switch argument.

  • Function jQuery.proxy( [Object] context, [String] name )

    New in 1.4 !

    Takes a function and returns a new one that will always have a particular context.

  • jQuery .focusout( [Function] handler(eventObject) )

    New in 1.4 !

    Bind an event handler to the "focusout" JavaScript event.

  • jQuery .focusin( [Function] handler(eventObject) )

    New in 1.4 !

    Bind an event handler to the "focusin" JavaScript event.

  • jQuery .has( [Element] contained )

    New in 1.4 !

    Reduce the set of matched elements to those that have a descendant that matches the selector or DOM element.

  • Boolean jQuery.contains( [Element] container, [Element] contained )

    New in 1.4 !

    Check to see if a DOM node is within another DOM node.

  • Function jQuery.noop( )

    New in 1.4 !

    An empty function.

  • jQuery .delay( [Integer] duration, [String] queueName )

    New in 1.4 !

    Set a timer to delay execution of subsequent items in the queue.

  • jQuery .parentsUntil( [Selector] selector )

    New in 1.4 !

    Get the ancestors of each element in the current set of matched elements, up to but not including the element matched by the selector.

  • jQuery .prevUntil( [Selector] selector )

    New in 1.4 !

    Get all preceding siblings of each element up to but not including the element matched by the selector.

  • jQuery .nextUntil( [Selector] selector )

    New in 1.4 !

    Get all following siblings of each element up to but not including the element matched by the selector.

  • Object jQuery.data( [Element] element )

    New in 1.4 !

    Returns value at named data store for the element, as set by , or the full data store for the element.

  • jQuery .clearQueue( [String] queueName )

    New in 1.4 !

    Remove from the queue all items that have not yet been run.

  • Array .toArray( )

    New in 1.4 !

    Retrieve all the DOM elements contained in the jQuery set, as an array.

  • Boolean jQuery.isEmptyObject( [Object] object )

    New in 1.4 !

    Check to see if an object is empty (contains no properties).

  • Boolean jQuery.isPlainObject( [Object] object )

    New in 1.4 !

    Check to see if an object is a plain object (created using "{}" or "new Object").

  • Number .index( [Element|jQuery] element )

    New in 1.0 !

    Search for a given element from among the matched elements.

  • Object .data( )

    New in 1.4 !

    Returns value at named data store for the element, as set by data(name, value).

  • jQuery .bind( [Object] events )

    New in 1.4 !

    Attach a handler to an event for the elements.

  • jQuery .first( )

    New in 1.4 !

    Reduce the set of matched elements to the first in the set.

  • jQuery .last( )

    New in 1.4 !

    Reduce the set of matched elements to the final one in the set.

  • jQuery jQuery( [Function] callback )

    New in 1.0 !

    Binds a function to be executed when the DOM has finished loading.

  • Array .closest( [Array] selectors, [Element] context )

    New in 1.4 !

    Gets an array of all the elements and selectors matched against the current element up through the DOM tree.

  • jQuery .add( [Selector] selector, [Element] context )

    New in 1.4 !

    Add elements to the set of matched elements.

  • jQuery .not( [Function] function(index) )

    New in 1.4 !

    Remove elements from the set of matched elements.

  • String jQuery.param( [Array|Object] obj, [Boolean] traditional )

    New in 1.4 !

    Create a serialized representation of an array or object, suitable for use in a URL query string or Ajax request.

  • jQuery .offset( [Function] function(index, coords) )

    New in 1.4 !

    Set the current coordinates of every element in the set of matched elements, relative to the document.

  • jQuery .css( [Map] map )

    New in 1.0 !

    Set one or more CSS properties for the set of matched elements.

  • jQuery .unwrap( )

    New in 1.4 !

    Remove the parents of the set of matched elements from the DOM, leaving the matched elements in their place.

  • jQuery .detach( [Selector] selector )

    New in 1.4 !

    Remove the set of matched elements from the DOM.

  • jQuery .replaceWith( [Function] function )

    New in 1.4 !

    Replace each element in the set of matched elements with the provided new content.

  • jQuery .wrapInner( [Function] wrappingFunction )

    New in 1.4 !

    Wrap an HTML structure around the content of each element in the set of matched elements.

  • jQuery .wrapAll( [String|Selector|Element|jQuery] wrappingElement )

    New in 1.2 !

    Wrap an HTML structure around all elements in the set of matched elements.

  • jQuery .wrap( [Function] wrappingFunction )

    New in 1.4 !

    Wrap an HTML structure around each element in the set of matched elements.

  • jQuery .before( [Function] function )

    New in 1.4 !

    Insert content, specified by the parameter, before each element in the set of matched elements.

  • jQuery .after( [Function] function(index) )

    New in 1.4 !

    Insert content, specified by the parameter, after each element in the set of matched elements.

  • jQuery .prepend( [Function] function(index, html) )

    New in 1.4 !

    Insert content, specified by the parameter, to the beginning of each element in the set of matched elements.

  • jQuery .append( [Function] function(index, html) )

    New in 1.4 !

    Insert content, specified by the parameter, to the end of each element in the set of matched elements.

  • jQuery .val( [Function] function(index, value) )

    New in 1.4 !

    Set the value of each element in the set of matched elements.

  • jQuery .text( [Function] function(index, text) )

    New in 1.4 !

    Set the content of each element in the set of matched elements to the specified text.

  • jQuery .html( [Function] function(index, oldhtml) )

    New in 1.4 !

    Set the HTML contents of each element in the set of matched elements.

  • jQuery .toggleClass( [Function] function(index, class), [Boolean] switch )

    New in 1.4 !

    Add or remove one or more classes from each element in the set of matched elements, depending on either the class's presence or the value of the switch argument.

  • jQuery .removeClass( [Function] function(index, class) )

    New in 1.4 !

    Remove a single class, multiple classes, or all classes from each element in the set of matched elements.

  • jQuery .removeAttr( [String] attributeName )

    New in 1.0 !

    Remove an attribute from each element in the set of matched elements.

  • jQuery .addClass( [Function] function(index, class) )

    New in 1.4 !

    Adds the specified class(es) to each of the set of matched elements.

  • jQuery.error( [String] message )

    New in 1.4.1 !

    Takes a string and throws an exception containing it.

  • Object jQuery.parseJSON( [String] json )

    New in 1.4.1 !

    Takes a well-formed JSON string and returns the resulting JavaScript object.

  • jQuery .die( [String] eventType, [String] handler )

    New in 1.3 !

    Remove an event handler previously attached using from the elements.

  • jQuery .width( [Function] function(index, width) )

    New in 1.4.1 !

    Set the CSS width of each element in the set of matched elements.

  • jQuery .height( [Function] function(index, height) )

    New in 1.4.1 !

    Set the CSS height of every matched element.

  • jQuery .undelegate( [String] selector, [String] eventType, [Function] handler )

    New in 1.4.2 !

    Remove a handler from the event for all elements which match the current selector, now or in the future, based upon a specific set of root elements.

  • jQuery .delegate( [String] selector, [String] eventType, [Object] eventData, [Function] handler )

    New in 1.4.2 !

    Attach a handler to one or more events for all elements that match the selector, now or in the future, based on a specific set of root elements.


Version 1.0 – jQuery API

Version 1.0

  • event.stopPropagation( )

    New in 1.0 !

    Prevents the event from bubbling up the DOM tree, preventing any parent handlers from being notified of the event.

  • undefined event.preventDefault( )

    New in 1.0 !

    If this method is called, the default action of the event will not be triggered.

  • Element event.target

    New in 1.0 !

    The DOM element that initiated the event.

  • String event.type

    New in 1.0 !

    Describes the nature of the event.

  • jQuery .each( [Function] function(index, Element) )

    New in 1.0 !

    Iterate over a jQuery object, executing a function for each matched element.

  • jQuery jQuery.pushStack( [Array] elements, [String] name, [Array] arguments )

    New in 1.3 !

    Add a collection of DOM elements onto the jQuery stack.

  • jQuery .keydown( )

    New in 1.0 !

    Bind an event handler to the "keydown" JavaScript event, or trigger that event on an element.

  • Number .index( [Element|jQuery] element )

    New in 1.0 !

    Search for a given element from among the matched elements.

  • Element, Array .get( [Number] index )

    New in 1.0 !

    Retrieve the DOM elements matched by the jQuery object.

  • Number .size( )

    New in 1.0 !

    Return the number of DOM elements matched by the jQuery object.

  • Object jQuery.noConflict( [Boolean] removeAll )

    New in 1.0 !

    Relinquish jQuery's control of the variable.

  • JQuery(":selected")

    New in 1.0 !

    Selects all elements that are selected.

  • JQuery(":checked")

    New in 1.0 !

    Matches all elements that are checked.

  • JQuery(":disabled")

    New in 1.0 !

    Selects all elements that are disabled.

  • JQuery(":enabled")

    New in 1.0 !

    Selects all elements that are enabled.

  • JQuery(":file")

    New in 1.0 !

    Selects all elements of type file.

  • JQuery(":button")

    New in 1.0 !

    Selects all button elements and elements of type button.

  • JQuery(":reset")

    New in 1.0 !

    Selects all elements of type reset.

  • JQuery(":image")

    New in 1.0 !

    Selects all elements of type image.

  • jQuery .submit( )

    New in 1.0 !

    Bind an event handler to the "submit" JavaScript event, or trigger that event on an element.

  • JQuery(":checkbox")

    New in 1.0 !

    Selects all elements of type checkbox.

  • JQuery(":radio")

    New in 1.0 !

    Selects all elements of type radio.

  • JQuery(":password")

    New in 1.0 !

    Selects all elements of type password.

  • jQuery .text( [Function] function(index, text) )

    New in 1.4 !

    Set the content of each element in the set of matched elements to the specified text.

  • JQuery(":input")

    New in 1.0 !

    Selects all input, textarea, select and button elements.

  • JQuery("[attribute|=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value either equal to a given string or starting with that string followed by a hyphen (-).

  • JQuery("[attribute~=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value containing a given word, delimited by spaces.

  • JQuery("[attributeFilter1][attributeFilter2][attributeFilterN]")

    New in 1.0 !

    Matches elements that match all of the specified attribute filters.

  • JQuery("[attribute*=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value containing the a given substring.

  • JQuery("[attribute$=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value ending exactly with a given string.

  • JQuery("[attribute^=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value beginning exactly with a given string.

  • JQuery("[attribute!=value]")

    New in 1.0 !

    Select elements that either don't have the specified attribute, or do have the specified attribute but not with a certain value.

  • JQuery("[attribute=value]")

    New in 1.0 !

    Selects elements that have the specified attribute with a value exactly equal to a certain value.

  • JQuery("[attribute]")

    New in 1.0 !

    Selects elements that have the specified attribute, with any value.

  • JQuery(":visible")

    New in 1.0 !

    Selects all elements that are visible.

  • JQuery(":hidden")

    New in 1.0 !

    Selects all elements that are hidden.

  • jQuery .parent( [Selector] selector )

    New in 1.0 !

    Get the parent of each element in the current set of matched elements, optionally filtered by a selector.

  • jQuery .empty( )

    New in 1.0 !

    Remove all child nodes of the set of matched elements from the DOM.

  • JQuery(":lt(index)")

    New in 1.0 !

    Select all elements at an index less than within the matched set.

  • JQuery(":gt(index)")

    New in 1.0 !

    Select all elements at an index greater than within the matched set.

  • JQuery(":eq(index)")

    New in 1.0 !

    Select the element at index within the matched set.

  • JQuery(":odd")

    New in 1.0 !

    Selects odd elements, zero-indexed. See also .

  • JQuery(":even")

    New in 1.0 !

    Selects even elements, zero-indexed. See also .

  • jQuery .not( [Function] function(index) )

    New in 1.4 !

    Remove elements from the set of matched elements.

  • JQuery(":last")

    New in 1.0 !

    Selects the last matched element.

  • JQuery(":first")

    New in 1.0 !

    Selects the first matched element.

  • JQuery("prev ~ siblings")

    New in 1.0 !

    Selects all sibling elements that follow after the "prev" element, have the same parent, and match the filtering "siblings" selector.

  • JQuery("prev + next")

    New in 1.0 !

    Selects all next elements matching "next" that are immediately preceded by a sibling "prev".

  • child")" rel="bookmark">JQuery("parent > child")

    New in 1.0 !

    Selects all direct child elements specified by "child" of elements specified by "parent".

  • JQuery("ancestor descendant")

    New in 1.0 !

    Selects all elements that are descendants of a given ancestor.

  • JQuery("selector1, selector2, selectorN")

    New in 1.0 !

    Selects the combined results of all the specified selectors.

  • JQuery("*")

    New in 1.0 !

    Selects all elements.

  • JQuery(".class")

    New in 1.0 !

    Selects all elements with the given class.

  • JQuery("element")

    New in 1.0 !

    Selects all elements with the given tag name.

  • JQuery("#id")

    New in 1.0 !

    Selects a single element with the given id attribute.

  • jQuery .scroll( )

    New in 1.0 !

    Bind an event handler to the "scroll" JavaScript event, or trigger that event on an element.

  • jQuery .resize( )

    New in 1.0 !

    Bind an event handler to the "resize" JavaScript event, or trigger that event on an element.

  • jQuery .keyup( )

    New in 1.0 !

    Bind an event handler to the "keyup" JavaScript event, or trigger that event on an element.

  • jQuery .keypress( )

    New in 1.0 !

    Bind an event handler to the "keypress" JavaScript event, or trigger that event on an element.

  • jQuery .select( )

    New in 1.0 !

    Bind an event handler to the "select" JavaScript event, or trigger that event on an element.

  • jQuery .change( )

    New in 1.0 !

    Bind an event handler to the "change" JavaScript event, or trigger that event on an element.

  • jQuery .blur( )

    New in 1.0 !

    Bind an event handler to the "blur" JavaScript event, or trigger that event on an element.

  • jQuery .focus( )

    New in 1.0 !

    Bind an event handler to the "focus" JavaScript event, or trigger that event on an element.

  • jQuery .mousemove( )

    New in 1.0 !

    Bind an event handler to the "mousemove" JavaScript event, or trigger that event on an element.

  • jQuery .hover( [Function] handlerInOut(eventObject) )

    New in 1.4 !

    Bind a single handler to the matched elements, to be executed when the mouse pointer enters or leaves the elements.

  • jQuery .mouseleave( )

    New in 1.0 !

    Bind an event handler to be fired when the mouse leaves an element, or trigger that handler on an element.

  • jQuery .mouseenter( )

    New in 1.0 !

    Bind an event handler to be fired when the mouse enters an element, or trigger that handler on an element.

  • jQuery .mouseout( )

    New in 1.0 !

    Bind an event handler to the "mouseout" JavaScript event, or trigger that event on an element.

  • jQuery .mouseover( )

    New in 1.0 !

    Bind an event handler to the "mouseover" JavaScript event, or trigger that event on an element.

  • jQuery .dblclick( )

    New in 1.0 !

    Bind an event handler to the "dblclick" JavaScript event, or trigger that event on an element.

  • jQuery .click( )

    New in 1.0 !

    Bind an event handler to the "click" JavaScript event, or trigger that event on an element.

  • jQuery .mouseup( )

    New in 1.0 !

    Bind an event handler to the "mouseup" JavaScript event, or trigger that event on an element.

  • jQuery .mousedown( )

    New in 1.0 !

    Bind an event handler to the "mousedown" JavaScript event, or trigger that event on an element.

  • jQuery .error( [Function] handler(eventObject) )

    New in 1.0 !

    Bind an event handler to the "error" JavaScript event.

  • jQuery .unload( [Function] handler(eventObject) )

    New in 1.0 !

    Bind an event handler to the "unload" JavaScript event.

  • jQuery .load( [String] url, [Map|String] data, [Function] complete(responseText, textStatus, XMLHttpRequest) )

    New in 1.0 !

    Load data from the server and place the returned HTML into the matched element.

  • jQuery .ready( [Function] handler )

    New in 1.0 !

    Specify a function to execute when the DOM is fully loaded.

  • Map jQuery.browser

    New in 1.0 !

    Contains flags for the useragent, read from navigator.userAgent. While jQuery.browser will not be removed from future versions of jQuery, every effort to use jQuery.support and proper feature detection should be made.

  • String jQuery.browser.version

    New in 1.1.3 !

    The version number of the rendering engine for the user's browser.

  • jQuery .trigger( [String] eventType, [Array] extraParameters )

    New in 1.0 !

    Execute all handlers and behaviors attached to the matched elements for the given event type.

  • jQuery .ajaxComplete( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

    New in 1.0 !

    Register a handler to be called when Ajax requests complete. This is an .

  • String .serialize( )

    New in 1.0 !

    Encode a set of form elements as a string for submission.

  • jQuery .ajaxSuccess( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

    New in 1.0 !

  • jQuery .ajaxStop( [Function] handler() )

    New in 1.0 !

    Register a handler to be called when all Ajax requests have completed. This is an .

  • jQuery .ajaxStart( [Function] handler() )

    New in 1.0 !

    Register a handler to be called when the first Ajax request begins. This is an .

  • jQuery .ajaxSend( [Function] handler(event, XMLHttpRequest, ajaxOptions) )

    New in 1.0 !

  • jQuery .ajaxError( [Function] handler(event, XMLHttpRequest, ajaxOptions, thrownError) )

    New in 1.0 !

    Register a handler to be called when Ajax requests complete with an error. This is an .

  • jQuery .unbind( [Object] event )

    New in 1.0 !

    Remove a previously-attached event handler from the elements.

  • jQuery .bind( [Object] events )

    New in 1.4 !

    Attach a handler to an event for the elements.

  • jQuery jQuery( [Function] callback )

    New in 1.0 !

    Binds a function to be executed when the DOM has finished loading.

  • jQuery .end( )

    New in 1.0 !

    End the most recent filtering operation in the current chain and return the set of matched elements to its previous state.

  • jQuery .siblings( [Selector] selector )

    New in 1.0 !

    Get the siblings of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .animate( [Options] properties, [Options] options )

    New in 1.0 !

    Perform a custom animation of a set of CSS properties.

  • jQuery .prev( [Selector] selector )

    New in 1.0 !

    Get the immediately preceding sibling of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .fadeTo( [String,Number] duration, [Number] opacity, [Callback] callback )

    New in 1.0 !

    Adjust the opacity of the matched elements.

  • jQuery .fadeOut( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Hide the matched elements by fading them to transparent.

  • jQuery .parents( [Selector] selector )

    New in 1.0 !

    Get the ancestors of each element in the current set of matched elements, optionally filtered by a selector.

  • jQuery .fadeIn( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display the matched elements by fading them to opaque.

  • jQuery .slideToggle( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display or hide the matched elements with a sliding motion.

  • XMLHttpRequest jQuery.post( [String] url, [Map|String] data, [Function] success(data, textStatus, XMLHttpRequest), [String] dataType )

    New in 1.0 !

    Load data from the server using a HTTP POST request.

  • jQuery .slideUp( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Hide the matched elements with a sliding motion.

  • jQuery .next( [Selector] selector )

    New in 1.0 !

    Get the immediately following sibling of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .slideDown( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display the matched elements with a sliding motion.

  • jQuery .find( [Selector] selector )

    New in 1.0 !

    Get the descendants of each element in the current set of matched elements, filtered by a selector.

  • XMLHttpRequest jQuery.getScript( [String] url, [Function] success(data, textStatus) )

    New in 1.0 !

    Load a JavaScript file from the server using a GET HTTP request, then execute it.

  • XMLHttpRequest jQuery.getJSON( [String] url, [Map] data, [Function] callback(data, textStatus) )

    New in 1.0 !

    Load JSON-encoded data from the server using a GET HTTP request.

  • XMLHttpRequest jQuery.get( [String] url, [Map|String] data, [Function] callback(data, textStatus, XMLHttpRequest), [String] dataType )

    New in 1.0 !

    Load data from the server using a HTTP GET request.

  • XMLHttpRequest jQuery.ajax( [Map] settings )

    New in 1.0 !

    Perform an asynchronous HTTP (Ajax) request.

  • Number length

    New in 1.0 !

    The number of elements in the jQuery object.

  • jQuery .children( [Selector] selector )

    New in 1.0 !

    Get the children of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .add( [Selector] selector, [Element] context )

    New in 1.4 !

    Add elements to the set of matched elements.

  • jQuery .toggle( [Boolean] showOrHide )

    New in 1.3 !

    Display or hide the matched elements.

  • jQuery .hide( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Hide the matched elements.

  • jQuery .width( [Function] function(index, width) )

    New in 1.4.1 !

    Set the CSS width of each element in the set of matched elements.

  • jQuery .height( [Function] function(index, height) )

    New in 1.4.1 !

    Set the CSS height of every matched element.

  • jQuery .show( [String,Number] duration, [Callback] callback )

    New in 1.0 !

    Display the matched elements.

  • String jQuery.trim( [String] str )

    New in 1.0 !

    Remove the whitespace from the beginning and end of a string.

  • Array jQuery.merge( [Array] first, [Array] second )

    New in 1.0 !

    Merge the contents of two arrays together into the first array.

  • Array jQuery.map( [Array] array, [Function] callback(elementOfArray, indexInArray) )

    New in 1.0 !

    Translate all items in an array or array-like object to another array of items.

  • Array jQuery.grep( [Array] array, [Function] function(elementOfArray, indexInArray), [Boolean] invert )

    New in 1.0 !

    Finds the elements of an array which satisfy a filter function. The original array is not affected.

  • Object jQuery.extend( [Boolean] deep, [Object] target, [Object] object1, [Object] objectN )

    New in 1.1.4 !

    Merge the contents of two or more objects together into the first object.

  • Object jQuery.each( [Object] collection, [Function] callback(indexInArray, valueOfElement) )

    New in 1.0 !

    A generic iterator function, which can be used to seamlessly iterate over both objects and arrays. Arrays and array-like objects with a length property (such as a function's arguments object) are iterated by numeric index, from 0 to length-1. Other objects are iterated via their named properties.

  • Boolean jQuery.boxModel

    New in 1.0 !

    . States if the current page, in the user's browser, is being rendered using the .

  • jQuery .css( [Map] map )

    New in 1.0 !

    Set one or more CSS properties for the set of matched elements.

  • jQuery .clone( [Boolean] withDataAndEvents )

    New in 1.0 !

    Create a copy of the set of matched elements.

  • jQuery .remove( [String] selector )

    New in 1.0 !

    Remove the set of matched elements from the DOM.

  • jQuery .wrap( [Function] wrappingFunction )

    New in 1.4 !

    Wrap an HTML structure around each element in the set of matched elements.

  • jQuery .insertBefore( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements before the target.

  • jQuery .before( [Function] function )

    New in 1.4 !

    Insert content, specified by the parameter, before each element in the set of matched elements.

  • jQuery .insertAfter( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements after the target.

  • jQuery .after( [Function] function(index) )

    New in 1.4 !

    Insert content, specified by the parameter, after each element in the set of matched elements.

  • jQuery .prependTo( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements to the beginning of the target.

  • jQuery .prepend( [Function] function(index, html) )

    New in 1.4 !

    Insert content, specified by the parameter, to the beginning of each element in the set of matched elements.

  • jQuery .appendTo( [Selector|Element|jQuery] target )

    New in 1.0 !

    Insert every element in the set of matched elements to the end of the target.

  • jQuery .append( [Function] function(index, html) )

    New in 1.4 !

    Insert content, specified by the parameter, to the end of each element in the set of matched elements.

  • jQuery .val( [Function] function(index, value) )

    New in 1.4 !

    Set the value of each element in the set of matched elements.

  • jQuery .html( [Function] function(index, oldhtml) )

    New in 1.4 !

    Set the HTML contents of each element in the set of matched elements.

  • Boolean .is( [Selector] selector )

    New in 1.0 !

    Check the current matched set of elements against a selector and return true if at least one of these elements matches the selector.

  • jQuery .filter( [Function] function(index) )

    New in 1.0 !

    Reduce the set of matched elements to those that match the selector or pass the function's test.

  • jQuery .toggleClass( [Function] function(index, class), [Boolean] switch )

    New in 1.4 !

    Add or remove one or more classes from each element in the set of matched elements, depending on either the class's presence or the value of the switch argument.

  • jQuery .removeClass( [Function] function(index, class) )

    New in 1.4 !

    Remove a single class, multiple classes, or all classes from each element in the set of matched elements.

  • jQuery .removeAttr( [String] attributeName )

    New in 1.0 !

    Remove an attribute from each element in the set of matched elements.

  • jQuery .attr( [String] attributeName, [Function] function(index, attr) )

    New in 1.1 !

    Set one or more attributes for the set of matched elements.

  • jQuery .addClass( [Function] function(index, class) )

    New in 1.4 !

    Adds the specified class(es) to each of the set of matched elements.


Version 1.0.4 – jQuery API

Version 1.0.4

  • Number event.pageY

    New in 1.0.4 !

    The mouse position relative to the top edge of the document.

  • Number event.pageX

    New in 1.0.4 !

    The mouse position relative to the left edge of the document.

  • jQuery.globalEval( [String] code )

    New in 1.0.4 !

    Execute some JavaScript code globally.


Version 1.1 – jQuery API

Version 1.1

  • Anything event.data

    New in 1.1 !

    Contains the optional data passed to jQuery.fn.bind when the current executing handler was bound.

  • jQuery .one( [String] eventType, [Object] eventData, [Function] handler(eventObject) )

    New in 1.1 !

    Attach a handler to an event for the elements. The handler is executed at most once per element.

  • jQuery.ajaxSetup( [Options] options )

    New in 1.1 !

    Set default values for future Ajax requests.

  • jQuery .attr( [String] attributeName, [Function] function(index, attr) )

    New in 1.1 !

    Set one or more attributes for the set of matched elements.


Version 1.1.2 – jQuery API

Version 1.1.2

  • jQuery .eq( [Integer] -index )

    New in 1.4 !

    Reduce the set of matched elements to the one at the specified index.


Version 1.1.3 – jQuery API

Version 1.1.3

  • String event.which

    New in 1.1.3 !

    For key or button events, this attribute indicates the specific button or key that was pressed.

  • Map jQuery.browser

    New in 1.0 !

    Contains flags for the useragent, read from navigator.userAgent. While jQuery.browser will not be removed from future versions of jQuery, every effort to use jQuery.support and proper feature detection should be made.

  • String jQuery.browser.version

    New in 1.1.3 !

    The version number of the rendering engine for the user's browser.

  • Array jQuery.unique( [Array] array )

    New in 1.1.3 !

    Sorts an array of DOM elements, in place, with the duplicates removed. Note that this only works on arrays of DOM elements, not strings or numbers.


Version 1.1.4 – jQuery API

Version 1.1.4

  • Element event.relatedTarget

    New in 1.1.4 !

    The other DOM element involved in the event, if any.

  • Boolean jQuery.isXMLDoc( [Element] node )

    New in 1.1.4 !

    Check to see if a DOM node is within an XML document (or is an XML document).

  • JQuery(":only-child")

    New in 1.1.4 !

    Selects all elements that are the only child of their parent.

  • JQuery(":last-child")

    New in 1.1.4 !

    Selects all elements that are the last child of their parent.

  • JQuery(":first-child")

    New in 1.1.4 !

    Selects all elements that are the first child of their parent.

  • JQuery(":nth-child(index/even/odd/equation)")

    New in 1.1.4 !

    Selects all elements that are the nth-child of their parent.

  • JQuery(":has(selector)")

    New in 1.1.4 !

    Selects elements which contain at least one element that matches the specified selector.

  • JQuery(":contains(text)")

    New in 1.1.4 !

    Select all elements that contain the specified text.

  • jQuery .slice( [Integer] start, [Integer] end )

    New in 1.1.4 !

    Reduce the set of matched elements to a subset specified by a range of indices.


Version 1.2 – jQuery API

Version 1.2

  • JQuery(":animated")

    New in 1.2 !

    Select all elements that are in the progress of an animation at the time the selector is run.

  • JQuery(":header")

    New in 1.2 !

    Selects all elements that are headers, like h1, h2, h3 and so on.

  • jQuery .dequeue( [String] queueName )

    New in 1.2 !

    Execute the next function on the queue for the matched elements.

  • jQuery .queue( [String] queueName, [Function] callback( next ) )

    New in 1.2 !

    Manipulate the queue of functions to be executed on the matched elements.

  • Object .triggerHandler( [String] eventType, [Array] extraParameters )

    New in 1.2 !

    Execute all handlers attached to an element for an event.

  • Array .serializeArray( )

    New in 1.2 !

    Encode a set of form elements as an array of names and values.

  • jQuery .stop( [Boolean] clearQueue, [Boolean] jumpToEnd )

    New in 1.2 !

    Stop the currently-running animation on the matched elements.

  • jQuery .andSelf( )

    New in 1.2 !

    Add the previous set of elements on the stack to the current set.

  • jQuery .prevAll( [Selector] selector )

    New in 1.2 !

    Get all preceding siblings of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .nextAll( [String] selector )

    New in 1.2 !

    Get all following siblings of each element in the set of matched elements, optionally filtered by a selector.

  • jQuery .contents( )

    New in 1.2 !

    Get the children of each element in the set of matched elements, including text nodes.

  • String jQuery.param( [Array|Object] obj, [Boolean] traditional )

    New in 1.4 !

    Create a serialized representation of an array or object, suitable for use in a URL query string or Ajax request.

  • boolean jQuery.isFunction( [Object] obj )

    New in 1.2 !

    Determine if the argument passed is a Javascript function object.

  • Number jQuery.inArray( [Any] value, [Array] array )

    New in 1.2 !

    Search for a specified value within an array and return its index (or -1 if not found).

  • Array jQuery.makeArray( [Object] obj )

    New in 1.2 !

    Convert an array-like object into a true JavaScript array.

  • Object .position( )

    New in 1.2 !

    Get the current coordinates of the first element in the set of matched elements, relative to the offset parent.

  • jQuery .offset( [Function] function(index, coords) )

    New in 1.4 !

    Set the current coordinates of every element in the set of matched elements, relative to the document.

  • jQuery .replaceAll( )

    New in 1.2 !

    Replace each target element with the set of matched elements.

  • jQuery .replaceWith( [Function] function )

    New in 1.4 !

    Replace each element in the set of matched elements with the provided new content.

  • jQuery .wrapInner( [Function] wrappingFunction )

    New in 1.4 !

    Wrap an HTML structure around the content of each element in the set of matched elements.

  • jQuery .wrapAll( [String|Selector|Element|jQuery] wrappingElement )

    New in 1.2 !

    Wrap an HTML structure around all elements in the set of matched elements.

  • jQuery .map( [Function] callback(index, domElement) )

    New in 1.2 !

    Pass each element in the current matched set through a function, producing a new jQuery object containing the return values.

  • Boolean .hasClass( [String] className )

    New in 1.2 !

    Determine whether any of the matched elements are assigned the given class.


Version 1.2.3 – jQuery API

Version 1.2.3

  • jQuery jQuery.removeData( [Element] element, [String] name )

    New in 1.2.3 !

    Remove a previously-stored piece of data.

  • Object jQuery.data( [Element] element )

    New in 1.4 !

    Returns value at named data store for the element, as set by , or the full data store for the element.

  • jQuery .removeData( [String] name )

    New in 1.2.3 !

    Remove a previously-stored piece of data.

  • Object .data( )

    New in 1.4 !

    Returns value at named data store for the element, as set by data(name, value).


Version 1.2.6 – jQuery API

Version 1.2.6

  • Number event.timeStamp

    New in 1.2.6 !

    This attribute returns the number of milliseconds since January 1, 1970, when the event is triggered.

  • Integer .outerWidth( [Boolean] includeMargin )

    New in 1.2.6 !

    Get the current computed width for the first element in the set of matched elements, including padding and border.

  • Integer .outerHeight( [Boolean] includeMargin )

    New in 1.2.6 !

    Get the current computed height for the first element in the set of matched elements, including padding, border, and optionally margin.

  • Integer .innerWidth( )

    New in 1.2.6 !

    Get the current computed width for the first element in the set of matched elements, including padding but not border.

  • Integer .innerHeight( )

    New in 1.2.6 !

    Get the current computed height for the first element in the set of matched elements, including padding but not border.

  • jQuery .scrollLeft( [Number] value )

    New in 1.2.6 !

    Set the current horizontal position of the scroll bar for each of the set of matched elements.

  • jQuery .scrollTop( [Number] value )

    New in 1.2.6 !

    Set the current vertical position of the scroll bar for each of the set of matched elements.


Version 1.3 – jQuery API

Version 1.3

  • Boolean event.isImmediatePropagationStopped( )

    New in 1.3 !

    Returns whether event.stopImmediatePropagation() was ever called on this event object.

  • event.stopImmediatePropagation( )

    New in 1.3 !

    Keeps the rest of the handlers from being executed and prevents the event from bubbling up the DOM tree

  • Boolean event.isPropagationStopped( )

    New in 1.3 !

    Returns whether was ever called on this event object.

  • Boolean event.isDefaultPrevented( )

    New in 1.3 !

    Returns whether was ever called on this event object.

  • Object event.result

    New in 1.3 !

    This attribute contains the last value returned by an event handler that was triggered by this event, unless the value was .

  • Element event.currentTarget

    New in 1.3 !

    The current DOM element within the event bubbling phase.

  • Boolean jQuery.fx.off

    New in 1.3 !

    Globally disable all animations.

  • jQuery jQuery.pushStack( [Array] elements, [String] name, [Array] arguments )

    New in 1.3 !

    Add a collection of DOM elements onto the jQuery stack.

  • jQuery jQuery.dequeue( [Element] element, [String] queueName )

    New in 1.3 !

    Execute the next function on the queue for the matched element.

  • jQuery jQuery.queue( [Element] element, [String] queueName, [Function] callback() )

    New in 1.3 !

    Manipulate the queue of functions to be executed on the matched element.

  • jQuery .die( [String] eventType, [String] handler )

    New in 1.3 !

    Remove an event handler previously attached using from the elements.

  • jQuery .live( [String] eventType, [Object] eventData, [Function] handler )

    New in 1.4 !

    Attach a handler to the event for all elements which match the current selector, now or in the future.

  • Array .closest( [Array] selectors, [Element] context )

    New in 1.4 !

    Gets an array of all the elements and selectors matched against the current element up through the DOM tree.

  • String selector

    New in 1.3 !

    A selector representing selector originally passed to jQuery().

  • Element context

    New in 1.3 !

    The DOM node context originally passed to jQuery(); if none was passed then context will likely be the document.

  • jQuery .toggle( [Boolean] showOrHide )

    New in 1.3 !

    Display or hide the matched elements.

  • boolean jQuery.isArray( [Object] obj )

    New in 1.3 !

    Determine whether the argument is an array.

  • Object jQuery.support

    New in 1.3 !

    A collection of properties that represent the presence of different browser features or bugs.

  • jQuery .toggleClass( [Function] function(index, class), [Boolean] switch )

    New in 1.4 !

    Add or remove one or more classes from each element in the set of matched elements, depending on either the class's presence or the value of the switch argument.


Version 1.4 – jQuery API

Version 1.4

  • Function jQuery.proxy( [Object] context, [String] name )

    New in 1.4 !

    Takes a function and returns a new one that will always have a particular context.

  • jQuery .focusout( [Function] handler(eventObject) )

    New in 1.4 !

    Bind an event handler to the "focusout" JavaScript event.

  • jQuery .focusin( [Function] handler(eventObject) )

    New in 1.4 !

    Bind an event handler to the "focusin" JavaScript event.

  • jQuery .has( [Element] contained )

    New in 1.4 !

    Reduce the set of matched elements to those that have a descendant that matches the selector or DOM element.

  • Boolean jQuery.contains( [Element] container, [Element] contained )

    New in 1.4 !

    Check to see if a DOM node is within another DOM node.

  • Function jQuery.noop( )

    New in 1.4 !

    An empty function.

  • jQuery .delay( [Integer] duration, [String] queueName )

    New in 1.4 !

    Set a timer to delay execution of subsequent items in the queue.

  • jQuery .parentsUntil( [Selector] selector )

    New in 1.4 !

    Get the ancestors of each element in the current set of matched elements, up to but not including the element matched by the selector.

  • jQuery .prevUntil( [Selector] selector )

    New in 1.4 !

    Get all preceding siblings of each element up to but not including the element matched by the selector.

  • jQuery .nextUntil( [Selector] selector )

    New in 1.4 !

    Get all following siblings of each element up to but not including the element matched by the selector.

  • Object jQuery.data( [Element] element )

    New in 1.4 !

    Returns value at named data store for the element, as set by , or the full data store for the element.

  • jQuery .clearQueue( [String] queueName )

    New in 1.4 !

    Remove from the queue all items that have not yet been run.

  • Array .toArray( )

    New in 1.4 !

    Retrieve all the DOM elements contained in the jQuery set, as an array.

  • Boolean jQuery.isEmptyObject( [Object] object )

    New in 1.4 !

    Check to see if an object is empty (contains no properties).

  • Boolean jQuery.isPlainObject( [Object] object )

    New in 1.4 !

    Check to see if an object is a plain object (created using "{}" or "new Object").

  • Number .index( [Element|jQuery] element )

    New in 1.0 !

    Search for a given element from among the matched elements.

  • Object .data( )

    New in 1.4 !

    Returns value at named data store for the element, as set by data(name, value).

  • jQuery .bind( [Object] events )

    New in 1.4 !

    Attach a handler to an event for the elements.

  • jQuery .first( )

    New in 1.4 !

    Reduce the set of matched elements to the first in the set.

  • jQuery .last( )

    New in 1.4 !

    Reduce the set of matched elements to the final one in the set.

  • jQuery jQuery( [Function] callback )

    New in 1.0 !

    Binds a function to be executed when the DOM has finished loading.

  • Array .closest( [Array] selectors, [Element] context )

    New in 1.4 !

    Gets an array of all the elements and selectors matched against the current element up through the DOM tree.

  • jQuery .add( [Selector] selector, [Element] context )

    New in 1.4 !

    Add elements to the set of matched elements.

  • jQuery .not( [Function] function(index) )

    New in 1.4 !

    Remove elements from the set of matched elements.

  • String jQuery.param( [Array|Object] obj, [Boolean] traditional )

    New in 1.4 !

    Create a serialized representation of an array or object, suitable for use in a URL query string or Ajax request.

  • jQuery .offset( [Function] function(index, coords) )

    New in 1.4 !

    Set the current coordinates of every element in the set of matched elements, relative to the document.

  • jQuery .css( [Map] map )

    New in 1.0 !

    Set one or more CSS properties for the set of matched elements.

  • jQuery .unwrap( )

    New in 1.4 !

    Remove the parents of the set of matched elements from the DOM, leaving the matched elements in their place.

  • jQuery .detach( [Selector] selector )

    New in 1.4 !

    Remove the set of matched elements from the DOM.

  • jQuery .replaceWith( [Function] function )

    New in 1.4 !

    Replace each element in the set of matched elements with the provided new content.

  • jQuery .wrapInner( [Function] wrappingFunction )

    New in 1.4 !

    Wrap an HTML structure around the content of each element in the set of matched elements.

  • jQuery .wrapAll( [String|Selector|Element|jQuery] wrappingElement )

    New in 1.2 !

    Wrap an HTML structure around all elements in the set of matched elements.

  • jQuery .wrap( [Function] wrappingFunction )

    New in 1.4 !

    Wrap an HTML structure around each element in the set of matched elements.

  • jQuery .before( [Function] function )

    New in 1.4 !

    Insert content, specified by the parameter, before each element in the set of matched elements.

  • jQuery .after( [Function] function(index) )

    New in 1.4 !

    Insert content, specified by the parameter, after each element in the set of matched elements.

  • jQuery .prepend( [Function] function(index, html) )

    New in 1.4 !

    Insert content, specified by the parameter, to the beginning of each element in the set of matched elements.

  • jQuery .append( [Function] function(index, html) )

    New in 1.4 !

    Insert content, specified by the parameter, to the end of each element in the set of matched elements.

  • jQuery .val( [Function] function(index, value) )

    New in 1.4 !

    Set the value of each element in the set of matched elements.

  • jQuery .text( [Function] function(index, text) )

    New in 1.4 !

    Set the content of each element in the set of matched elements to the specified text.

  • jQuery .html( [Function] function(index, oldhtml) )

    New in 1.4 !

    Set the HTML contents of each element in the set of matched elements.

  • jQuery .toggleClass( [Function] function(index, class), [Boolean] switch )

    New in 1.4 !

    Add or remove one or more classes from each element in the set of matched elements, depending on either the class's presence or the value of the switch argument.

  • jQuery .removeClass( [Function] function(index, class) )

    New in 1.4 !

    Remove a single class, multiple classes, or all classes from each element in the set of matched elements.

  • jQuery .removeAttr( [String] attributeName )

    New in 1.0 !

    Remove an attribute from each element in the set of matched elements.

  • jQuery .addClass( [Function] function(index, class) )

    New in 1.4 !

    Adds the specified class(es) to each of the set of matched elements.


Version 1.4.1 – jQuery API

Version 1.4.1

  • jQuery.error( [String] message )

    New in 1.4.1 !

    Takes a string and throws an exception containing it.

  • Object jQuery.parseJSON( [String] json )

    New in 1.4.1 !

    Takes a well-formed JSON string and returns the resulting JavaScript object.

  • jQuery .die( [String] eventType, [String] handler )

    New in 1.3 !

    Remove an event handler previously attached using from the elements.

  • jQuery .width( [Function] function(index, width) )

    New in 1.4.1 !

    Set the CSS width of each element in the set of matched elements.

  • jQuery .height( [Function] function(index, height) )

    New in 1.4.1 !

    Set the CSS height of every matched element.


Version 1.4.2 – jQuery API

Version 1.4.2

  • jQuery .undelegate( [String] selector, [String] eventType, [Function] handler )

    New in 1.4.2 !

    Remove a handler from the event for all elements which match the current selector, now or in the future, based upon a specific set of root elements.

  • jQuery .delegate( [String] selector, [String] eventType, [Object] eventData, [Function] handler )

    New in 1.4.2 !

    Attach a handler to one or more events for all elements that match the selector, now or in the future, based on a specific set of root elements.